C   AIRFLOW IN A BOX
C   Version 2.0
C   (c) Hanley Innovaitons  1995
C
C  INPUT FILES
C  DATAX.inp    -  X-DIRECTION/PHYSICAL DATA (SEE README.TXT)
C  DATAY.inp    -  Y-DIRECTION DATA
C
C  OUTPUT FILES
C  PRES.out     -  COMPUTED PRESSURE
C  RHO.out      -  COMPUTED DENSITY
C  U.out        -  COMPUTED X_COMPONENT OF VELOCITY
C  V.out        -  COMPUTED Y_COMPONENT OF VELOCITY
C  MACH.out     -  MACH NUMBER
C  TOTP.out     -  TOTAL PRESSURE
C  SL.out       -  TECPLOT (tm) FORMATTED FILE
C  CHIST.out    -  CONVERGENCE HISTORY OF MASS,MOMENTUM & ENERGY RESIDUALS
C
C  VARIABLES
C  NX,NY        - MAXIMUM GRID IN X & Y DIRECTIONS RESPECTIVELY.  THESE
C                 PARAMETERS MUST BE VARIED IN MOST OF SUBROUTINES TO
C                 INCREASE THE SIZE OF THE SIMULATION
C
	IMPLICIT REAL*8 (A-H,O-Z)
	PARAMETER (NX=50,NY=50)
	DIMENSION U1(NX,NY),U2(NX,NY),U3(NX,NY),U4(NX,NY)
	DIMENSION U1B(NX,NY),U2B(NX,NY),U3B(NX,NY),U4B(NX,NY)
	DIMENSION F1(NX,NY),F2(NX,NY),F3(NX,NY),F4(NX,NY)
	DIMENSION G1(NX,NY),G2(NX,NY),G3(NX,NY),G4(NX,NY)
	DIMENSION F1X(NX,NY),F2X(NX,NY),F3X(NX,NY),F4X(NX,NY)
	DIMENSION G1Y(NX,NY),G2Y(NX,NY),G3Y(NX,NY),G4Y(NX,NY)
C
C DIMENSION QUANTIES AT INTERMEDIATE STEP
C
	DIMENSION FP1(NX,NY),FP2(NX,NY),FP3(NX,NY),FP4(NX,NY)
	DIMENSION FM1(NX,NY),FM2(NX,NY),FM3(NX,NY),FM4(NX,NY)
	DIMENSION GP1(NX,NY),GP2(NX,NY),GP3(NX,NY),GP4(NX,NY)
	DIMENSION GM1(NX,NY),GM2(NX,NY),GM3(NX,NY),GM4(NX,NY)
	DIMENSION F1BX(NX,NY),F2BX(NX,NY),F3BX(NX,NY),F4BX(NX,NY)
	DIMENSION G1BY(NX,NY),G2BY(NX,NY),G3BY(NX,NY),G4BY(NX,NY)
C
C DIMENSION THE STATE VARIABLES AND METRICS
C
	DIMENSION U(NX,NY),V(NX,NY),P(NX,NY),RHO(NX,NY),E(NX,NY)
	DIMENSION XIX(NX,NY),XY(NX,NY),EX(NX,NY),EY(NX,NY)
	dimension as1(nx),as2(nx),GXI(NX,NY),GE(NX,NY)
	DIMENSION AS3(NX),AS4(NX),xp1(nx,ny),yp1(nx,ny)
	dimension ddx(nx,ny), ddy(nx,ny), dtt(nx,ny),xmu(nx,ny)
	dimension u1o(nx,ny),u2o(nx,ny),u3o(nx,ny),u4o(nx,ny)
	dimension iter1(500), conv1(500)
C
C OTHER VARIABLES
C
	DIMENSION NPX(30),X(NX),NPY(30),Y(NY),ALX(30),BEX(30)
	DIMENSION ALY(30),BEY(30),SPX(30),EPX(30),SPY(30),EPY(30)
	DIMENSION WB1(NX),WB2(NX),SIG(NY),SIG2(NY)
	DIMENSION FP1X(30,NY),FP2X(30,NY),FP3X(30,NY),FP4X(30,NY)
	DIMENSION FM1X(30,NY),FM2X(30,NY),FM3X(30,NY),FM4X(30,NY)
	DIMENSION GP1Y(30,NX),GP2Y(30,NX),GP3Y(30,NX),GP4Y(30,NX)
	DIMENSION GM1Y(30,NX),GM2Y(30,NX),GM3Y(30,NX),GM4Y(30,NX)
	DIMENSION DXP2(30,NX),DXP3(30,NX),DXP4(30,NX)
	DIMENSION DXM2(30,NX),DXM3(30,NX),DXM4(30,NX)
	DIMENSION DYP2(30,NY),DYP3(30,NY),DYP4(30,NY)
	DIMENSION DYM2(30,NY),DYM3(30,NY),DYM4(30,NY)
 
C
C VISCOUS VARIABLES
C
	DIMENSION UX(NX,NY),UY(NX,NY),VX(NX,NY),VY(NX,NY),TX(NX,NY)
	DIMENSION TY(NX,NY),FV2(NX,NY),GV2(NX,NY)
	DIMENSION FV3(NX,NY),GV3(NX,NY),FV4(NX,NY),GV4(NX,NY)
	DIMENSION T(NX,NY)
C
C DERIVATIVE OPERATOR
C
	DIMENSION DX(NX,33),DY(NY,33)
	REAL*8 MU0,NX1(NX),NX2(NX),JAC(NX,NY),NY1(NX),NY2(NX)
	REAL*8 KK0,MU,KK,KX,KY,MINLET(NY),GMA
	COMMON /XD1/ FP1,FM1,FP2,FM2,FP3,FM3,FP4,FM4,FP1X,FM1X,FP2X,
     &         FM2X,FP3X,FM3X,FP4X,FM4X,FV2,FV3,FV4,DXP2,DXM2,DXP3,
     &         DXM3,DXP4,DXM4,DX,NPX,ALX,NDX,MXPY
	COMMON /YD1/ GP1,GM1,GP2,GM2,GP3,GM3,GP4,GM4,GP1Y,GM1Y,GP2Y,
     &         GM2Y,GP3Y,GM3Y,GP4Y,GM4Y,GV2,GV3,GV4,DYP2,DYM2,DYP3,
     &         DYM3,DYP4,DYM4,DY,NPY,ALY,NDY,MXPX
	COMMON /BNDRY/ U,V,P,RHO,T,E,AS1,AS2,AS3,AS4,NX1,NY1,NX2,NY2,
     &         SIG,GMA,S0,T0,P0,PE,HOO,RR,MINLET
        COMMON /W_CONST/ TWX_0,TWX_N,TWY_0,TWY_N,UW_0,UW_N,VW_0,VW_N
C
 
C  JRA June 98 - next statement to avoid undefined variable
         ttt=0
	PI=3.141592654D0
	XH=1.0/2.0
	XQ=1.0/4.0
	NX11=1
	MX11=1
	NY11=2
	MY11=1
C --------------------------------------------------------------------
 
   	WRITE (6,*) '        AIRFLOW IN A BOX'
   	WRITE (6,*) '           Version 2.0  '
        WRITE (6,*) '  (c) Hanley Innovations  1995 '
 
C SETUP THE NUMERICS
C
C READ IN CONSTANTS
C
	OPEN(UNIT=9,FILE='datax.inp',STATUS='OLD')
	OPEN(UNIT=10,FILE='datay.inp',STATUS='OLD')
	READ(9,*) FT,sig5,UW_N,MU0,IRS
        READ(9,*) TWX_0,TWX_N,TWY_0,TWY_N,GRAV
	write(6,*) ft,sig5,UW_N,mu0,IRS
        WRITE(6,*) TWX_0, TWX_N, TWY_0, TWY_N, GRAV
	READ(9,*)NDX
	READ(10,*)NDY
	write(6,*) ndx,ndy
	NU=0.0
        PE=1.0
        UW_0=0.0D0
        VW_0=0.0D0
        VW_N=0.0D0
C
C COMPUTE THE DERIVATIVES OPERATOR
C
	write(6,*) ' X-DATA'
	DO 400I=1,NDX
	   READ(9,*) SPX(I),EPX(I),NPX(I)
	   write(6,*) i,spx(i),epx(i),npx(i)
400     CONTINUE
	write(6,*) ' Y-DATA'
	DO 401I=1,NDY
	   READ(10,*) SPY(I),EPY(I),NPY(I)
	   write(6,*) spy(i),epy(i),npy(i)
401     CONTINUE
c	READ(10,*) IDS
	CLOSE(UNIT=9)
	CLOSE(UNIT=10)
        WRITE(6,*) ' ITERATION#  TIME             FINAL',
     &             '          MASS RESIDUAL'
C
C FIND THE LEADING EDGE AND TRAILING EDGE
C
c	 NPS=0
c	 DO 413I=1,IDS
c413        NPS=NPS+NPY(I)+1
c	NPS=NPS+1
c	NPS2=NPS+1
	CALL BOUND(ALX,BEX,SPX,EPX,NDX)
	CALL POINTS(DX,NPX,NDX)
	CALL BOUND(ALY,BEY,SPY,EPY,NDY)
	CALL POINTS(DY,NPY,NDY)
C
C COMPUTE MAXIMUM NUMBER OF POINTS IN X AND Y DIRECTIONS
C
	MXPX=0
	MXPY=0
	DO 2I=1,NDX
	   MXPX=MXPX+NPX(I)+1
2       CONTINUE
	DO 3I=1,NDY
	   MXPY=MXPY+NPY(I)+1
3       CONTINUE
C
C GET X AND Y AT EACH POINT
C
	CALL XX(X,ALX,BEX,NPX,NDX)
	CALL XX(Y,ALY,BEY,NPY,NDY)
C
C SETUP BOUNDARY CONDITION PARAMETERS
C
	CALL GRID6(X,Y,xp1,yp1,XIX,EX,XY,EY,JAC,WB1,WB2,MXPX,MXPY)
c
c find delta x and delta y for local time stepping
c
	do 1101k=1,mxpy
	   ict=0
	   do 1101i=1,ndx
	      do 1101j=1,npx(i)+1
		 ict=ict+1
		 if(j.lt.npx(i)+1) then
		   ddx(ict,k)=xp1(ict+1,k)-xp1(ict,k)
		 else
		   ddx(ict,k)=xp1(ict,k)-xp1(ict-1,k)
		 endif
1101    continue
 
	do 1102k=1,mxpx
	   ict=0
	   do 1102i=1,ndy
	      do 1102j=1,npy(i)+1
		 ict=ict+1
		 if(j.lt.npy(i)+1) then
		   ddy(k,ict)=yp1(k,ict+1)-yp1(k,ict)
		 else
		   ddy(k,ict)=yp1(k,ict)-yp1(k,ict-1)
		 endif
1102    continue
 
	DO 50I=1,MXPX
	   D1=DSQRT(WB1(I)**2+1.)
	   D2=DSQRT(WB2(I)**2+1.)
	   NX1(I)=-WB1(I)/D1
	   NY1(I)=1./D1
	   NX2(I)=-WB2(I)/D2
	   NY2(I)=1./D2
c        WRITE(6,*)I,NX1(I),NY1(I),NX2(I),NY2(I)
50      CONTINUE
	DO 51 I=1,MXPY
	   A=(WB2(1)-WB1(1))/(Y(MXPY)-Y(1))
	   B=WB2(1)-A*Y(MXPY)
	   SIG(I)=(A*Y(I)+B)
C       WRITE(6,*) SIG(I)
51      CONTINUE
	DO 52 I=1,MXPY
	   A=(WB2(MXPX)-WB1(MXPX))/(Y(MXPY)-Y(1))
	   B=WB2(MXPX)-A*Y(MXPY)
	   SIG2(I)=(A*Y(I)+B)
52      CONTINUE
	icn1=0
	icn2=0
C
C END NUMERICS SET UP
C---------------------------------------------------------------------
C
C SET UP THE PHYSICS
C
	GMA=dble(14)/dble(10)
	PI=3.141592654D0
	RR=287.00D0
	CP=GMA*RR/(GMA-1.0D0)
	PR=0.690D0
	KK0=MU0*CP/PR
	T02=272.777777777D0
C
C SET UP INITIAL CONDITIONS
C
	P0=dble(101000)
	RHO0=1.2
	HOO=GMA/(GMA-1)*P0/RHO0
	A0=DSQRT(GMA*P0/RHO0)
	S0=P0/RHO0**GMA
	PE=PE*P0
	T0=P0/(RHO0*RR)
	V0=0.0
	U0=0.0
         D1TMP = ((GMA-1.0)/GMA)
        MINLET(1)=SQRT( ((P0/PE)**D1TMP-1.0) * 2./(GMA-1.0) )
	DO 1231J=1,MXPY
C	   MINLET(J)=SQRT(((P0/PE)**D1TMP-1.0)*2./(GMA-1.0))
            MINLET(J) = MINLET(1)
1231    CONTINUE
	IF(IRS.NE.0) THEN
	  OPEN(UNIT=8,FILE='pres.out',STATUS='OLD')
	  OPEN(UNIT=9,FILE='rho.out',STATUS='OLD')
	  OPEN(UNIT=10,FILE='u.out',STATUS='OLD')
	  OPEN(UNIT=11,FILE='v.out',STATUS='OLD')
	  READ(8,*) IDX,IDY
	  READ(9,*) IDX,IDY
	  READ(10,*) IDX,IDY
	  READ(11,*) IDX,IDY
	 END IF
C
	DO 212 J=1,MXPY
	   DO212 I=1,MXPX
	     IF(IRS.NE.0) THEN
	       READ(8,*) XT,YT,P(I,J)
	       P(I,J)=P(I,J)*P0
	       READ(9,*) XT,YT,RHO(I,J)
	       RHO(I,J)=RHO(I,J)*RHO0
	       READ(10,*) XT,YT,U(I,J)
	       U(I,J)=U(I,J)*A0
	       READ(11,*) XT,YT,V(I,J)
	       V(I,J)=V(I,J)*A0
	      ELSE
	       P(I,J)=PE
	       XM1=(((P0/PE)**((GMA-1.0)/GMA)-1.0)*2./(GMA-1.0)
     &              )**0.5
	       RHO(I,J)=RHO0*(1.+(GMA-1.0)/2.0*XM1**2)**(1./(1.-GMA))
	       C1=A0
	       U(I,J)=XM1*C1
	       V(I,J)=V0
	      END IF
	      T(i,j)=P(I,J)/(RHO(I,J)*RR)
	      E(I,J)=P(I,J)/((GMA-1.)*RHO(I,J))+V(I,J)*V(I,J)/2.
     &               +U(I,J)*U(I,J)/2.0
	      U1(I,J)=RHO(I,J)
	      U2(I,J)=RHO(I,J)*U(I,J)
	      U3(I,J)=RHO(I,J)*V(I,J)
	      U4(I,J)=RHO(I,J)*E(I,J)
	      GXI(i,j)=DSQRT(XIX(I,J)*XIX(I,J)+XY(I,J)*XY(I,J))
	      GE(i,j)=DSQRT(EX(I,J)*EX(I,J)+EY(I,J)*EY(I,J))
212     CONTINUE
	DO 1991I=1,MXPX
	      as1(i)=DSQRT(GMA*P(I,1)/RHO(I,1))
	      as2(i)=DSQRT(GMA*P(I,mxpy)/RHO(I,mxpy))
1991    CONTINUE
	DO 1992 J=1,MXPY
	      as3(j)=DSQRT(GMA*P(1,J)/RHO(1,J))
	      as4(j)=DSQRT(GMA*P(mxpx,J)/RHO(mxpx,J))
1992    CONTINUE
C
	IF(IRS.NE.0) THEN
	   CLOSE(UNIT=8)
	   CLOSE(UNIT=9)
	   CLOSE(UNIT=10)
	   CLOSE(UNIT=11)
	END IF
C
	SO1=P0/RHO0**GMA
	RP0=U0+2.*A0/(GMA-1.)
	RM0=U0-2.*A0/(GMA-1.)
C
C START TIME MARCHING - 2 STEP RUNGE-KUTTA
C
	 it=1
2001     if(ttt.ge.ft) goto 20
	   IF (IT.EQ.1) GOTO 4000
C FIRST STEP
	   DO 4I=1,MXPX
	      DO 4J=1,MXPY
	       U1B(I,J)=U1(I,J)-DTT(I,J)*JAC(I,J)*(F1X(I,J)+G1Y(I,J))
	       U2B(I,J)=U2(I,J)-DTT(I,J)*JAC(I,J)*(F2X(I,J)+G2Y(I,J))
	       U3B(I,J)=U3(I,J)-DTT(I,J)*JAC(I,J)*(F3X(I,J)+G3Y(I,J)-
     &                          RHO(I,J)*GRAV)
	       U4B(I,J)=U4(I,J)-DTT(I,J)*JAC(I,J)*(F4X(I,J)+G4Y(I,J)-
     &                          RHO(I,J)*V(I,J)*GRAV)
4          CONTINUE
C
C FIND THE STATE VARIABLES
C
	   CALL STATE(U1B,U2B,U3B,U4B,U,V,RHO,P,E,T,MXPX,MXPY)
C
C Inlet Conditions
C
 
	    CALL INLET(MY11,MXPY,MX11,U1B,U2B,U3B,U4B,1)
C
C EXIT CONDITIONS
C
	   CALL AEXIT(MY11,MXPY,MXPX,U1B,U2B,U3B,U4B,1)
C
C BOTTOM WALL CONDITIONS FOR SUBSONIC FLOW
C
	   CALL BOTWALL(NX11,MXPX,MY11,MXPX,U1B,U2B,U3B,U4B,1)
C
C TOPWALL  CONDITIONS
C
	   CALL TOPWALL(NX11+1,MXPX-1,MXPY,MXPX,U1B,U2B,U3B,U4B,1)
C
C COMPUTE THE NEW FBAR AND GBAR
C
C
C COMPUTE THE DERIVATIVES FOR THE VISCOUS TERMS
C
	   CALL DERIVX(DX,U,UX,ALX,NPX,NDX,MXPY)
	   CALL DERIVX(DX,V,VX,ALX,NPX,NDX,MXPY)
	   CALL DERIVX(DX,T,TX,ALX,NPX,NDX,MXPY)
C
C TREAT THE INTERFACE POINTS
C
	   IP=0
	   DO 601J=1,NDX-1
	      IP=IP+NPX(J)+1
	      DO 601K=1,MXPY
		 UX(IP,K)=UX(IP+1,K)
		 VX(IP,K)=VX(IP+1,K)
		 TX(IP,K)=TX(IP+1,K)
601        CONTINUE
C
	   CALL DERIVY(DY,U,UY,ALY,NPY,NDY,MXPX)
	   CALL DERIVY(DY,V,VY,ALY,NPY,NDY,MXPX)
	   CALL DERIVY(DY,T,TY,ALY,NPY,NDY,MXPX)
C INTERFACE POINTS
	   IP=0
	   DO 611J=1,NDY-1
	      IP=IP+NPY(J)+1
	      DO 611K=1,MXPX
		 UY(K,IP)=UY(K,IP+1)
		 VY(K,IP)=VY(K,IP+1)
		 TY(K,IP)=TY(K,IP+1)
611        CONTINUE
C
C COMPUTE THE FLUX TERMS
C
	   DO 6I=1,MXPX
	      DO 6J=1,MXPY
c
c compute vanleer fluxes
c
	      AC=DSQRT(GMA*P(I,J)/RHO(I,J))
	      UB=(XIX(I,J)*U(I,J)+XY(I,J)*V(I,J))/GXI(I,J)
	      VB=(EX(I,J)*U(I,J)+EY(I,J)*V(I,J))/GE(I,J)
	      XM=UB/AC
	      YM=VB/AC
	      KX=XIX(I,J)/GXI(I,J)
	      KY=XY(I,J)/GXI(I,J)
	      FMP=(RHO(I,J)*AC*(XM+1.0)**2)*XQ
	      FMM=-(RHO(I,J)*AC*(XM-1.0)**2)*XQ
	      FEP=(-(GMA-1.0)*UB**2+2.0*(GMA-1.0)*UB*AC+2.*AC**2)
     &            /(GMA**2-1.0)+(U(I,J)**2+V(I,J)**2)*XH
	      FEM=(-(GMA-1.0)*UB**2-2.0*(GMA-1.0)*UB*AC+2.*AC**2)
     &            /(GMA**2-1.0)+(U(I,J)**2+V(I,J)**2)*XH
	      FP1(I,J)=GXI(I,J)*FMP/JAC(I,J)
	      FM1(I,J)=GXI(I,J)*FMM/JAC(I,J)
	      FP2(I,J)=FP1(I,J)*(KX*(-UB+2.0*AC)/GMA+U(I,J))
	      FM2(I,J)=FM1(I,J)*(KX*(-UB-2.0*AC)/GMA+U(I,J))
	      FP3(I,J)=FP1(I,J)*(KY*(-UB+2.0*AC)/GMA+V(I,J))
	      FM3(I,J)=FM1(I,J)*(KY*(-UB-2.0*AC)/GMA+V(I,J))
	      FP4(I,J)=FP1(I,J)*FEP
	      FM4(I,J)=FM1(I,J)*FEM
C
C MODIFY FOR SUPERSONIC FLOWS
C
	      IF(XM.GT.1.0) THEN
		 FP1(I,J)=FP1(I,J)+FM1(I,J)
		 FM1(I,J)=0.0
		 FP2(I,J)=FP2(I,J)+FM2(I,J)
		 FM2(I,J)=0.0
		 FP3(I,J)=FP3(I,J)+FM3(I,J)
		 FM3(I,J)=0.0
		 FP4(I,J)=FP4(I,J)+FM4(I,J)
		 FM4(I,J)=0.0
	      END IF
C
	      IF(XM.LT.-1.0) THEN
		 FM1(I,J)=FP1(I,J)+FM1(I,J)
		 FP1(I,J)=0.0
		 FM2(I,J)=FP2(I,J)+FM2(I,J)
		 FP2(I,J)=0.0
		 FM3(I,J)=FP3(I,J)+FM3(I,J)
		 FP3(I,J)=0.0
		 FM4(I,J)=FP4(I,J)+FM4(I,J)
		 FP4(I,J)=0.0
	      END IF
C
	      KX=EX(I,J)/GE(I,J)
	      KY=EY(I,J)/GE(I,J)
	      GMP=(RHO(I,J)*AC*(YM+1.0)**2)*XQ
	      GMM=-(RHO(I,J)*AC*(YM-1.0)**2)*XQ
	      GEP=(-(GMA-1.0)*VB**2+2.0*(GMA-1.0)*VB*AC+2.*AC**2)
     &            /(GMA**2-1.0)+(U(I,J)**2+V(I,J)**2)*XH
	      GEM=(-(GMA-1.0)*VB**2-2.0*(GMA-1.0)*VB*AC+2.*AC**2)
     &            /(GMA**2-1.0)+(U(I,J)**2+V(I,J)**2)*XH
	      GP1(I,J)=GE(I,J)*GMP/JAC(I,J)
	      GM1(I,J)=GE(I,J)*GMM/JAC(I,J)
	      GP2(I,J)=GP1(I,J)*(KX*(-VB+2.0*AC)/GMA+U(I,J))
	      GM2(I,J)=GM1(I,J)*(KX*(-VB-2.0*AC)/GMA+U(I,J))
	      GP3(I,J)=GP1(I,J)*(KY*(-VB+2.0*AC)/GMA+V(I,J))
	      GM3(I,J)=GM1(I,J)*(KY*(-VB-2.0*AC)/GMA+V(I,J))
	      GP4(I,J)=GP1(I,J)*GEP
	      GM4(I,J)=GM1(I,J)*GEM
C
C MODIFY FOR SUPERSONIC FLOWS
C
	      IF(YM.GT.1.0) THEN
		 GP1(I,J)=GP1(I,J)+GM1(I,J)
		 GM1(I,J)=0.0
		 GP2(I,J)=GP2(I,J)+GM2(I,J)
		 GM2(I,J)=0.0
		 GP3(I,J)=GP3(I,J)+GM3(I,J)
		 GM3(I,J)=0.0
		 GP4(I,J)=GP4(I,J)+GM4(I,J)
		 GM4(I,J)=0.0
	      END IF
C
	      IF(YM.LT.-1.0) THEN
		 GM1(I,J)=GP1(I,J)+GM1(I,J)
		 GP1(I,J)=0.0
		 GM2(I,J)=GP2(I,J)+GM2(I,J)
		 GP2(I,J)=0.0
		 GM3(I,J)=GP3(I,J)+GM3(I,J)
		 GP3(I,J)=0.0
		 GM4(I,J)=GP4(I,J)+GM4(I,J)
		 GP4(I,J)=0.0
	      END IF
C
C VISCOUS FLUXES
C
	      MU=MU0*(T(I,J)/T02)**1.5*(T02+110.56)/(T(I,J)+110.56)
	      KK=MU*CP/PR
	      TUXX=2.0/3.0*MU*(2.0*(XIX(I,J)*UX(I,J)+EX(I,J)*UY(I,J))
     &             -(XY(I,J)*VX(I,J)+EY(I,J)*VY(I,J)) )
	      TUYY=2.0/3.0*MU*(2.0*(XY(I,J)*VX(I,J)+EY(I,J)*VY(I,J))
     &             -(XIX(I,J)*UX(I,J)+EX(I,J)*UY(I,J)) )
	      TUXY=MU*(XY(I,J)*UX(I,J)+EY(I,J)*UY(I,J)+XIX(I,J)*VX(I,J)
     &             +EX(I,J)*VY(I,J) )
	      QX=-KK*(XIX(I,J)*TX(I,J)+EX(I,J)*TY(I,J))
	      QY=-KK*(XY(I,J)*TX(I,J)+EY(I,J)*TY(I,J))
	      FV44=U(I,J)*TUXX+V(I,J)*TUXY-QX
	      GV44=U(I,J)*TUXY+V(I,J)*TUYY-QY
C
	      FV2(I,J)=(XIX(I,J)*TUXX+XY(I,J)*TUXY)/JAC(I,J)
	      GV2(I,J)=(EX(I,J)*TUXX+EY(I,J)*TUXY)/JAC(I,J)
	      FV3(I,J)=(XIX(I,J)*TUXY+XY(I,J)*TUYY)/JAC(I,J)
	      GV3(I,J)=(EX(I,J)*TUXY+EY(I,J)*TUYY)/JAC(I,J)
	      FV4(I,J)=(XIX(I,J)*FV44+XY(I,J)*GV44)/JAC(I,J)
	      GV4(I,J)=(EX(I,J)*FV44+EY(I,J)*GV44)/JAC(I,J)
C
C NOW COMPUTE THE MODIFIED FBAR AND GBAR TO TAKE INTO ACCOUNT THE
C TRANSFORMATION
C
	      F1(I,J)=FP1(I,J)+FM1(I,J)
	      F2(I,J)=FP2(I,J)+FM2(I,J)-FV2(I,J)
	      F3(I,J)=FP3(I,J)+FM3(I,J)-FV3(I,J)
	      F4(I,J)=FP4(I,J)+FM4(I,J)-FV4(I,J)
 
	      G1(I,J)=GP1(I,J)+GM1(I,J)
	      G2(I,J)=GP2(I,J)+GM2(I,J)-GV2(I,J)
	      G3(I,J)=GP3(I,J)+GM3(I,J)-GV3(I,J)
	      G4(I,J)=GP4(I,J)+GM4(I,J)-GV4(I,J)
6          CONTINUE
C
C FIND THE DERIVATIVE OF FBAR AND GBAR
C
	   CALL DERIVX(DX,F1,F1BX,ALX,NPX,NDX,MXPY)
	   CALL DERIVX(DX,F2,F2BX,ALX,NPX,NDX,MXPY)
	   CALL DERIVX(DX,F3,F3BX,ALX,NPX,NDX,MXPY)
	   CALL DERIVX(DX,F4,F4BX,ALX,NPX,NDX,MXPY)
C DERIVATIVES AT THE INTERFACE POINTS
C
	   CALL FVSPLTX2
	   IP=0
	   DO 60J=1,NDX-1
	      IP=IP+NPX(J)+1
	      DO 60K=1,MXPY
		 F1BX(IP,K)=FP1X(J,K)+FM1X(J+1,K)
		 F1BX(IP+1,K)=F1BX(IP,K)
		 F2BX(IP,K)=FP2X(J,K)+FM2X(J+1,K)-DXP2(J,K)
		 F2BX(IP+1,K)=F2BX(IP,K)
		 F3BX(IP,K)=FP3X(J,K)+FM3X(J+1,K)-DXP3(J,K)
		 F3BX(IP+1,K)=F3BX(IP,K)
		 F4BX(IP,K)=FP4X(J,K)+FM4X(J+1,K)-DXP4(J,K)
		 F4BX(IP+1,K)=F4BX(IP,K)
60         CONTINUE
C
C REPLACE THE CORRECT FLUX VECTORS AND DERIVATIVES
C
	   CALL DERIVY(DY,G1,G1BY,ALY,NPY,NDY,MXPX)
	   CALL DERIVY(DY,G2,G2BY,ALY,NPY,NDY,MXPX)
	   CALL DERIVY(DY,G3,G3BY,ALY,NPY,NDY,MXPX)
	   CALL DERIVY(DY,G4,G4BY,ALY,NPY,NDY,MXPX)
C
C Y INTERFACE CONDITIONS
C
	   CALL FVSPLTY2
	   IP=0
	   DO 61J=1,NDY-1
	      IP=IP+NPY(J)+1
	      DO 61K=1,MXPX
		 G1BY(K,IP)=GP1Y(J,K)+GM1Y(J+1,K)
		 G1BY(K,IP+1)=G1BY(K,IP)
		 G2BY(K,IP)=GP2Y(J,K)+GM2Y(J+1,K)-DYP2(J,K)
		 G2BY(K,IP+1)=G2BY(K,IP)
		 G3BY(K,IP)=GP3Y(J,K)+GM3Y(J+1,K)-DYP3(J,K)
		 G3BY(K,IP+1)=G3BY(K,IP)
		 G4BY(K,IP)=GP4Y(J,K)+GM4Y(J+1,K)-DYP4(J,K)
		 G4BY(K,IP+1)=G4BY(K,IP)
61         CONTINUE
 
C
C IMPLEMENT THE SECOND STEP OF THE INTEGRATION
C
	   DO 40I=1,MXPX
	      DO 40J=1,MXPY
	      u1o(i,j)=u1(i,j)
	      u2o(i,j)=u2(i,j)
	      u3o(i,j)=u3(i,j)
	      u4o(i,j)=u4(i,j)
	      U1(I,J)=.5*(U1(I,J)-DTT(I,J)*F1BX(I,J)*JAC(I,J)
     &                  +u1b(i,j)-DTT(I,J)*G1BY(I,J)*JAC(I,J))
	      U2(I,J)=.5*(U2(I,J)-DTT(I,J)*F2BX(I,J)*JAC(I,J)
     &                  +u2b(i,j)-DTT(I,J)*G2BY(I,J)*JAC(I,J))
	      U3(I,J)=.5*(U3(I,J)-DTT(I,J)*F3BX(I,J)*JAC(I,J)
     &                  +u3b(i,j)-DTT(I,J)*G3BY(I,J)*JAC(I,J)
     &                  +DTT(I,J)*RHO(I,J)*GRAV*JAC(I,J) )
	      U4(I,J)=.5*(U4(I,J)-DTT(I,J)*F4BX(I,J)*JAC(I,J)
     &                  +u4b(i,j)-DTT(I,J)*G4BY(I,J)*JAC(I,J)
     &                  -DTT(I,J)*RHO(I,J)*V(I,J)*GRAV*JAC(I,J) )
40         CONTINUE
C
C FIND STATE VARIABLES AGAIN:
C
	   CALL STATE(U1,U2,U3,U4,U,V,RHO,P,E,T,MXPX,MXPY)
 
C
C Inlet Conditions
C
 
	    CALL INLET(MY11,MXPY,MX11,U1,U2,U3,U4,1)
C
C EXIT CONDITIONS
C
	   CALL AEXIT(MY11,MXPY,MXPX,U1,U2,U3,U4,1)
C
C BOTTOM WALL CONDITIONS FOR SUBSONIC FLOW
C
	   CALL BOTWALL(NX11,MXPX,MY11,MXPX,U1,U2,U3,U4,1)
C
C TOPWALL  CONDITIONS
C
	   CALL TOPWALL(NX11+1,MXPX-1,MXPY,MXPX,U1,U2,U3,U4,1)
C
C UPDATE THE FLUX VECTORS
C
C COMPUTE THE DERIVATIVES FOR THE VISCOUS TERMS
C
4000       CALL DERIVX(DX,U,UX,ALX,NPX,NDX,MXPY)
	   CALL DERIVX(DX,V,VX,ALX,NPX,NDX,MXPY)
	   CALL DERIVX(DX,T,TX,ALX,NPX,NDX,MXPY)
C
C TREAT THE INTERFACE POINTS
C
	   IP=0
	   DO 602J=1,NDX-1
	      IP=IP+NPX(J)+1
	      DO 602K=1,MXPY
		 UX(IP,K)=UX(IP+1,K)
		 VX(IP,K)=VX(IP+1,K)
		 TX(IP,K)=TX(IP+1,K)
602        CONTINUE
C
	   CALL DERIVY(DY,U,UY,ALY,NPY,NDY,MXPX)
	   CALL DERIVY(DY,V,VY,ALY,NPY,NDY,MXPX)
	   CALL DERIVY(DY,T,TY,ALY,NPY,NDY,MXPX)
C INTERFACE POINTS
	   IP=0
	   DO 612J=1,NDY-1
	      IP=IP+NPY(J)+1
	      DO 612K=1,MXPX
		 UY(K,IP)=UY(K,IP+1)
		 VY(K,IP)=VY(K,IP+1)
		 TY(K,IP)=TY(K,IP+1)
612        CONTINUE
C
C COMPUTE THE FLUX TERMS
	   DO 8I=1,MXPX
	      DO 8J=1,MXPY
c
c compute vanleer fluxes
c
	      AC=DSQRT(GMA*P(I,J)/RHO(I,J))
	      UB=(XIX(I,J)*U(I,J)+XY(I,J)*V(I,J))/GXI(I,J)
	      VB=(EX(I,J)*U(I,J)+EY(I,J)*V(I,J))/GE(I,J)
	      XM=UB/AC
	      YM=VB/AC
	      KX=XIX(I,J)/GXI(I,J)
	      KY=XY(I,J)/GXI(I,J)
	      FMP=(RHO(I,J)*AC*(XM+1.0)**2)*XQ
	      FMM=-(RHO(I,J)*AC*(XM-1.0)**2)*XQ
	      FEP=(-(GMA-1.0)*UB**2+2.0*(GMA-1.0)*UB*AC+2.*AC**2)
     &            /(GMA**2-1.0)+(U(I,J)**2+V(I,J)**2)*XH
	      FEM=(-(GMA-1.0)*UB**2-2.0*(GMA-1.0)*UB*AC+2.*AC**2)
     &            /(GMA**2-1.0)+(U(I,J)**2+V(I,J)**2)*XH
	      FP1(I,J)=GXI(I,J)*FMP/JAC(I,J)
	      FM1(I,J)=GXI(I,J)*FMM/JAC(I,J)
	      FP2(I,J)=FP1(I,J)*(KX*(-UB+2.0*AC)/GMA+U(I,J))
	      FM2(I,J)=FM1(I,J)*(KX*(-UB-2.0*AC)/GMA+U(I,J))
	      FP3(I,J)=FP1(I,J)*(KY*(-UB+2.0*AC)/GMA+V(I,J))
	      FM3(I,J)=FM1(I,J)*(KY*(-UB-2.0*AC)/GMA+V(I,J))
	      FP4(I,J)=FP1(I,J)*FEP
	      FM4(I,J)=FM1(I,J)*FEM
C
C MODIFY OF SUPERSONIC FLOWS
C
	      IF(XM.GT.1.0) THEN
		 FP1(I,J)=FP1(I,J)+FM1(I,J)
		 FM1(I,J)=0.0
		 FP2(I,J)=FP2(I,J)+FM2(I,J)
		 FM2(I,J)=0.0
		 FP3(I,J)=FP3(I,J)+FM3(I,J)
		 FM3(I,J)=0.0
		 FP4(I,J)=FP4(I,J)+FM4(I,J)
		 FM4(I,J)=0.0
	      END IF
C
	      IF(XM.LT.-1.0) THEN
		 FM1(I,J)=FP1(I,J)+FM1(I,J)
		 FP1(I,J)=0.0
		 FM2(I,J)=FP2(I,J)+FM2(I,J)
		 FP2(I,J)=0.0
		 FM3(I,J)=FP3(I,J)+FM3(I,J)
		 FP3(I,J)=0.0
		 FM4(I,J)=FP4(I,J)+FM4(I,J)
		 FP4(I,J)=0.0
	      END IF
C
	      KX=EX(I,J)/GE(I,J)
	      KY=EY(I,J)/GE(I,J)
	      GMP=(RHO(I,J)*AC*(YM+1.0)**2)*XQ
	      GMM=-(RHO(I,J)*AC*(YM-1.0)**2)*XQ
	      GEP=(-(GMA-1.0)*VB**2+2.0*(GMA-1.0)*VB*AC+2.*AC**2)
     &            /(GMA**2-1.0)+(U(I,J)**2+V(I,J)**2)*XH
	      GEM=(-(GMA-1.0)*VB**2-2.0*(GMA-1.0)*VB*AC+2.*AC**2)
     &            /(GMA**2-1.0)+(U(I,J)**2+V(I,J)**2)*XH
	      GP1(I,J)=GE(I,J)*GMP/JAC(I,J)
	      GM1(I,J)=GE(I,J)*GMM/JAC(I,J)
	      GP2(I,J)=GP1(I,J)*(KX*(-VB+2.0*AC)/GMA+U(I,J))
	      GM2(I,J)=GM1(I,J)*(KX*(-VB-2.0*AC)/GMA+U(I,J))
	      GP3(I,J)=GP1(I,J)*(KY*(-VB+2.0*AC)/GMA+V(I,J))
	      GM3(I,J)=GM1(I,J)*(KY*(-VB-2.0*AC)/GMA+V(I,J))
	      GP4(I,J)=GP1(I,J)*GEP
	      GM4(I,J)=GM1(I,J)*GEM
C
C MODIFY for SUPERSONIC FLOWS
C
	      IF(YM.GT.1.0) THEN
		 GP1(I,J)=GP1(I,J)+GM1(I,J)
		 GM1(I,J)=0.0
		 GP2(I,J)=GP2(I,J)+GM2(I,J)
		 GM2(I,J)=0.0
		 GP3(I,J)=GP3(I,J)+GM3(I,J)
		 GM3(I,J)=0.0
		 GP4(I,J)=GP4(I,J)+GM4(I,J)
		 GM4(I,J)=0.0
	      END IF
C
	      IF(YM.LT.-1.0) THEN
		 GM1(I,J)=GP1(I,J)+GM1(I,J)
		 GP1(I,J)=0.0
		 GM2(I,J)=GP2(I,J)+GM2(I,J)
		 GP2(I,J)=0.0
		 GM3(I,J)=GP3(I,J)+GM3(I,J)
		 GP3(I,J)=0.0
		 GM4(I,J)=GP4(I,J)+GM4(I,J)
		 GP4(I,J)=0.0
	      END IF
C
C VISCOUS FLUXES
C
	      MU=MU0*(T(I,J)/T02)**1.5*(T02+110.56)/(T(I,J)+110.56)
	      xmu(i,j)=mu
	      KK=MU*CP/PR
	      TUXX=2.0/3.0*MU*(2.0*(XIX(I,J)*UX(I,J)+EX(I,J)*UY(I,J))
     &             -(XY(I,J)*VX(I,J)+EY(I,J)*VY(I,J)) )
	      TUYY=2.0/3.0*MU*(2.0*(XY(I,J)*VX(I,J)+EY(I,J)*VY(I,J))
     &             -(XIX(I,J)*UX(I,J)+EX(I,J)*UY(I,J)) )
	      TUXY=MU*(XY(I,J)*UX(I,J)+EY(I,J)*UY(I,J)+XIX(I,J)*VX(I,J)
     &             +EX(I,J)*VY(I,J) )
	      QX=-KK*(XIX(I,J)*TX(I,J)+EX(I,J)*TY(I,J))
	      QY=-KK*(XY(I,J)*TX(I,J)+EY(I,J)*TY(I,J))
	      FV44=U(I,J)*TUXX+V(I,J)*TUXY-QX
	      GV44=U(I,J)*TUXY+V(I,J)*TUYY-QY
C
	      FV2(I,J)=(XIX(I,J)*TUXX+XY(I,J)*TUXY)/JAC(I,J)
	      GV2(I,J)=(EX(I,J)*TUXX+EY(I,J)*TUXY)/JAC(I,J)
	      FV3(I,J)=(XIX(I,J)*TUXY+XY(I,J)*TUYY)/JAC(I,J)
	      GV3(I,J)=(EX(I,J)*TUXY+EY(I,J)*TUYY)/JAC(I,J)
	      FV4(I,J)=(XIX(I,J)*FV44+XY(I,J)*GV44)/JAC(I,J)
	      GV4(I,J)=(EX(I,J)*FV44+EY(I,J)*GV44)/JAC(I,J)
C
C NOW COMPUTE THE MODIFIED FBAR AND GBAR TO TAKE INTO ACCOUNT THE
C TRANSFORMATION
C
	      F1(I,J)=FP1(I,J)+FM1(I,J)
	      F2(I,J)=FP2(I,J)+FM2(I,J)-FV2(I,J)
	      F3(I,J)=FP3(I,J)+FM3(I,J)-FV3(I,J)
	      F4(I,J)=FP4(I,J)+FM4(I,J)-FV4(I,J)
 
	      G1(I,J)=GP1(I,J)+GM1(I,J)
	      G2(I,J)=GP2(I,J)+GM2(I,J)-GV2(I,J)
	      G3(I,J)=GP3(I,J)+GM3(I,J)-GV3(I,J)
	      G4(I,J)=GP4(I,J)+GM4(I,J)-GV4(I,J)
8          CONTINUE
 
	   CALL DERIVX(DX,F1,F1X,ALX,NPX,NDX,MXPY)
	   CALL DERIVX(DX,F2,F2X,ALX,NPX,NDX,MXPY)
	   CALL DERIVX(DX,F3,F3X,ALX,NPX,NDX,MXPY)
	   CALL DERIVX(DX,F4,F4X,ALX,NPX,NDX,MXPY)
C
C INTERFACE CONDITIONS; CORRECT CHARACTERISITIC VARIABLES AT INTERFACE
C
	   CALL FVSPLTX2
C
	   IP=0
	   DO 62J=1,NDX-1
	      IP=IP+NPX(J)+1
	      DO 62K=1,MXPY
		 F1X(IP,K)=FP1X(J,K)+FM1X(J+1,K)
		 F1X(IP+1,K)=F1X(IP,K)
		 F2X(IP,K)=FP2X(J,K)+FM2X(J+1,K)-DXP2(J,K)
		 F2X(IP+1,K)=F2X(IP,K)
		 F3X(IP,K)=FP3X(J,K)+FM3X(J+1,K)-DXP3(J,K)
		 F3X(IP+1,K)=F3X(IP,K)
		 F4X(IP,K)=FP4X(J,K)+FM4X(J+1,K)-DXP4(J,K)
		 F4X(IP+1,K)=F4X(IP,K)
62         CONTINUE
 
	   CALL DERIVY(DY,G1,G1Y,ALY,NPY,NDY,MXPX)
	   CALL DERIVY(DY,G2,G2Y,ALY,NPY,NDY,MXPX)
	   CALL DERIVY(DY,G3,G3Y,ALY,NPY,NDY,MXPX)
	   CALL DERIVY(DY,G4,G4Y,ALY,NPY,NDY,MXPX)
C
C Y INTERFACE CONDITIONS
C
	   CALL FVSPLTY2
C
	   IP=0
	   DO 63J=1,NDY-1
	      IP=IP+NPY(J)+1
	      DO 63K=1,MXPX
		 G1Y(K,IP)=GP1Y(J,K)+GM1Y(J+1,K)
		 G1Y(K,IP+1)=G1Y(K,IP)
		 G2Y(K,IP)=GP2Y(J,K)+GM2Y(J+1,K)-DYP2(J,K)
		 G2Y(K,IP+1)=G2Y(K,IP)
		 G3Y(K,IP)=GP3Y(J,K)+GM3Y(J+1,K)-DYP3(J,K)
		 G3Y(K,IP+1)=G3Y(K,IP)
		 G4Y(K,IP)=GP4Y(J,K)+GM4Y(J+1,K)-DYP4(J,K)
		 G4Y(K,IP+1)=G4Y(K,IP)
63         CONTINUE
C
C FIND THE LOCAL TIME STEPS
C
	   dt=100
	   DO 1235I=1,MXPX
	      DO 1235J=1,MXPY
		 AS=DSQRT(P(I,J)/RHO(I,J)*GMA)
		 rdltx=rho(i,j)*dabs(u(i,j))*ddx(i,j)/xmu(i,j)
		 rdlty=rho(i,j)*dabs(v(i,j))*ddy(i,j)/xmu(i,j)
		 if(rdltx.le.rdlty) then
		    rdlt=rdltx
		 else
		    rdlt=rdlty
		 endif
		 dxiv=as*dsqrt(1.0/ddx(i,j)**2+1./ddy(i,j)**2)
		 dtcfl=1./(dabs(u(i,j))/ddx(i,j)+dabs(v(i,j))/ddy(i,j)
     &                 +dxiv)
c                 if (rdlt.gt.0) then
c                 dtt(i,j)=sig5*dtcfl/(1.0+2.0/rdlt)
c                 else
		 dtt(i,j)=sig5*dtcfl
c                 endif
		 if(dtt(i,j).le.dt) dt=dtt(i,j)
c        write(6,*) dtt(i,j),ddx(i,j),as,u(i,j),v(i,j)
1235       continue
	   ttt=ttt+dt
	   it=it+1
	   if (dt.eq.0.) then
	      write(6,*) ' a zero delta time was detected'
	      goto 20
	   endif
c
c find the local subdomain time
c
	   minx=1
	   maxx=0
	   miny=1
	   maxy=0
	   do 1236ix=1,ndx
	      maxx=maxx+npx(ix)+1
	      miny=1
	      maxy=0
	      do 1237iy=1,ndy
		 maxy=maxy+npy(iy)+1
		 dtd=100.0
		 do1238i=minx,maxx
		   do1238j=miny,maxy
		     if(dtt(i,j).le.dtd) dtd=dtt(i,j)
 1238            continue
		 do 1239i=minx,maxx
		    do1239j=miny,maxy
		      dtt(i,j)=dtd
1239             continue
		 miny=miny+npy(iy)+1
1237          continue
		 minx=minx+npx(ix)+1
1236       continue
c
c change the interface points
c
	   IP=0
	   DO 6122J=1,NDX-1
	      IP=IP+NPX(J)+1
	      DO 6122K=1,MXPY
c                  if(dtt(ip+1,k).le.dtt(ip,k)) then
c                    dtt(ip,k)=dtt(ip+1,k)
		   dtt(IP,K)=(dtt(IP+1,K)+dtt(ip,k))/2.0
c                  else
		    dtt(ip+1,k)=dtt(ip,k)
c                  endif
6122        CONTINUE
	   IP=0
	   DO 6121J=1,NDY-1
	      IP=IP+NPY(J)+1
	      DO 6121K=1,MXPX
c        write(6,*) j,k,dtt(k,ip+1),dtt(k,ip)
c                  if(dtt(k,ip+1).le.dtt(k,ip) ) then
c                    dtt(k,ip)=dtt(k,ip+1)
		   dtt(K,IP)=(dtt(K,IP+1)+dtt(k,ip))/2.0
c                  else
		    dtt(k,ip+1)=dtt(k,ip)
c                  endif
6121        CONTINUE
c
c convergence history
c
	    icn2=icn2+1
	    kwrt=ft/dt/200.
	    if(icn2.ge.kwrt) then
	      icn1=icn1+1
	      icn2=0
	      iter1(icn1)=it
	     CON1=0.0
	     DO 9892 I=1,MXPX
		DO 9892 J=1,MXPY
		   CON1=CON1+DABS(U1(I,J)-U1o(I,J))/DTt(i,j)
9892         CONTINUE
	     CON1=DLOG10(CON1/dble(MXPY*MXPX))
	     conv1(icn1)=con1
             write(6,2121) it,ttt,ft,con1
2121         format(1x,I8,2x,f16.12,2x,f11.8,2x,f10.6)
	     end if
C
	goto 2001
C
C END TIME MARCHING
C
20      CONTINUE
4001    continue
	write(6,*) 'deltat, final t, iterations'
	write(6,*) dt,ttt,it
C
C  CHECK FOR CONVERGENCE
C
	CON1=0.0
	CON2=0.0
	CON3=0.0
	CON4=0.0
	DO 9891 I=1,MXPX
	   DO 9891 J=1,MXPY
	      CON1=CON1+DABS(U1(I,J)-U1o(I,J))/DTt(i,j)
	      CON2=CON2+DABS(U2(I,J)-U2o(I,J))/DTt(i,j)
	      CON3=CON3+DABS(U3(I,J)-U3o(I,J))/DTt(i,j)
	      CON4=CON4+DABS(U4(I,J)-U4o(I,J))/DTt(i,j)
9891    CONTINUE
	CON1=DLOG10(CON1/dble(MXPY*MXPX))
	CON2=DLOG10(CON2/dble(MXPY*MXPX))
	CON3=DLOG10(CON3/dble(MXPY*MXPX))
	CON4=DLOG10(CON4/dble(MXPY*MXPX))
C
C DISPLAY THE RESULTS
C
	OPEN(UNIT=8,FILE='mach.out',STATUS='UNKNOWN')
	OPEN(UNIT=7,FILE='pres.out',STATUS='UNKNOWN')
	OPEN(UNIT=9,FILE='rho.out',STATUS='UNKNOWN')
	OPEN(UNIT=11,FILE='totp.out',STATUS='UNKNOWN')
	OPEN(UNIT=12,FILE='u.out',STATUS='UNKNOWN')
	open(unit=13,file='v.out',status='unknown')
	OPEN(UNIT=14,FILE='conv.out',status='unknown')
	open(unit=16,file='sl.out',status='unknown')
c	open(unit=17,file='chist.out',status='unknown')
        print * , 'AIR Output ================================='
	do 9893i=1,icn1
	   write(*,*) iter1(i),conv1(i)
 9893   continue
c	close(unit=17)
	write(16,*) ' VARIABLES=X,Y,U,V,PRES,RHO,TEMP,TOTP,VORT'
	write(16,*) ' ZONE   I=', MXPX, ' , J=', MXPY
 
	WRITE(14,*) CON1
	WRITE(14,*) CON2
	WRITE(14,*) CON3
	WRITE(14,*) CON4
	CLOSE(UNIT=14)
	WRITE(7,*) MXPX,MXPY
	WRITE(8,*) MXPX,MXPY
	WRITE(9,*) MXPX,MXPY
	write(13,*) mxpx,mxpy
	write(12,*)mxpx,mxpy
	WRITE(11,*) MXPX,MXPY
	DO 99JJ=1,MXPY
	DO 99I=1,MXPX
	XMA=DSQRT(RHO(I,JJ)*(U(I,JJ)**2+V(I,JJ)**2)/(GMA*P(I,JJ)))
	WRITE(9,*) Xp1(I,jj), Yp1(i,JJ),RHO(I,JJ)/RHO0
	WRITE(7,*) Xp1(I,jj), yp1(i,JJ), P(I,JJ)/P0
	WRITE(8,*)Xp1(I,jj),Yp1(i,JJ),DSQRT(RHO(I,JJ)*(U(I,JJ)**2+
     &       v(i,jj)**2) /(GMA*P(I,JJ)))
	PTOT=P(I,JJ)*(1.+(GMA-1.)*XMA**2/2.)**(GMA/(GMA-1.))/P0
	WRITE(11,*)Xp1(I,jj),Yp1(i,JJ),PTOT
	write(12,*) xp1(i,jj),yp1(i,jj),u(i,jj)/A0
	write(13,*) xp1(i,jj),yp1(i,jj),v(i,jj)/A0
	VORT=VX(I,JJ)-UY(I,JJ)
	WRITE(16,*) XP1(I,JJ),YP1(I,JJ),U(I,JJ),V(I,JJ),P(I,JJ),
     &              RHO(I,JJ),T(I,JJ),PTOT,VORT
99      CONTINUE
	close(unit=13)
	close(unit=12)
	CLOSE(UNIT=11)
	CLOSE(UNIT=9)
	CLOSE(UNIT=8)
	CLOSE(UNIT=16)
	CLOSE(UNIT=7)
	STOP
	END
C
C SUBROUTINE TO DECODE THE STATE VARIABLES
C
 
	SUBROUTINE STATE(U1,U2,U3,U4,U,V,RHO,P,E,T,MX,MY)
	IMPLICIT REAL*8 (A-H,O-Z)
	PARAMETER(NX=50,NY=50)
	DIMENSION U(NX,NY),RHO(NX,NY),V(NX,NY),E(NX,NY)
	DIMENSION P(NX,NY),U1(NX,NY),U2(NX,NY),U3(NX,NY)
	DIMENSION U4(NX,NY),T(NX,NY)
	GMA=dble(14)/dble(10)
	ONE=dble(1)
	P5=dble(5)/dble(10)
	GCN=(GMA-ONE)
	RR=287.0
	DO 2I=1,MX
	   DO 2J=1,MY
	      RHO(I,J)=U1(I,J)
	      E(I,J)=U4(I,J)/U1(I,J)
	      U(I,J)=U2(I,J)/U1(I,J)
	      V(I,J)=U3(I,J)/U1(I,J)
	      P(I,J)=GCN*RHO(I,J)*(E(I,J)-P5*(V(I,J)*V(I,J)
     &               +U(I,J)*U(I,J)))
	      T(I,J)=P(I,J)/(RHO(I,J)*RR)
c          WRITE(6,*) U(I,J),V(I,J),I,J
2       CONTINUE
C       WRITE(6,*)
	RETURN
	END
c
c other routines
c
 	  SUBROUTINE SPECTOP(DR,N)
	  IMPLICIT REAL*8(A-H,O-Z)
	  DIMENSION D1(0:32,0:32),DR(0:32,0:32),X(0:32)
	  REAL*8 DR
C
C PROGRAM TO COMPUTE THE CHEBYSHEV SPECTRAL OPERATOR
C	
	  ANG=dble(1)
	  s=dble(6)
	  o=dble(1)
	  t=dble(2)
	  PI=t*DASIN(ANG)
	  DO 2I=0,N
	     X(I)=DCOS(PI*dble(I)/dble(N))
2	  CONTINUE
C
C IF J=K
C
	  DO 4J=1,N-1
	     D1(J,J)=-X(J)/(t*(o-X(J)**2))
4	  CONTINUE
	  D1(0,0)=(t*dble(N)**2+o)/s
	  D1(N,N)=-D1(0,0)
C
C IF J.NE.K
C
	  FCTR1=1.0D0
	  DO 6K=0,N
	     CK=1.0D0
	     IF (K.EQ.0) CK=t
	     IF (K.EQ.N) CK=t
	     FCTR2=o
             DO 8J=0,N
		CJ=o
	        IF(J.EQ.0) CJ=t
		IF(J.EQ.N) CJ=t
		   FCTR=FCTR1*FCTR2
		   IF(J.NE.K)THEN
		     D1(K,J)=CK*FCTR/(CJ*(X(K)-X(J)))
		   END IF
		   FCTR2=-o*FCTR2
8		CONTINUE
		FCTR1=-o*FCTR1
6	  CONTINUE
	  DO 10K=0,N
	     DO 10J=0,N
	        DR(K,J)=D1(N-K,N-J)
10	  CONTINUE
	  RETURN
	  END
C
C PROGRAM TO FIND THE BOUNDARIES OF EACH DOMAIN
C
	SUBROUTINE BOUND(AL,BE,X1,X2,ND)
	IMPLICIT REAL*8(A-H,O-Z)
	DIMENSION AL(30),BE(30),X1(30),X2(30)
	t=dble(2)
	o=dble(1)
	DO 3J=1,ND
	   AL(J)=-t/(X1(J)-X2(J))
	   BE(J)=o-X2(J)*AL(J)
3	CONTINUE
	RETURN
	END
C
C SUBROUTINE TO FIND THE NUMBER OF POINTS IN EACH DOMAIN, THEN FIND
C THE DERIVATIVE OPERATOR
C
	SUBROUTINE POINTS(D,NP,ND)
	IMPLICIT REAL*8(A-H,O-Z)
	PARAMETER (NX=50,NY=50)
	DIMENSION D(NX,33),NP(30),DD(0:32,0:32)
	JMIN=1
	JMAX=0
	DO 2I=1,ND
C
C COMPUTE THE DERIVATIVE FOR EACH DOMAIN
C
	   CALL SPECTOP(DD,NP(I))
	   JMAX=JMAX+NP(I)+1
	   DO 4J=JMIN,JMAX
	      DO 4K=1,NP(I)+1
		 D(J,K)=DD(J-JMIN,K-1)
4         CONTINUE
	   JMIN=JMIN+NP(I)+1
2      CONTINUE
	RETURN
	END
 
C
C SUBROUTINE TO COMPUTE THE DERIVATIVES
C
	SUBROUTINE FVSPLTX2
        IMPLICIT REAL*8(A-H,O-Z)
	PARAMETER (NX=50,NY=50)
	DIMENSION DX(NX,33),ALX(30),NPX(30)
	DIMENSION FP1(NX,NY),FM1(NX,NY),FP1X(30,NX),FM1X(30,NX)
	DIMENSION FP2(NX,NY),FM2(NX,NY),FP2X(30,NX),FM2X(30,NX)
	DIMENSION FP3(NX,NY),FM3(NX,NY),FP3X(30,NX),FM3X(30,NX)
	DIMENSION FP4(NX,NY),FM4(NX,NY),FP4X(30,NX),FM4X(30,NX)
	DIMENSION FV2(NX,NY),DXP2(30,NX),DXM2(30,NX)
	DIMENSION FV3(NX,NY),DXP3(30,NX),DXM3(30,NX)
	DIMENSION FV4(NX,NY),DXP4(30,NX),DXM4(30,NX)
	COMMON /XD1/ FP1,FM1,FP2,FM2,FP3,FM3,FP4,FM4,FP1X,FM1X,FP2X,
     &         FM2X,FP3X,FM3X,FP4X,FM4X,FV2,FV3,FV4,DXP2,DXM2,DXP3,
     &         DXM3,DXP4,DXM4,DX,NPX,ALX,NDX,MXPY
 
 
	DO 30 IK=1,MXPY
	JMAX=0
	JMIN=1
	DO 2I=1,NDX
	   JMAX=JMAX+NPX(I)+1
C
C INITIALIZE
C
	   FP1X(I,IK)=0.
	   FM1X(I,IK)=0.
	   FP2X(I,IK)=0.
	   FM2X(I,IK)=0.
	   FP3X(I,IK)=0.
	   FM3X(I,IK)=0.
	   FP4X(I,IK)=0.
	   FM4X(I,IK)=0.
	   DXP2(I,IK)=0.
	   DXM2(I,IK)=0.
	   DXP3(I,IK)=0.
	   DXM3(I,IK)=0.
	   DXP4(I,IK)=0.
	   DXM4(I,IK)=0.
	   DO 3K=0,NPX(I)
	      JK=JMIN+K
	      FP1X(I,IK)=FP1X(I,IK)+DX(JMAX,K+1)*FP1(JK,IK)
	      FM1X(I,IK)=FM1X(I,IK)+DX(JMIN,K+1)*FM1(JK,IK)
	      FP2X(I,IK)=FP2X(I,IK)+DX(JMAX,K+1)*FP2(JK,IK)
	      FM2X(I,IK)=FM2X(I,IK)+DX(JMIN,K+1)*FM2(JK,IK)
	      FP3X(I,IK)=FP3X(I,IK)+DX(JMAX,K+1)*FP3(JK,IK)
	      FM3X(I,IK)=FM3X(I,IK)+DX(JMIN,K+1)*FM3(JK,IK)
	      FP4X(I,IK)=FP4X(I,IK)+DX(JMAX,K+1)*FP4(JK,IK)
	      FM4X(I,IK)=FM4X(I,IK)+DX(JMIN,K+1)*FM4(JK,IK)
	      DXP2(I,IK)=DXP2(I,IK)+DX(JMAX,K+1)*FV2(JK,IK)
	      DXM2(I,IK)=DXM2(I,IK)+DX(JMIN,K+1)*FV2(JK,IK)
	      DXP3(I,IK)=DXP3(I,IK)+DX(JMAX,K+1)*FV3(JK,IK)
	      DXM3(I,IK)=DXM3(I,IK)+DX(JMIN,K+1)*FV3(JK,IK)
	      DXP4(I,IK)=DXP4(I,IK)+DX(JMAX,K+1)*FV4(JK,IK)
	      DXM4(I,IK)=DXM4(I,IK)+DX(JMIN,K+1)*FV4(JK,IK)
3          CONTINUE
	      FP1X(I,IK)=FP1X(I,IK)*ALX(I)
	      FM1X(I,IK)=FM1X(I,IK)*ALX(I)
	      FP2X(I,IK)=FP2X(I,IK)*ALX(I)
	      FM2X(I,IK)=FM2X(I,IK)*ALX(I)
	      FP3X(I,IK)=FP3X(I,IK)*ALX(I)
	      FM3X(I,IK)=FM3X(I,IK)*ALX(I)
	      FP4X(I,IK)=FP4X(I,IK)*ALX(I)
	      FM4X(I,IK)=FM4X(I,IK)*ALX(I)
	      DXP2(I,IK)=DXP2(I,IK)*ALX(I)
	      DXM2(I,IK)=DXM2(I,IK)*ALX(I)
	      DXP3(I,IK)=DXP3(I,IK)*ALX(I)
	      DXM3(I,IK)=DXM3(I,IK)*ALX(I)
	      DXP4(I,IK)=DXP4(I,IK)*ALX(I)
	      DXM4(I,IK)=DXM4(I,IK)*ALX(I)
	   JMIN=JMIN+NPX(I)+1
2      CONTINUE
30     CONTINUE
	RETURN
	END
C
C SUBROUTINE TO COMPUTE THE DERIVATIVES
C
	SUBROUTINE FVSPLTY2
	IMPLICIT REAL*8(A-H,O-Z)
	PARAMETER (NX=50,NY=50)
	DIMENSION DY(NX,33),ALY(30),NPY(30)
	DIMENSION GP1(NX,NY),GM1(NX,NY),GP1Y(30,NY),GM1Y(30,NY)
	DIMENSION GP2(NX,NY),GM2(NX,NY),GP2Y(30,NY),GM2Y(30,NY)
	DIMENSION GP3(NX,NY),GM3(NX,NY),GP3Y(30,NY),GM3Y(30,NY)
	DIMENSION GP4(NX,NY),GM4(NX,NY),GP4Y(30,NY),GM4Y(30,NY)
	DIMENSION GV2(NX,NY),DYP2(30,NY),DYM2(30,NY)
	DIMENSION GV3(NX,NY),DYP3(30,NY),DYM3(30,NY)
	DIMENSION GV4(NX,NY),DYP4(30,NY),DYM4(30,NY)
	COMMON /YD1/ GP1,GM1,GP2,GM2,GP3,GM3,GP4,GM4,GP1Y,GM1Y,GP2Y,
     &         GM2Y,GP3Y,GM3Y,GP4Y,GM4Y,GV2,GV3,GV4,DYP2,DYM2,DYP3,
     &         DYM3,DYP4,DYM4,DY,NPY,ALY,NDY,MXPX
	DO 30 JK=1,MXPX
	JMAX=0
	JMIN=1
	DO 2I=1,NDY
	   JMAX=JMAX+NPY(I)+1
C
C INITIALIZE
C
	   GP1Y(I,JK)=0.
	   GM1Y(I,JK)=0.
	   GP2Y(I,JK)=0.
	   GM2Y(I,JK)=0.
	   GP3Y(I,JK)=0.
	   GM3Y(I,JK)=0.
	   GP4Y(I,JK)=0.
	   GM4Y(I,JK)=0.
	   DYP2(I,JK)=0.
	   DYM2(I,JK)=0.
	   DYP3(I,JK)=0.
	   DYM3(I,JK)=0.
	   DYP4(I,JK)=0.
	   DYM4(I,JK)=0.
	   DO 3K=0,NPY(I)
	      IK=JMIN+K
	      GP1Y(I,JK)=GP1Y(I,JK)+DY(JMAX,K+1)*GP1(JK,IK)
	      GM1Y(I,JK)=GM1Y(I,JK)+DY(JMIN,K+1)*GM1(JK,IK)
	      GP2Y(I,JK)=GP2Y(I,JK)+DY(JMAX,K+1)*GP2(JK,IK)
	      GM2Y(I,JK)=GM2Y(I,JK)+DY(JMIN,K+1)*GM2(JK,IK)
	      GP3Y(I,JK)=GP3Y(I,JK)+DY(JMAX,K+1)*GP3(JK,IK)
	      GM3Y(I,JK)=GM3Y(I,JK)+DY(JMIN,K+1)*GM3(JK,IK)
	      GP4Y(I,JK)=GP4Y(I,JK)+DY(JMAX,K+1)*GP4(JK,IK)
	      GM4Y(I,JK)=GM4Y(I,JK)+DY(JMIN,K+1)*GM4(JK,IK)
	      DYP2(I,JK)=DYP2(I,JK)+DY(JMAX,K+1)*GV2(JK,IK)
	      DYM2(I,JK)=DYM2(I,JK)+DY(JMIN,K+1)*GV2(JK,IK)
	      DYP3(I,JK)=DYP3(I,JK)+DY(JMAX,K+1)*GV3(JK,IK)
	      DYM3(I,JK)=DYM3(I,JK)+DY(JMIN,K+1)*GV3(JK,IK)
	      DYP4(I,JK)=DYP4(I,JK)+DY(JMAX,K+1)*GV4(JK,IK)
	      DYM4(I,JK)=DYM4(I,JK)+DY(JMIN,K+1)*GV4(JK,IK)
3          CONTINUE
	      GP1Y(I,JK)=GP1Y(I,JK)*ALY(I)
	      GM1Y(I,JK)=GM1Y(I,JK)*ALY(I)
	      GP2Y(I,JK)=GP2Y(I,JK)*ALY(I)
	      GM2Y(I,JK)=GM2Y(I,JK)*ALY(I)
	      GP3Y(I,JK)=GP3Y(I,JK)*ALY(I)
	      GM3Y(I,JK)=GM3Y(I,JK)*ALY(I)
	      GP4Y(I,JK)=GP4Y(I,JK)*ALY(I)
	      GM4Y(I,JK)=GM4Y(I,JK)*ALY(I)
	      DYP2(I,JK)=DYP2(I,JK)*ALY(I)
	      DYM2(I,JK)=DYM2(I,JK)*ALY(I)
	      DYP3(I,JK)=DYP3(I,JK)*ALY(I)
	      DYM3(I,JK)=DYM3(I,JK)*ALY(I)
	      DYP4(I,JK)=DYP4(I,JK)*ALY(I)
	      DYM4(I,JK)=DYM4(I,JK)*ALY(I)
	   JMIN=JMIN+NPY(I)+1
2      CONTINUE
30     CONTINUE
	RETURN
	END
C
C SUBROUTINE TO COMPUTE THE DERIVATIVES
C
	SUBROUTINE DERIVX(D,U,UX,AL,NP,ND,M)
	IMPLICIT REAL*8(A-H,O-Z)
	PARAMETER (NX=50,NY=50)
	DIMENSION D(NX,33),U(NX,NY),UX(NX,NY),AL(30),NP(30)
	DO 100JM=1,M
	JMAX=0
	JMIN=1
	DO 2I=1,ND
	   JMAX=JMAX+NP(I)+1
	   DO 4J=JMIN,JMAX
	      UXT=0.
	      DO 3K=0,NP(I)
		 UXT=UXT+D(J,K+1)*U(JMIN+K,JM)
3            CONTINUE
	      UX(J,JM)=UXT*AL(I)
4         CONTINUE
	
	   JMIN=JMIN+NP(I)+1
2      CONTINUE
100    CONTINUE
	RETURN
	END
C
C SUBROUTINE TO COMPUTE THE DERIVATIVES
C
	SUBROUTINE DERIVY(D,U,UY,AL,NP,ND,M)
	IMPLICIT REAL*8(A-H,O-Z)
	PARAMETER(NX=50,NY=50)
	DIMENSION D(NY,33),U(NX,NY),UY(NX,NY),AL(30),NP(30)
	DO 100JM=1,M
	JMAX=0
	JMIN=1
	DO 2I=1,ND
	   JMAX=JMAX+NP(I)+1
	   DO 4J=JMIN,JMAX
	      UYT=0.
	      DO 3K=0,NP(I)
		 UYT=UYT+D(J,K+1)*U(JM,JMIN+K)
3            CONTINUE
	      UY(JM,J)=UYT*AL(I)
4         CONTINUE
	   JMIN=JMIN+NP(I)+1
2      CONTINUE
100    CONTINUE
	RETURN
	END
C
C PROGRAM TO COMPUTE X
C
	SUBROUTINE XX(X,AL,BE,NP,ND)
	IMPLICIT REAL*8(A-H,O-Z)
	PARAMETER (NX=50,NY=50)
	DIMENSION X(NX),NP(30),AL(30),BE(30)
	ANG=dble(1)
	PI=dble(2)*DASIN(ANG)
	JMAX=0
	JMIN=1
	DO 2I=1,ND
	   JMAX=JMAX+NP(I)+1
	   DO 3J=JMIN,JMAX
	      XI=-DCOS(PI*dble(J-JMIN)/dble(NP(I)))
	      X(J)=(XI-BE(I))/AL(I)
3         CONTINUE
	   JMIN=JMIN+NP(I)+1
2      CONTINUE
       RETURN
       END
C
C
C PROGRAM TO CALCULATE THE METRICS FOR THE TWO-DIMENSIONAL PROBLEM
C
	SUBROUTINE GRID6(X,Y,xp1,yp1,XX,EX,XY,EY,JAC,F1PP,F2PP,
     &                  MXPX,MXPY)
	IMPLICIT REAL*8(A-H,O-Z)
	PARAMETER (NX=50,NY=50)
	DIMENSION X(NX),Y(NY),XX(NX,NY),EX(NX,NY),XY(NX,NY)
	DIMENSION EY(NX,NY),JAC(NX,NY),F1PP(NX),F2PP(NX)
	dimension xp1(nx,ny),yp1(nx,ny)
	REAL*8 JAC,N0,NM
	ANG=dble(1)
	PI=2.*DASIN(ANG)
	N0=Y(1)
	NM=Y(MXPY)
	II=0.
	A=0.1
	DO 2I=1,MXPX
	   IF(X(I).GE.0.AND.X(I).LE.1.)THEN
C
C Flat plate
C
           F1=0.0D0
           F1PP(I)=0.0D0
C
c cosine arc
C	   F1=0.05*(1.0+DCOS(2.0*PI*(X(I)-0.5)))
C	   F1PP(I)=-0.1*PI*DSIN(2.0*PI*(X(I)-0.5))
c Circular Arc
 
c         BN=(A/2.+1./(8.*A))**2-(X(I)-.5)**2
c         F1=BN**0.5-(1./(8.*A)-A/2.)
c         F1=4.*(0.25-(X(I)-.5)**2.)*0.05
c         IF(II.EQ.0) F1=0.
c         F1PP(I)=-8.*(X(I)-.5)*0.05
c         F1PP(I)=-(X(I)-0.5)*BN**(-0.5)
c
c exp function
c           F1=0.1*DEXP(-5.0*(X(I)-0.5)**2)
c           F1PP(I)=-10*(X(I)-.5)*F1
c
C         IF(II.EQ.0) F1PP(I)=0.
C         II=II+1
C         IF(X(I).EQ.1) II=0
c  uncover if not  exp function
	   ELSE
	   F1=0.2*EXP(-(X(I)-0.5)**2)*0.
	   F1PP(I)=-2.*(X(I)-0.5)*F1
	   ENDIF
	   F2=Y(MXPY)-F1*0.
	   F1P=F1PP(I)
	   F2PP(I)=-F1P*0.
	   F2P=F2PP(I)
	   DO 2J=1,MXPY
	      YP=(Y(J)*(F2-F1)-(N0*F2-NM*F1))/(NM-N0)
	      yp1(i,j)=yp
	      xp1(i,j)=x(i)
	      XX(I,J)=1.
	      XY(I,J)=0.
	      EX(I,J)=(N0*F2P-NM*F1P)/(F2-F1)-((N0*F2-NM*F1+YP*
     &              (NM-N0))*(F2P-F1P))/(F2-F1)**2.
	      EY(I,J)=(NM-N0)/(F2-F1)
	      JAC(I,J)=XX(I,J)*EY(I,J)-XY(I,J)*EX(I,J)
C            IF(J.EQ.1) THEN
C              F1PP(I)=F1PP(I)-EX(I,J)*(F2-F1)/(NM-N0)
C            ENDIF
C            IF(J.EQ.MXPY) THEN
C              F2PP(I)=F2PP(I)-EX(I,J)*(F2-F1)/(NM-N0)
C            ENDIF
2      CONTINUE
	RETURN
	END
c
c Implement boundary conditions at walls and inlets
c
	SUBROUTINE INLET(SPY,EPY,APX,U1,U2,U3,U4,IW)
	IMPLICIT REAL*8(A-H,O-Z)
	PARAMETER(NX=50,NY=50)
	DIMENSION U(NX,NY),V(NX,NY),RHO(NX,NY),T(NX,NY),E(NX,NY)
	DIMENSION AS1(NX),AS2(NX),AS3(NY),AS4(NY),NX1(NX),NY1(NX)
	DIMENSION NX2(NX),NY2(NX),SIG(NX),P(NX,NY)
	DIMENSION U1(NX,NY),U2(NX,NY),U3(NX,NY),U4(NX,NY)
	REAL*8 NX1,NX2,NY1,NY2,MINLET(NY)
	INTEGER SPY,EPY,APX
	COMMON /BNDRY/ U,V,P,RHO,T,E,AS1,AS2,AS3,AS4,NX1,NY1,NX2,NY2,
     &         SIG,GMA,S0,T0,P0,PE,HOO,RR,MINLET
        COMMON /W_CONST/ TWX_0,TWX_N,TWY_0,TWY_N,UW_0,UW_N,VW_0,VW_N
C
C COMPUT RIEMANN INVERIANTS AT THE BOUNDARIES
C
	DO 22I=SPY,EPY
	   IF(IW.EQ.1) THEN
	      pp=dlog(p(APX,I)/P0)-gma*u(APX,I)/as3(I)
	      p(APX,I)=P0*dexp(pp)
	      T(APX,I)=TWY_0
	      rho(APX,I)=p(APX,I)/(T(APX,I)*RR)
	      as3(I)= dsqrt(gma*p(APX,I)/rho(APX,I))
	      U(APX,I)=0.0D0
	      V(APX,I)=VW_0
	   ELSE
	      IF(MINLET(I).LT.1.0) THEN
	      RMB=U(APX,I)-2.*DSQRT(GMA*P(APX,I)/RHO(APX,I))/(GMA-1.)
	      AQ=1./(GMA-1.)+2./(GMA-1.)**2*(1.+SIG(I)**2)
	      BQ=2.*(1.+SIG(I)**2)*RMB/(GMA-1.)
	      CQ=RMB**2*(1.+SIG(I)**2)/2.-HOO
	      C=(-BQ+DSQRT(BQ**2-4.*AQ*CQ))/(2.*AQ)
	      U(APX,I)=RMB+2.*C/(GMA-1.)
	      V(APX,I)=SIG(I)*U(APX,I)
	      RHO(APX,I)=(GMA*S0/C**2)**(1./(1.-GMA))
	      P(APX,I)=RHO(APX,I)*C**2/GMA
	      T(APX,I)=P(APX,I)/(RHO(APX,I)*RR)
	      ELSE
		XFT=1.0+(GMA-1.0)/2.0*MINLET(I)**2
		P(APX,I)=P0/XFT**(GMA/(GMA-1.0))
		RHO0=P0/(RR*T0)
		RHO(APX,I)=RHO0/XFT**(1.0/(GMA-1.0))
		T(APX,I)=P(APX,I)/(RHO(APX,I)*RR)
		SSP=DSQRT(GMA*P(APX,I)/RHO(APX,I))
		U(APX,I)=SSP*MINLET(I)
		V(APX,I)=SIG(I)*U(APX,I)
		END IF
	   END IF
	   E(APX,I)=P(APX,I)/((GMA-1.)*RHO(APX,I))+(U(APX,I)*U(APX,I)+
     &            V(APX,I)*V(APX,I))/2.
	   U1(APX,I)=RHO(APX,I)
	   U2(APX,I)=RHO(APX,I)*U(APX,I)
	   U3(APX,I)=RHO(APX,I)*V(APX,I)
	   U4(APX,I)=RHO(APX,I)*E(APX,I)
22      CONTINUE
	RETURN
	END
C
C
	SUBROUTINE AEXIT(SPY,EPY,APX,U1,U2,U3,U4,IW)
	IMPLICIT REAL*8(A-H,O-Z)
	PARAMETER(NX=50,NY=50)
	DIMENSION U(NX,NY),V(NX,NY),RHO(NX,NY),T(NX,NY),E(NX,NY)
	DIMENSION AS1(NX),AS2(NX),AS3(NY),AS4(NY),NX1(NX),NY1(NX)
	DIMENSION NX2(NX),NY2(NX),SIG(NX),P(NX,NY)
	DIMENSION U1(NX,NY),U2(NX,NY),U3(NX,NY),U4(NX,NY)
	INTEGER SPY,EPY,APX
	REAL*8 NX1,NX2,NY1,NY2,MINLET(NY)
	COMMON /BNDRY/ U,V,P,RHO,T,E,AS1,AS2,AS3,AS4,NX1,NY1,NX2,NY2,
     &         SIG,GMA,S0,T0,P0,PE,HOO,RR,MINLET
        COMMON /W_CONST/ TWX_0,TWX_N,TWY_0,TWY_N,UW_0,UW_N,VW_0,VW_N
C
	DO 22I=SPY,EPY
	   IF(IW.EQ.1) THEN
	      pp=dlog(p(APX,I)/P0)+gma*u(APX,I)/as4(I)
	      p(APX,I)=P0*dexp(pp)
	      T(APX,I)=TWY_N
	      rho(APX,I)=p(APX,I)/(T(APX,I)*RR)
	      as4(I)= dsqrt(gma*p(APX,I)/rho(APX,I))
	      U(APX,I)=0.0D0
	      V(APX,I)=VW_N
	   ELSE
	      SSP=DSQRT(GMA*P(APX,I)/RHO(APX,I))
	      IF(U(APX,I).LT.SSP) THEN
	      SOB=P(APX,I)/RHO(APX,I)**GMA
	      RPB=U(APX,I)+2.*DSQRT(GMA*P(APX,I)/RHO(APX,I))/(GMA-1.)
	      RHO(APX,I)=(PE/SOB)**(1./GMA)
	      C=DSQRT(GMA*PE/RHO(APX,I))
	      U(APX,I)=RPB-2.*C/(GMA-1.)
C              IF(U(APX,I).LT.0.) V(APX,I)=0.0
	      P(APX,I)=PE
	      T(APX,I)=P(APX,I)/(RHO(APX,I)*RR)
	      ENDIF
	   ENDIF
	   E(APX,I)=P(APX,I)/((GMA-1.)*RHO(APX,I))+(U(APX,I)*U(APX,I)+
     &           V(APX,I)*V(APX,I))/2.
	   U1(APX,I)=RHO(APX,I)
	   U2(APX,I)=RHO(APX,I)*U(APX,I)
	   U3(APX,I)=RHO(APX,I)*V(APX,I)
	   U4(APX,I)=RHO(APX,I)*E(APX,I)
22         CONTINUE
	RETURN
	END
C
	SUBROUTINE BOTWALL(SPX,EPX,APY,MXPX,U1,U2,U3,U4,IV)
	IMPLICIT REAL*8(A-H,O-Z)
	PARAMETER(NX=50,NY=50)
	DIMENSION U(NX,NY),V(NX,NY),RHO(NX,NY),T(NX,NY),E(NX,NY)
	DIMENSION AS1(NX),AS2(NX),AS3(NY),AS4(NY),NX1(NX),NY1(NX)
	DIMENSION NX2(NX),NY2(NX),SIG(NX),P(NX,NY)
	DIMENSION U1(NX,NY),U2(NX,NY),U3(NX,NY),U4(NX,NY)
	INTEGER SPX,EPX,APY
	REAL*8 NX1,NX2,NY1,NY2,MINLET(NY)
	COMMON /BNDRY/ U,V,P,RHO,T,E,AS1,AS2,AS3,AS4,NX1,NY1,NX2,NY2,
     &         SIG,GMA,S0,T0,P0,PE,HOO,RR,MINLET
        COMMON /W_CONST/ TWX_0,TWX_N,TWY_0,TWY_N,UW_0,UW_N,VW_0,VW_N
C
	DO 23I=SPX,EPX
	   VT1=U(I,APY)*NY1(I)-V(I,APY)*NX1(I)
	   VN1=U(I,APY)*NX1(I)+V(I,APY)*NY1(I)
	   SOB1=P(I,APY)/RHO(I,APY)**GMA
	   RMB=VN1-2.*DSQRT(GMA*P(I,APY)/RHO(I,APY))/(GMA-1.)
	   RPB=VN1+2.*DSQRT(GMA*P(I,APY)/RHO(I,APY))/(GMA-1.)
	   SS=-((GMA-1.)/2.*RMB)
	   SS2=SS**2
C
C BOTTOM WALL CONDITIONS FOR SUBSONIC FLOW
C
 
c          v(i,1)=-nx1(i)*u(i,1)/ny1(i)
c          RHO(I,1)=(SS2/(GMA*SOB1))**(1./(GMA-1.))
	   pp=dlog(p(i,APY)/P0)-gma*vn1/as1(i)
	   p(i,APY)=P0*dexp(pp)
	   IF(IV.EQ.0) THEN
	      U(I,APY)=(VT1*NY1(I))/(NY1(I)*NY1(I)+NX1(I)*NX1(I))
	      V(I,APY)=-(VT1*NX1(I))/(NY1(I)*NY1(I)+NX1(I)*NX1(I))
	      rho(i,APY)=(p(i,APY)/sob1)**(1.0/gma)
              T(I,APY)=P(I,APY)/(RR*RHO(I,APY))
	   ELSE
	      U(I,APY)=UW_0
	      V(I,APY)=0.0
	      T(I,APY)=TWX_0
C              WRITE(6,*) TWALL
	      rho(i,APY)=p(i,APY)/(T(i,APY)*RR)
	   ENDIF
	   as1(i)= dsqrt(gma*p(i,APY)/rho(i,APY))
C	   IF(I.EQ.MXPX) THEN
C	     P(I,APY)=PE
C	     RHO(I,APY)=(PE/(TWALL*RR))
Cc            C=DSQRT(GMA*PE/RHO(I,APY))
Cc            U(I,APY)=RMU1+2.*C/(GMA-1.)
Cc            V(I,APY)=SIG2(1)*U(I,APY)
C	   ENDIF
	
	   E(I,APY)=P(I,APY)/((GMA-1.)*RHO(I,APY))+(U(I,APY)*U(I,APY)+
     &              V(I,APY)*V(I,APY))/2.
	   U1(I,APY)=RHO(I,APY)
	   U2(I,APY)=RHO(I,APY)*U(I,APY)
	   U3(I,APY)=RHO(I,APY)*V(I,APY)
	   U4(I,APY)=RHO(I,APY)*E(I,APY)
23      CONTINUE
	RETURN
	END
C
	SUBROUTINE TOPWALL(SPX,EPX,APY,MXPX,U1,U2,U3,U4,IV)
	IMPLICIT REAL*8(A-H,O-Z)
	PARAMETER(NX=50,NY=50)
	DIMENSION U(NX,NY),V(NX,NY),RHO(NX,NY),T(NX,NY),E(NX,NY)
	DIMENSION AS1(NX),AS2(NX),AS3(NY),AS4(NY),NX1(NX),NY1(NX)
	DIMENSION NX2(NX),NY2(NX),SIG(NX),P(NX,NY)
	DIMENSION U1(NX,NY),U2(NX,NY),U3(NX,NY),U4(NX,NY)
	INTEGER SPX,EPX,APY
	REAL*8 NX1,NX2,NY1,NY2,MINLET(NY)
	COMMON /BNDRY/ U,V,P,RHO,T,E,AS1,AS2,AS3,AS4,NX1,NY1,NX2,NY2,
     &         SIG,GMA,S0,T0,P0,PE,HOO,RR,MINLET
        COMMON /W_CONST/ TWX_0,TWX_N,TWY_0,TWY_N,UW_0,UW_N,VW_0,VW_N
C
C TOPWALL  CONDITIONS
C
	DO 2I=SPX,EPX
	   VT2=U(I,APY)*NY2(I)-V(I,APY)*NX2(I)
	   VN2=U(I,APY)*NX2(I)+V(I,APY)*NY2(I)
	   SOB2=P(I,APY)/RHO(I,APY)**GMA
	   RMB=VN2-2.*DSQRT(GMA*P(I,APY)/RHO(I,APY))/(GMA-1.)
	   RPB=VN2+2.*DSQRT(GMA*P(I,APY)/RHO(I,APY))/(GMA-1.)
	   SS=((GMA-1.)/2.*RPB)
	   SS2=SS**2
	   U(I,APY)=(VT2*NY2(I))/(NY2(I)*NY2(I)+NX2(I)*NX2(I))
	   V(I,APY)=-(VT2*NX2(I))/(NY2(I)*NY2(I)+NX2(I)*NX2(I))
c          v(i,APY)=-nx2(i)*u(i,APY)/ny2(i)
	   SS2=((GMA-1.)/2.*(RPB))**2
	   pp=dlog(p(i,APY)/P0)+gma*vn2/as2(i)
	   p(i,APY)=P0*dexp(pp)
	   IF(IV.EQ.0) THEN
	      U(I,APY)=(VT2*NY2(I))/(NY2(I)*NY2(I)+NX2(I)*NX2(I))
	      V(I,APY)=-(VT2*NX2(I))/(NY2(I)*NY2(I)+NX2(I)*NX2(I))
	      rho(i,APY)=(p(i,APY)/sob2)**(1.0/gma)
	      T(I,APY)=P(I,APY)/(RR*RHO(I,APY))
	   ELSE
	      U(I,APY)=UW_N
	      V(I,APY)=0.0
	      T(I,APY)=TWX_N
	      rho(i,APY)=p(i,APY)/(T(i,APY)*RR)
	   ENDIF
	   as2(i)= dsqrt(gma*p(i,APY)/rho(i,APY))
C	   IF(I.EQ.MXPX) THEN
C	     P(I,APY)=PE
C	     RHO(I,APY)=(PE/SOB2)**(1./GMA)
c            C=DSQRT(GMA*PE/RHO(I,APY))
c            U(I,APY)=RMU2+2.*C/(GMA-1.)
c            V(I,APY)=SIG2(APY)*U(I,APY)
C	  ENDIF
C         P(I,APY)=RHO(I,APY)*(RPB*(GMA-1)/2.)**2/GMA
	  E(I,APY)=P(I,APY)/((GMA-1.)*RHO(I,APY))+
     &              (U(I,APY)*U(I,APY)+ V(I,APY)*V(I,APY))/2.
	  U1(I,APY)=RHO(I,APY)
	  U2(I,APY)=RHO(I,APY)*U(I,APY)
	  U3(I,APY)=RHO(I,APY)*V(I,APY)
	  U4(I,APY)=RHO(I,APY)*E(I,APY)
2       CONTINUE
	RETURN
	END
