C *** Double-precision Linpack benchmark
      do i = 1,10
         call linpak8
      enddo
      end


      subroutine linpak8
 
      REAL*4 secnds
      DOUBLE PRECISION aa(200,200),a(201,200),b(200),x(200)
      DOUBLE PRECISION time(8,6),cray,ops,total,norma,normx
      DOUBLE PRECISION resid,residn,eps
      real*8 epslon
      INTEGER ipvt(200)
 
c      open (7, file='summary.dat', status='unknown', position='append')
c      write (7,*) 'LINPACK8'
 
      lda = 201
      ldaa = 200
 
      n = 200
      cray = .056
      WRITE (*,*) 'LP8 Double-precision Linpack...'
c      WRITE (*,100)
c  100 FORMAT (' Please send the results of this run to:'//
c     & ' Jack J. Dongarra'/' Mathematics and Computer Science Division'
c     & /' Argonne National Laboratory'/' Argonne, Illinois 60439'//
c     & ' Telephone: 312-972-7246'//' ARPAnet: DONGARRA@ANL-MCS'/)
      ops = (2.0D0*n**3)/3.0D0+2.0D0*n**2
 
      CALL matgen(a,lda,n,b,norma)
      t1 = secnds(0.0)
      CALL dgefa(a,lda,n,ipvt,info)
      time(1,1) = secnds(0.0)-t1
      t1 = secnds(0.0)
      CALL dgesl(a,lda,n,ipvt,b,0)
      time(1,2) = secnds(0.0)-t1
      total = time(1,1)+time(1,2)
 
C     compute a residual to verify results.
 
      DO i = 1,n
          x(i) = b(i)
      END DO
      CALL matgen(a,lda,n,b,norma)
      DO i = 1,n
          b(i) = -b(i)
      END DO
      CALL dmxpy(n,b,n,lda,x,a)
      resid = 0.0d00
      normx = 0.0d00
      DO i = 1,n
          resid = dmax1(resid,dabs(b(i)))
          normx = dmax1(normx,dabs(x(i)))
      END DO
      eps = epslon(1.0D0)
      residn = resid/(n*norma*normx*eps)
      WRITE (*,200)
  200 FORMAT ('     norm. resid      resid           machep',
     & '         x(1)          x(n)')
      WRITE (*,300) residn,resid,eps,x(1),x(n)
  300 FORMAT (1P,5d16.8)
 
      WRITE (*,400) n
  400 FORMAT (/'    Times are reported for matrices of order ',I5)
      WRITE (*,500)
  500 FORMAT (6X,'dgefa',6X,'dgesl',6X,'total',5X,'mflops',7X,'unit',
     & 6X,'ratio')
 
      time(1,3) = total
      time(1,4) = ops/(1.0D6*total)
      time(1,5) = 2.0D0/time(1,4)
      time(1,6) = total/cray
      WRITE (*,600) lda
  600 FORMAT (' Times for array with leading dimension of',I4)
      WRITE (*,700) (time(1,i),i = 1,6)
  700 FORMAT (6(1Pd11.3))
 
      CALL matgen(a,lda,n,b,norma)
      t1 = secnds(0.0)
      CALL dgefa(a,lda,n,ipvt,info)
      time(2,1) = secnds(0.0)-t1
      t1 = secnds(0.0)
      CALL dgesl(a,lda,n,ipvt,b,0)
      time(2,2) = secnds(0.0)-t1
      total = time(2,1)+time(2,2)
      time(2,3) = total
      time(2,4) = ops/(1.0D6*total)
      time(2,5) = 2.0D0/time(2,4)
      time(2,6) = total/cray
 
      CALL matgen(a,lda,n,b,norma)
      t1 = secnds(0.0)
      CALL dgefa(a,lda,n,ipvt,info)
      time(3,1) = secnds(0.0)-t1
      t1 = secnds(0.0)
      CALL dgesl(a,lda,n,ipvt,b,0)
      time(3,2) = secnds(0.0)-t1
      total = time(3,1)+time(3,2)
      time(3,3) = total
      time(3,4) = ops/(1.0D6*total)
      time(3,5) = 2.0D0/time(3,4)
      time(3,6) = total/cray
 
      ntimes = 10
      tm2 = 0
      t1 = secnds(0.0)
      DO i = 1,ntimes
          tm = secnds(0.0)
          CALL matgen(a,lda,n,b,norma)
          tm2 = tm2+secnds(0.0)-tm
          CALL dgefa(a,lda,n,ipvt,info)
      END DO
      time(4,1) = (secnds(0.0)-t1-tm2)/ntimes
      t1 = secnds(0.0)
      DO i = 1,ntimes
          CALL dgesl(a,lda,n,ipvt,b,0)
      END DO
      time(4,2) = (secnds(0.0)-t1)/ntimes
      total = time(4,1)+time(4,2)
      time(4,3) = total
      time(4,4) = ops/(1.0D6*total)
      time(4,5) = 2.0D0/time(4,4)
      time(4,6) = total/cray
 
      WRITE (*,700) (time(2,i),i = 1,6)
      WRITE (*,700) (time(3,i),i = 1,6)
      WRITE (*,700) (time(4,i),i = 1,6)
 
      CALL matgen(aa,ldaa,n,b,norma)
      t1 = secnds(0.0)
      CALL dgefa(aa,ldaa,n,ipvt,info)
      time(5,1) = secnds(0.0)-t1
      t1 = secnds(0.0)
      CALL dgesl(aa,ldaa,n,ipvt,b,0)
      time(5,2) = secnds(0.0)-t1
      total = time(5,1)+time(5,2)
      time(5,3) = total
      time(5,4) = ops/(1.0D6*total)
      time(5,5) = 2.0D0/time(5,4)
      time(5,6) = total/cray
 
      CALL matgen(aa,ldaa,n,b,norma)
      t1 = secnds(0.0)
      CALL dgefa(aa,ldaa,n,ipvt,info)
      time(6,1) = secnds(0.0)-t1
      t1 = secnds(0.0)
      CALL dgesl(aa,ldaa,n,ipvt,b,0)
      time(6,2) = secnds(0.0)-t1
      total = time(6,1)+time(6,2)
      time(6,3) = total
      time(6,4) = ops/(1.0D6*total)
      time(6,5) = 2.0D0/time(6,4)
      time(6,6) = total/cray
 
      CALL matgen(aa,ldaa,n,b,norma)
      t1 = secnds(0.0)
      CALL dgefa(aa,ldaa,n,ipvt,info)
      time(7,1) = secnds(0.0)-t1
      t1 = secnds(0.0)
      CALL dgesl(aa,ldaa,n,ipvt,b,0)
      time(7,2) = secnds(0.0)-t1
      total = time(7,1)+time(7,2)
      time(7,3) = total
      time(7,4) = ops/(1.0D6*total)
      time(7,5) = 2.0D0/time(7,4)
      time(7,6) = total/cray
 
      ntimes = 10
      tm2 = 0
      t1 = secnds(0.0)
      DO i = 1,ntimes
          tm = secnds(0.0)
          CALL matgen(aa,ldaa,n,b,norma)
          tm2 = tm2+secnds(0.0)-tm
          CALL dgefa(aa,ldaa,n,ipvt,info)
      END DO
      time(8,1) = (secnds(0.0)-t1-tm2)/ntimes
      t1 = secnds(0.0)
      DO i = 1,ntimes
          CALL dgesl(aa,ldaa,n,ipvt,b,0)
      END DO
      time(8,2) = (secnds(0.0)-t1)/ntimes
      total = time(8,1)+time(8,2)
      time(8,3) = total
      time(8,4) = ops/(1.0D6*total)
      time(8,5) = 2.0D0/time(8,4)
      time(8,6) = total/cray
 
      WRITE (*,800) ldaa
  800 FORMAT (/' Times for array with leading dimension of',I4)
      WRITE (*,700) (time(5,i),i = 1,6)
      WRITE (*,700) (time(6,i),i = 1,6)
      WRITE (*,700) (time(7,i),i = 1,6)
      WRITE (*,700) (time(8,i),i = 1,6)
 
	 emflops = 0.
	 do i = 1, 8
	      emflops = emflops + time(i,4)
	 end do
	 emflops = emflops / 8.
	 print*, ' '
	 print*, 'Average REAL*8 MFLOPS = ', emflops
c      write(7,*) emflops
      END
 
      SUBROUTINE matgen(a,lda,n,b,norma)
      DOUBLE PRECISION a(lda,*),b(*),norma
 
      init = 1325
      norma = 0.0
      DO j = 1,n
          DO i = 1,n
              init = mod(3125*init,65536)
              a(i,j) = (init-32768.0)/16384.0
              norma = dmax1(a(i,j),norma)
          END DO
      END DO
      DO i = 1,n
          b(i) = 0.0
      END DO
      DO j = 1,n
          DO i = 1,n
              b(i) = b(i)+a(i,j)
          END DO
      END DO
      RETURN
      END
 
      SUBROUTINE dgefa(a,lda,n,ipvt,info)
      INTEGER lda,n,ipvt(*),info
      DOUBLE PRECISION a(lda,*)
 
C     dgefa factors a double precision matrix by gaussian elimination.
 
C     dgefa is usually called by dgeco, but it can be called
C     directly with a saving in time if  rcond  is not needed.
C     (time for dgeco) = (1 + 9/n)*(time for dgefa) .
 
C     on entry
 
C     a       double precision(lda, n)
C     the matrix to be factored.
 
C     lda     integer
C     the leading dimension of the array  a .
 
C     n       integer
C     the order of the matrix  a .
 
C     on return
 
C     a       an upper triangular matrix and the multipliers
C     which were used to obtain it.
C     the factorization can be written  a = l*u  where
C     l  is a product of permutation and unit lower
C     triangular matrices and  u  is upper triangular.
 
C     ipvt    integer(n)
C     an integer vector of pivot indices.
 
C     info    integer
C     = 0  normal value.
C     = k  if  u(k,k) .eq. 0.0 .  this is not an error
C     condition for this subroutine, but it does
C     indicate that dgesl or dgedi will divide by zero
C     if called.  use  rcond  in dgeco for a reliable
C     indication of singularity.
 
C     linpack. this version dated 08/14/78 .
C     cleve moler, university of new mexico, argonne national lab.
 
C     subroutines and functions
 
C     blas daxpy,dscal,idamax
 
C     internal variables
 
      DOUBLE PRECISION t
      INTEGER idamax,j,k,kp1,l,nm1
 
 
C     gaussian elimination with partial pivoting
 
      info = 0
      nm1 = n-1
      IF ( nm1 .GE. 1 ) THEN
          DO k = 1,nm1
              kp1 = k+1
 
C             find l = pivot index
 
              l = idamax(n-k+1,a(k,k),1)+k-1
              ipvt(k) = l
 
C             zero pivot implies this column already triangularized
 
              IF ( a(l,k) .EQ. 0.0D0 ) THEN
                  info = k
              ELSE
 
C                 interchange if necessary
 
                  IF ( l .NE. k ) THEN
                      t = a(l,k)
                      a(l,k) = a(k,k)
                      a(k,k) = t
                  END IF
 
C                 compute multipliers
 
                  t = -1.0D0/a(k,k)
                  CALL dscal(n-k,t,a(k+1,k),1)
 
C                 row elimination with column indexing
 
                  DO j = kp1,n
                      t = a(l,j)
                      IF ( l .NE. k ) THEN
                          a(l,j) = a(k,j)
                          a(k,j) = t
                      END IF
                      CALL daxpy(n-k,t,a(k+1,k),1,a(k+1,j),1)
                  END DO
              END IF
          END DO
      END IF
      ipvt(n) = n
      IF ( a(n,n) .EQ. 0.0D0 ) info = n
      RETURN
      END
 
      SUBROUTINE dgesl(a,lda,n,ipvt,b,job)
      INTEGER lda,n,ipvt(*),job
      DOUBLE PRECISION a(lda,*),b(*)
 
C     dgesl solves the double precision system
C     a * x = b  or  trans(a) * x = b
C     using the factors computed by dgeco or dgefa.
 
C     on entry
 
C     a       double precision(lda, n)
C     the output from dgeco or dgefa.
 
C     lda     integer
C     the leading dimension of the array  a .
 
C     n       integer
C     the order of the matrix  a .
 
C     ipvt    integer(n)
C     the pivot vector from dgeco or dgefa.
 
C     b       double precision(n)
C     the right hand side vector.
 
C     job     integer
C     = 0         to solve  a*x = b ,
C     = nonzero   to solve  trans(a)*x = b  where
C     trans(a)  is the transpose.
 
C     on return
 
C     b       the solution vector  x .
 
C     error condition
 
C     a division by zero will occur if the input factor contains a
C     zero on the diagonal.  technically this indicates singularity
C     but it is often caused by improper arguments or improper
C     setting of lda .  it will not occur if the subroutines are
C     called correctly and if dgeco has set rcond .gt. 0.0
C     or dgefa has set info .eq. 0 .
 
C     to compute  inverse(a) * c  where  c  is a matrix
C     with  p  columns
C     call dgeco(a,lda,n,ipvt,rcond,z)
C     if (rcond is too small) go to ...
C     do 10 j = 1, p
C     call dgesl(a,lda,n,ipvt,c(1,j),0)
C     10 continue
 
C     linpack. this version dated 08/14/78 .
C     cleve moler, university of new mexico, argonne national lab.
 
C     subroutines and functions
 
C     blas daxpy,ddot
 
C     internal variables
 
      DOUBLE PRECISION ddot,t
      INTEGER k,kb,l,nm1
 
      nm1 = n-1
      IF ( job .EQ. 0 ) THEN
 
C         job = 0 , solve  a * x = b
C         first solve  l*y = b
 
          IF ( nm1 .GE. 1 ) THEN
              DO k = 1,nm1
                  l = ipvt(k)
                  t = b(l)
                  IF ( l .NE. k ) THEN
                      b(l) = b(k)
                      b(k) = t
                  END IF
                  CALL daxpy(n-k,t,a(k+1,k),1,b(k+1),1)
              END DO
          END IF
 
C         now solve  u*x = y
 
          DO kb = 1,n
              k = n+1-kb
              b(k) = b(k)/a(k,k)
              t = -b(k)
              CALL daxpy(k-1,t,a(1,k),1,b(1),1)
          END DO
      ELSE
 
C         job = nonzero, solve  trans(a) * x = b
C         first solve  trans(u)*y = b
 
          DO k = 1,n
              t = ddot(k-1,a(1,k),1,b(1),1)
              b(k) = (b(k)-t)/a(k,k)
          END DO
 
C         now solve trans(l)*x = y
 
          IF ( nm1 .GE. 1 ) THEN
              DO kb = 1,nm1
                  k = n-kb
                  b(k) = b(k)+ddot(n-k,a(k+1,k),1,b(k+1),1)
                  l = ipvt(k)
                  IF ( l .NE. k ) THEN
                      t = b(l)
                      b(l) = b(k)
                      b(k) = t
                  END IF
              END DO
          END IF
      END IF
      RETURN
      END
 
      SUBROUTINE daxpy(n,da,dx,incx,dy,incy)
 
C     constant times a vector plus a vector.
C     uses unrolled loops for increments equal to one.
C     jack dongarra, linpack, 3/11/78.
 
      DOUBLE PRECISION dx(*),dy(*),da
      INTEGER i,incx,incy,ix,iy,m,mp1,n
 
      IF ( n .GT. 0 ) THEN
          IF ( da .NE. 0.0D0 ) THEN
              IF ( incx .NE. 1 .OR. incy .NE. 1 ) THEN
 
C                 code for unequal increments or equal increments
C                 not equal to 1
 
                  ix = 1
                  iy = 1
                  IF ( incx .LT. 0 ) ix = (-n+1)*incx+1
                  IF ( incy .LT. 0 ) iy = (-n+1)*incy+1
                  DO i = 1,n
                      dy(iy) = dy(iy)+da*dx(ix)
                      ix = ix+incx
                      iy = iy+incy
                  END DO
              ELSE
 
C                 code for both increments equal to 1
 
 
C                 clean-up loop
 
                  m = mod(n,4)
                  IF ( m .NE. 0 ) THEN
                      DO i = 1,m
                          dy(i) = dy(i)+da*dx(i)
                      END DO
                      IF ( n .LT. 4 ) RETURN
                  END IF
                  mp1 = m+1
                  DO i = mp1,n,4
                      dy(i) = dy(i)+da*dx(i)
                      dy(i+1) = dy(i+1)+da*dx(i+1)
                      dy(i+2) = dy(i+2)+da*dx(i+2)
                      dy(i+3) = dy(i+3)+da*dx(i+3)
                  END DO
              END IF
          END IF
      END IF
      RETURN
      END
      DOUBLE PRECISION FUNCTION ddot(n,dx,incx,dy,incy)
 
C     forms the dot product of two vectors.
C     uses unrolled loops for increments equal to one.
C     jack dongarra, linpack, 3/11/78.
 
      DOUBLE PRECISION dx(*),dy(*),dtemp
      INTEGER i,incx,incy,ix,iy,m,mp1,n
 
      ddot = 0.0D0
      dtemp = 0.0D0
      IF ( n .GT. 0 ) THEN
          IF ( incx .NE. 1 .OR. incy .NE. 1 ) THEN
 
C             code for unequal increments or equal increments
C             not equal to 1
 
              ix = 1
              iy = 1
              IF ( incx .LT. 0 ) ix = (-n+1)*incx+1
              IF ( incy .LT. 0 ) iy = (-n+1)*incy+1
              DO i = 1,n
                  dtemp = dtemp+dx(ix)*dy(iy)
                  ix = ix+incx
                  iy = iy+incy
              END DO
              ddot = dtemp
          ELSE
 
C             code for both increments equal to 1
 
 
C             clean-up loop
 
              m = mod(n,5)
              IF ( m .NE. 0 ) THEN
                  DO i = 1,m
                      dtemp = dtemp+dx(i)*dy(i)
                  END DO
                  IF ( n .LT. 5 ) GO TO 1
              END IF
              mp1 = m+1
              DO i = mp1,n,5
                  dtemp = dtemp+dx(i)*dy(i)+dx(i+1)*dy(i+1)+dx(i+2)*dy
     &             (i+2)+dx(i+3)*dy(i+3)+dx(i+4)*dy(i+4)
              END DO
    1         ddot = dtemp
          END IF
      END IF
      RETURN
      END
 
      SUBROUTINE dscal(n,da,dx,incx)
 
C     scales a vector by a constant.
C     uses unrolled loops for increment equal to one.
C     jack dongarra, linpack, 3/11/78.
 
      DOUBLE PRECISION da,dx(*)
      INTEGER i,incx,m,mp1,n,nincx
 
      IF ( n .GT. 0 ) THEN
          IF ( incx .EQ. 1 ) THEN
 
C             code for increment equal to 1
 
 
C             clean-up loop
 
              m = mod(n,5)
              IF ( m .NE. 0 ) THEN
                  DO i = 1,m
                      dx(i) = da*dx(i)
                  END DO
                  IF ( n .LT. 5 ) RETURN
              END IF
              mp1 = m+1
              DO i = mp1,n,5
                  dx(i) = da*dx(i)
                  dx(i+1) = da*dx(i+1)
                  dx(i+2) = da*dx(i+2)
                  dx(i+3) = da*dx(i+3)
                  dx(i+4) = da*dx(i+4)
              END DO
          ELSE
 
C             code for increment not equal to 1
 
              nincx = n*incx
              DO i = 1,nincx,incx
                  dx(i) = da*dx(i)
              END DO
          END IF
      END IF
      RETURN
      END
      INTEGER FUNCTION idamax(n,dx,incx)
 
C     finds the index of element having max. dabsolute value.
C     jack dongarra, linpack, 3/11/78.
 
      DOUBLE PRECISION dx(*),dmax
      INTEGER i,incx,ix,n
 
      idamax = 0
      IF ( n .GE. 1 ) THEN
          idamax = 1
          IF ( n .NE. 1 ) THEN
              IF ( incx .EQ. 1 ) THEN
 
C                 code for increment equal to 1
 
                  dmax = dabs(dx(1))
                  DO i = 2,n
                      IF ( dabs(dx(i)) .GT. dmax ) THEN
                          idamax = i
                          dmax = dabs(dx(i))
                      END IF
                  END DO
              ELSE
 
C                 code for increment not equal to 1
 
                  ix = 1
                  dmax = dabs(dx(1))
                  ix = ix+incx
                  DO i = 2,n
                      IF ( dabs(dx(ix)) .GT. dmax ) THEN
                          idamax = i
                          dmax = dabs(dx(ix))
                      END IF
                      ix = ix+incx
                  END DO
              END IF
          END IF
      END IF
      RETURN
      END
 
      real*8 FUNCTION epslon(x)
      real*8 x
 
C     estimate unit roundoff in quantities of size x.
 
      real*8 a,b,c,eps
 
C     this program should function properly on all systems
C     satisfying the following two assumptions,
C     1.  the base used in representing dfloating point
C     numbers is not a power of three.
C     2.  the quantity  a  in statement 10 is represented to
C     the accuracy used in dfloating point variables
C     that are stored in memory.
C     the statement number 10 and the go to 10 are intended to
C     force optimizing compilers to generate code satisfying
C     assumption 2.
C     under these assumptions, it should be true that,
C     a  is not exactly equal to four-thirds,
C     b  has a zero for its last bit or digit,
C     c  is not exactly equal to one,
C     eps  measures the separation of 1.0 from
C     the next larger dfloating point number.
C     the developers of eispack would appreciate being informed
C     about any systems where these assumptions do not hold.
 
C     *****************************************************************
C     this routine is one of the auxiliary routines used by eispack iii
C     to avoid machine dependencies.
C     *****************************************************************
 
C     this version dated 4/6/83.
 
      a = 4.0d00 / 3.0d00
C     a = 4.0d00  * 0.33333333d00
      DO WHILE ( .TRUE. )
          b = a-1.0d00
          c = b+b+b
          eps = dabs(c-1.0d00)
          IF ( eps .NE. 0.0  ) go to 1
      END DO
    1 epslon = eps*dabs(x)
      RETURN
      END
 
 
c      DOUBLE PRECISION FUNCTION epslon(x)
c      DOUBLE PRECISION x
 
C     estimate unit roundoff in quantities of size x.
 
c      DOUBLE PRECISION a,b,c,eps
 
C     this program should function properly on all systems
C     satisfying the following two assumptions,
C     1.  the base used in representing dfloating point
C     numbers is not a power of three.
C     2.  the quantity  a  in statement 10 is represented to
C     the accuracy used in dfloating point variables
C     that are stored in memory.
C     the statement number 10 and the go to 10 are intended to
C     force optimizing compilers to generate code satisfying
C     assumption 2.
C     under these assumptions, it should be true that,
C     a  is not exactly equal to four-thirds,
C     b  has a zero for its last bit or digit,
C     c  is not exactly equal to one,
C     eps  measures the separation of 1.0 from
C     the next larger dfloating point number.
C     the developers of eispack would appreciate being informed
C     about any systems where these assumptions do not hold.
 
C     *****************************************************************
C     this routine is one of the auxiliary routines used by eispack iii
C     to avoid machine dependencies.
C     *****************************************************************
 
C     this version dated 4/6/83.
 
c      a = 4.0D0/3.0D0
C     a = 4.0d0 * 0.33333333d0
c	print*, 'In EPSLON'
c      DO WHILE ( .TRUE. )
c          b = a-1.0D0
c          c = b+b+b
c          eps = dabs(c-1.0D0)
c          IF ( eps .NE. 0.0D0 ) go to 1
c    1 END DO
c      print*, 'after loop'
c      epslon = eps*dabs(x)
c      RETURN
c      END
 
      SUBROUTINE mm(a,lda,n1,n3,b,ldb,n2,c,ldc)
      DOUBLE PRECISION a(lda,*),b(ldb,*),c(ldc,*)
 
C     purpose:
C     multiply matrix b times matrix c and store the result in matrix a.
 
C     parameters:
 
C     a double precision(lda,n3), matrix of n1 rows and n3 columns
 
C     lda integer, leading dimension of array a
 
C     n1 integer, number of rows in matrices a and b
 
C     n3 integer, number of columns in matrices a and c
 
C     b double precision(ldb,n2), matrix of n1 rows and n2 columns
 
C     ldb integer, leading dimension of array b
 
C     n2 integer, number of columns in matrix b, and number of rows in
C     matrix c
 
C     c double precision(ldc,n3), matrix of n2 rows and n3 columns
 
C     ldc integer, leading dimension of array c
 
C     ----------------------------------------------------------------------
 
      DO j = 1,n3
          DO i = 1,n1
              a(i,j) = 0.0
          END DO
          CALL dmxpy(n2,a(1,j),n1,ldb,c(1,j),b)
 
      END DO
      RETURN
      END
 
      SUBROUTINE dmxpy(n1,y,n2,ldm,x,m)
      DOUBLE PRECISION y(*),x(*),m(ldm,*)
 
C     purpose:
C     multiply matrix m times vector x and add the result to vector y.
 
C     parameters:
 
C     n1 integer, number of elements in vector y, and number of rows in
C     matrix m
 
C     y double precision(n1), vector of length n1 to which is added
C     the product m*x
 
C     n2 integer, number of elements in vector x, and number of columns
C     in matrix m
 
C     ldm integer, leading dimension of array m
 
C     x double precision(n2), vector of length n2
 
C     m double precision(ldm,n2), matrix of n1 rows and n2 columns
 
C     ----------------------------------------------------------------------
 
C     cleanup odd vector
 
      j = mod(n2,2)
      IF ( j .GE. 1 ) THEN
          DO i = 1,n1
              y(i) = (y(i))+x(j)*m(i,j)
          END DO
      END IF
 
C     cleanup odd group of two vectors
 
      j = mod(n2,4)
      IF ( j .GE. 2 ) THEN
          DO i = 1,n1
              y(i) = ((y(i))+x(j-1)*m(i,j-1))+x(j)*m(i,j)
          END DO
      END IF
 
C     cleanup odd group of four vectors
 
      j = mod(n2,8)
      IF ( j .GE. 4 ) THEN
          DO i = 1,n1
              y(i) = ((((y(i))+x(j-3)*m(i,j-3))+x(j-2)*m(i,j-2))+x(j-1)
     &         *m(i,j-1))+x(j)*m(i,j)
          END DO
      END IF
 
C     cleanup odd group of eight vectors
 
      j = mod(n2,16)
      IF ( j .GE. 8 ) THEN
          DO i = 1,n1
              y(i) = ((((((((y(i))+x(j-7)*m(i,j-7))+x(j-6)*m(i,j-6))+x
     &         (j-5)*m(i,j-5))+x(j-4)*m(i,j-4))+x(j-3)*m(i,j-3))+x(j-2)
     &         *m(i,j-2))+x(j-1)*m(i,j-1))+x(j)*m(i,j)
          END DO
      END IF
 
C     main loop - groups of sixteen vectors
 
      jmin = j+16
      DO j = jmin,n2,16
          DO i = 1,n1
              y(i) = ((((((((((((((((y(i))+x(j-15)*m(i,j-15))+x(j-14)*m
     &         (i,j-14))+x(j-13)*m(i,j-13))+x(j-12)*m(i,j-12))+x(j-11)
     &         *m(i,j-11))+x(j-10)*m(i,j-10))+x(j-9)*m(i,j-9))+x(j-8)*m
     &         (i,j-8))+x(j-7)*m(i,j-7))+x(j-6)*m(i,j-6))+x(j-5)*m(i,j
     &         -5))+x(j-4)*m(i,j-4))+x(j-3)*m(i,j-3))+x(j-2)*m(i,j-2))
     &         +x(j-1)*m(i,j-1))+x(j)*m(i,j)
          END DO
      END DO
      RETURN
      END
C     INCLUDE 'timer.for' 
