c***********************************************************************
      SUBROUTINE angles(ityp,ip,iq,ita,aka,aao,maxang)
      IMPLICIT REAL*8 (A-H,O-Z)
c
c      angle sorting - returns energy params in aka,aao
c                  returns angle specifiers in ita
c                  enter with maxang = dimension of arrays
c
      COMMON /odds  / nnobs , natoms , nvdws , nangls , ntors , sc
c
      INTEGER ityp(natoms) , ip(nnobs) , iq(nnobs) , ita(3,maxang)
      REAL*8 aka(maxang) , aao(maxang)
c
c arl
c      400 fff params set for local storage
c
      INTEGER conn(50)
      LOGICAL it2ok
      INTEGER nangs , i , i2 , it2 , nconn , j , i1 , i3 , it1 , it3 , k
      DIMENSION ii1(400) , ii2(400) , ii3(400) 
      REAL*8 aaka(400) , aaao(400)
c
c      parameters for hydrogen atoms
c
      REAL*8 haka(14) , haao(14)
      DATA haka/14*0.012/
      DATA haao/109.47 , 120.0 , 120.0 , 180.0 , 109.47 , 109.47 , 
     &     120.0 , 120.0 , 120.0 , 109.5 , 0.0 , 109.47 , 109.47 , 
     &     109.47/
c
c      read parameters
c
      nangls = 0
      IF ( natoms.LT.3 ) RETURN
      OPEN (Unit=21,FILE='angff.fff',STATUS='old',ERR=200)
      READ (21,*,ERR=300) nangs
      IF ( nangs.GT.400 ) GOTO 300
       do 444 i=1,nangs
          read(21,*,err=300) ii1(i),ii2(i),ii3(i),aaka(i),aaao(i)
c          print *,i,ii1(i),ii2(i),ii3(i),aaka(i),aaao(i)
444   continue
c      READ (21,*,ERR=300) (ii1(i),ii2(i),ii3(i),aaka(i),
c     &                                 aaao(i),i=1,nangs)
      CLOSE (Unit=21)
c
c      do the assignments
c      method:
c      do all atoms i2
c      find all connections to atom i2
c      permute combinations of 2 connections -> connected atoms i1,i3
c      assign parameters for angle i1,i2,i3 and add to list
c
      DO 100 i2 = 1 , natoms
         it2 = ityp(i2)
         it2ok = (it2.LE.14 .AND. it2.GE.1)
         nconn = 0
         DO 50 i = 1 , nnobs
            IF ( ip(i).EQ.i2 ) THEN
               nconn = nconn + 1
               conn(nconn) = iq(i)
            ELSEIF ( iq(i).EQ.i2 ) THEN
               nconn = nconn + 1
               conn(nconn) = ip(i)
            ENDIF
 50      CONTINUE
         IF ( nconn.GE.2 ) THEN
            DO 80 i = 1 , nconn - 1
               DO 60 j = i + 1 , nconn
                  i1 = conn(i)
                  i3 = conn(j)
                  it1 = ityp(i1)
                  it3 = ityp(i3)
                  nangls = nangls + 1
                  IF ( nangls.GT.maxang ) GOTO 400
                  ita(1,nangls) = i1
                  ita(2,nangls) = i2
                  ita(3,nangls) = i3
                  IF ( (it1.EQ.15 .OR. it3.EQ.15) .AND. it2ok ) THEN
                     aka(nangls) = haka(it2)
                     aao(nangls) = haao(it2)
                     GOTO 60
                  ENDIF
                  DO 55 k = 1 , nangs
                     IF ( it2.NE.ii2(k) ) GOTO 55
                     IF ( it1.NE.ii1(k) .OR. it3.NE.ii3(k) ) THEN
                        IF ( it3.NE.ii1(k) .OR. it1.NE.ii3(k) ) GOTO 55
                     ENDIF
                     aka(nangls) = aaka(k)
                     aao(nangls) = aaao(k)
                     GOTO 60
 55               CONTINUE
                  aka(nangls) = 0.02
                  aao(nangls) = 109.0
                  IF ( it2ok ) aao(nangls) = haao(it2)
                  WRITE (*,99001) i1 , i2 , i3 , it1 , it2 , it3 , 
     &                            aao(nangls) , aka(nangls)
                  WRITE (69,99001) i1 , i2 , i3 , it1 , it2 , it3 , 
     &                             aao(nangls) , aka(nangls)
 60            CONTINUE
 80         CONTINUE
         ENDIF
 100  CONTINUE
      RETURN
 200  WRITE (69,'('' FATAL ERROR - ANGFF.FFF NOT FOUND'')')
      STOP 'FATAL ERROR - ANGFF.FFF NOT FOUND'
 300  WRITE (69,'('' FATAL ERROR - READ ERROR IN ANGFF.FFF'')')
      STOP 'FATAL ERROR - READ ERROR IN ANGFF.FFF'
 400  WRITE (69,'('' FATAL ERROR - MAXIMUM NO OF ANGLES EXCEEDED'')')
      STOP 'FATAL ERROR - MAXIMUM NO OF ANGLES EXCEEDED'
99001 FORMAT (' *ANGLE',3I4,' ( TYPE',3I3,' ) NOT FOUND IN ANGFF.FFF**'/
     &        '     default values: angle = ',F6.1,
     &        '   force constant = ',F8.3)
      END
c***********************************************************************
      SUBROUTINE bond(ityp,ip,iq,akt,alo)
      IMPLICIT REAL*8 (A-H,O-Z)
c
c      bond sorting - returns energy params in akt,alo
c
      COMMON /odds  / nnobs , natoms , nvdws , nangls , ntors , sc
      INTEGER ityp(natoms) , ip(nnobs) , iq(nnobs)
      REAL*8 akt(nnobs) , alo(nnobs)
      INTEGER nbonds , i , j , ij , it1 , it2
c
c arl
c      200 fff params set for local storage
c
      DIMENSION itt1(200) , itt2(200)
      REAL*8 aakt(200) , aalo(200)
c
c      read parameters
c
      IF ( nnobs.EQ.0 ) RETURN
      OPEN (Unit=21,FILE='bondff.fff',STATUS='old',ERR=300)
      READ (21,*,ERR=400) nbonds
      IF ( nbonds.GT.200 ) GOTO 400
      READ (21,*,ERR=400) (itt1(i),itt2(i),aakt(i),aalo(i),
     &                                 i=1,nbonds)
      CLOSE (Unit=21)
c
c      do the assignments
c
      DO 200 i = 1 , nnobs
         DO 50 j = 1 , nbonds
            ij = j
            it1 = itt1(j)
            it2 = itt2(j)
            IF ( it1.EQ.ityp(ip(i)) .AND. it2.EQ.ityp(iq(i)) ) GOTO 100
            IF ( it2.EQ.ityp(ip(i)) .AND. it1.EQ.ityp(iq(i)) ) GOTO 100
 50      CONTINUE
         akt(i) = 300.0
         alo(i) = 1.5
         WRITE (*,99001) ip(i) , iq(i) , ityp(ip(i)) , ityp(iq(i))
         WRITE (69,99001) ip(i) , iq(i) , ityp(ip(i)) , ityp(iq(i))
         GOTO 200
 100     akt(i) = aakt(ij)
         alo(i) = aalo(ij)
 200  CONTINUE
      RETURN
 300  WRITE (69,'('' FATAL ERROR - BONDFF.FFF NOT FOUND'')')
      STOP 'FATAL ERROR - BONDFF.FFF NOT FOUND'
 400  WRITE (69,'('' FATAL ERROR - READ ERROR IN BONDFF.FFF'')')
      STOP 'FATAL ERROR - READ ERROR IN BONDFF.FFF'
99001 FORMAT (1X,'**BOND',2I4,' (TYPE',2I3,') NOT FOUND IN BONDFF**'/
     &       '    default values: length = 1.5   force constant = 300.0'
     &       )
      END
c***********************************************************************
      REAL*8 FUNCTION energ(x,y,z,chge,ityp,iatom,xyz,ndim)
      IMPLICIT REAL*8 (A-H,O-Z)
c
c      energy function
c      evaluates energy associated with one atom iatom at coordinates
c      x(iatom)=xyz(1), y(iatom)=xyz(2), z(iatom)=xyz(3)
c      ndim defines dimensionality of xyz ie 2-d (no z minim) or 3-d
cc      all SACOPY to set up single atom parameters before calling ENERG
c
      COMMON /odds  / nnobs , natoms , nvdws , nangls , ntors , sc
      REAL*8 x(natoms) , y(natoms) , z(natoms) , chge(natoms) ,xyz(ndim)
      INTEGER ityp(natoms)
      REAL*8 xsav , ysav , zsav , dengy , stdum(200)
c
c      dimensions for 'single atom' energy calculation
c
      COMMON /sateng/ ipl , iql , aktl , alol , ital , akal , aaol , 
     &                ittl , avl , afdl , n3l , n4l , eel , rrl
c
c      dimensions increased by arl; 100 angles, 200 torsions per atom
c
      REAL*8 aktl(50) , alol(50) , akal(100) , aaol(100)
      DIMENSION ital(3,100),ittl(4,200) 
      REAL*8 avl(200) , afdl(200) 
      INTEGER n3l(500) , n4l(500)
      REAL*8 eel(500) , rrl(500)
      INTEGER ipl(50) , iql(50)
c
      xsav = x(iatom)
      ysav = y(iatom)
      zsav = z(iatom)
      IF ( ndim.GT.0 ) x(iatom) = xyz(1)
      IF ( ndim.GT.1 ) y(iatom) = xyz(2)
      IF ( ndim.GT.2 ) z(iatom) = xyz(3)
c
c      evaluate all energies, no strain, no output
c
      CALL mengy(0,dengy,.TRUE.,.TRUE.,.TRUE.,.TRUE.,.FALSE.,x,y,z,ipl,
     &           iql,chge,ityp,aktl,alol,ital,akal,aaol,ittl,avl,afdl,
     &           n3l,n4l,eel,rrl,stdum)
c
      x(iatom) = xsav
      y(iatom) = ysav
      z(iatom) = zsav
      energ = dengy
      RETURN
      END
      SUBROUTINE ffread(x,y,z,ip,iq,ityp,nat,chge,maxat,maxob)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER maxat , maxob
      REAL*8 x(maxat) , y(maxat) , z(maxat) , chge(maxat)
      INTEGER ip(maxob) , iq(maxob) , ityp(maxat) , nat(maxat) , 
     &        itrans(32) , nbr(6) , jtrans(16) , i , k
      CHARACTER zsymb*2 , zelem*64 , zfile*32
      COMMON /odds  / nnobs , natoms , nvdws , nangls , ntors , sc
      DATA zelem/
     &' HHeLiBe B C N O FNeNaMgAlSi P SCl A KCaScTi VCrMnFeCoNiCuZnGaXX'
     &/
      DATA itrans/15 , 4*29 , 1 , 9 , 10 , 16 , 5*29 , 14 , 12 , 17 , 
     &     15*29/
      DATA jtrans/4*6 , 5*7 , 2*8 , 2*16 , 15 , 1 , 9/
 
c      PRINT * , 'Input file name? ==>'
c      READ (*,'(A)') zfile
c      OPEN (21,FILE=zfile)
      OPEN (21,FILE='molenrgy.in',STATUS='OLD',ACCESS='SEQUENTIAL')
      READ (21,'(//i4/)') natoms                               
      nnobs = 0
 
      DO 100 i = 1 , natoms
         READ (21,'(4x,a2,4x,3f10.5,1x,6i4)') zsymb , x(i) , y(i) , 
     &         z(i) , nbr
         nat(i) = (index(zelem,zsymb)+1)/2
         IF ( nat(i).EQ.0 ) THEN
            READ (zsymb,'(i2)') ityp(i)
            nat(i) = jtrans(ityp(i))
         ELSE
            ityp(i) = itrans(nat(i))
         ENDIF
         chge(i) = 0.0
         DO 50 k = 1 , 6
            IF ( nbr(k).GT.i ) THEN
               nnobs = nnobs + 1
               ip(nnobs) = i
               iq(nnobs) = nbr(k)
            ENDIF
 50      CONTINUE
 100  CONTINUE
      CLOSE (21)
      END
      SUBROUTINE ffwrite(x,y,z,ip,iq,ityp,nat,chge,maxat,maxob)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER maxat , maxob , i , j , ipos
      REAL*8 x(maxat) , y(maxat) , z(maxat) , chge(maxat)
      INTEGER ip(maxob) , iq(maxob) , ityp(maxat) , nat(maxat) , nbr(6)
      CHARACTER zelem*64 , zfile*32
      COMMON /odds  / nnobs , natoms , nvdws , nangls , ntors , sc
      DATA zelem/
     &' HHeLiBe B C N O FNeNaMgAlSi P SCl A KCaScTi VCrMnFeCoNiCuZnGaXX'
     &/
 
c      PRINT * , 'Output file name? ==>'
c      READ (*,'(A)') zfile
c      OPEN (21,FILE=zfile)
      OPEN (21,FILE='molenrgy.out')
      WRITE (21,'(//i4/)') natoms
 
      DO 200 i = 1 , natoms
         DO 50 j = 1 , 6
            nbr(j) = 0
 50      CONTINUE
         ipos = 0
         DO 100 j = i , nnobs
            IF ( ip(j).EQ.i ) THEN
               ipos = ipos + 1
               nbr(ipos) = iq(j)
            ELSEIF ( iq(j).EQ.i ) THEN
               ipos = ipos + 1
               nbr(ipos) = ip(j)
            ENDIF
 100     CONTINUE
         WRITE (21,'(i4,a2,4x,3f10.5,1x,6i4)') i , 
     &          zelem(2*nat(i)-1:2*nat(i)) , x(i) , y(i) , z(i) , nbr
 200  CONTINUE
      CLOSE (21)
      END 
c***********************************************************************
      SUBROUTINE mengy(ik,energ,bcalc,acalc,tcalc,vcalc,stcalc,x,y,z,ip,
     &                 iq,chge,ityp,akt,alo,ita,aka,aao,itt,av,afd,n3,
     &                 n4,ee,rr,strain)
      IMPLICIT REAL*8 (A-H,O-Z)
c
c      FULL ENERGY SUBROUTINE
c      FOR SIMPLEX - MINBT3-  AND  NEWTON RAPHSON -MINBT2-
c      JGV APRIL 1982
c      -------------------------
c      SK&F 1983 JGV
c      No liability is accepted for failure or fault on this software
c      -------------------------
c      ***************
c      BOND LENGTH,ANGLE,TORS,NONBONDING ENERGIES SUMMED
c
c      call bonds,angles,tors,chges,vdwnbi before calling this routine
c
c      bcalc .true. => calculate bond energy etc
c      stcalc .true.=> calculate strain energy for each atom
ci      k    .ne.0  => output intermediate results to fortran channel ik
c      energ returned with total energy
c
      COMMON /odds  / nnobs , natoms , nvdws , nangls , ntors , sc
      INTEGER nnobs , natoms , nvdws , nangls , ntors
      REAL*8 sc
c
c      passed variables
c
      INTEGER ik , ita(3,nangls) , itt(4,ntors) , n3(nvdws) , n4(nvdws)
     &         , ityp(natoms)
      INTEGER ip(nnobs) , iq(nnobs)
c
      REAL*8 energ , x(natoms) , y(natoms) , z(natoms) , chge(natoms)
      REAL*8 akt(nnobs) , alo(nnobs) , aka(nangls) , aao(nangls)
      REAL*8 av(ntors) , afd(ntors) , ee(nvdws) , rr(nvdws)
      REAL*8 strain(natoms)
c
      LOGICAL bcalc , acalc , tcalc , vcalc , stcalc
c
c      local variables
c
      LOGICAL used , chgedf
      INTEGER i , ii , jj , ia , ib , ic , id
      REAL*8 sumeb , sumag , sumtr , sumec , sumen
      REAL*8 rm , xx , yy , ec , en , eb , ea , et , alp , a , b , c , d
      REAL*8 hypxy , hypxz , hypyz , xs , zs , dex , dey , dez , xa ,za, 
     &     dang , per , sign
      REAL*8 p , q , r , s , t , u
      REAL*8 rm2
      SAVE used , chgedf
      DATA used/.FALSE./
c
c      initialise counters
c
      IF ( stcalc ) THEN
         DO 50 i = 1 , natoms
            strain(i) = 0.0
 50      CONTINUE
      ENDIF
      sumeb = 0.0
      sumag = 0.0
      sumtr = 0.0
      sumec = 0.0
      sumen = 0.0
c
c      look for charges
c
      IF ( used ) THEN
         IF ( chge(1).EQ.0.0 ) THEN
            chgedf = .FALSE.
         ELSE
            chgedf = .TRUE.
         ENDIF
         GOTO 200
      ENDIF
      chgedf = .FALSE.
      DO 100 i = 1 , natoms
         IF ( chge(i).NE.0.0 ) THEN
            chgedf = .TRUE.
            GOTO 200
         ENDIF
 100  CONTINUE
 200  used = .TRUE.
c
c      1,4 non bonding energy - do first & check close contacts
c
      IF ( nvdws.NE.0 .AND. natoms.GT.3 ) THEN
         IF ( vcalc ) THEN
            ec = 0.0
            DO 220 i = 1 , nvdws
               ii = n3(i)
               jj = n4(i)
               rm2 = (x(ii)-x(jj))**2 + (y(ii)-y(jj))**2 + (z(ii)-z(jj))
     &               **2
ccccccccccif (rm2.ge.225.0) goto201
               rm = sqrt(rm2)
c
c      coulombics
c
               IF ( chgedf ) THEN
                  ec = chge(ii)*chge(jj)*332.17/rm
                  sumec = sumec + ec
               ENDIF
c
c      vdw's
c
               IF ( ee(i).NE.0.0 ) THEN
                  alp = rm/rr(i)
                  xx = 8.28E05*exp(-alp*13.587)
                  IF ( rm.GE.1.0 ) THEN
                     yy = -2.25/(alp**6)
                  ELSE
c            yy=0.0
                     yy = 2.25/(rm**6)
                  ENDIF
                  en = ee(i)*(xx+yy)
                  sumen = sumen + en
               ELSE
                  en = 0.0
               ENDIF
               IF ( stcalc ) THEN
                  strain(ii) = strain(ii) + 0.5*(en+ec)
                  strain(jj) = strain(jj) + 0.5*(en+ec)
               ENDIF
 220        CONTINUE
c
            IF ( ik.NE.0 ) WRITE (ik,99001) sumec
            IF ( ik.NE.0 ) WRITE (ik,99002) sumen
         ENDIF
      ENDIF
c
c      bonds energy
c
      IF ( nnobs.NE.0 ) THEN
         IF ( bcalc ) THEN
            DO 240 i = 1 , nnobs
               ii = ip(i)
               jj = iq(i)      
               rm = sqrt((x(ii)-x(jj))**2+(y(ii)-y(jj))**2+(z(ii)-z(jj))
     &              **2)
               eb = akt(i)*(rm-alo(i))**2
               sumeb = sumeb + eb
               IF ( stcalc ) THEN
                  strain(ii) = strain(ii) + 0.5*eb
                  strain(jj) = strain(jj) + 0.5*eb
               ENDIF
               IF ( ik.NE.0 .AND. eb.GT.1.0 ) WRITE (ik,99003) ii , jj , 
     &              rm , eb
 240        CONTINUE
            IF ( ik.NE.0 ) WRITE (ik,99004) sumeb
         ENDIF
      ENDIF
c
c      angles energy
c
      IF ( nangls.NE.0 ) THEN
         IF ( acalc ) THEN
            DO 260 i = 1 , nangls
               ia = ita(1,i)
               ib = ita(2,i)
               ic = ita(3,i)
               a = (x(ia)-x(ic))**2 + (y(ia)-y(ic))**2 + (z(ia)-z(ic))
     &             **2
               b = (x(ia)-x(ib))**2 + (y(ia)-y(ib))**2 + (z(ia)-z(ib))
     &             **2
               c = (x(ib)-x(ic))**2 + (y(ib)-y(ic))**2 + (z(ib)-z(ic))
     &             **2
               d = (b+c-a)/(2.0*sqrt(b*c))
               IF ( d.LT.-1.0 ) d = -1.0
               d = acos(d)*57.2957796
               ea = aka(i)*(d-aao(i))**2
               sumag = sumag + ea
               IF ( stcalc ) THEN
                  strain(ia) = strain(ia) + 0.3333333*ea
                  strain(ib) = strain(ib) + 0.3333333*ea
                  strain(ic) = strain(ic) + 0.3333333*ea
               ENDIF
               IF ( ik.NE.0 .AND. ea.GT.1.0 ) WRITE (ik,99005) ia , ib , 
     &              ic , d , ea
 260        CONTINUE
c
            IF ( ik.NE.0 ) WRITE (ik,99006) sumag
         ENDIF
      ENDIF
c
c      torsional angle energy
c
      IF ( ntors.NE.0 ) THEN
         IF ( tcalc ) THEN
            DO 280 i = 1 , ntors
               ia = itt(1,i)
               ib = itt(2,i)
               ic = itt(3,i)
               id = itt(4,i)
               IF ( (ityp(ib).LE.10000) .AND. (ityp(ic).LE.10000) ) THEN
                  hypxy = sqrt((x(ic)-x(ib))**2+(y(ic)-y(ib))**2)
                  p = (x(ic)-x(ib))/hypxy
                  q = (y(ic)-y(ib))/hypxy
                  hypyz = sqrt((x(ib)-x(ic))**2+(y(ib)-y(ic))
     &                    **2+(z(ib)-z(ic))**2)
                  r = (z(ic)-z(ib))/hypyz
                  s = hypxy/hypyz
                  xs = (x(id)-x(ib))*q - (y(id)-y(ib))*p
                  zs = (z(id)-z(ib))
     &                 *s - ((y(id)-y(ib))*q+(x(id)-x(ib))*p)*r
                  hypxz = sqrt(xs*xs+zs*zs)
                  t = xs/hypxz
                  u = zs/hypxz
                  dex = x(ia) - x(ib)
                  dey = y(ia) - y(ib)
                  dez = z(ia) - z(ib)
                  xa = (dex*q-dey*p)*u - (dez*s-(dey*q+dex*p)*r)*t
                  za = (dez*s-(dey*q+dex*p)*r)*u + (dex*q-dey*p)*t
                  IF ( abs(za).LT.1E-8 ) THEN
                     dang = 90
                  ELSE
                     dang = 57.2957796*atan(xa/za)
                  ENDIF               
                  IF ( dang.LT.0.0 ) dang = dang + 180
c                  dang = acos(za/sqrt(xa*xa+za*za))*57.2957796
                  IF ( xa.GT.0.0001 ) dang = -dang
                  per = abs(afd(i))
                  sign = afd(i)/per
                  et = av(i)*(1.0+sign*cos(per*dang*0.0174532925))
                  sumtr = sumtr + et
                  IF ( stcalc ) THEN
                     strain(ia) = strain(ia) + 0.25*et
                     strain(ib) = strain(ib) + 0.25*et
                     strain(ic) = strain(ic) + 0.25*et
                     strain(id) = strain(id) + 0.25*et
                  ENDIF
                  IF ( ik.NE.0 .AND. et.GT.1.0 ) WRITE (ik,99007) ia , 
     &                 ib , ic , id , dang , et
               ENDIF
 280        CONTINUE
c
            IF ( ik.NE.0 ) WRITE (ik,99008) sumtr
         ENDIF
      ENDIF
c
c      total
c
      energ = sumeb + sumag + sumtr + sumec + sumen
      IF ( ik.NE.0 ) WRITE (ik,99009) energ
c
      RETURN
99001 FORMAT (10X,'Total Coulombic Energy =      ',F10.3,' Kcal/Mole')
99002 FORMAT (10X,'Total van der Waals Energy =  ',F10.3,' Kcal/Mole'/)
99003 FORMAT (' Atom',I3,' &',I3,' at',F5.2,' dist has Energy=',F10.3)
99004 FORMAT (10X,'Total Bonding Energy =        ',F10.3,' Kcal/Mole')
99005 FORMAT (' Atoms',3I3,' at',F7.1,' Degs has Energy=',F10.3)
99006 FORMAT (10X,'Total Bond Angle Energy =     ',F10.3,' Kcal/Mole')
99007 FORMAT (' Atoms',4I3,' at',F7.1,' Degs has Energy=',F10.3)
99008 FORMAT (10X,'Total Torsional Angle Energy =',F10.3,' Kcal/Mole')
99009 FORMAT (/10X,'Total Energy =',F10.3,' Kcal/Mole')
      END
      PROGRAM min02
      IMPLICIT REAL*8 (A-H,O-Z)
c
c      minimisation by NR - new version 24/7/85
c
c      link with sigmadraw/lib (drawlib,sigmalib,vaxlib,vaxttio)
c
c      parameter (maxat = 300)
c      parameter (maxob = 300)
c      parameter (maxang= 500)
c      parameter (maxtor= 600)
c      parameter (maxvdw= 20000)
 
      PARAMETER (maxat=50)
      PARAMETER (maxob=50)
      PARAMETER (maxang=80)
      PARAMETER (maxtor=100)
      PARAMETER (maxvdw=2000)
c
      COMMON /odds  / nnobs , natoms , nvdws , nangls , ntors , sc
      REAL*8 x(maxat) , y(maxat) , z(maxat) , chge(maxat)
      INTEGER ip(maxob) , iq(maxob) , nat(maxat) , ityp(maxat)
      INTEGER n3(maxvdw) , n4(maxvdw) , ita(3,maxang) , itt(4,maxtor)
      REAL*8 akt(maxob) , alo(maxob) , aka(maxang) , aao(maxang)
      REAL*8 av(maxtor) , afd(maxtor) , rr(maxvdw) , ee(maxvdw)
      INTEGER iwork(maxat)
      REAL*8 strain(maxat)
      INTEGER*2 tospn(maxat)
      INTEGER maxit , i
      REAL*8 rmsmin , engmin , rms , energ1 , energy
c
c      read molecule
c
c      CALL under0(.TRUE.)
      do ijk = 1 , 200
      OPEN (69,FILE='skf.log')
c      OPEN (6,FILE='con',filetype='tty')
      PRINT * , ' '
      PRINT * , '** FIRST DERIVATIVE MINIMISER **'
      PRINT * , ' '
      PRINT * , ' '
      maxit = 20
c         READ (11,END=250) egy , natoms , nnobs ,
c     &                     (ip(j),j=1,nnobs) , (iq(j),j=1,nnobs) ,
c     &                     (nat(j),j=1,natoms) , (x(j),j=1,natoms) ,
c     &                     (y(j),j=1,natoms) , (z(j),j=1,natoms) ,
c     &                     (ityp(j),j=1,natoms) , (chge(j),j=1,natoms)
      CALL ffread(x,y,z,ip,iq,ityp,nat,chge,maxat,maxob)
c
c      setup energy calculation parameters
c
      CALL bond(ityp,ip,iq,akt,alo)
      CALL angles(ityp,ip,iq,ita,aka,aao,maxang)
      CALL tors(ityp,ip,iq,ita,itt,av,afd,maxtor)
      CALL vdwnbi(nat,ip,iq,x,y,z,ita,n3,n4,rr,ee,iwork,maxvdw)
      DO 100 i = 1 , natoms
         tospn(i) = 3
 100  CONTINUE
c
      rmsmin = 0.1
      engmin = 0.001
c
c      use simplex only if rms is enormous
c
      CALL nrmin(0,rmsmin,engmin,6,tospn,x,y,z,ip,iq,chge,ityp,
     &           akt,alo,ita,aka,aao,itt,av,afd,n3,n4,ee,rr,strain,
     &           iwork,rms,energ1)
      CALL nrmin(maxit,rmsmin,engmin,6,tospn,x,y,z,ip,iq,chge,
     &           ityp,akt,alo,ita,aka,aao,itt,av,afd,n3,n4,ee,rr,strain,
     &           iwork,rms,energy)
      CALL nrmin(0,rmsmin,engmin,6,tospn,x,y,z,ip,iq,chge,ityp,
     &           akt,alo,ita,aka,aao,itt,av,afd,n3,n4,ee,rr,strain,
     &           iwork,rms,energy)
c
c         WRITE (2) energy , natoms , nnobs ,
c     &             (ip(j),j=1,nnobs) , (iq(j),j=1,nnobs) ,
c     &             (nat(j),j=1,natoms) , (x(j),j=1,natoms) ,
c     &             (y(j),j=1,natoms) , (z(j),j=1,natoms) ,
c     &             (ityp(j),j=1,natoms) , (chge(j),j=1,natoms)
      CALL ffwrite(x,y,z,ip,iq,ityp,nat,chge,maxat,maxob)
      enddo
      END
c***********************************************************************
      SUBROUTINE nrmin(maxit,rmsmin,engmin,idev,tospn,x,y,z,ip,
     &                 iq,chge,ityp,akt,alo,ita,aka,aao,itt,av,afd,n3,
     &                 n4,ee,rr,strain,iwork,rms,energy)
      IMPLICIT REAL*8 (A-H,O-Z)
c
c      Generalised Newton Raphson / Simplex minimiser
c      call bonds,angles,tors,vdwnbi before calling this routine
c
c      maxit      - Maximum no. of iterations allowed
c      rmsmin      - Convergence criterion - exit when rms less than rms
c      engmin      - Convergence criterion - exit when energy reduced by
c      idev      - Device for output of results (0=no output)
c      tospn      - Integer*2 array defines which atoms to move
c              0 => do not move, 1 => min x ...3 => min x,y,z
c      x,y,z      - Starting coordinates
c      ip,iq      - Connectivity
c      chge      - Partial atomic charges
c      akt,alo      - Bond stretch parameters
c      ita      - Angle atom specifiers
c      aka,aao      - Angle bend parameters
c      itt      - Torsional angle specifiers
c      av,afd      - Torsional rock parameters
c      n3,n4      - VDW interaction specifiers
c      ee,rr      - VDW energy parameters
c      strain      - Real array, returned with energy of each atom
c      iwork      - Integer array (natoms) - workspace
c      rms      - Returned containing RMS at minimum
c      energy      - Returned containing energy at minimum
c
      COMMON /odds  / nnobs , natoms , nvdws , nangls , ntors , sc
c
      REAL*8 dstep , fderiv(3) , bderiv(3) , am(3) , sm(3) , xyz(3) , 
     &     xyzs(3) , rdstp
c
      REAL*8 x(natoms) , y(natoms) , z(natoms) , chge(natoms)
      INTEGER ip(nnobs) , iq(nnobs) , ita(3,nangls) , itt(4,ntors) , 
     &        ityp(natoms)
      INTEGER n3(nvdws) , n4(nvdws) , ndim
      REAL*8 akt(nnobs) , alo(nnobs) , aka(nangls) , aao(nangls)
      REAL*8 av(ntors) , afd(ntors) , rr(nvdws) , ee(nvdws)
      INTEGER iwork(natoms)
      REAL*8 strain(natoms)
      INTEGER*2 tospn(natoms)
      LOGICAL simflg
c
c      dimensions for 'single atom' energy calculation
c
      COMMON /sateng/ ipl , iql , aktl , alol , ital , akal , aaol , 
     &                ittl , avl , afdl , n3l , n4l , eel , rrl
c
c      dimensions increased by arl; 100 angles, 200 torsions per atom
c
      REAL*8 aktl,alol,akal,aaol,avl,afdl,eel,rrl
      DIMENSION aktl(50) , alol(50) , ital(3,100) , akal(100) , 
     &          aaol(100)
      DIMENSION ittl(4,200) , avl(200) , afdl(200) , n3l(500) , n4l(500)
      DIMENSION eel(500) , rrl(500) , ipl(50) , iql(50)
      INTEGER i , jnobs , jangls , jtors , jvdws , jatoms , iiter , kk , 
     &        mnobs , mangls , mtors , mvdws , j
 
      REAL*8 engy , englst , sgd , sgg , fengy , sga , psave , dengy , 
     &     vv , s , dmult , gengy
 
      DATA dstep/0.002/ , rdstp/500.0/
c
c      say what we're doing
c
      IF ( idev.NE.0 ) THEN
         WRITE (idev,
     &  '(i5,'' Iterations to RMS ='',f7.2,'' or'',f7.2,'' cal/Mole''/)'
     &  ) maxit , rmsmin , engmin*1000.0
      ENDIF
c
c      save parameter array sizes
c
      jnobs = nnobs
      jangls = nangls
      jtors = ntors
      jvdws = nvdws
c
c      calculate no. of atoms to minimise (for rms)
c
      jatoms = 0
      DO 100 i = 1 , natoms
         IF ( tospn(i).NE.0 ) THEN
            ndim = tospn(i)
            jatoms = jatoms + ndim
         ENDIF
 100  CONTINUE
c
c      rotate and calculate start energy
c
      CALL mengy(idev,engy,.TRUE.,.TRUE.,.TRUE.,.TRUE.,.TRUE.,x,y,z,ip,
     &           iq,chge,ityp,akt,alo,ita,aka,aao,itt,av,afd,n3,n4,ee,
     &           rr,strain)
c
      englst = engy + engmin + 1000.0
c
      IF ( maxit.LE.0 ) THEN
         IF ( idev.NE.0 ) THEN
            WRITE (69,'('' unminimised ENERGY = '',f9.3)') engy
            WRITE (idev,'(/10x,''Final ENERGY = '',f9.3/)') engy
         ENDIF
         energy = engy
         RETURN
      ENDIF
c
c      loop starts here
c
      DO 200 iiter = 1 , maxit
c
c      exit tests
c
         IF ( abs(englst-engy).LE.engmin ) GOTO 300
c
         englst = engy
c
c      sort atoms according to energy
c
         CALL shells(strain,iwork,natoms)
         sgd = 0.0
         sgg = 0.0
         DO 150 kk = natoms , 1 , -1
c
c      consider atoms most energetic -> least energetic
c
            i = iwork(kk)
c
c      only minimise if tospn is .true.
c
            IF ( tospn(i).NE.0 ) THEN
               ndim = tospn(i)
c
c      setup single atom energy parameters
c
               CALL sacopy(i,mnobs,mangls,mtors,mvdws,ip,iq,akt,alo,ita,
     &                     aka,aao,itt,av,afd,n3,n4,ee,rr)
c
c      setup array sizes in common
c
               nnobs = mnobs
               nangls = mangls
               ntors = mtors
               nvdws = mvdws
 
               xyz(1) = x(i)
               xyz(2) = y(i)
               xyz(3) = z(i)
               fengy = energ(x,y,z,chge,ityp,i,xyz,ndim)
c
               sga = 0.0
c
c      find derivatives
c
               DO 110 j = 1 , ndim
                  psave = xyz(j)
                  xyz(j) = psave + dstep
                  dengy = energ(x,y,z,chge,ityp,i,xyz,ndim)
                  fderiv(j) = (dengy-fengy)*rdstp
                  xyz(j) = psave - dstep
                  dengy = energ(x,y,z,chge,ityp,i,xyz,ndim)
                  bderiv(j) = (fengy-dengy)*rdstp
                  xyz(j) = psave
                  vv = 0.5*(fderiv(j)+bderiv(j))
c
c      rms
c
                  sga = sga + vv*vv
                  sgd = sgd + vv*vv
c
c      calculate movement for NR method, or step length for simplex
c
                  am(j) = abs((fderiv(j)-bderiv(j))*rdstp)
                  IF ( am(j).GE.1.0E-20 ) am(j) = -vv/am(j)
c
c      limit step size for simplex
c
                  sm(j) = am(j)
                  s = abs(am(j))
                  IF ( s.EQ.0.0 ) s = 0.0001
                  IF ( s.GT.0.2 ) sm(j) = 0.2*sm(j)/s
                  IF ( s.LT.0.001 ) sm(j) = 0.01
 110           CONTINUE
c
               sga = sqrt(sga/float(ndim))
               IF ( idev.NE.0 .AND. sga.GT.50.0 )
     &               WRITE (idev,'('' Atom '',i4,'' has RMS = '',f9.1)')
     &               i , sga
c
c      NR
c
               sgg = sgg + am(1)**2
               IF ( ndim.GT.1 ) sgg = sgg + am(2)**2
               IF ( ndim.GT.2 ) sgg = sgg + am(3)**2
c
               dmult = 1.42
 120           xyzs(1) = xyz(1) + dmult*am(1)
               IF ( ndim.GT.1 ) xyzs(2) = xyz(2) + dmult*am(2)
               IF ( ndim.GT.2 ) xyzs(3) = xyz(3) + dmult*am(3)
               gengy = energ(x,y,z,chge,ityp,i,xyzs,ndim)
               IF ( gengy.GT.fengy .AND. dmult.GT.0.1 ) THEN
                  dmult = dmult*0.70
                  GOTO 120
               ENDIF
               IF ( dmult.GT.0.1 ) THEN
                  x(i) = xyzs(1)
                  IF ( ndim.GT.1 ) y(i) = xyzs(2)
                  IF ( ndim.GT.2 ) z(i) = xyzs(3)
               ENDIF
c
c      recover full array sizes
c
               nnobs = jnobs
               nangls = jangls
               ntors = jtors
               nvdws = jvdws
            ENDIF
 150     CONTINUE
c
c      evaluate total energy for output and minimisation test
c
         CALL mengy(0,engy,.TRUE.,.TRUE.,.TRUE.,.TRUE.,.TRUE.,x,y,z,ip,
     &              iq,chge,ityp,akt,alo,ita,aka,aao,itt,av,afd,n3,n4,
     &              ee,rr,strain)
         sgd = sqrt(sgd/float(jatoms))
         sgg = sqrt(sgg/float(jatoms))
c
c      tell the waiting crowd
c
         IF ( idev.NE.0 ) THEN
            IF ( mod(iiter,15).EQ.1 ) WRITE (idev,
     &'(/'' Iter  Energy RMS   Dist RMS     Energy'',            ''  [Tt
     &o stop]''/)')
            WRITE (idev,'(1x,i4,2x,f10.3,2x,f9.4,2x,f9.3)') iiter , 
     &             sgd , sgg , engy
         ENDIF
c
c      exit condition on rms
c
         IF ( sgd.LT.rmsmin ) GOTO 300
c
 200  CONTINUE
c
c      one final energy, to say we've done
c
 300  CALL mengy(idev,engy,.TRUE.,.TRUE.,.TRUE.,.TRUE.,.TRUE.,x,y,z,ip,
     &           iq,chge,ityp,akt,alo,ita,aka,aao,itt,av,afd,n3,n4,ee,
     &           rr,strain)
c
      IF ( idev.NE.0 ) WRITE (idev,'(/10x,''Final RMS    = '',f9.3/)')
     &                         sgd
      IF ( idev.NE.0 ) WRITE (idev,'(10x,''Distance RMS = '',f10.4/)')
     &                         sgg
      WRITE (69,'('' Final ENERGY = '',f9.3)') engy
      WRITE (69,'('' Final    RMS = '',f9.3)') sgd
      WRITE (69,'('' Distance RMS = '',f10.4)') sgg
c
      energy = engy
      rms = sgd
      RETURN
      END
c***********************************************************************
      SUBROUTINE sacopy(i,mnobs,mangls,mtors,mvdws,ip,iq,akt,alo,ita,
     &                  aka,aao,itt,av,afd,n3,n4,ee,rr)
      IMPLICIT REAL*8 (A-H,O-Z)
c
c      copies energy parameters relevant to atom i into the
c      single atom energy arrays. Returns mnobs,mangls...etc
c
      COMMON /odds  / nnobs , natoms , nvdws , nangls , ntors , sc
c
      INTEGER ip(nnobs) , iq(nnobs) , ita(3,nangls) , itt(4,ntors)
      INTEGER n3(nvdws) , n4(nvdws)
      REAL*8 akt(nnobs) , alo(nnobs) , aka(nangls) , aao(nangls)
      REAL*8 av(ntors) , afd(ntors) , rr(nvdws) , ee(nvdws)
      INTEGER arlang , arltor , arlvdw
      INTEGER j
c
c      dimensions for 'single atom' energy calculation
c
      COMMON /sateng/ ipl , iql , aktl , alol , ital , akal , aaol , 
     &                ittl , avl , afdl , n3l , n4l , eel , rrl
c
c      dimensions increased by arl; 100 angles, 200 torsions per atom
c
      REAL*8 aktl,alol,akal,aaol,avl,afdl,eel,rrl
      DIMENSION aktl(50) , alol(50) , ital(3,100) , akal(100) , 
     &          aaol(100)
      DIMENSION ittl(4,200) , avl(200) , afdl(200) , n3l(500) , n4l(500)
      DIMENSION eel(500) , rrl(500) , ipl(50) , iql(50)
c
      arlang = 100
      arltor = 200
      arlvdw = 500
c
c      sort bonds
c
      mnobs = 0
      DO 100 j = 1 , nnobs
         IF ( ip(j).EQ.i .OR. iq(j).EQ.i ) THEN
            mnobs = mnobs + 1
            ipl(mnobs) = ip(j)
            iql(mnobs) = iq(j)
            aktl(mnobs) = akt(j)
            alol(mnobs) = alo(j)
         ENDIF
 100  CONTINUE
c
c      sort angles
c
      mangls = 0
      DO 200 j = 1 , nangls
         IF ( ita(1,j).EQ.i .OR. ita(2,j).EQ.i .OR. ita(3,j).EQ.i ) THEN
            mangls = mangls + 1
            IF ( mangls.GT.arlang ) THEN
               WRITE (69,'('' Too many angles on single atom'')')
               STOP 'Too many angles on single atom'
            ENDIF
            ital(1,mangls) = ita(1,j)
            ital(2,mangls) = ita(2,j)
            ital(3,mangls) = ita(3,j)
            akal(mangls) = aka(j)
            aaol(mangls) = aao(j)
         ENDIF
 200  CONTINUE
c
c      sort torsions
c
      mtors = 0
      DO 300 j = 1 , ntors
         IF ( itt(1,j).EQ.i .OR. itt(2,j).EQ.i .OR. itt(3,j).EQ.i .OR. 
     &        itt(4,j).EQ.i ) THEN
            mtors = mtors + 1
            IF ( mtors.GT.arltor ) THEN
               WRITE (69,'('' Too many torsions on single atom'')')
               STOP 'Too many torsions on single atom'
            ENDIF
            ittl(1,mtors) = itt(1,j)
            ittl(2,mtors) = itt(2,j)
            ittl(3,mtors) = itt(3,j)
            ittl(4,mtors) = itt(4,j)
            avl(mtors) = av(j)
            afdl(mtors) = afd(j)
         ENDIF
 300  CONTINUE
c
c      sort vdw interactions
c
      mvdws = 0
      DO 400 j = 1 , nvdws
         IF ( n3(j).EQ.i .OR. n4(j).EQ.i ) THEN
            mvdws = mvdws + 1
            IF ( mvdws.GT.arlvdw ) THEN
               WRITE (69,'('' Too many vdw on single atom'')')
               STOP 'Too many vdw on single atom'
            ENDIF
            n3l(mvdws) = n3(j)
            n4l(mvdws) = n4(j)
            rrl(mvdws) = rr(j)
            eel(mvdws) = ee(j)
         ENDIF
 400  CONTINUE
      RETURN
      END


C***********************************************************************
      SUBROUTINE shells(array,iorder,nelems)
c
c     Sets up an array IORDER which points to the order (ascending) of
c     the elements of ARRAY.  NELEMS is the number of elements in
c     ARRAY  and IORDER.
c
c     The 'SHELL SORT' used for this was filched from one of J.Newman's
c     programmes, and he got it from 'ACORN USER' magazine.
c
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER i , n , m , j , k , itemp
      REAL*8 array(nelems) 
      INTEGER iorder(nelems)
c
c  Initialise IORDER
      DO 100 i = 1 , nelems
         iorder(i) = i
 100  CONTINUE
      n = nelems
      IF ( nelems.LT.2 ) RETURN
 200  n = (n+2)/3
      DO 300 m = n + 1 , n*3
         DO 250 j = m , nelems , n
            DO 220 k = j , m , -n
               IF ( array(iorder(k)).GE.array(iorder(k-n)) ) GOTO 250
c swap values in temp, iorder
               itemp = iorder(k)
               iorder(k) = iorder(k-n)
               iorder(k-n) = itemp
 220        CONTINUE
 250     CONTINUE
 300  CONTINUE
      IF ( n.NE.1 ) GOTO 200
      RETURN
      END
c***********************************************************************
      SUBROUTINE tors(ityp,ip,iq,ita,itt,av,afd,maxtor)
      IMPLICIT REAL*8 (A-H,O-Z)
c
c      tors sorting -  returns energy params in av,afd
c                  returns angle specifiers in itt
c                  enter with maxtor = dimension of arrays
c      nb call ANGLES before calling this routine
c
      COMMON /odds  / nnobs , natoms , nvdws , nangls , ntors , sc
c
      INTEGER ityp(natoms) , ip(nnobs) , iq(nnobs) , ita(3,nangls)
      INTEGER itt(4,maxtor)
      REAL*8 av(maxtor) , afd(maxtor)
c
c arl
c      400 fff params set for local storage
c
      LOGICAL torset
      INTEGER ic1(50) , ic4(50)
      INTEGER nto , i , ib , i2 , it2 , i3 , it3 , ni1 , ni4 , ia , 
     &        ia2 , ia1 , ia3 , k , ik , it5 , it6 , j , i1 , i4
      REAL*8 vo1 , fd1
      DIMENSION itt5(400) , itt6(400)
      REAL*8 vo(400) , fd(400)
c
c      read parameters
c
      ntors = 0
      IF ( natoms.LT.4 ) RETURN
      OPEN (Unit=21,FILE='torff.fff',STATUS='old',ERR=400)
      READ (21,*,ERR=500) nto
      IF ( nto.GT.400 ) GOTO 500
      READ (21,*,ERR=500) (itt5(i),itt6(i),vo(i),fd(i),i=1,
     &                                 nto)
      CLOSE (Unit=21)
c
c      do the assignments
c      method:
c      do all bonds i2,i3
c      find all angles with 2 matches, either way, to i2,i3
c      permute combinations of 2 angles -> connected atoms i1,i4
ca      ssign parameters for torsional angle i1,i2,i3,i4 and add to list
c
      DO 300 ib = 1 , nnobs
         i2 = ip(ib)
         it2 = ityp(i2)
         i3 = iq(ib)
         it3 = ityp(i3)
         ni1 = 0
         ni4 = 0
         DO 50 ia = 1 , nangls
            ia2 = ita(2,ia)
            IF ( ia2.EQ.i2 .OR. ia2.EQ.i3 ) THEN
               ia1 = ita(1,ia)
               ia3 = ita(3,ia)
               IF ( ia2.EQ.i2 .AND. ia3.EQ.i3 ) THEN
                  ni1 = ni1 + 1
                  ic1(ni1) = ia1
               ELSEIF ( ia2.EQ.i2 .AND. ia1.EQ.i3 ) THEN
                  ni1 = ni1 + 1
                  ic1(ni1) = ia3
               ELSEIF ( ia2.EQ.i3 .AND. ia3.EQ.i2 ) THEN
                  ni4 = ni4 + 1
                  ic4(ni4) = ia1
               ELSEIF ( ia2.EQ.i3 .AND. ia1.EQ.i2 ) THEN
                  ni4 = ni4 + 1
                  ic4(ni4) = ia3
               ENDIF
            ENDIF
 50      CONTINUE
         IF ( ni1.EQ.0 .OR. ni4.EQ.0 ) GOTO 300
c
c      assign based on it2,it3
c
         torset = .FALSE.
         DO 100 k = 1 , nto
            ik = k
            it5 = itt5(k)
            it6 = itt6(k)
            IF ( it2.EQ.it5 .AND. it3.EQ.it6 ) GOTO 150
            IF ( it3.EQ.it5 .AND. it2.EQ.it6 ) GOTO 150
 100     CONTINUE
         vo1 = 0.1
         fd1 = 3.0
         torset = .FALSE.
         GOTO 200
 150     vo1 = vo(ik)
         fd1 = fd(ik)
         torset = .TRUE.
c
c        permute the angles
c
 200     DO 250 i = 1 , ni1
            DO 220 j = 1 , ni4
               i1 = ic1(i)
               i4 = ic4(j)
               ntors = ntors + 1
               IF ( ntors.GT.maxtor ) GOTO 600
               itt(1,ntors) = i1
               itt(2,ntors) = i2
               itt(3,ntors) = i3
               itt(4,ntors) = i4
               av(ntors) = vo1
               afd(ntors) = fd1
               IF ( .NOT.torset ) WRITE (*,99001) i1 , i2 , i3 , i4 , 
     &              it2 , it3 , fd1 , vo1
               IF ( .NOT.torset ) WRITE (69,99001) i1 , i2 , i3 , i4 , 
     &              it2 , it3 , fd1 , vo1
 220        CONTINUE
 250     CONTINUE
 300  CONTINUE
      RETURN
 400  WRITE (69,'('' FATAL ERROR - TORFF.FFF NOT FOUND'')')
      STOP 'FATAL ERROR - TORFF.FFF NOT FOUND'
 500  WRITE (69,'('' FATAL ERROR - READ ERROR IN TORFF.FFF'')')
      STOP 'FATAL ERROR - READ ERROR IN TORFF.FFF'
 600  WRITE (69,'('' FATAL ERROR - MAXIMUM NO OF TORSIONS EXCEEDED'')')
      STOP 'FATAL ERROR - MAXIMUM NO OF TORSIONS EXCEEDED'
99001 FORMAT (' *TORS  ',4I4,' ( TYPE',2I3,
     &        ' ) NOT FOUND IN TORFF.FFF**'/
     &        '     default values: multip = ',F6.1,
     &        '   force constant = ',F8.3)
      END
c***********************************************************************
      SUBROUTINE vdwnbi(nat,ip,iq,x,y,z,ita,n3,n4,rr,ee,vdw,maxvdw)
      IMPLICIT REAL*8 (A-H,O-Z)
c
cv      dw sorting -   returns energy params in rr,ee, indices in n3,n4
c                  enter with maxvdw = dimension of arrays
c      nb call ANGLES before calling this routine
c      integer array vdw(natoms) must be passed as workspace
c
      COMMON /odds  / nnobs , natoms , nvdws , nangls , ntors , sc
c
      INTEGER nat(natoms) , ip(nnobs) , iq(nnobs)
      REAL*8 x(natoms) , y(natoms) , z(natoms)
      INTEGER ita(3,nangls)
      INTEGER n3(maxvdw) , n4(maxvdw) , maxvdw , vdw(natoms)
      REAL*8 rr(maxvdw) , ee(maxvdw)
      INTEGER i , j , nip , iip , iiq , niq , k , ita1 , ita2 , ita3 , 
     &        n4a , ii , jj , ivdw , n3a
      REAL*8 vdwmax , rrr
      REAL*8 e(10,10) , rs(10)
c
c  vdwff.fff is
c  H C N O F (P) Cl Br I protonic H
c            (S)
      INTEGER vdat(54)
      DATA vdat/1 , 1 , 1 , 1 , 1 , 2 , 3 , 4 , 5 , 2 , 2 , 2 , 2 , 2 , 
     &     6 , 6 , 7 , 6 , 6 , 6 , 6 , 6 , 6 , 6 , 6 , 6 , 6 , 6 , 6 , 
     &     6 , 6 , 6 , 6 , 6 , 8 , 6 , 6 , 6 , 6 , 6 , 6 , 6 , 6 , 6 , 
     &     6 , 6 , 6 , 6 , 6 , 6 , 6 , 6 , 9 , 1000/
c
c      read vdw parameters from vdwff.fff into memory
c
      nvdws = 0
      vdwmax = 15.0
      IF ( natoms.LT.4 ) RETURN
      OPEN (Unit=21,FILE='vdwff.fff',STATUS='old',ERR=700)
      READ (21,*,ERR=800) (rs(i),i=1,10)
      READ (21,*,ERR=800) ((e(i,j),j=1,10),i=1,10)
      CLOSE (Unit=21)
      DO 100 i = 1 , 10
         DO 50 j = 1 , 10
            e(j,i) = e(i,j)
 50      CONTINUE
 100  CONTINUE
c
c      setup initial guesses at types
c
      DO 200 i = 1 , natoms
         nip = nat(i)
         IF ( nip.LT.1 .OR. nip.GT.53 ) nip = 54
         vdw(i) = vdat(nip)
 200  CONTINUE
c
c      refine guesses of types, include protonic hydrogens
c
      DO 300 i = 1 , nnobs
         iip = ip(i)
         iiq = iq(i)
         nip = nat(iip)
         niq = nat(iiq)
         IF ( nip.LT.1 .OR. nip.GT.53 ) nip = 54
         IF ( niq.LT.1 .OR. niq.GT.53 ) niq = 54
         IF ( nip.EQ.1 .AND. (niq.EQ.7 .OR. niq.EQ.8) ) vdw(iip) = 10
         IF ( niq.EQ.1 .AND. (nip.EQ.7 .OR. nip.EQ.8) ) vdw(iiq) = 10
 300  CONTINUE
c
c      find which atom pairs are to be included
c
      DO 400 i = 1 , natoms - 1
         IF ( abs(vdw(i)).NE.1000 ) THEN
c
c        find which atoms are in same angle specifier as i, flag as not
c        included by setting vdw(i) negative. First set all vdw(i) posit
c
            DO 320 k = 1 , natoms
               vdw(k) = abs(vdw(k))
 320        CONTINUE
            DO 340 k = 1 , nangls
               ita1 = ita(1,k)
               ita2 = ita(2,k)
               ita3 = ita(3,k)
               IF ( i.EQ.ita1 .OR. i.EQ.ita2 .OR. i.EQ.ita3 ) THEN
                  vdw(ita1) = -1.0*abs(vdw(ita1))
                  vdw(ita2) = -1.0*abs(vdw(ita2))
                  vdw(ita3) = -1.0*abs(vdw(ita3))
               ENDIF
 340        CONTINUE
c
c        step through vdw interactions, setting up
c
            DO 380 j = i , natoms
               n4a = vdw(j)
               IF ( vdw(j).EQ.1000 ) GOTO 380
               IF ( vdw(j).LT.0 ) GOTO 380
               nvdws = nvdws + 1
 350           IF ( nvdws.GT.maxvdw ) THEN
c
c          code here to remove vdw's at larger than vdwmax angstroms
c          find distance i,j if not found already in rr,flag removal in
c
                  WRITE (*,99001) maxvdw , vdwmax
                  WRITE (69,99001) maxvdw , vdwmax
                  DO 355 k = 1 , nvdws - 1
                     IF ( rr(k).LE.0.0 ) THEN
                        ii = n3(k)
                        jj = n4(k)
                        rr(k) = sqrt((x(ii)-x(jj))**2+(y(ii)-y(jj))**2+(
     &                          z(ii)-z(jj))**2)
                     ENDIF
                     IF ( rr(k).GT.vdwmax ) THEN
                        ee(k) = 1.0
                     ELSE
                        ee(k) = -1.0
                     ENDIF
 355              CONTINUE
                  ivdw = 0
                  DO 360 k = 1 , nvdws - 1
                     IF ( ee(k).LT.0.0 ) THEN
                        ivdw = ivdw + 1
                        n3(ivdw) = n3(k)
                        n4(ivdw) = n4(k)
                        rr(ivdw) = rr(k)
                     ENDIF
 360              CONTINUE
                  ivdw = ivdw + 1
                  nvdws = ivdw
                  vdwmax = vdwmax - 2.0
                  IF ( vdwmax.LT.4.0 ) GOTO 900
                  IF ( nvdws.GT.maxvdw ) GOTO 350
               ENDIF
               rr(nvdws) = -1.0
               n3(nvdws) = i
               n4(nvdws) = j
 380        CONTINUE
         ENDIF
 400  CONTINUE
c
c      now assign the ee and rr parameters
c
      DO 500 k = 1 , natoms
         vdw(k) = abs(vdw(k))
 500  CONTINUE
      DO 600 i = 1 , nvdws
         n3a = vdw(n3(i))
         n4a = vdw(n4(i))
         rrr = rs(n3a)
         IF ( n3a.EQ.10 ) THEN
            IF ( n4a.EQ.3 ) THEN
            ELSEIF ( n4a.EQ.4 ) THEN
            ELSEIF ( n4a.EQ.5 ) THEN
            ELSEIF ( n4a.EQ.7 ) THEN
            ELSEIF ( n4a.NE.8 ) THEN
               rrr = 1.0
            ENDIF
         ENDIF
         rr(i) = rrr + rs(n4a)
         ee(i) = e(n3a,n4a)
 600  CONTINUE
c
c      end of calculation - write out summary
c
      WRITE (*,99002)
      WRITE (*,99003) natoms , nnobs , nangls , ntors , nvdws
      WRITE (69,99003) natoms , nnobs , nangls , ntors , nvdws
      WRITE (*,99004)
c
      RETURN
 700  WRITE (69,'('' FATAL ERROR - VDWFF.FFF NOT FOUND'')')
      STOP 'FATAL ERROR - VDWFF.FFF NOT FOUND'
 800  WRITE (69,'('' FATAL ERROR - READ ERROR IN VDWFF.FFF'')')
      STOP 'FATAL ERROR - READ ERROR IN VDWFF.FFF'
 900  nvdws = 0
      PRINT * , '*****************************************************'
      PRINT * , '*  Fatal error - vdw range limited to <4 Angstroms  *'
      PRINT * , '*****************************************************'
      WRITE (69,
     &'('' Fatal error - vdw range limited to '',            ''<4 Angstr
     &oms'')')
      RETURN
99001 FORMAT (/' **There are more than ',I6,
     &        ' VDW Interactions **'/' The vdws will be limited to a ',
     &        F5.1,' angs. range')
99002 FORMAT (' ---------------Internal Parameters-------------')
99003 FORMAT (' |Atoms',I4,' Bonds',I4,' Angs',I4,' Tors',I4,' Vdw',I5,
     &        '|')
99004 FORMAT (' -----------------------------------------------')
      END
