      PROGRAM TFFT
c      PARAMETER (NN=1024)
c      PARAMETER (NN=8 192)
c      PARAMETER (NN=32 768)
c      PARAMETER (NN=131 072)
c      PARAMETER (NN=262 144)
c      PARAMETER (NN=524 288)
      PARAMETER (NN=1 048 576)
      REAL*4 X(NN),TRG(NN/4)
      integer*4 IBI(NN/2)
      INTEGER*4 I0,I1,IA,IB
c      CHARACTER ANS*1
      LOGICAL PRI
C
c      WRITE (*,10)
c   10 FORMAT (' Enter N ->',$)
c      READ (*,*) N
c      IF (N.GT.NN) STOP 'Too Big'
c      PRINT 15
c   15 FORMAT (' Output? [Y/N]:',$)
c      READ '(A1)', ANS
c      PRI=ANS.EQ.'Y'.OR.ANS.EQ.'y'
c
      n=nn                              ! Fake these answers for testing
      pri=.FALSE.
      ntrial=20
      print * , ' TFFT Output =========================='
      print *, 'N = ',n
C
      IF (PRI) OPEN (UNIT=7,FILE='T.OUT',FORM='FORMATTED')
C
      DO 20 I=1,N
   20 X(I)=0
      DO 30 I=1,10
   30 X(I)=1
      DO 40 I=N-8,N
   40 X(I)=1
C
c      CALL TIMER(IA)
      DO 500 ITRIAL=1,NTRIAL
C
      IF (PRI) THEN
        PRINT *, 'Writing Original Time Series'
        CALL OUT1(X,N,'ORIGINAL TIME SERIES','X')
      ENDIF
C
      PRINT *, 'FFTfwd, trial ',itrial
c      IF (NTRIAL.EQ.1) CALL TIMER(I0)
      CALL RFFT(X,TRG,IBI,N,+1)
c      IF (NTRIAL.EQ.1) THEN
c        CALL TIMER(I1)
c        PRINT 100, 0.01*float(I1-I0)
c  100   FORMAT (' Forward Transform: DT=',F10.3,' sec')
c      ENDIF
C
      IF (PRI) THEN
        PRINT *, 'Writing Transform'
        CALL OUT1C(X,N/2,'TRANSFORM','XT')
      ENDIF
C
      PRINT *, 'FFTinv, trial ',itrial
c      IF (NTRIAL.EQ.1) CALL TIMER(I0)
      CALL RFFT(X,TRG,IBI,N,-1)
c      IF (NTRIAL.EQ.1) THEN
c        CALL TIMER(I1)
c        PRINT 200, 0.01*float(I1-I0)
c  200   FORMAT (' Inverse Transform: DT=',F10.3,' sec')
c      ENDIF
C
      IF (PRI) THEN
        PRINT *, 'Writing Inverse'
        CALL OUT1(X,N,'TEST INVERSION','X')
      ENDIF
C
  500 CONTINUE
c      CALL TIMER(IB)
c      PRINT 510, ntrial,0.01*float(IB-IA)
c  510 FORMAT (' Total time for',I5,' passes: DT=',F10.3,' sec')
C
C     Computing RMS Error
C
      ERRTOT=0
      DO 610 I=1,10
  610 ERRTOT=ERRTOT+(X(I)-1)**2
      DO 620 I=11,N-9
  620 ERRTOT=ERRTOT+X(I)**2
      DO 630 I=N-8,N
  630 ERRTOT=ERRTOT+(X(I)-1)**2
      ERRRMS=SQRT(ERRTOT/FLOAT(N))
      PRINT 640, ERRRMS
  640 FORMAT (' RMS Error = ',1P,E15.7)
C
      STOP
      END
      SUBROUTINE OUT1(X,N,TITLE,COLHED)
      DIMENSION X(*)
      CHARACTER TITLE*(*),COLHED*(*),FMT1*11,FMT2*17
C
      LA=MIN(LEN_TRIM(TITLE),70)
      LS=(72-LA)/2
      L10=LS/10
      L1=MOD(LS,10)
      FMT1='(1H1,10X,A)'
c      FMT1(6:7)=CHAR(48+L10)//CHAR(48+L1)
      FMT1(6:6)=CHAR(48+L10)
      FMT1(7:7)=CHAR(48+L1)
C
      LB=MIN(LEN_TRIM(COLHED),8)
      LS=9-LB
      L10=LS/10
      L1=MOD(LS,10)
      FMT2='(1X,6(01X,A8,3X))'
c      FMT2(7:8)=CHAR(48+L10)//CHAR(48+L1)
      FMT2(7:7)=CHAR(48+L10)
      FMT2(8:8)=CHAR(48+L1)
      FMT2(12:12)=CHAR(48+LB)
C
      I1=1
   10 I2=MIN(I1+49,N)
      WRITE (7,FMT1) TITLE(1:LA)
C
      I0=MIN(1+((N-I1)/50),6)
      WRITE (7,FMT2) (COLHED(1:LB),I=1,I0)
C
      DO 50 I=I1,I2
      J2=50*MIN((N-I)/50,5)
   50 WRITE (7,60) (X(I+J),J=0,J2,50)
   60 FORMAT (1X,1P,6E12.4)
      I1=I1+300
      IF (I1.LT.N) GO TO 10
      RETURN
      END
 
      SUBROUTINE OUT1C(X,N,TITLE,COLHED)
      REAL X(2,*)
      CHARACTER TITLE*(*),COLHED*(*),FMT1*11,FMT2*33
C
      LA=MIN(LEN_TRIM(TITLE),70)
      LS=(72-LA)/2
      L10=LS/10
      L1=MOD(LS,10)
      FMT1='(1H1,10X,A)'
c      FMT1(6:7)=CHAR(48+L10)//CHAR(48+L1)
      FMT1(6:6)=CHAR(48+L10)
      FMT1(7:7)=CHAR(48+L1)
C
      LB=MIN(LEN_TRIM(COLHED),8)
      LS=9-LB
      L10=LS/10
      L1=MOD(LS,10)
      FMT2='(1X,3(01X,3HRE ,A8,01X,3HIM ,A8))'
c      FMT2(7:8)=CHAR(48+L10)//CHAR(48+L1)
      FMT2(7:7)=CHAR(48+L10)
      FMT2(8:8)=CHAR(48+L1)
      FMT2(20:21)=FMT2(7:8)
      FMT2(18:18)=CHAR(48+LB)
      FMT2(31:31)=FMT2(18:18)
C
      I1=1
   10 I2=MIN(I1+49,N)
      WRITE (7,FMT1) TITLE(1:LA)
C
      I0=MIN(1+((N-I1)/50),6)
      WRITE (7,FMT2) (COLHED(1:LB),I=1,I0)
C
      DO 50 I=I1,I2
      J2=50*MIN((N-I)/50,2)
   50 WRITE (7,60) (X(1,I+J),X(2,I+J),J=0,J2,50)
   60 FORMAT (1X,1P,6E12.4)
      I1=I1+150
      IF (I1.LT.N) GO TO 10
      RETURN
      END
 
      SUBROUTINE RFFT(X,TRG,IBI,NPTS,IDIR)
      DIMENSION X(*),TRG(*),IBI(*)
      SAVE NPSOLD,MPTS
      DATA NPSOLD/0/,TWOPI/6.28318531/
C
C     Fourier Transform of Real-Valued Time Series
C     If IDIR > 0, forward transform
C       Input:  X is real-values time series
C       Output: X is transform with hermetian symmetry.
C               X(0) is zero frequency component
C               X(1) is Nyquist frequency component
C               X(i) is real part of i-frequency component
C               X(i+1) is imaginary part of i-th frequency component
C     If IDIR < 0, inverse transform
C     IBI is bit-reversal table;  must be dimensionned at least NPTS/2
C     TRG is trigonometric table; must be dimensionned at least NPTS/4
C     Note that time and frequency spacing are related by:
C       (delta t) (delta omega) = 2 pi.
C
      IF (NPTS.LE.0) THEN
        PRINT 10, NPTS
   10   FORMAT (' Number of points (',I5,') is not a power of two.')
        STOP
      ENDIF
      IF (NPTS.EQ.1) RETURN
      DO 20 NU=1,20
      M=2**NU
   20 IF (M.EQ.NPTS) GO TO 40
        PRINT 10, NPTS
        STOP
C
   40 XPTS=1./FLOAT(NPTS)
      IF (IDIR.LT.0) THEN
        DO 50 I=1,NPTS
   50   X(I)=X(I)*XPTS
      ENDIF
      IF (NPTS.EQ.2) GO TO 430
      LPTS=NPTS/4
      CONST=TWOPI*XPTS
C
      IF (NPTS.NE.NPSOLD .OR. IDIR.EQ.0) THEN
C                                      Form Bit-Reversal Table
        NPSOLD=NPTS
        I=1
        IBI(1)=0
        IHI=1
        MU=2*LPTS
        MPTS=MU
        NEW=NU-1
        DO 80 J=1,NEW
        MU=MU/2
        DO 70 K=1,IHI
        I=I+1
   70   IBI(I)=IBI(K)+MU
   80   IHI=IHI*2
C                                      Form Trigonometric Table
        DO 90 I=1,LPTS
   90   TRG(I)=COS(CONST*FLOAT(I-1))
      ENDIF
      IF (IDIR.EQ.0) RETURN
C
C     Reconstruct Transform of complex sequence Y(K)+i*Z(K)
C     (Inverse Transform Only)
C
      IF (IDIR.LT.0) THEN
        SR=X(1)
        X(1)=SR+X(2)
        X(2)=SR-X(2)
        X(MPTS+1)=2.*X(MPTS+1)
        X(MPTS+2)=-2.*X(MPTS+2)
        IF (NPTS.EQ.4) GO TO 140
        IHI=MPTS-1
        IFOLD=NPTS-1
        ICOS=1
        ISIN=LPTS-1
C
        DO 110 I=3,IHI,2
        YR=X(I)+X(IFOLD)
        YI=X(I+1)-X(IFOLD+1)
        ZR=X(I)-X(IFOLD)
        ZI=X(I+1)+X(IFOLD+1)
        SR=TRG(ICOS+1)*ZR-TRG(ISIN+1)*ZI
        SI=TRG(ICOS+1)*ZI+TRG(ISIN+1)*ZR
        X(I)=YR-SI
        X(I+1)=SR+YI
        X(IFOLD)=YR+SI
        X(IFOLD+1)=SR-YI
        IFOLD=IFOLD-2
        ICOS=ICOS+1
  110   ISIN=ISIN-1
      ENDIF
C
C     Rearrange order of input points
C
      DO 130 I=1,MPTS
      J=IBI(I)
      IF (J.GT.(I-1)) THEN
        M=2*I-1
        N=2*J+1
        SR=X(M)
        SI=X(M+1)
        X(M)=X(N)
        X(M+1)=X(N+1)
        X(N)=SR
        X(N+1)=SI
      ENDIF
  130 CONTINUE
C
C     Find Discrete Fourier Transform of
C     <X(1)+iX(2)>,<X(3)+iX(4)>,...,<X(NPTS-1)+iX(NPTS)>
C
  140 DO 400 I=2,NU
      IGAP=2**I
      JGAP=IGAP/2
      L=JGAP+1
      KHI=NPTS+1-IGAP
C
      DO 150 K=1,KHI,IGAP
      SR=X(K)
      SI=X(K+1)
      X(K)=SR+X(L)
      X(K+1)=SI+X(L+1)
      X(L)=SR-X(L)
      X(L+1)=SI-X(L+1)
  150 L=L+IGAP
C
      IF (NU.EQ.2 .AND. IDIR.GT.0) GO TO 420
      IF (I.EQ.2) GO TO 400
C
      KGAP=JGAP/2
      KLO=KGAP+1
      L=KLO+JGAP
      KHI=NPTS+1-IGAP+KGAP
C
      DO 170 K=KLO,KHI,IGAP
      SR=X(L)
      SI=X(L+1)
      IF (IDIR.GT.0) THEN
        X(L)=X(K)-SI
        X(L+1)=X(K+1)+SR
        X(K)=X(K)+SI
        X(K+1)=X(K+1)-SR
      ELSE
        X(L)=X(K)+SI
        X(L+1)=X(K+1)-SR
        X(K)=X(K)-SI
        X(K+1)=X(K+1)+SR
      ENDIF
  170 L=L+IGAP
C
      IF (I.EQ.3) GO TO 400
      NUM=2**(NU-I)
      INT=2*NUM
      IHI=LPTS-INT
      K=3
C                                     Forward Transform
      IF (IDIR.GT.0) THEN
        DO 320 J=1,NUM
        L=K+JGAP
        M=K+KGAP
        N=M+JGAP
        ISIN=IHI
        DO 310 ICOS=INT,IHI,INT
          YR=TRG(ICOS+1)*X(L)+TRG(ISIN+1)*X(L+1)
          YI=TRG(ICOS+1)*X(L+1)-TRG(ISIN+1)*X(L)
          X(L)=X(K)-YR
          X(L+1)=X(K+1)-YI
          X(K)=X(K)+YR
          X(K+1)=X(K+1)+YI
          YR=TRG(ICOS+1)*X(N+1)-TRG(ISIN+1)*X(N)
          YI=TRG(ICOS+1)*X(N)+TRG(ISIN+1)*X(N+1)
          X(N)=X(M)-YR
          X(N+1)=X(M+1)+YI
          X(M)=X(M)+YR
          X(M+1)=X(M+1)-YI
          K=K+2
          L=L+2
          M=M+2
          N=N+2
  310     ISIN=ISIN-INT
  320   K=N+2
      ELSE
C                                     Inverse Transform
        DO 340 J=1,NUM
        L=K+JGAP
        M=K+KGAP
        N=M+JGAP
        ISIN=IHI
        DO 330 ICOS=INT,IHI,INT
          YR=TRG(ICOS+1)*X(L)-TRG(ISIN+1)*X(L+1)
          YI=TRG(ICOS+1)*X(L+1)+TRG(ISIN+1)*X(L)
          X(L)=X(K)-YR
          X(L+1)=X(K+1)-YI
          X(K)=X(K)+YR
          X(K+1)=X(K+1)+YI
          YR=TRG(ICOS+1)*X(N+1)+TRG(ISIN+1)*X(N)
          YI=TRG(ICOS+1)*X(N)-TRG(ISIN+1)*X(N+1)
          X(N)=X(M)+YR
          X(N+1)=X(M+1)-YI
          X(M)=X(M)-YR
          X(M+1)=X(M+1)+YI
          K=K+2
          L=L+2
          M=M+2
          N=N+2
  330     ISIN=ISIN-INT
  340   K=N+2
      ENDIF
  400 CONTINUE
C
C     Decode Output (Forward Transform Only)
C
      IF (IDIR.LT.0) RETURN
      IHI=MPTS-1
      IFOLD=NPTS-1
      ICOS=1
      ISIN=LPTS-1
C
      DO 410 I=3,IHI,2
      YR=.5*(X(I)+X(IFOLD))
      YI=.5*(X(I+1)-X(IFOLD+1))
      ZR=.5*(X(I+1)+X(IFOLD+1))
      ZI=.5*(X(IFOLD)-X(I))
      SR=TRG(ICOS+1)*ZR+TRG(ISIN+1)*ZI
      SI=TRG(ICOS+1)*ZI-TRG(ISIN+1)*ZR
      X(I)=YR+SR
      X(I+1)=SI+YI
      X(IFOLD)=YR-SR
      X(IFOLD+1)=SI-YI
      IFOLD=IFOLD-2
      ICOS=ICOS+1
  410 ISIN=ISIN-1
C
  420 X(MPTS)=-X(MPTS)
  430 SR=X(1)
      X(1)=SR+X(2)
      X(2)=SR-X(2)
C
      RETURN
      END
      FUNCTION LEN_TRIM(A)
      character*(*) a
      l=len(a)
      do i=l,1,-1
        if (a(i:i).ne.' ') then
          len_trim=i
          return
        endif
      enddo
      return
      end
