**==b8a.for
C 						 30/avril/84
C
C
C                 F O R T R A N    B E N C H M A R K
C                 ----------------------------------
C
C         This is a " vanilla " fortran program that is adapted
C     to be run on any machine .
C         The program has a pure CP profile with quasi-nil I/O .
C     * it reads an input file of 100 cards : READ (5,fmt) and
C       writes only 15 lines of output with : PRINT fmt , list ,
C     * it has no dependance feature on any particular compiler
C       hardware or concept , and doesn't use any scratch file ,
C     * it occupies , at execution , about 350Kbytes (absolute
C       memory size) and finally
C     * it takes about 2000 s of a VAX 11/780
C
C
C Notes :
C ------
C
C 1- 'double precision' means "IMPLICIT DOUBLEPRECISION (A-H,O-Z)"
C    and is meant for 32-bits machines ;
C    'single precision' version , meanning "IMPLICIT REAL (A-H,O-Z)" ,
C    is also available on request .
C
C 2- the data file is planned initially for "small" computer
C    (i.e. VAX,Prime..) If the machine is a microcomputer we
C    should decrease the amount of time needed while if it's a
C    large mainframe , this amount should be increased ;
C    The following applies :
C    the 12th line of the data is :   050.       -5.       20.
C    050 means simulation of 50 event-time seconds , and will
C    take , about 2000 seconds of a Vax 11/780 (with FPA) ;
C    for a microcomputer , change 050 to 036 to use one fourth
C    of CP time and while for a large mainframe , change 050
C    to 100 to increase fourfold.
C    The data is given separately from the source file ;
C    please check that there are exactly 100 hundred 'lines' .
C
C 3- For an UNIX machine :
C    * interactively :
C      f77 -w -Nn4000 sourced.f       to compile source file ,
C          -w flag to avoid warning message and -Nn4000 to in
C           crease size of some tables during compilation .
C      (time a.out < data)&          to execute in background
C                                    mode and get CPU time
C    * in "batch mode"
C      with sh  : time a.out < data > result 2 >& 1 &
C      with csh : time a.out >& result &
C
C 4- examples of output :
C  MAIN : FIN S00002
C  MAIN : FIN S00001
C  MAIN : FIN S00011
C  MAIN : FIN S00022
C  TEMPS = 33.00000000 , NITERA :    1  !                     !   !
C  TEMPS = 34.00010300 , NITERA :  196  !                     !   !
C  TEMPS = 35.00010300 , NITERA : 1217  !                     !   !
C  TEMPS = 36.00184250 , NITERA : 1757  !<< 1/4 of CP Time    !   !
C  TEMPS = 37.00208664 , NITERA : 2021                        !   !
C  TEMPS = 38.00031281 , NITERA : 2317                        !   !
C  TEMPS = 39.00342941 , NITERA : 2615                        !   !
C  TEMPS = 40.00069809 , NITERA : 2915       1/2 of CP Time >>!   !
C  TEMPS = 45.00157166 , NITERA : 4424                            !
C  TEMPS = 50.00123596 , NITERA : 5997             full CP Time >>!
C 2644.8u 0.0s 47:53 92% 0+245k 0+13io 233pf+0w
C
C 5- Please send any result(s) and remark(s)/comment(s) to :
C  Nhuan DODUC
C  FRAMENTEC
C  La Boursidiere
C  F 92350 Le Plessis Rpbinson
C uucp     : ...seismo!mcvax!inria!ftc!ndoduc
C 'ARPA'   : 'mcvax!inria!ftc!ndoduc'@SEISMO.CSS.GOV
C Bit/Earn : Ndoduc at FRSAC11
C
C 6- Please feel free to make comment(s)/remark(s) about this
C program or this benchmark .
C There is no condition about using this freeware : however
C I would appreciate receiving any new result from you to enrich
C the benchmark report , which is also available freely on request .
C
C-CDC-PROGRAM MAIN (TAPE5,OUTPUT,TAPE6=OUTPUT)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa11 / v0011n(20) , v0012x(20) , v0011 , v0012 , tlim , 
     &                zlimin , zlimax , dtvoi , timimp(20) , difref(20)
     &                 , difmic(20) , v00001 , v22202 , temimp , 
     &                temmic , delm , delv , delvi , delvs , v22201 , 
     &                v22203 , dtpre , dtphy , dttemp , dtchan , dtdis , 
     &                dtbef , dtorg , nimic , nmultr , izone , 
     &                n00011(20) , isort , necrit , nstar , iplot , 
     &                nzone , ifre(20) , ico , iimp , npas1(20) , 
     &                npas2(20)
      COMMON /aaa26 / deb(21) , debv(21) , debl(21) , alfad(21) , 
     &                alfb(21) , alft(21) , ha(21) , hb(21) , he(21,2) , 
     &                hem(21) , ve(21,2) , xa(21) , xb(21) , xd(21) , 
     &                xem(21) , sdsc , tjonc(21) , hjonb(21,2) , 
     &                hjont(21,2) , debav(21) , glinf(21) , glsup(21) , 
     &                pp1 , pp2 , alniv , vgjo(21) , glinfp(21) , 
     &                v55198(21) , icas(21) , iczw(21)
      COMMON /aaa22 / dh(22,2) , dm(22,2) , dpdt , duu(22,2) , dv(22,2)
     &                 , dnu(22,2)
      COMMON /aaa33 / vco , xl0055 , d876 , dint , dext , vol002 , 
     &                vol005 , lco , ncray
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      COMMON /aaa77 / qinit , tpui(20) , qpui(20) , rpui , plmoy , 
     &                xhtc(22,12) , pl(22,12) , qrepa(22,12) , 
     &                xmcga(22,12) , xmcuo(22,12) , qced(22,12) , 
     &                qcon(22,12) , quga(22,12) , qfou(22,12) , qcei(2)
     &                 , qconi(2) , qugii(2) , tmi(2) , dtmi(2) , 
     &                qtotal , qtug , qtgf , terc(2) , tgai(22,12) , 
     &                tgaii(22,12) , t876(22,12) , tumax(22,12) , 
     &                tumin(22,12) , dtgai(22,12) , dt876(22,12) , 
     &                terco(22,12) , tmu(2) , dtmu(2) , npui , nasl(22)
     &                 , nsl(22)
      COMMON /aaa88 / flup(22,2) , fluv(22,2) , flul(22,2) , fluiv(22,2)
     &                 , debil(22,2) , fluil(22,2) , debi(22) , 
     &                debhi(22) , debiv(22,2)
      COMMON /aaa99 / hlcf , hvcfo , hvap , hcon , hvin , hlin , r876 , 
     &                rgai , xm876 , xmgai , xl876 , xlgai , cp876 , 
     &                cpgai , xmc876 , xmcgai , diahy , hgapp(22) , 
     &                hcg(22) , htc(22,12) , hvcff(22)
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa16 / dbent(20) , tent(20) , hent(20) , debe , ente , 
     &                dbsor(20) , tsor(20) , debs , dpdtt(20) , 
     &                tdpdt(20) , hsor(20) , thsor(20) , ents , ndbent , 
     &                ndpdt , ndbsor , nhsor
      COMMON /aaa17 / ddpdt , ddh(22,2) , ddv(22,2) , ddm(22,2) , 
     &                ddu(22,2)
      COMMON /aaa18 / ddeb(21) , dddeb(21) , dxat(21) , dxag(21) , 
     &                dxbt(21) , dxbg(21) , dnug(21) , dnuf(21) , 
     &                dhe(22,2) , ddebo(21)
      COMMON /aaa20 / dqp(22,2) , dflul(22) , dfluv(22) , dfluil(22) , 
     &                dfluiv(22) , ddebil(22) , ddebiv(22) , dqcei(2) , 
     &                dqced(22,12) , ddtuo(22,12) , ddtga(22,12) , 
     &                ddtmi(2) , ddtmu(2)
      DOUBLE PRECISION m
      do ijk = 1 , 100
      OPEN (5,FILE='doduc.in')
      CALL s00000(0)
      READ (5,99001) ilect , isort , iplot , nlect
      CALL s00002
      PRINT 99002
      CALL s00001
      PRINT 99003
      CALL s00011
      PRINT 99004
      CALL s00022
      PRINT 99005
      nitera = 1
      necrit = 0
      nstar = 0
      v00001 = .01
 100  CALL s00001
      CALL s00012
      CALL s00015
      CALL s00013
      CALL s00014
      CALL s00009
      CALL s00020
      CALL s00017
      nivo = niv
      CALL s00018(i12,i21,iorg)
      CALL s00005(iorga)
      CALL s00019
      CALL s00004(icat(2),nivo,iorg)
      nitera = nitera + 1
      CALL s00006(istop)
      IF ( istop.EQ.0 ) GOTO 100
      temimp = tem - 100000.D+00
      CALL s00005(iorga)
      close(5)
      enddo
      STOP
99001 FORMAT (3(I1,9X),I2)
99002 FORMAT (' MAIN : FIN S00002')
99003 FORMAT (' MAIN : FIN S00001')
99004 FORMAT (' MAIN : FIN S00011')
99005 FORMAT (' MAIN : FIN S00022')
      END
      SUBROUTINE s00006(istop)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa11 / v0011n(20) , v0012x(20) , v0011 , v0012 , tlim , 
     &                zlimin , zlimax , dtvoi , timimp(20) , difref(20)
     &                 , difmic(20) , v00001 , v22202 , temimp , 
     &                temmic , delm , delv , delvi , delvs , v22201 , 
     &                v22203 , dtpre , dtphy , dttemp , dtchan , dtdis , 
     &                dtbef , dtorg , nimic , nmultr , izone , 
     &                n00011(20) , isort , necrit , nstar , iplot , 
     &                nzone , ifre(20) , ico , iimp , npas1(20) , 
     &                npas2(20)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      istop = 0
      znn = zniv
      IF ( znn.GT.zlimax ) istop = 1
      IF ( znn.LT.zlimin ) istop = 1
      IF ( tem.GE.tlim ) istop = 1
      RETURN
      END
      SUBROUTINE s00009
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa26 / deb(21) , debv(21) , debl(21) , alfad(21) , 
     &                alfb(21) , alft(21) , ha(21) , hb(21) , he(21,2) , 
     &                hem(21) , ve(21,2) , xa(21) , xb(21) , xd(21) , 
     &                xem(21) , sdsc , tjonc(21) , hjonb(21,2) , 
     &                hjont(21,2) , debav(21) , glinf(21) , glsup(21) , 
     &                pp1 , pp2 , alniv , vgjo(21) , glinfp(21) , 
     &                v55198(21) , icas(21) , iczw(21)
      COMMON /aaa22 / dh(22,2) , dm(22,2) , dpdt , duu(22,2) , dv(22,2)
     &                 , dnu(22,2)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa88 / flup(22,2) , fluv(22,2) , flul(22,2) , fluiv(22,2)
     &                 , debil(22,2) , fluil(22,2) , debi(22) , 
     &                debhi(22) , debiv(22,2)
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      COMMON /aaa11 / v0011n(20) , v0012x(20) , v0011 , v0012 , tlim , 
     &                zlimin , zlimax , dtvoi , timimp(20) , difref(20)
     &                 , difmic(20) , v00001 , v22202 , temimp , 
     &                temmic , delm , delv , delvi , delvs , v22201 , 
     &                v22203 , dtpre , dtphy , dttemp , dtchan , dtdis , 
     &                dtbef , dtorg , nimic , nmultr , izone , 
     &                n00011(20) , isort , necrit , nstar , iplot , 
     &                nzone , ifre(20) , ico , iimp , npas1(20) , 
     &                npas2(20)
      COMMON /aaa16 / dbent(20) , tent(20) , hent(20) , debe , ente , 
     &                dbsor(20) , tsor(20) , debs , dpdtt(20) , 
     &                tdpdt(20) , hsor(20) , thsor(20) , ents , ndbent , 
     &                ndpdt , ndbsor , nhsor
      DOUBLE PRECISION m , cc(22,2)
      coef = 144.D+00/778.D+00
      DO 100 i = 2 , nc1
         j = i - 1
         ity = ityp(i)
         j1 = 2
         IF ( ity.EQ.1 ) j1 = 1
         IF ( ity.EQ.2 ) THEN
            dm(i,1) = debl(j) - debl(i) - debi(i)
            dm(i,2) = debv(j) - debv(i) + debi(i)
            duu(i,1) = debl(j)*he(j,1) - debl(i)*he(i,1) + flul(i,1)
     &                  + fluil(i,1) - debil(i,1)*hf(i,1) + debiv(i,2)
     &                 *hfs - debiv(i,1)*hgs + debil(i,2)*hfs
            duu(i,2) = debv(j)*he(j,2) - debv(i)*he(i,2) + fluv(i,2)
     &                  + fluiv(i,2) + debil(i,1)*hgs - debiv(i,2)
     &                 *hg(i,2) + debiv(i,1)*hgs - debil(i,2)*hfs
         ELSEIF ( ity.EQ.3 ) THEN
            dm(i,1) = deb(j) - debi(i)
            dm(i,2) = -deb(i) + debi(i)
            duu(i,1) = debl(j)*he(j,1) + debv(j)*he(j,2) - debhi(i)
     &                  + flup(i,1)
            duu(i,2) = -debl(i)*he(i,1) - debv(i)*he(i,2) + debhi(i)
     &                  + flup(i,2)
         ELSE
            dm(i,1) = deb(j) - deb(i)
            duu(i,1) = debl(j)*he(j,1) + debv(j)*he(j,2) - debl(i)
     &                 *he(i,1) - debv(i)*he(i,2) + flup(i,1)
         ENDIF
         DO 50 k = 1 , j1
            cc(i,k) = duu(i,k) - h(i,k)*dm(i,k)
            aa(i,k) = vv(i,k)*dm(i,k) + dvvh(i,k)*cc(i,k)
            dv(i,k) = aa(i,k) + bb(i,k)*dpdt
            IF ( dabs(dv(i,k)).LT.1.D-10 ) dv(i,k) = 0.D+00
            epsm = delm*vc(i)/vvfs
            ym = m(i,k)
            IF ( ym.LT.epsm ) ym = epsm
            dh(i,k) = (cc(i,k)+coef*v(i,k)*dpdt)/ym
            dnu(i,k) = dvvh(i,k)*dh(i,k) + dvvp(i,k)*dpdt
 50      CONTINUE
 100  CONTINUE
      taft = tem + 1.D-4
      CALL s00934(thsor,hsor,hsor,taft,haft,x,2)
      dh(nc2,1) = (haft-h(nc2,1))/1.D-4
      dnu(nc2,1) = dvvh(nc2,1)*dh(nc2,1) + dvvp(nc2,1)*dpdt
      CALL s00934(tent,hent,hent,taft,haft,x,20)
      dh(1,1) = (haft-h(1,1))/1.D-4
      dnu(1,1) = dvvh(1,1)*dh(1,1) + dvvp(1,1)*dpdt
      IF ( icat(2).LE.2 ) RETURN
      iss = 1
      vitess = dv(niv,1)
      IF ( vitess.LT.0. ) iss = 2
      RETURN
      END
      SUBROUTINE s00055(ii)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa11 / v0011n(20) , v0012x(20) , v0011 , v0012 , tlim , 
     &                zlimin , zlimax , dtvoi , timimp(20) , difref(20)
     &                 , difmic(20) , v00001 , v22202 , temimp , 
     &                temmic , delm , delv , delvi , delvs , v22201 , 
     &                v22203 , dtpre , dtphy , dttemp , dtchan , dtdis , 
     &                dtbef , dtorg , nimic , nmultr , izone , 
     &                n00011(20) , isort , necrit , nstar , iplot , 
     &                nzone , ifre(20) , ico , iimp , npas1(20) , 
     &                npas2(20)
      COMMON /aaa77 / qinit , tpui(20) , qpui(20) , rpui , plmoy , 
     &                xhtc(22,12) , pl(22,12) , qrepa(22,12) , 
     &                xmcga(22,12) , xmcuo(22,12) , qced(22,12) , 
     &                qcon(22,12) , quga(22,12) , qfou(22,12) , qcei(2)
     &                 , qconi(2) , qugii(2) , tmi(2) , dtmi(2) , 
     &                qtotal , qtug , qtgf , terc(2) , tgai(22,12) , 
     &                tgaii(22,12) , t876(22,12) , tumax(22,12) , 
     &                tumin(22,12) , dtgai(22,12) , dt876(22,12) , 
     &                terco(22,12) , tmu(2) , dtmu(2) , npui , nasl(22)
     &                 , nsl(22)
      COMMON /aaa33 / vco , xl0055 , d876 , dint , dext , vol002 , 
     &                vol005 , lco , ncray
      COMMON /aaa99 / hlcf , hvcfo , hvap , hcon , hvin , hlin , r876 , 
     &                rgai , xm876 , xmgai , xl876 , xlgai , cp876 , 
     &                cpgai , xmc876 , xmcgai , diahy , hgapp(22) , 
     &                hcg(22) , htc(22,12) , hvcff(22)
      pi = 3.14159
      IF ( nmultr.LE.1 ) RETURN
      n1 = nasl(ii)
      n2 = nsl(ii)
      i2 = 0
      DO 100 i = 1 , n2
         i1 = i2 + 1
         i2 = i*nmultr
         xmcg = 0.D+00
         xmcu = 0.D+00
         DO 50 k = i1 , i2
            xmcg = xmcg + tgai(ii,k)*xmcga(ii,k)
            xmcu = xmcu + t876(ii,k)*xmcuo(ii,k)
 50      CONTINUE
         xmcga(ii,i) = xmcga(ii,i1)*nmultr
         xmcuo(ii,i) = xmcuo(ii,i1)*nmultr
         tgai(ii,i) = xmcg/xmcga(ii,i)
         t876(ii,i) = xmcu/xmcuo(ii,i)
         pl(ii,i) = pl(ii,i1)
         xhtc(ii,i) = xhtc(ii,i1)*nmultr
         qrepa(ii,i) = qrepa(ii,i1)*nmultr
         tumax(ii,i) = t876(ii,i) + pl(ii,i)*plmoy/8./pi/xl876
         tumin(ii,i) = t876(ii,i) - pl(ii,i)*plmoy/8./pi/xl876
         tgaii(ii,i) = tgai(ii,i) + pl(ii,i)
     &                 *plmoy/2./pi/xlgai*dlog(dext/dint)
 100  CONTINUE
      nasl(ii) = nsl(ii)
      RETURN
      END
      SUBROUTINE s00015
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa26 / deb(21) , debv(21) , debl(21) , alfad(21) , 
     &                alfb(21) , alft(21) , ha(21) , hb(21) , he(21,2) , 
     &                hem(21) , ve(21,2) , xa(21) , xb(21) , xd(21) , 
     &                xem(21) , sdsc , tjonc(21) , hjonb(21,2) , 
     &                hjont(21,2) , debav(21) , glinf(21) , glsup(21) , 
     &                pp1 , pp2 , alniv , vgjo(21) , glinfp(21) , 
     &                v55198(21) , icas(21) , iczw(21)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      DOUBLE PRECISION m
      DO 100 i = 1 , nc1
         sec = sc(i)
         debav(i) = deb(i)
         idoduc = ityp(i)
         IF ( idoduc.EQ.2 ) THEN
            vfb = vv(i,1)
            vgb = vv(i,2)
            hfb = hf(i,1)
            hgb = hg(i,2)
         ELSEIF ( idoduc.EQ.3 ) THEN
            ica = ist(i,2)
            vfb = vvfs
            vgb = vvgs
            IF ( ica.EQ.1 ) vfb = vv(i,2)
            IF ( ica.EQ.3 ) vgb = vv(i,2)
            hfb = hf(i,2)
            hgb = hg(i,2)
         ELSE
            ica = ist(i,1)
            vfb = vvfs
            vgb = vvgs
            IF ( ica.EQ.1 ) vfb = vv(i,1)
            IF ( ica.EQ.3 ) vgb = vv(i,1)
            hfb = hf(i,1)
            hgb = hg(i,1)
         ENDIF
         j = i + 1
         idoduc = ityp(j)
         IF ( idoduc.EQ.2 ) THEN
            vft = vv(j,1)
            vgt = vv(j,2)
            hft = hf(j,1)
            hgt = hg(j,2)
         ELSEIF ( idoduc.EQ.3 ) THEN
            ica = ist(j,1)
            vft = vvfs
            vgt = vvgs
            hft = hf(j,1)
            hgt = hg(j,1)
            IF ( ica.EQ.1 ) vft = vv(j,1)
            IF ( ica.EQ.3 ) vgt = vv(j,1)
         ELSE
            ica = ist(j,1)
            vft = vvfs
            vgt = vvgs
            IF ( ica.EQ.1 ) vft = vv(j,1)
            IF ( ica.EQ.3 ) vgt = vv(j,1)
            hft = hf(j,1)
            hgt = hg(j,1)
         ENDIF
         tjonc(i) = ts
         hjonb(i,1) = hfb
         hjonb(i,2) = hgb
         hjont(i,1) = hft
         hjont(i,2) = hgt
         ve(i,1) = (vfb+vft)/2.D+00
         ve(i,2) = (vgb+vgt)/2.D+00
         CALL s33019(i,sec)
 100  CONTINUE
      RETURN
      END
      DOUBLE PRECISION FUNCTION f00113(iopt,p,diahy,twa,tfl,al)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      DOUBLE PRECISION r(15) , f(15)
      DATA r/.15 , .25 , .35 , .45 , .65 , .85 , 1.05 , 1.25 , 1.45 , 
     &     1.95 , 2.45 , 2.95 , 3.45 , 3.95 , 4.45/
      DATA f/.4258 , .5359 , .6235 , .6981 , .8238 , .9295 , 1.0222 , 
     &     1.1056 , 1.1820 , 1.3506 , 1.4967 , 1.6271 , 1.7459 , 
     &     1.8555 , 1.9578/
      tw = twa/1000. + .45967
      tf = tfl/1000. + .45967
      IF ( iopt.GE.3 ) THEN
         ccc = (1.-.6*al)*1.73/(1.25-.15*al)
      ELSE
         pwl = (p/14.696)*diahy*tw/tf
         tt = tw*1000.D+00
         eh2o = s00093(pwl,tt)
         rap = tf/tw
         IF ( rap.LT..45 ) THEN
            i1 = INT(rap/.1-1.5) + 1
         ELSEIF ( rap.GE.1.45 ) THEN
            i1 = INT(rap/.5-2.9) + 9
         ELSE
            i1 = INT(rap/.2-2.25) + 4
         ENDIF
         i2 = i1 + 1
         r1 = r(i1)
         r2 = r(i2)
         f1 = f(i1)
         f2 = f(i2)
         ff = f1 + (rap-r1)*(f2-f1)/(r2-r1)
         ah2o = 2.*eh2o*ff
         ewall = .6
         ccc = 1.73/(1./ewall+1./ah2o-1.)
      ENDIF
      f00113 = ccc*(tw+tf)*(tw*tw+tf*tf)/3600.D+00
      RETURN
      END
      SUBROUTINE s00061(i,hv,hvt,hvme,hvms,ynu,re,tfl,dtfl,iopt)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa26 / deb(21) , debv(21) , debl(21) , alfad(21) , 
     &                alfb(21) , alft(21) , ha(21) , hb(21) , he(21,2) , 
     &                hem(21) , ve(21,2) , xa(21) , xb(21) , xd(21) , 
     &                xem(21) , sdsc , tjonc(21) , hjonb(21,2) , 
     &                hjont(21,2) , debav(21) , glinf(21) , glsup(21) , 
     &                pp1 , pp2 , alniv , vgjo(21) , glinfp(21) , 
     &                v55198(21) , icas(21) , iczw(21)
      COMMON /aaa99 / hlcf , hvcfo , hvap , hcon , hvin , hlin , r876 , 
     &                rgai , xm876 , xmgai , xl876 , xlgai , cp876 , 
     &                cpgai , xmc876 , xmcgai , diahy , hgapp(22) , 
     &                hcg(22) , htc(22,12) , hvcff(22)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa22 / dh(22,2) , dm(22,2) , dpdt , duu(22,2) , dv(22,2)
     &                 , dnu(22,2)
      COMMON /aaa18 / ddeb(21) , dddeb(21) , dxat(21) , dxag(21) , 
     &                dxbt(21) , dxbg(21) , dnug(21) , dnuf(21) , 
     &                dhe(22,2) , ddebo(21)
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      DOUBLE PRECISION x(21) , y(21)
      DATA a , b , c , d , e/.76082D-15 , -.74064D-11 , .23241D-7 , 
     &     .14794D-4 , .10467D-1/
      DATA r , s/1.7399D-2 , 5.4997D-5/
      CALL x21y21(x,y)
      hvt = 0.D+00
      hvme = 0.D+00
      hvms = 0.D+00
      tfla = tfl
      IF ( tfl.GE.1600. ) tfla = 1600.D+00
      tf = tfla
      ie = i - 1
      debe = debav(ie)
      debs = debav(i)
      deve = xa(ie)*debe + xb(ie)
      devs = xa(i)*debs + xb(i)
      sec = scapa(i)
      debm = (deve+devs)/2.D+00
      eps = 1.D+00
      IF ( debm.LT.0. ) eps = -1.D+00
      vis = (r+s*tf)/3600.D+00
      re = eps*debm*diahy/(vis*sec)
      reo = re
      IF ( re.LT.1000. ) THEN
         i1 = INT(re/200.) + 1
      ELSEIF ( re.LT.4000. ) THEN
         i1 = INT(re/500.) + 4
      ELSEIF ( re.LT.10000. ) THEN
         i1 = INT(re/2000.) + 10
      ELSEIF ( re.GE.30000. ) THEN
         IF ( re.GE.49999. ) re = 49999.D+00
         i1 = INT(re/10000.) + 16
      ELSE
         i1 = INT(re/5000.) + 13
      ENDIF
      i2 = i1 + 1
      y1 = y(i1)
      y2 = y(i2)
      x1 = x(i1)
      x2 = x(i2)
      rap = (y2-y1)/(x2-x1)
      tmre = y1 + rap*(re-x1)
      ynu = .023*tmre
      ynuo = ynu
      IF ( ynu.LT.3.5 ) ynu = 3.5
      tf = tfla
      con = e + tf*(d+tf*(c+tf*(b+a*tf)))
      hv = ynu*con/(3600.*diahy)
      IF ( iopt.LE.0 ) RETURN
      dtfla = dtfl
      IF ( tfl.GE.1600. ) dtfla = 0.D+00
      dnut = 0.D+00
      IF ( ynuo.GE.3.5 ) THEN
         IF ( reo.LE.49999. ) THEN
            dqe = (dxag(ie)*debe+xa(ie)+dxbg(ie))*ddeb(ie) + dxat(ie)
     &            *debe + dxbt(ie)
            dqs = (dxag(i)*debs+xa(i)+dxbg(i))*ddeb(i) + dxat(i)
     &            *debs + dxbt(i)
            dqt = .5*(dqe+dqs)
            dmut = s*dtfla/3600.D+00
            dret = eps*diahy*(dqt-debm*dmut/vis)/(vis*sec)
            dnut = .023*rap*dret
            ynumax = 5.*ynuo
            abnut = dabs(dnut)
            IF ( abnut.GE.ynumax ) dnut = dnut*ynumax/abnut
         ENDIF
      ENDIF
      dlat = (d+tf*(2.*c+tf*(3.*b+4.*a*tf)))*dtfla
      hvt = (ynu*dlat+dnut*con)/(3600.*diahy)
      RETURN
      END
      DOUBLE PRECISION FUNCTION s22202(al,dal,tw,dtw,tf,dtf,p,dpdt,
     &                                 diahy,iopt)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      DOUBLE PRECISION r(15) , f(15)
      DATA r/.15 , .25 , .35 , .45 , .65 , .85 , 1.05 , 1.25 , 1.45 , 
     &     1.95 , 2.45 , 2.95 , 3.45 , 3.95 , 4.45/
      DATA f/.4258 , .5359 , .6235 , .6981 , .8238 , .9295 , 1.0222 , 
     &     1.1056 , 1.1820 , 1.3506 , 1.4967 , 1.6271 , 1.7459 , 
     &     1.8555 , 1.9578/
      twra = tw/1000. + .45967
      tfra = tf/1000. + .45967
      tfc = tfra*tfra
      twc = twra*twra
      ts = twra + tfra
      tsc = ts*ts
      hrt = ts*(twc+tfc)
      hrft = tsc + 2.*tfc
      hrwt = tsc + 2.*twc
      IF ( iopt.EQ.3 ) THEN
         cc = 1.73/3600.D+00
         den = 1.25 - .15*al
         dhdtf = cc*(1.-.6*al)*hrft/den
         dhdtw = cc*(1.-.6*al)*hrwt/den
         dhdal = cc*hrt*(-.6)/(den*den)
         s22202 = dhdtf*dtf + dhdtw*dtw + dhdal*dal
         RETURN
      ELSE
         rr = tfra/twra
         IF ( rr.LT..45 ) THEN
            i1 = INT(rr/.1-1.5) + 1
         ELSEIF ( rr.GE.1.45 ) THEN
            i1 = INT(rr/.5-2.9) + 9
         ELSE
            i1 = INT(rr/.2-2.25) + 4
         ENDIF
         i2 = i1 + 1
         r1 = r(i1)
         r2 = r(i2)
         f1 = f(i1)
         f2 = f(i2)
         pent = (f2-f1)/(r2-r1)
         ff = f1 + (rr-r1)*pent
         dtwa = dtw/1000.D+00
         dtfa = dtf/1000.D+00
         xt = 1.D-4
         px = p + xt*dpdt
         twx = twra + dtwa*xt
         tfx = tfra + dtfa*xt
         pwlx = (px/14.696)*diahy*twx/tfx
         pwl = (p/14.696)*diahy*twra/tfra
         ewall = .6
         tt = twra*1000.D+00
         ttx = twx*1000.D+00
         eh2o = s00093(pwl,tt)
         eh2ox = s00093(pwlx,ttx)
         deh2o = (eh2ox-eh2o)/xt
         ah2o = 2.*eh2o*ff
         drr = (dtfa-rr*dtwa)/twra
         df = pent*drr
         dah2o = 2.*(eh2o*df+deh2o*ff)
         den = 1./ewall + 1./ah2o - 1.D+00
         dcc = 1.73*dah2o/(den*den*ah2o*ah2o)
         cc = 1.73/den
         s22202 = (dcc*hrt+cc*(dtwa*hrwt+dtfa*hrft))/3600.D+00
         RETURN
      ENDIF
      END
      SUBROUTINE s00089(i,al,dal,dtf,xx)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      COMMON /aaa77 / qinit , tpui(20) , qpui(20) , rpui , plmoy , 
     &                xhtc(22,12) , pl(22,12) , qrepa(22,12) , 
     &                xmcga(22,12) , xmcuo(22,12) , qced(22,12) , 
     &                qcon(22,12) , quga(22,12) , qfou(22,12) , qcei(2)
     &                 , qconi(2) , qugii(2) , tmi(2) , dtmi(2) , 
     &                qtotal , qtug , qtgf , terc(2) , tgai(22,12) , 
     &                tgaii(22,12) , t876(22,12) , tumax(22,12) , 
     &                tumin(22,12) , dtgai(22,12) , dt876(22,12) , 
     &                terco(22,12) , tmu(2) , dtmu(2) , npui , nasl(22)
     &                 , nsl(22)
      COMMON /aaa99 / hlcf , hvcfo , hvap , hcon , hvin , hlin , r876 , 
     &                rgai , xm876 , xmgai , xl876 , xlgai , cp876 , 
     &                cpgai , xmc876 , xmcgai , diahy , hgapp(22) , 
     &                hcg(22) , htc(22,12) , hvcff(22)
      COMMON /aaa22 / dh(22,2) , dm(22,2) , dpdt , duu(22,2) , dv(22,2)
     &                 , dnu(22,2)
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      COMMON /aaa88 / flup(22,2) , fluv(22,2) , flul(22,2) , fluiv(22,2)
     &                 , debil(22,2) , fluil(22,2) , debi(22) , 
     &                debhi(22) , debiv(22,2)
      COMMON /aaa17 / ddpdt , ddh(22,2) , ddv(22,2) , ddm(22,2) , 
     &                ddu(22,2)
      COMMON /aaa20 / dqp(22,2) , dflul(22) , dfluv(22) , dfluil(22) , 
     &                dfluiv(22) , ddebil(22) , ddebiv(22) , dqcei(2) , 
     &                dqced(22,12) , ddtuo(22,12) , ddtga(22,12) , 
     &                ddtmi(2) , ddtmu(2)
      DOUBLE PRECISION dal(12) , dtf(22,2) , xx(8) , al(12) , dq(2) , 
     &                 xtss(2)
      DOUBLE PRECISION m , dxtss(2) , tff(2) , dtff(2)
      IF ( ityp(i).EQ.3 ) THEN
         dq(1) = 0.D+00
         dq(2) = 0.D+00
         tff(1) = t(i,1)
         tff(2) = t(i,2)
         dtff(1) = dtf(i,1)
         dtff(2) = dtf(i,2)
         n1 = nasl(i)
         xtss(1) = 1.D+00
         xtss(2) = 1.D+00
         dxtss(1) = 0.D+00
         dxtss(2) = 0.D+00
         IF ( ts.GT.tff(1) ) THEN
            ect = ts - tff(1)
            ectc = ect*ect + 2.4
            xtss(1) = .025 + 2.34/ectc
            dxtss(1) = (4.68*ect/(ectc*ectc))*(dtff(1)-dtsat)
         ENDIF
         DO 50 j = 1 , n1
            IF ( j.NE.islni ) THEN
               tga = tgai(i,j)
               dtga = dtgai(i,j)
               ind = (n1+j-islni)/n1 + 1
               xts = xtss(ind)
               tfl = tff(ind)
               dtfl = dtff(ind)
               xsi = 1.D+00
               dxsi = 0.D+00
               IF ( tfl.GT.tga ) THEN
                  ect = tfl - tga + 2.D+00
                  xsi = .1 + 1.8/ect
                  dxsi = -1.8*(dtfl-dtga)/(ect*ect)
               ENDIF
               hcoef = hlcf*(2-ind) + hvcf*(ind-1)
               dhvcf = 0.D+00
               dhcoe = (ind-1)*hvcf
               hr = htc(i,j) - hcoef*xsi*xts
               dhr = s22202(al(ind),dal(ind),tga,dtga,tfl,dtfl,x1,x2,x3,
     &               3)
               dhr = s22202(al(j),dal(j),tga,dtga,tfl,dtfl,x1,x2,x3,3)
               dh1 = hcoef*(xsi*dxtss(ind)+dxsi*xts) + dhcoe*xsi*xts + 
     &               dhr
               dqced(i,j) = (htc(i,j)*(dtga-dtfl)+dh1*(tga-tfl))
     &                      *xhtc(i,j)
               dq(ind) = dq(ind) + dqced(i,j)
            ENDIF
 50      CONTINUE
         DO 100 j = 1 , 2
            tfl = tff(j)
            dtfl = dtff(j)
            tga = tmi(j)
            dtga = dtmi(j)
            xsi = 1.D+00
            dxsi = 0.D+00
            IF ( tfl.GT.tga ) THEN
               ect = tfl - tga + 2.D+00
               xsi = .1 + 1.8/ect
               dxsi = -1.8*(dtfl-dtga)/(ect*ect)
            ENDIF
            xy = ri(j)
            dxy = dv(i,j)*n1/vc(i)
            xts = xtss(j)
            dxts = dxtss(j)
            x = xsi*dxts + dxsi*xts
            hcoef = hlcf*(2-j) + hvcf*(j-1)
            dhvcf = 0.D+00
            dhcoe = (j-1)*dhvcf
            dhr = s22202(al(j),dal(j),tga,dtga,tfl,dtfl,x1,x2,x3,3)
            dh1 = dhcoe*xsi*xts + hcoef*x + dhr
            dqcei(j) = (htc(i,j)*(xy*(dtga-dtfl)+dxy*(tga-tfl))
     &                 +(tga-tfl)*xy*dh1)*xhtc(i,islni)
            dq(j) = dq(j) + dqcei(j)
 100     CONTINUE
         xx(1) = dq(1)
         xx(2) = dq(2)
         RETURN
      ELSE
         hvcf = hvcff(i)
         n1 = nasl(i)
         tfl = t(i,1)
         dtfl = dtf(i,1)
         dqpa = 0.D+00
         IF ( icat(2).LE.2 ) THEN
            tvap = t(i,1)
            dtvap = dtf(i,1)
            IF ( ityp(i).NE.1 ) THEN
               tvap = t(i,2)
               dtvap = dtf(i,2)
               tfl = ts
               dtfl = dtsat
               dfluv1 = 0.D+00
               dfluv2 = 0.D+00
               dflul1 = 0.D+00
               dflul2 = 0.D+00
               dflvme = 0.D+00
               dflvms = 0.D+00
            ENDIF
            CALL s00061(i,hv,hvt,hvme,hvms,ynu,re,tvap,dtvap,1)
            DO 120 j = 1 , n1
               IF ( ityp(i).NE.1 ) THEN
                  hvcf = hvcfo
                  dhvcf = 0.D+00
               ENDIF
               tga = tgai(i,j)
               dtga = dtgai(i,j)
               alff = al(j)
               dalf = dal(j)
               xsi = 1.D+00
               dxsi = 0.D+00
               IF ( tfl.GT.tga ) THEN
                  ect = tfl - tga + 2.D+00
                  xsi = .1 + 1.8/ect
                  dxsi = -1.8*(dtfl-dtga)/(ect*ect)
               ENDIF
               xts = 1.D+00
               dxts = 0.D+00
               IF ( tfl.LT.ts ) THEN
                  ect = ts - tfl
                  ectc = ect*ect + 2.4
                  xts = .025 + 2.34/ectc
                  dxts = (4.68*ect/(ectc*ectc))*(dtfl-dtsat)
               ENDIF
               hmil = 100./3600.D+00
               zz1 = zcot(ibch-1)
               zz2 = zcot(ihch)
               zz = zcot(i-1) + (xl(i)*(j-.5))/n1
               yy = ((zz-zz1)/(zz2-zz1)) - .5
               tbord = 700.D+00
               tmil = 900.D+00
               aco = (tmil-tbord)*4.D+00
               tmoy = tmil - aco*yy*yy
               tmin = tmoy - 100.D+00
               tmax = tmoy + 100.D+00
               ect = tmax - tmin
               z1 = (tmax-tga)/ect
               dz1 = -dtga/ect
               z2 = (tga-tmin)/ect
               dz2 = dtga/ect
               IF ( tga.GT.tmax ) THEN
                  z1 = 0.D+00
                  z2 = 1.D+00
                  dz1 = 0.D+00
                  dz2 = 0.D+00
               ELSEIF ( tga.LT.tmin ) THEN
                  z1 = 1.D+00
                  z2 = 0.D+00
                  dz1 = 0.D+00
                  dz2 = 0.D+00
               ENDIF
               IF ( alff.GT.1.D-4 ) THEN
                  pt1 = -.1
                  pt2 = 2.*(hvcf-hmil)/hvcf
                  qt1 = 1.D+00
                  qt2 = 1. - pt2
                  al1 = .625
                  al2 = .95
                  IF ( alff.LE.al1 ) THEN
                     y1 = (pt1*alff+qt1)*hlcf
                     dy1 = pt1*hlcf*dal(j)
                  ELSEIF ( alff.GT.al2 ) THEN
                     y1 = (pt2*alff+qt2)*hvcf
                     dy1 = 2.*(hvcf-hmil)*dalf + (2.*alff-1.)*dhvcf
                  ELSE
                     xla = al2 - al1
                     x1 = pt1*al1 + qt1
                     x2 = pt2*al2 + qt2
                     h1 = x1*hlcf
                     h2 = x2*hvcf
                     u1 = -pt1/x1
                     u2 = -pt2/x2
                     tc1 = 2. - u1*xla
                     tc2 = 2. + u2*xla
                     xla3 = xla*xla*xla
                     te1 = alff - al1
                     te2 = al2 - alff
                     p1 = te2*te2*(tc1*te1+xla)/xla3
                     p2 = te1*te1*(tc2*te2+xla)/xla3
                     y1 = (h1*p1+h2*p2)
                     dp1dt = -te2*(tc1*(3.*alff-2.*al1-al2)+2.*xla)
     &                       *dal(j)/xla3
                     dp2dt = -te1*(tc2*(3.*alff-2.*al2-al1)-2.*xla)
     &                       *dal(j)/xla3
                     dh2 = (pt2*al2+qt2)*dhvcf
                     dy1 = dp1dt*h1 + dp2dt*h2 + dh2*p2
                  ENDIF
               ELSE
                  y1 = hlcf
                  dy1 = 0.D+00
               ENDIF
               IF ( alff.GT..5 ) THEN
                  y2 = 2.*(hvcf-hmil)*(alff-1.) + hvcf
                  dy2 = 2.*(hvcf-hmil)*dalf + (2.*alff-1.)*dhvcf
               ELSE
                  beta = (hmil-hvcf)/(hlcf-hvcf)
                  zb = (.5-beta)/(.5*(1.-beta))
                  za = zb*zb/(1.-zb)
                  zc = -1./(za+zb)
                  y2 = 1./(za*alff+zb) + zc
                  y2 = y2*(hlcf-hvcf) + hvcf
                  dnom = za*alff + zb
                  dy2 = -(hlcf-hvcf)*za*dalf/(dnom*dnom)
     &                   + (1.-1./dnom-zc)*dhvcf
               ENDIF
               dhc = dz1*y1 + dz2*y2 + z1*dy1 + z2*dy2
               hcoef = z1*y1 + z2*y2
               IF ( ityp(i).EQ.2 ) THEN
                  y = (hcoef-hvcf)/(hlcf-hvcf)
                  dydt = dhc/(hlcf-hvcf)
                  hvcf = hvcff(i)
                  dhvcf = hvt
                  sur = xhtc(i,j)
                  hr1 = f00113(1,p,diahy,tga,t(i,1),0.0D0)
                  hr2 = f00113(1,p,diahy,tga,t(i,2),1.0D0)
                  dhr1 = s22202(x1,x2,tga,dtga,t(i,1),dtf(i,1),p,dpdt,
     &                   diahy,1)
                  dhr2 = s22202(x1,x2,tga,dtga,t(i,2),dtf(i,2),p,dpdt,
     &                   diahy,1)
                  hl1 = hlcf + hr1
                  hv1 = hvap + hr1
                  hl2 = hcon + hr2
                  hv2 = hvcf + hr2
                  dhl1 = dhr1
                  dhv1 = dhr1
                  dhl2 = dhr2
                  dhv2 = dhr2 + dhvcf
                  s1 = sur*y
                  s2 = sur*(1.-y)
                  ds1 = sur*dydt
                  ds2 = -ds1
                  dtf1 = dtf(i,1)
                  dtf2 = dtf(i,2)
                  tf1 = t(i,1)
                  tf2 = t(i,2)
                  IF ( ts.LT.tga ) THEN
                     dul1 = hl1*((dtsat-dtf1)*s1+(ts-tf1)*ds1)
     &                       + dhl1*(ts-tf1)*s1
                     dul2 = 0.D+00
                     duv1 = hv1*((dtga-dtsat)*s1+(tga-ts)*ds1)
     &                       + dhv1*(tga-ts)*s1
                     duv2 = hv2*((dtga-dtf2)*s2+(tga-tf2)*ds2)
     &                       + dhv2*(tga-tf2)*s2
                     duvme = hvme*(tga-tf2)*s2
                     duvms = hvms*(tga-tf2)*s2
                     fluvv2 = hv2*(tga-tf2)*s2
                     flull1 = hl1*(ts-tf1)*s1
                  ELSE
                     duv1 = 0.D+00
                     duv2 = hv2*((dtsat-dtf2)*s2+(ts-tf2)*ds2)
     &                       + dhv2*(ts-tf2)*s2
                     duvme = hvme*(ts-tf2)*s2
                     duvms = hvms*(ts-tf2)*s2
                     dul1 = hl1*((dtga-dtf1)*s1+(tga-tf1)*ds1)
     &                       + dhl1*(tga-tf1)*s1
                     dul2 = hl2*((dtga-dtsat)*s2+(tga-ts)*ds2)
     &                       + dhl2*(tga-ts)*s2
                     fluvv2 = hv2*(ts-tf2)*s2
                     flull1 = hl1*(tga-tf1)*s1
                  ENDIF
                  dtcor = 0.D+00
                  duv1 = duv1 + dtcor
                  duv2 = duv2 - dtcor
                  dfluv1 = dfluv1 + duv1
                  dfluv2 = dfluv2 + duv2
                  dflul1 = dflul1 + dul1
                  dflul2 = dflul2 + dul2
                  dflvme = dflvme + duvme
                  dflvms = dflvms + duvms
                  dqced(i,j) = dul1 + dul2 + duv1 + duv2
               ELSE
                  x1 = tem
                  dhr = s22202(x1,x2,tga,dtga,tfl,dtfl,p,dpdt,diahy,1)
                  dhtc = dhr + dhc*xsi*xts + hcoef*(dxsi*xts+xsi*dxts)
                  dqced(i,j) = xhtc(i,j)
     &                         *(dhtc*(tga-tfl)+htc(i,j)*(dtga-dtfl))
                  dqpa = dqpa + dqced(i,j)
               ENDIF
 120        CONTINUE
            IF ( ityp(i).EQ.2 ) THEN
               xx(1) = dflul1
               xx(2) = dfluv2
               xx(7) = dflvme
               xx(8) = dflvms
               dqp(i,1) = dflul1 + dfluv1
               dqp(i,2) = dflul2 + dfluv2
               x = v(i,2)/vc(i)
               dx = dv(i,2)/vc(i)
               smax = 1.8*shtc(i)
               IF ( x.GE..8 ) THEN
                  ro = .0295/12.D+00
                  IF ( x.GE..95 ) THEN
                     IF ( x.LT..99 ) THEN
                        r = ro
                        rp = 0.D+00
                     ELSEIF ( x.GE..999 ) THEN
                        r = ro/5.D+00
                        rp = 0.D+00
                     ELSE
                        r = ro*(89.-.8*x/.009)
                        rp = -.8*ro/.009
                     ENDIF
                     si = 3.*(1.-x)*vc(i)/r
                     dsi = -3.*vc(i)*(1.+(1.-x)*rp/r)*dx/r
                  ELSE
                     xla = .15
                     y2 = .15*vc(i)/ro
                     rap = -20.D+00
                     tc1 = .95 - x
                     tc2 = x - .8
                     si1 = smax*tc1*tc1*(2.*tc2+xla)
                     si2 = y2*tc2*tc2*((2.-rap*xla)*tc1+xla)
                     si = (si1+si2)/3.375D-3
                     dsi = dx*tc2*
     &                     (-6.*smax*tc1+y2*((2.-rap*xla)*(2.7-3.*x)
     &                     +2.*xla))/3.375D-3
                  ENDIF
               ELSE
                  si = smax*(-1.5625*x+2.5)*x
                  dsi = smax*(-3.125*x+2.5)*dx
               ENDIF
               dfisup = hvin*(si*(dtf(i,2)-dtsat)+dsi*(t(i,2)-ts))
               dfiinf = hlin*(si*(dtsat-dtf(i,1))+dsi*(ts-t(i,1)))
               duiv1 = dfisup
               xx(3) = dfiinf
               xx(4) = -dfisup
               duil2 = -dfiinf
               xx(5) = (dfluv1+duiv1+debil(i,1)*(dh(i,1)-dhgps*dpdt))
     &                 /(hgs-h(i,1))
               xx(6) = (dflul2+duil2+debiv(i,2)*(dh(i,2)-dhfps*dpdt))
     &                 /(hfs-h(i,2))
               RETURN
            ELSE
               xx(1) = dqpa
               RETURN
            ENDIF
         ELSE
            ind = 1 + (nc1+i-niv)/nc1
            DO 140 j = 1 , n1
               tga = tgai(i,j)
               dtga = dtgai(i,j)
               hcoe = htc(i,j)
               xts = 1.D+00
               dxts = 0.D+00
               IF ( tfl.LT.ts ) THEN
                  ect = ts - tfl
                  x = 1./(2.4+ect*ect)
                  xts = .025 + 2.34*x
                  dxts = 4.68*ect*x*x*(dtfl-dtsat)
               ENDIF
               xsi = 1.D+00
               dxsi = 0.D+00
               IF ( tfl.GT.tga ) THEN
                  ect = tfl - tga + 2.D+00
                  xsi = .1 + 1.8/ect
                  dxsi = -1.8*(dtfl-dtga)/(ect*ect)
               ENDIF
               h1 = hlcf*(2-ind) + hvcf*(ind-1)
               dhvcf = 0.D+00
               dh1 = dhvcf*(ind-1)
               hr = hcoe - h1*xts*xsi
               dhr = s22202(al(j),dal(j),tga,dtga,tfl,dtfl,x1,x2,x3,3)
               dhcoe = h1*(xsi*dxts+dxsi*xts) + dh1*xsi*xts + dhr
               dqpa = dqpa + xhtc(i,j)
     &                *(hcoe*(dtga-dtfl)+dhcoe*(tga-tfl))
 140        CONTINUE
            xx(1) = dqpa
            RETURN
         ENDIF
      ENDIF
      END
      SUBROUTINE s00013
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      COMMON /aaa77 / qinit , tpui(20) , qpui(20) , rpui , plmoy , 
     &                xhtc(22,12) , pl(22,12) , qrepa(22,12) , 
     &                xmcga(22,12) , xmcuo(22,12) , qced(22,12) , 
     &                qcon(22,12) , quga(22,12) , qfou(22,12) , qcei(2)
     &                 , qconi(2) , qugii(2) , tmi(2) , dtmi(2) , 
     &                qtotal , qtug , qtgf , terc(2) , tgai(22,12) , 
     &                tgaii(22,12) , t876(22,12) , tumax(22,12) , 
     &                tumin(22,12) , dtgai(22,12) , dt876(22,12) , 
     &                terco(22,12) , tmu(2) , dtmu(2) , npui , nasl(22)
     &                 , nsl(22)
      COMMON /aaa88 / flup(22,2) , fluv(22,2) , flul(22,2) , fluiv(22,2)
     &                 , debil(22,2) , fluil(22,2) , debi(22) , 
     &                debhi(22) , debiv(22,2)
      COMMON /aaa99 / hlcf , hvcfo , hvap , hcon , hvin , hlin , r876 , 
     &                rgai , xm876 , xmgai , xl876 , xlgai , cp876 , 
     &                cpgai , xmc876 , xmcgai , diahy , hgapp(22) , 
     &                hcg(22) , htc(22,12) , hvcff(22)
      COMMON /aaa22 / dh(22,2) , dm(22,2) , dpdt , duu(22,2) , dv(22,2)
     &                 , dnu(22,2)
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa26 / deb(21) , debv(21) , debl(21) , alfad(21) , 
     &                alfb(21) , alft(21) , ha(21) , hb(21) , he(21,2) , 
     &                hem(21) , ve(21,2) , xa(21) , xb(21) , xd(21) , 
     &                xem(21) , sdsc , tjonc(21) , hjonb(21,2) , 
     &                hjont(21,2) , debav(21) , glinf(21) , glsup(21) , 
     &                pp1 , pp2 , alniv , vgjo(21) , glinfp(21) , 
     &                v55198(21) , icas(21) , iczw(21)
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      COMMON /aaa11 / v0011n(20) , v0012x(20) , v0011 , v0012 , tlim , 
     &                zlimin , zlimax , dtvoi , timimp(20) , difref(20)
     &                 , difmic(20) , v00001 , v22202 , temimp , 
     &                temmic , delm , delv , delvi , delvs , v22201 , 
     &                v22203 , dtpre , dtphy , dttemp , dtchan , dtdis , 
     &                dtbef , dtorg , nimic , nmultr , izone , 
     &                n00011(20) , isort , necrit , nstar , iplot , 
     &                nzone , ifre(20) , ico , iimp , npas1(20) , 
     &                npas2(20)
      DOUBLE PRECISION m , xy(3) , alff(12)
      DO 200 i = 2 , nc1
         sec = scapa(i)
         IF ( icat(2).LT.3 ) THEN
            tfl = t(i,1)
            IF ( ityp(i).EQ.2 ) tfl = t(i,2)
            CALL s00061(i,hvcf,x1,x2,x3,ynu,re,tfl,x4,0)
            hvcff(i) = hvcf
         ENDIF
         n1 = nasl(i)
         DO 50 j = 1 , n1
            alff(j) = tvid(i,j)
 50      CONTINUE
         idoduc = ityp(i)
         IF ( idoduc.EQ.2 ) THEN
            fluv(i,1) = 0.D+00
            fluv(i,2) = 0.D+00
            flul(i,1) = 0.D+00
            flul(i,2) = 0.D+00
            n1 = nasl(i)
            x = v(i,2)/vc(i)
            DO 60 j = 1 , n1
               tga = tgai(i,j)
               CALL s44553(i,1,j,alff(j),hcoef,hray)
               ica = icat(2)
               hray1 = f00113(ica,p,diahy,tga,t(i,1),0.0D0)
               hray2 = f00113(ica,p,diahy,tga,t(i,2),1.0D0)
               hlc = hlcf + hray1
               hva = hvap + hray1
               hvc = hvcf + hray2
               hco = hcon + hray2
               y = (hcoef-hvcfo)/(hlcf-hvcfo)
               htc(i,j) = hcoef
               sht1 = xhtc(i,j)*y
               sht2 = xhtc(i,j)*(1.-y)
               IF ( ts.LT.tga ) THEN
                  flull1 = hlc*(ts-t(i,1))*sht1
                  fluvv1 = hva*(tga-ts)*sht1
                  flull2 = 0.D+00
                  fluvv2 = hvc*(tga-t(i,2))*sht2
               ELSE
                  fluvv1 = 0.D+00
                  flull1 = hlc*(tga-t(i,1))*sht1
                  flull2 = hco*(tga-ts)*sht2
                  fluvv2 = hvc*(ts-t(i,2))*sht2
               ENDIF
               tcor = 0.D+00
               fluv(i,1) = fluv(i,1) + fluvv1 + tcor
               fluv(i,2) = fluv(i,2) + fluvv2 - tcor
               flul(i,1) = flul(i,1) + flull1
               flul(i,2) = flul(i,2) + flull2
               qced(i,j) = flull1 + flull2 + fluvv1 + fluvv2
 60         CONTINUE
            x = v(i,2)/vc(i)
            smax = 1.8*shtc(i)
            IF ( x.GE..8 ) THEN
               ro = .0295/12.D+00
               IF ( x.GE..95 ) THEN
                  r = ro
                  IF ( x.GT..99 ) THEN
                     r = ro/5.D+00
                     IF ( x.LE..999 ) r = ro*(89.-.8*x/.009)
                  ENDIF
                  sint = 3.*(1.-x)*vc(i)/r
               ELSE
                  xla = .15
                  y2 = .15*vc(i)/ro
                  rap = -20.D+00
                  tc1 = .95 - x
                  tc2 = x - .8
                  sint1 = smax*tc1*tc1*(2.*tc2+xla)
                  sint2 = y2*tc2*tc2*((2.-rap*xla)*tc1+xla)
                  sint = (sint1+sint2)/3.375D-3
               ENDIF
            ELSE
               sint = smax*(-1.5625*x+2.5)*x
            ENDIF
            fiinf = hlin*sint*(ts-t(i,1))
            fisup = hvin*sint*(t(i,2)-ts)
            fluiv(i,1) = fisup
            fluil(i,1) = fiinf
            fluiv(i,2) = -fisup
            fluil(i,2) = -fiinf
            flup(i,1) = flul(i,1) + fluv(i,1)
            flup(i,2) = flul(i,2) + fluv(i,2)
            debil(i,1) = (fluv(i,1)+fluiv(i,1))/(hgs-hf(i,1))
            debiv(i,2) = (flul(i,2)+fluil(i,2))/(hfs-hg(i,2))
            debiv(i,1) = 0.D+00
            debil(i,2) = 0.D+00
            debi(i) = debil(i,1) + debiv(i,1) - debil(i,2) - debiv(i,2)
         ELSEIF ( idoduc.EQ.3 ) THEN
            n1 = nasl(i)
            flup(i,1) = 0.D+00
            flup(i,2) = 0.D+00
            isl1 = islni - 1
            isl2 = islni + 1
            iopt1 = 2
            IF ( isl1.NE.0 ) THEN
               DO 70 j = 1 , isl1
                  CALL s44553(i,1,j,alfa(i,1),hco,hray)
                  hcoef = hco + hray
                  htc(i,j) = hcoef
                  qced(i,j) = hcoef*(tgai(i,j)-t(i,1))*xhtc(i,j)
                  flup(i,1) = flup(i,1) + qced(i,j)
 70            CONTINUE
            ENDIF
            j = isl1 + 1
            zz = hniv(i)
            hslab = xl(i)/n1
            zs = zz - isl1*hslab
            r1 = zs/hslab
            r2 = 1. - r1
            sec1 = xhtc(i,j)*r1
            sec2 = xhtc(i,j)*r2
            tm1 = tmi(1)
            tm2 = tmi(2)
            ri(1) = r1
            ri(2) = r2
            CALL s44553(i,1,j,alfa(i,1),hco,hray)
            hco1 = hco + hray
            CALL s44553(i,2,j,alfa(i,2),hco,hray)
            hco2 = hco + hray
            q1 = hco1*(tm1-t(i,1))*sec1
            q2 = hco2*(tm2-t(i,2))*sec2
            qced(i,j) = q1 + q2
            flup(i,1) = flup(i,1) + q1
            flup(i,2) = flup(i,2) + q2
            qcei(1) = q1
            qcei(2) = q2
            IF ( isl2.LE.n1 ) THEN
               DO 80 j = isl2 , n1
                  CALL s44553(i,2,j,alfa(i,2),hco,hray)
                  hcoef = hco + hray
                  htc(i,j) = hcoef
                  qced(i,j) = hcoef*(tgai(i,j)-t(i,2))*xhtc(i,j)
                  flup(i,2) = flup(i,2) + qced(i,j)
 80            CONTINUE
            ENDIF
         ELSE
            n1 = nasl(i)
            fi = 0.D+00
            DO 100 j = 1 , n1
               CALL s44553(i,1,j,alff(j),hco,hray)
               hcoef = hco + hray
               htc(i,j) = hcoef
               qced(i,j) = hcoef*(tgai(i,j)-t(i,1))*xhtc(i,j)
               fi = fi + qced(i,j)
 100        CONTINUE
            flup(i,1) = fi
         ENDIF
 200  CONTINUE
      IF ( icat(2).LE.2 ) RETURN
      i = niv
      vg = vvgs
      vf = vvfs
      IF ( ist(i,1).EQ.1 ) vf = vv(i,1)
      IF ( ist(i,1).EQ.3 ) vg = vv(i,1)
      tempe = t(i,1)
      sec = scapa(i)
      i = niv
      z1 = xl(i-1)/2.D+00
      z2 = hniv(i)/2.D+00
      hj = f00111(i-1)
      x = (hj-hfs)/(hgs-hfs)
      alb = x/(x+(1.-x)*vvfs/vvgs)
      alt = alfa(i,1)
      IF ( alb.LE..05 ) z1 = z1*alb/.05
      IF ( alt.LE..05 ) z2 = z2*alt/.05
      alfad(i-1) = (z2*alb+z1*alt)/(z1+z2)
      pp1 = (alt-alb)/(z1+z2)
      IF ( hniv(i).GT.(xl(i)/2.) ) THEN
         alniv = alfad(i-1) + pp1*xl(i)/2. + pp2*(hniv(i)-xl(i)/2.)
      ELSE
         alniv = alfad(i-1) + pp1*hniv(i)
      ENDIF
      IF ( alniv.GT..9999 ) alniv = .9999
      al = alniv
      IF ( alniv.LT.0. ) alniv = 0.D+00
      gg = 1.D+6
      IF ( kgliss.EQ.4 ) CALL f88345(gg,al,al,vg,vf,tempe,x1,x2,x3,x4,
     &                               vgj,x5,x6,ix,x7,x8,iy)
      fluxg = 0.D+00
      IF ( al.LE..99999 ) fluxg = sec*vgj*al/((1.-al)*vg)
      vg = vvgs
      vf = vvfs
      IF ( ist(i,2).EQ.1 ) vf = vv(i,2)
      IF ( ist(i,2).EQ.3 ) vg = vv(i,2)
      tempe = t(i,2)
      al = alfa(i,2)
      IF ( kgliss.EQ.4 ) CALL f88345(gg,al,al,vg,vf,tempe,x1,x2,x3,x4,
     &                               vgj,x5,x6,ix,x7,x8,iy)
      fluxf = ((1.-al)*fluxg*vg/al-vgj*sec)/vf
      debi(i) = fluxg + fluxf
      debhi(i) = fluxg*hg(i,1) + fluxf*hf(i,2)
      RETURN
      END
      SUBROUTINE s00014
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa26 / deb(21) , debv(21) , debl(21) , alfad(21) , 
     &                alfb(21) , alft(21) , ha(21) , hb(21) , he(21,2) , 
     &                hem(21) , ve(21,2) , xa(21) , xb(21) , xd(21) , 
     &                xem(21) , sdsc , tjonc(21) , hjonb(21,2) , 
     &                hjont(21,2) , debav(21) , glinf(21) , glsup(21) , 
     &                pp1 , pp2 , alniv , vgjo(21) , glinfp(21) , 
     &                v55198(21) , icas(21) , iczw(21)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      COMMON /aaa88 / flup(22,2) , fluv(22,2) , flul(22,2) , fluiv(22,2)
     &                 , debil(22,2) , fluil(22,2) , debi(22) , 
     &                debhi(22) , debiv(22,2)
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      COMMON /aaa22 / dh(22,2) , dm(22,2) , dpdt , duu(22,2) , dv(22,2)
     &                 , dnu(22,2)
      COMMON /aaa16 / dbent(20) , tent(20) , hent(20) , debe , ente , 
     &                dbsor(20) , tsor(20) , debs , dpdtt(20) , 
     &                tdpdt(20) , hsor(20) , thsor(20) , ents , ndbent , 
     &                ndpdt , ndbsor , nhsor
      DOUBLE PRECISION m , num , d(22) , e(22) , f(22)
      eps = 1.D-8
      DO 100 i = 2 , nc1
         a(i) = 0.D+00
         b(i) = 0.D+00
         c(i) = 0.D+00
         d(i) = 0.D+00
         e(i) = 0.D+00
         f(i) = 0.D+00
 100  CONTINUE
      IF ( kdeb.EQ.0 ) THEN
         deb(1) = debe
      ELSE
         ret = 15.D+00
         d1 = deb(1)
         dmcdt = deb(1) - deb(nc1)
         d2 = debe - sdsc*dmcdt
         deb(1) = d1 + (dt/ret)*(d2-d1)
      ENDIF
      IF ( kpress.NE.1 ) deb(nc1) = debs
      DO 200 i = 2 , nc1
         j = i - 1
         idoduc = ityp(i)
         IF ( idoduc.EQ.2 ) THEN
            xsli = delh(i,1) + dvvh(i,1)*he(i,1)
            xslj = delh(i,1) + dvvh(i,1)*he(j,1)
            xsvi = delh(i,2) + dvvh(i,2)*he(i,2)
            xsvj = delh(i,2) + dvvh(i,2)*he(j,2)
            xsifs1 = delh(i,1) + dvvh(i,1)*hfs
            xsifs2 = delh(i,2) + dvvh(i,2)*hfs
            xsigs1 = delh(i,1) + dvvh(i,1)*hgs
            xsigs2 = delh(i,2) + dvvh(i,2)*hgs
            xsifi = delh(i,1) + dvvh(i,1)*hf(i,1)
            xsigi = delh(i,2) + dvvh(i,2)*hg(i,2)
            a(i) = xb(i)*xsli - xb(j)*xslj + dvvh(i,1)
     &             *(flul(i,1)+fluil(i,1)) + xb(j)*xsvj - xb(i)
     &             *xsvi + dvvh(i,2)*(fluv(i,2)+fluiv(i,2)) + debil(i,1)
     &             *(xsigs2-xsifi) + debiv(i,2)*(xsifs1-xsigi)
     &              + debiv(i,1)*(xsigs2-xsigs1) + debil(i,2)
     &             *(xsifs1-xsifs2)
            b(i) = (1.-xa(j))*xslj + xa(j)*xsvj
            c(i) = -(1.-xa(i))*xsli - xa(i)*xsvi
            d(i) = bb(i,1) + bb(i,2)
            e(i) = -a(i)
         ELSEIF ( idoduc.EQ.3 ) THEN
            a(i) = (delh(i,2)-delh(i,1))*debi(i) + dvvh(i,1)
     &             *(hb(j)-debhi(i)+flup(i,1)) + dvvh(i,2)
     &             *(-hb(i)+debhi(i)+flup(i,2))
            b(i) = delh(i,1) + dvvh(i,1)*ha(j)
            c(i) = -(delh(i,2)+dvvh(i,2)*ha(i))
            d(i) = bb(i,1) + bb(i,2)
            e(i) = -a(i)
         ELSE
            a(i) = dvvh(i,1)*(hb(j)-hb(i)+flup(i,1))
            b(i) = delh(i,1) + dvvh(i,1)*ha(j)
            c(i) = -(delh(i,1)+dvvh(i,1)*ha(i))
            d(i) = bb(i,1)
            e(i) = -a(i)
         ENDIF
 200  CONTINUE
      IF ( kpress.EQ.1 ) THEN
         taft = tem + 1.D-4
         CALL s00934(tdpdt,dpdtt,dpdtt,taft,paft,x,13)
         dpdt = (paft-p)/1.D-4
         DO 250 i = 2 , nc1
            deb(i) = (-d(i)*dpdt-a(i)-b(i)*deb(i-1))/c(i)
 250     CONTINUE
      ELSE
         e(2) = e(2) - b(2)*deb(1)
         e(nc1) = e(nc1) - c(nc1)*debs
         deb(nc1) = debs
         f(2) = 1.D+00
         num = 0.D+00
         denom = 0.D+00
         DO 300 i = 2 , nc
            num = num + f(i)*e(i)
            denom = denom + f(i)*d(i)
            f(i+1) = -f(i)*c(i)/b(i+1)
 300     CONTINUE
         num = num + f(nc1)*e(nc1)
         denom = denom + f(nc1)*d(nc1)
         dpdt = num/denom
         deb(2) = (e(2)-d(2)*dpdt)/c(2)
         DO 350 i = 3 , nc
            deb(i) = (e(i)-b(i)*deb(i-1)-d(i)*dpdt)/c(i)
 350     CONTINUE
      ENDIF
      DO 400 i = 1 , nc1
         debv(i) = xa(i)*deb(i) + xb(i)
         debl(i) = deb(i) - debv(i)
         xd(i) = 0.5
         xem(i) = 0.5
         hem(i) = 0.5
         IF ( dabs(deb(i)).GE.eps ) THEN
            xd(i) = debv(i)/deb(i)
            hem(i) = (he(i,1)*debl(i)+he(i,2)*debv(i))/deb(i)
            xem(i) = (hem(i)-hfs)/hfgs
         ENDIF
 400  CONTINUE
      debs = deb(nc1)
      RETURN
      END
      SUBROUTINE s00017
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa26 / deb(21) , debv(21) , debl(21) , alfad(21) , 
     &                alfb(21) , alft(21) , ha(21) , hb(21) , he(21,2) , 
     &                hem(21) , ve(21,2) , xa(21) , xb(21) , xd(21) , 
     &                xem(21) , sdsc , tjonc(21) , hjonb(21,2) , 
     &                hjont(21,2) , debav(21) , glinf(21) , glsup(21) , 
     &                pp1 , pp2 , alniv , vgjo(21) , glinfp(21) , 
     &                v55198(21) , icas(21) , iczw(21)
      COMMON /aaa22 / dh(22,2) , dm(22,2) , dpdt , duu(22,2) , dv(22,2)
     &                 , dnu(22,2)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      COMMON /aaa88 / flup(22,2) , fluv(22,2) , flul(22,2) , fluiv(22,2)
     &                 , debil(22,2) , fluil(22,2) , debi(22) , 
     &                debhi(22) , debiv(22,2)
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa99 / hlcf , hvcfo , hvap , hcon , hvin , hlin , r876 , 
     &                rgai , xm876 , xmgai , xl876 , xlgai , cp876 , 
     &                cpgai , xmc876 , xmcgai , diahy , hgapp(22) , 
     &                hcg(22) , htc(22,12) , hvcff(22)
      COMMON /aaa33 / vco , xl0055 , d876 , dint , dext , vol002 , 
     &                vol005 , lco , ncray
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      COMMON /aaa77 / qinit , tpui(20) , qpui(20) , rpui , plmoy , 
     &                xhtc(22,12) , pl(22,12) , qrepa(22,12) , 
     &                xmcga(22,12) , xmcuo(22,12) , qced(22,12) , 
     &                qcon(22,12) , quga(22,12) , qfou(22,12) , qcei(2)
     &                 , qconi(2) , qugii(2) , tmi(2) , dtmi(2) , 
     &                qtotal , qtug , qtgf , terc(2) , tgai(22,12) , 
     &                tgaii(22,12) , t876(22,12) , tumax(22,12) , 
     &                tumin(22,12) , dtgai(22,12) , dt876(22,12) , 
     &                terco(22,12) , tmu(2) , dtmu(2) , npui , nasl(22)
     &                 , nsl(22)
      COMMON /aaa17 / ddpdt , ddh(22,2) , ddv(22,2) , ddm(22,2) , 
     &                ddu(22,2)
      COMMON /aaa18 / ddeb(21) , dddeb(21) , dxat(21) , dxag(21) , 
     &                dxbt(21) , dxbg(21) , dnug(21) , dnuf(21) , 
     &                dhe(22,2) , ddebo(21)
      COMMON /aaa20 / dqp(22,2) , dflul(22) , dfluv(22) , dfluil(22) , 
     &                dfluiv(22) , ddebil(22) , ddebiv(22) , dqcei(2) , 
     &                dqced(22,12) , ddtuo(22,12) , ddtga(22,12) , 
     &                ddtmi(2) , ddtmu(2)
      COMMON /aaa11 / v0011n(20) , v0012x(20) , v0011 , v0012 , tlim , 
     &                zlimin , zlimax , dtvoi , timimp(20) , difref(20)
     &                 , difmic(20) , v00001 , v22202 , temimp , 
     &                temmic , delm , delv , delvi , delvs , v22201 , 
     &                v22203 , dtpre , dtphy , dttemp , dtchan , dtdis , 
     &                dtbef , dtorg , nimic , nmultr , izone , 
     &                n00011(20) , isort , necrit , nstar , iplot , 
     &                nzone , ifre(20) , ico , iimp , npas1(20) , 
     &                npas2(20)
      COMMON /aaa16 / dbent(20) , tent(20) , hent(20) , debe , ente , 
     &                dbsor(20) , tsor(20) , debs , dpdtt(20) , 
     &                tdpdt(20) , hsor(20) , thsor(20) , ents , ndbent , 
     &                ndpdt , ndbsor , nhsor
      DOUBLE PRECISION m , num , dalfa(22,2) , dtf(22,2)
      DOUBLE PRECISION r(22) , ta(22) , w(22) , dal(12) , xx(8) , s(22)
      DOUBLE PRECISION dml(21) , dmv(21)
      DOUBLE PRECISION ya(5) , tta(5) , cr(5)
      DOUBLE PRECISION e(22) , f(22) , al(12)
      DOUBLE PRECISION dalbb(21) , daltt(21)
      DOUBLE PRECISION dtvid(22,12) , dfluve(22) , dfluvs(22)
      coef = 144.D+00/778.D+00
      eps = 1.D-6
      dtsat = dtsat*dpdt
      tess = tem + 1.D-4
      CALL s00934(tent,dbent,hent,tess,x1,x2,20)
      dqinj = (x1-deb(1))/1.D-4
      dh(1,1) = (x2-h(1,1))/1.D-4
      CALL s00934(thsor,hsor,hsor,tess,entss,x,2)
      dh(nc2,1) = (entss-h(nc2,1))/1.D-4
      dhfs = dhfps*dpdt
      dhgs = dhgps*dpdt
      dnufs = dvvfps*dpdt
      dnugs = dvvgps*dpdt
      DO 100 i = 1 , nc1
         ie = i
         is = i + 1
         dvfb = dnufs
         dvft = dnufs
         dvgb = dnugs
         dvgt = dnugs
         dhfb = dhfs
         dhft = dhfs
         dhgb = dhgs
         dhgt = dhgs
         ddebo(i) = ddeb(i)
         idoduc = ityp(ie)
         IF ( idoduc.EQ.2 ) THEN
            dhfb = dh(ie,1)
            dhgb = dh(ie,2)
            dvfb = dnu(ie,1)
            dvgb = dnu(ie,2)
         ELSEIF ( idoduc.EQ.3 ) THEN
            ica = ist(ie,2)
            IF ( ica.EQ.1 ) THEN
               dhfb = dh(ie,2)
               dvfb = dnu(ie,2)
            ELSEIF ( ica.EQ.3 ) THEN
               dhgb = dh(ie,2)
               dvgb = dnu(ie,2)
            ENDIF
         ELSE
            ica = ist(ie,1)
            IF ( ica.EQ.1 ) THEN
               dhfb = dh(ie,1)
               dvfb = dnu(ie,1)
            ELSEIF ( ica.EQ.3 ) THEN
               dhgb = dh(ie,1)
               dvgb = dnu(ie,1)
            ENDIF
         ENDIF
         IF ( ityp(is).EQ.2 ) THEN
            dhft = dh(is,1)
            dhgt = dh(is,2)
            dvft = dnu(is,1)
            dvgt = dnu(is,2)
         ELSE
            ica = ist(is,1)
            IF ( ica.EQ.1 ) THEN
               dhft = dh(is,1)
               dvft = dnu(is,1)
            ELSEIF ( ica.EQ.3 ) THEN
               dhgt = dh(is,1)
               dvgt = dnu(is,1)
            ENDIF
         ENDIF
         dnug(i) = (dvgb+dvgt)/2.
         dnuf(i) = (dvfb+dvft)/2.
         dhe(i,1) = dhfb
         dhe(i,2) = dhgb
         debll = debav(i)*(1.-xa(i)) - xb(i)
         debvv = debav(i)*xa(i) + xb(i)
         IF ( debll.LT.0. ) dhe(i,1) = dhft
         IF ( debvv.LT.0. ) dhe(i,2) = dhgt
 100  CONTINUE
      vfdvg = vvfs/vvgs
      dvfdvg = (dvvfps-vfdvg*dvvgps)*dpdt
      dalfa(1,1) = 0.
      dalfa(nc2,1) = 0.
      DO 200 i = 2 , nc1
         j1 = 2 - 1/ityp(i)
         DO 150 j = 1 , j1
            dtf(i,j) = dtdp(i,j)*dpdt + dtdh(i,j)*dh(i,j)
            dalfa(i,j) = 0.
            IF ( ist(i,j).EQ.2 ) THEN
               x = (h(i,j)-hfs)/hfgs
               dxdt = (dh(i,j)-(dhfps+dhfgs*x)*dpdt)/hfgs
               aldx = 1./(x+(1.-x)*vfdvg)
               aldx = aldx*aldx
               dalfa(i,j) = aldx*(vfdvg*dxdt-(1.-x)*x*dvfdvg/vvgs)
            ENDIF
 150     CONTINUE
 200  CONTINUE
      dalbb(1) = 0.
      daltt(nc1) = 0.
      DO 400 i = 2 , nc1
         ni = nasl(i)
         DO 250 j = 1 , ni
            al(j) = tvid(i,j)
 250     CONTINUE
         CALL s33018(i,dalfa,dal,daljb,daljt)
         daltt(i-1) = daljb
         dalbb(i) = daljt
         DO 300 j = 1 , ni
            dtvid(i,j) = dal(j)
 300     CONTINUE
 400  CONTINUE
      DO 500 i = 1 , nc1
         dalb = dalbb(i)
         dalt = daltt(i)
         sec = sc(i)
         ik = iczw(i)
         IF ( kgliss.EQ.4 ) CALL s33022(i,sec,ik,dalb,dalt,x1,x2,x3,x4)
         dxat(i) = x1
         dxag(i) = x2
         dxbt(i) = x3
         dxbg(i) = x4
 500  CONTINUE
      DO 600 i = 2 , nc1
         ni = nasl(i)
         DO 550 j = 1 , ni
            al(j) = tvid(i,j)
            dal(j) = dtvid(i,j)
 550     CONTINUE
         CALL s00089(i,al,dal,dtf,xx)
         IF ( ityp(i).EQ.2 ) THEN
            dflul(i) = xx(1)
            dfluv(i) = xx(2)
            dfluil(i) = xx(3)
            dfluiv(i) = xx(4)
            ddebil(i) = xx(5)
            ddebiv(i) = xx(6)
            dfluve(i) = xx(7)
            dfluvs(i) = xx(8)
         ELSE
            dqp(i,1) = xx(1)
            dqp(i,2) = xx(2)
         ENDIF
 600  CONTINUE
      DO 700 i = 2 , nc1
         ie = i - 1
         is = i
         IF ( ityp(i).LT.2 ) THEN
            hlve = he(ie,2) - he(ie,1)
            hlvs = he(is,2) - he(is,1)
            vh = dvvh(i,1)
            dvp = dvvp(i,1)*dpdt
            dvvpp = dnupp(i,1)*dpdt
            dvvhh = dnuhp(i,1)*dh(i,1)
            dvvhp = dnuhp(i,1)*dpdt
            dadt = vh*(dqp(i,1)+hlve*dxbt(ie)-hlvs*dxbt(is)
     &             +(dhe(ie,2)-dhe(ie,1))*xb(ie)-(dhe(is,2)-dhe(is,1))
     &             *xb(is)) + dvvhp*(flup(i,1)+hb(ie)-hb(is))
            dadme = vh*hlve*dxbg(ie)
            dadms = -vh*hlvs*dxbg(is)
            dbdt = vh*(hlve*dxat(ie)+xa(ie)*dhe(ie,2)+(1.-xa(ie))
     &             *dhe(ie,1)) + dvp + (ha(ie)-h(i,1))*dvvhp
            dbdme = vh*hlve*dxag(ie)
            dcdt = -vh*(hlvs*dxat(is)+xa(is)*dhe(is,2)+(1.-xa(is))
     &             *dhe(is,1)) - dvp - (ha(is)-h(i,1))*dvvhp
            dcdms = -vh*hlvs*dxag(is)
            w(i) = bb(i,1)
            r(i) = dvp*dm(i,1) + dpdt*(m(i,1)*(dvvpp+dvvhh)+coef*v(i,1)
     &             *dvvhp)
         ELSEIF ( ityp(i).GE.3 ) THEN
            vp1 = dvvp(i,1)*dpdt
            vp2 = dvvp(i,2)*dpdt
            vh1 = dvvh(i,1)
            vh2 = dvvh(i,2)
            dvvpp1 = dnupp(i,1)*dpdt
            dvvhh1 = dnuhp(i,1)*dh(i,1)
            dvvhp1 = dnuhp(i,1)*dpdt
            dvvpp2 = dnupp(i,2)*dpdt
            dvvhh2 = dnuhp(i,2)*dh(i,2)
            dvvhp2 = dnuhp(i,2)*dpdt
            hlve = he(ie,2) - he(ie,1)
            hlvs = he(is,2) - he(is,1)
            all = alfa(i,1)
            ddebi = 0.
            ddebhi = 0.
            IF ( all.GT.1.D-6 ) ddebi = debi(i)/(all*(1.-all))
     &                                  *dalfa(i,1)
            ddebi = ddebi - debi(i)*dvvgps*dpdt/vvgs
            ddebhi = ddebi*hgs + debi(i)*dhgps*dpdt
            dadt = vh1*(dqp(i,1)+hlve*dxbt(ie)+xb(ie)
     &             *(dhe(ie,2)-dhe(ie,1)))
     &              + vh2*(dqp(i,2)-hlvs*dxbt(is)-xb(is)
     &             *(dhe(is,2)-dhe(is,1))) + debi(i)
     &             *(vp2-vp1-h(i,2)*dvvhp2+h(i,1)*dvvhp1)
     &              + ddebi*(delh(i,2)-delh(i,1)) + ddebhi*(vh2-vh1)
     &              + dvvhp1*(hb(ie)-debhi(i)+flup(i,1))
     &              + dvvhp2*(debhi(i)-hb(is)+flup(i,2))
            dadme = vh1*hlve*dxbg(ie)
            dadms = -vh2*hlvs*dxbg(is)
            dbdt = vh1*(hlve*dxat(ie)+xa(ie)*dhe(ie,2)+(1.-xa(ie))
     &             *dhe(ie,1)) + vp1 + (ha(ie)-h(i,1))*dvvhp1
            dbdme = vh1*hlve*dxag(ie)
            dcdt = -vh2*(hlvs*dxat(is)+xa(is)*dhe(is,2)+(1.-xa(is))
     &             *dhe(is,1)) - vp2 - (ha(is)-h(i,2))*dvvhp2
            dcdms = -vh2*hlvs*dxag(is)
            w(i) = bb(i,1) + bb(i,2)
            r(i) = dm(i,1)*vp1 + dm(i,2)
     &             *vp2 + dpdt*(coef*(dv(i,1)*(vh1-vh2)+v(i,1)
     &             *dvvhp1+v(i,2)*dvvhp2)+m(i,1)*(dvvpp1+dvvhh1)+m(i,2)
     &             *(dvvpp2+dvvhh2))
         ELSE
            dflvme = dfluve(i)
            dflvms = dfluvs(i)
            vh1 = dvvh(i,1)
            vh2 = dvvh(i,2)
            vp1 = dvvp(i,1)*dpdt
            vp2 = dvvp(i,2)*dpdt
            yne1 = delh(i,1) + vh1*he(ie,1)
            yne2 = delh(i,2) + vh2*he(ie,2)
            yns1 = delh(i,1) + vh1*he(is,1)
            yns2 = delh(i,2) + vh2*he(is,2)
            dns = yns1 - yns2
            dne = yne1 - yne2
            yl1 = delh(i,1) + vh1*h(i,1)
            yl2 = delh(i,2) + vh2*h(i,2)
            ga1 = delh(i,1) + vh1*hfs
            ga2 = delh(i,2) + vh2*hgs
            ddns = vp1 - vp2 + vh1*dhe(is,1) - vh2*dhe(is,2)
            ddne = vp1 - vp2 + vh1*dhe(ie,1) - vh2*dhe(ie,2)
            dga2 = vp2 + vh2*dhgps*dpdt - dnu(i,1)
            dga1 = vp1 + vh1*dhfps*dpdt - dnu(i,2)
            dadt = dns*dxbt(is) - dne*dxbt(ie)
     &              + vh1*(dflul(i)+dfluil(i))
     &              + vh2*(dfluv(i)+dfluiv(i)) + ddebil(i)*(-yl1+ga2)
     &              + ddebiv(i)*(ga1-yl2) + xb(is)*ddns - xb(ie)
     &             *ddne + debil(i,1)*dga2 + debiv(i,2)*dga1
            dadme = -dne*dxbg(ie) + vh2*dflvme
            dadms = dns*dxbg(is) + vh2*dflvms
            dbdt = -dne*dxat(ie) + xa(ie)*(vp2+vh2*dhe(ie,2))
     &              + (1.-xa(ie))*(vp1+vh1*dhe(ie,1))
            dbdme = -dne*dxag(ie)
            dcdt = dns*dxat(is) - xa(is)*(vp2+vh2*dhe(is,2))
     &              - (1.-xa(is))*(vp1+vh1*dhe(is,1))
            dcdms = dns*dxag(is)
            w(i) = bb(i,1) + bb(i,2)
            r(i) = dpdt*(dm(i,1)*dvvp(i,1)+dm(i,2)*dvvp(i,2)
     &             +coef*dv(i,1)*(vh1-vh2))
         ENDIF
         r(i) = r(i) + dadt + deb(ie)*dbdt + deb(is)*dcdt
         s(i) = dadme + deb(ie)*dbdme + b(i)
         ta(i) = dadms + deb(is)*dcdms + c(i)
         e(i) = -r(i)
 700  CONTINUE
      IF ( kdeb.EQ.0 ) THEN
         ddeb(1) = dqinj
      ELSE
         ret = 1./15.
         ddeb(1) = ddeb(1)*(1.-ret*(1.+sdsc))
     &              + ret*(sdsc*ddeb(nc1)+dqinj)
      ENDIF
      IF ( kpress.EQ.0 ) THEN
         tess = tem + 1.D-4
         CALL s00934(tsor,dbsor,dbsor,tess,x1,x2,ndbsor)
         ddeb(nc1) = (x1-deb(nc1))/1.D-4
         e(2) = e(2) - s(2)*ddeb(1)
         e(nc1) = e(nc1) - ta(nc1)*ddeb(nc1)
         f(2) = 1.
         num = 0.
         denom = 0.
         DO 750 i = 2 , nc
            num = num + f(i)*e(i)
            denom = denom + f(i)*w(i)
            f(i+1) = -f(i)*ta(i)/s(i+1)
 750     CONTINUE
         num = num + f(nc1)*e(nc1)
         denom = denom + f(nc1)*w(nc1)
         ddpdt = num/denom
         ddeb(2) = (e(2)-w(2)*ddpdt)/ta(2)
         DO 800 i = 3 , nc
            ddeb(i) = (e(i)-s(i)*ddeb(i-1)-w(i)*ddpdt)/ta(i)
 800     CONTINUE
      ELSE
         ddpdt = 0.
         DO 850 i = 2 , nc1
            ddeb(i) = (-r(i)-w(i)*ddpdt-s(i)*ddeb(i-1))/ta(i)
 850     CONTINUE
      ENDIF
      DO 900 i = 1 , nc1
         dxmm = ddeb(i)
         xmm = deb(i)
         xaa = xa(i)
         dxadm = dxag(i)
         dxadt = dxat(i)
         dxbdm = dxbg(i)
         dxbdt = dxbt(i)
         dml(i) = dxmm*(1.-xaa-xmm*dxadm-dxbdm) - xmm*dxadt - dxbdt
         dmv(i) = dxmm*(xaa+xmm*dxadm+dxbdm) + xmm*dxadt + dxbdt
         qsec = (dxmm-ddebo(i))/dt
         y = dabs(dxmm)/(20.*dt)
         doduc = .01
         y = dmax1(y,doduc)
         yy = dabs(qsec)
         IF ( yy.GE.y ) qsec = qsec*y/yy
         dddeb(i) = qsec
 900  CONTINUE
      dddeb(1) = 0.
      DO 1000 i = 2 , nc1
         ie = i - 1
         is = i
         IF ( ityp(i).LT.2 ) THEN
            ddv(i,2) = 0.
            ddh(i,2) = 0.
            ddm(i,2) = 0.
            ddu(i,2) = 0.
            ddm(i,1) = ddeb(ie) - ddeb(is)
            ddu(i,1) = dml(ie)*he(ie,1) + dmv(ie)*he(ie,2) - dml(is)
     &                 *he(is,1) - dmv(is)*he(is,2) + debv(ie)*dhe(ie,2)
     &                  + dqp(i,1) + debl(ie)*dhe(ie,1) - debv(is)
     &                 *dhe(is,2) - debl(is)*dhe(is,1)
         ELSEIF ( ityp(i).GE.3 ) THEN
            ddm(i,1) = ddeb(ie) - ddebi
            ddm(i,2) = ddebi - ddeb(is)
            ddu(i,1) = dml(ie)*he(ie,1) + dmv(ie)*he(ie,2) - ddebhi + 
     &                 dqp(i,1) + debl(ie)*dhe(ie,1) + debv(ie)
     &                 *dhe(ie,2)
            ddu(i,2) = ddebhi - dml(is)*he(is,1) - dmv(is)*he(is,2)
     &                  - debl(is)*dhe(is,1) - debv(is)*dhe(is,2)
     &                  + dqp(i,2)
         ELSE
            dfluv(i) = dfluv(i) + dfluve(i)*ddeb(ie) + dfluvs(i)
     &                 *ddeb(is)
            ddm(i,1) = dml(ie) - dml(is) - ddebil(i) + ddebiv(i)
            ddm(i,2) = dmv(ie) - dmv(is) + ddebil(i) - ddebiv(i)
            ddu(i,1) = dml(ie)*he(ie,1) - dml(is)*he(is,1) + dflul(i)
     &                  + dfluil(i) + debl(ie)*dhe(ie,1) - debl(is)
     &                 *dhe(is,1) - debil(i,1)*dh(i,1) + debiv(i,2)
     &                 *dhfps*dpdt - h(i,1)*ddebil(i) + hfs*ddebiv(i)
            ddu(i,2) = dmv(ie)*he(ie,2) - dmv(is)*he(is,2) + dfluv(i)
     &                  + dfluiv(i) + debv(ie)*dhe(ie,2) - debv(is)
     &                 *dhe(is,2) + debil(i,1)*dhgps*dpdt - debiv(i,2)
     &                 *dh(i,2) + hgs*ddebil(i) - h(i,2)*ddebiv(i)
         ENDIF
         j1 = 2 - 1/ityp(i)
         epsm = delm*vc(i)/vvfs
         DO 950 j = 1 , j1
            daj = dvvh(i,j)*(ddu(i,j)-h(i,j)*ddm(i,j)) + vv(i,j)
     &            *ddm(i,j)
     &             + (dvvp(i,j)*dm(i,j)+dnuhp(i,j)*(duu(i,j)-h(i,j)
     &            *dm(i,j)))*dpdt
            dbj = dm(i,j)*dvvp(i,j) + m(i,j)
     &            *(dnupp(i,j)*dpdt+dnuhp(i,j)*dh(i,j))
     &             + coef*(dvvh(i,j)*dv(i,j)+v(i,j)*dnuhp(i,j)*dpdt)
            ddv(i,j) = daj + dbj*dpdt + bb(i,j)*ddpdt
            ym = m(i,j)
            IF ( ym.GE.epsm ) THEN
               ddh(i,j) = (coef*(dv(i,j)*dpdt+v(i,j)*ddpdt)+ddu(i,j)
     &                    -h(i,j)*ddm(i,j)-2.*dh(i,j)*dm(i,j))/ym
            ELSE
               ym = epsm
               dym = 0.
               ddh(i,j) = (coef*(dv(i,j)*dpdt+v(i,j)*ddpdt)+ddu(i,j)
     &                    -h(i,j)*ddm(i,j)-dh(i,j)*(dm(i,j)+dym))/ym
            ENDIF
            IF ( dabs(ddh(i,j)).LT.1.D-4 ) ddh(i,j) = 0.
            IF ( dabs(ddv(i,j)).LT.1.D-4 ) ddv(i,j) = 0.
 950     CONTINUE
 1000 CONTINUE
      ttem = tem + 1.D-4
      CALL s00934(tpui,qpui,qpui,ttem,rpui,xx(1),6)
      qqtot = qinit*rpui
      dqtdt = (qqtot-qtotal)/1.D-4
      DO 1100 i = 2 , nc1
         n1 = nasl(i)
         ccc = hcg(i)*ncray*xl(i)/n1
         DO 1050 j = 1 , n1
            dqfou = qrepa(i,j)*dqtdt
            dquga = (dt876(i,j)-dtgai(i,j))*ccc
            ddtuo(i,j) = (dqfou-dquga)/xmcuo(i,j)
            ddtga(i,j) = (dquga-dqced(i,j))/xmcga(i,j)
 1050    CONTINUE
 1100 CONTINUE
      IF ( icat(2).LE.2 ) GOTO 1200
      i = niv
      j = islni
      n1 = nasl(i)
      dqfou = qrepa(i,j)*dqtdt
      coeff = xlgai*sec*xl(i)/n1
      ccc = hcg(i)*ncray*xl(i)/n1
      dri = n1*dv(i,1)/vc(i)
      IF ( i.EQ.2 .AND. j.EQ.1 ) THEN
         ya(1) = ri(1)*xl(i)/(2.*n1)
         ya(2) = (1.-ri(2)/2.)*xl(i)/n1
         tta(1) = dtmi(1)
         tta(2) = dtmi(2)
         ii = i
         jj = islni + 1
         IF ( n1.LE.1 ) THEN
            ii = niv + 1
            jj = 1
         ENDIF
         ya(3) = xl(i)/n1 + .5*xl(ii)/nasl(ii)
         tta(3) = dtgai(ii,jj)
         der1 = 2.*(tta(2)-tta(1))/((ya(2)-ya(1))*(ya(2)+ya(1)))
         CALL s00099(3,ya,tta,cr)
         der2 = 2.*cr(1)
      ELSEIF ( i.NE.nc1 .OR. j.NE.n1 ) THEN
         ii = i
         jj = islni - 1
         IF ( jj.LT.1 ) THEN
            ii = i - 1
            jj = nasl(ii)
         ENDIF
         ya(1) = -.5*xl(ii)/nasl(ii)
         tta(1) = dtgai(ii,jj)
         ya(2) = .5*ri(1)*xl(i)/n1
         tta(2) = dtmi(1)
         tta(3) = dtmi(2)
         ya(3) = (1.-.5*ri(2))*xl(i)/n1
         ii = i
         jj = islni + 1
         IF ( jj.GT.n1 ) THEN
            ii = i + 1
            jj = 1
         ENDIF
         ya(4) = xl(i)/n1 + .5*xl(ii)/nasl(ii)
         tta(4) = dtgai(ii,jj)
         CALL s00099(4,ya,tta,cr)
         der1 = 6.*cr(1)*ya(2) + 2*cr(2)
         der2 = 6.*cr(1)*ya(3) + 2*cr(2)
      ELSE
         ya(1) = ri(2)*xl(i)/(2.*n1)
         ya(2) = (1.-ri(1)/2.)*xl(i)/n1
         tta(1) = dtmi(2)
         tta(2) = dtmi(1)
         ii = i
         jj = islni - 1
         IF ( n1.LE.1 ) THEN
            ii = i - 1
            jj = nasl(ii)
         ENDIF
         ya(3) = xl(i)/n1 + .5*xl(ii)/nasl(ii)
         tta(3) = dtgai(ii,jj)
         der2 = 2.*(tta(2)-tta(1))/((ya(2)-ya(1))*(ya(2)+ya(1)))
         CALL s00099(3,ya,tta,cr)
         der1 = 2.*cr(1)
      ENDIF
      dquce1 = hlcf*(tmu(1)-tmi(1))*xhtc(i,j)
      dquce2 = hvcff(i)*(tmu(2)-tmi(2))*xhtc(i,j)
      IF ( ri(1).GE.eps ) dquce1 = (dqcei(1)-qcei(1)*dri/ri(1))/ri(1)
      IF ( ri(2).GE.eps ) dquce2 = (dqcei(2)+qcei(2)*dri/ri(2))/ri(2)
      dqugi1 = ccc*(dtmu(1)-dtmi(1))
      dqugi2 = ccc*(dtmu(2)-dtmi(1))
      dqcon1 = coeff*der1
      dqcon2 = coeff*der2
      ymcga = xmcga(i,j)
      ymcuo = xmcuo(i,j)
      ddtmu(1) = (dqfou-dqugi1)/ymcuo
      ddtmu(2) = (dqfou-dqugi2)/ymcuo
      ddtmi(1) = (dqugi1+dqcon1-dquce1)/ymcga
      ddtmi(2) = (dqugi2+dqcon2-dquce2)/ymcga
      ylim = .05
      ys = xl(i)/n1
      y1 = ri(1)*ys
      y2 = ri(2)*ys
      dy1 = dri*ys
      dy2 = -dri*ys
      yz = dv(i,1)*(tmi(1)-tmi(2))/scapa(i)
      dyz = (ddv(i,1)*(tmi(1)-tmi(2))+dv(i,1)*(dtmi(1)-dtmi(2)))
     &      /scapa(i)
      IF ( dv(i,1).GE.0. ) THEN
         IF ( y1.LT.ylim ) THEN
            dterc = dyz/ylim
            IF ( ri(1).GE.1.D-3 ) ddtmi(1) = ddtmi(1) - dterc
            i1 = i
            j1 = islni - 1
            IF ( j1.LT.1 ) THEN
               i1 = i - 1
               j1 = nasl(i1)
            ENDIF
            IF ( i1.LT.ibch .OR. i1.GT.ihch ) GOTO 1200
            dterc = xmcga(i,j)*(dyz*(1.-y1/ylim)-yz*dy1/ylim)
     &              /(ys*xmcga(i1,j1))
            ddtga(i1,j1) = ddtga(i1,j1) - dterc
         ELSE
            ddtmi(1) = ddtmi(1) - (dyz-yz*dy1/y1)/y1
            GOTO 1200
         ENDIF
      ENDIF
      IF ( y2.LT.ylim ) THEN
         dterc = dyz/ylim
         IF ( ri(2).GE.1.D-3 ) ddtmi(2) = ddtmi(2) - dterc
         i1 = i
         j1 = islni + 1
         IF ( j1.GT.n1 ) THEN
            i1 = i + 1
            j1 = 1
         ENDIF
         IF ( i1.GE.ibch .AND. i1.LE.ihch ) THEN
            dterc = xmcga(i,j)*(dyz*(1.-y2/ylim)-yz*dy2/ylim)
     &              /(ys*xmcga(i1,j1))
            ddtga(i1,j1) = ddtga(i1,j1) - dterc
         ENDIF
      ELSE
         ddtmi(2) = ddtmi(2) - (dyz-yz*dy2/y2)/y2
      ENDIF
 1200 RETURN
      END
**==b8b.for
      SUBROUTINE s33018(i,dalf,al,daljb,daljt)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa22 / dh(22,2) , dm(22,2) , dpdt , duu(22,2) , dv(22,2)
     &                 , dnu(22,2)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa77 / qinit , tpui(20) , qpui(20) , rpui , plmoy , 
     &                xhtc(22,12) , pl(22,12) , qrepa(22,12) , 
     &                xmcga(22,12) , xmcuo(22,12) , qced(22,12) , 
     &                qcon(22,12) , quga(22,12) , qfou(22,12) , qcei(2)
     &                 , qconi(2) , qugii(2) , tmi(2) , dtmi(2) , 
     &                qtotal , qtug , qtgf , terc(2) , tgai(22,12) , 
     &                tgaii(22,12) , t876(22,12) , tumax(22,12) , 
     &                tumin(22,12) , dtgai(22,12) , dt876(22,12) , 
     &                terco(22,12) , tmu(2) , dtmu(2) , npui , nasl(22)
     &                 , nsl(22)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      DOUBLE PRECISION m , dalf(22,2) , ax(3) , ay(3) , al(12)
      ni = nasl(i)
      alec = .01
      alin = alec
      alsu = 1. - alec
      xlm = xl(i)/2.
      dxlm = 0.
      IF ( ityp(i).GT.2 ) THEN
         xlm = hniv(i)/2.
         dxlm = dv(i,1)/scapa(i)
      ENDIF
      ax(2) = zcot(i-1) + xlm
      alm = alfa(i,1)
      dalm = dalf(i,1)
      IF ( ityp(i).EQ.2 ) THEN
         alm = v(i,2)/vc(i)
         dalm = dv(i,2)/vc(i)
      ENDIF
      der = dalm/alec
      fm = 0.
      dfm = 0.
      gm = 0.
      dgm = 0.
      hm = 1.
      dhm = 0.
      ay(2) = dalm
      IF ( alm.LT.alin ) THEN
         hm = alm/alec
         fm = 1. - hm
         dhm = der
         dfm = -der
      ELSEIF ( alm.GT.alsu ) THEN
         gm = (alm-alsu)/alec
         hm = 1. - gm
         dgm = der
         dhm = -der
      ENDIF
      j = i - 1
      ax(1) = zcot(i-1)
      idoduc = ityp(j)
      IF ( idoduc.EQ.2 ) THEN
         xlb = -xl(j)/2.
         dxlb = 0.
         alb = v(j,2)/vc(j)
         dalb = dv(j,2)/vc(j)
      ELSEIF ( idoduc.EQ.3 ) THEN
         xlb = (hniv(j)-xl(j))/2.
         dxlb = dv(j,1)/scapa(j)
         alb = alfa(j,2)
         dalb = dalf(j,2)
      ELSE
         xlb = -xl(j)/2.
         IF ( j.EQ.1 ) xlb = -xl(i)/2.
         dalb = dalf(j,1)
         alb = alfa(j,1)
         dxlb = 0.
      ENDIF
      der = dalb/alec
      fb = 0.
      dfb = 0.
      gb = 0.
      dgb = 0.
      hb = 1.
      dhb = 0.
      IF ( alb.LT.alin ) THEN
         hb = alb/alec
         fb = 1. - hb
         dhb = der
         dfb = -der
      ELSEIF ( alb.GT.alsu ) THEN
         gb = (alb-alsu)/alec
         hb = 1. - gb
         dgb = der
         dhb = -der
      ENDIF
      xlhb = xlm - xlb
      aljo = (alb*xlm-alm*xlb)/xlhb
      tdd = hb + fm*fb + gm*gb
      dtdd = dhb + fm*dfb + dfm*fb + gm*dgb + dgm*gb
      tcc = hm*tdd
      dtcc = hm*dtdd + dhm*tdd
      daljo = (dalb*xlm-dalm*xlb+dxlm*(alb-aljo)-dxlb*(alm-aljo))/xlhb
      ay(1) = dalm + (daljo-dalm)*tcc + (aljo-alm)*dtcc
      daljb = ay(1)
      p1 = (ay(2)-ay(1))/(ax(2)-ax(1))
      q1 = ay(1) - ax(1)*p1
      dax2 = 0.
      IF ( ityp(i).GT.2 ) THEN
         ax(2) = zcot(i-1) + (xl(i)+hniv(i))/2.
         alm = alfa(i,2)
         dalm = dalf(i,2)
         dax2 = dv(i,1)/scapa(i)
         der = dalm/alec
         fm = 0.
         dfm = 0.
         gm = 0.
         dgm = 0.
         hm = 1.
         dhm = 0.
         IF ( alm.LT.alin ) THEN
            hm = alm/alec
            fm = 1. - hm
            dhm = der
            dfm = -der
         ELSEIF ( alm.GT.alsu ) THEN
            gm = (alm-alsu)/alec
            hm = 1. - gm
            dgm = der
            dhm = -der
         ENDIF
      ENDIF
      j = i + 1
      ax(3) = zcot(i-1) + xl(i)
      xlm = ax(2) - ax(3)
      dxlm = dax2
      idoduc = ityp(j)
      IF ( idoduc.EQ.2 ) THEN
         xlh = xl(j)/2.
         dxlh = 0.
         alh = v(j,2)/vc(j)
         dalh = dv(j,2)/vc(j)
      ELSEIF ( idoduc.EQ.3 ) THEN
         xlh = hniv(j)/2.
         dxlh = dv(j,1)/scapa(j)
         alh = alfa(j,1)
         dalh = dalf(j,1)
      ELSE
         xlh = xl(j)/2.
         dxlh = 0.
         IF ( j.EQ.nc2 ) xlh = xl(i)/2.
         alh = alfa(j,1)
         dalh = dalf(j,1)
      ENDIF
      der = dalh/alec
      fh = 0.
      dfh = 0.
      gh = 0.
      dgh = 0.
      hh = 1.
      dhh = 0.
      IF ( alh.LT.alin ) THEN
         hh = alh/alec
         fh = 1. - hh
         dhh = der
         dfh = -der
      ELSEIF ( alh.GT.alsu ) THEN
         gh = (alh-alsu)/alec
         hh = 1. - gh
         dgh = der
         dhh = -der
      ENDIF
      xlhb = xlh - xlm
      aljo = (alm*xlh-alh*xlm)/xlhb
      daljo = (dalm*xlh-dalh*xlm+dxlh*(alm-aljo)-dxlm*(alh-aljo))/xlhb
      tdd = hh + fm*fh + gm*gh
      dtdd = dhh + fm*dfh + dfm*fh + gm*dgh + dgm*gh
      tcc = hm*tdd
      dtcc = hm*dtdd + dhm*tdd
      ay(3) = dalm + (daljo-dalm)*tcc + (aljo-alm)*dtcc
      daljt = ay(3)
      p2 = (ay(3)-ay(2))/(ax(3)-ax(2))
      q2 = ay(2) - ax(2)*p2
      IF ( icat(2).LT.3 ) THEN
         daljb = dalm
         daljt = dalm
         DO 50 j = 1 , ni
            xp = zcot(i-1) + (j-.5)*xl(i)/ni
            IF ( xp.GE.ax(2) ) THEN
               al(j) = p2*xp + q2
            ELSE
               al(j) = p1*xp + q1
            ENDIF
 50      CONTINUE
         RETURN
      ELSEIF ( ityp(i).GE.3 ) THEN
         al(1) = dalf(i,1)
         al(2) = dalf(i,2)
         RETURN
      ELSE
         DO 100 j = 1 , ni
            al(j) = dalm
 100     CONTINUE
         RETURN
      ENDIF
      END
      SUBROUTINE s33019(i,sec)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa26 / deb(21) , debv(21) , debl(21) , alfad(21) , 
     &                alfb(21) , alft(21) , ha(21) , hb(21) , he(21,2) , 
     &                hem(21) , ve(21,2) , xa(21) , xb(21) , xd(21) , 
     &                xem(21) , sdsc , tjonc(21) , hjonb(21,2) , 
     &                hjont(21,2) , debav(21) , glinf(21) , glsup(21) , 
     &                pp1 , pp2 , alniv , vgjo(21) , glinfp(21) , 
     &                v55198(21) , icas(21) , iczw(21)
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      DOUBLE PRECISION m
      vf = ve(i,1)
      vg = ve(i,2)
      g = deb(i)/sec
      tjon = tjonc(i)
      ichoix = kgliss
      IF ( ichoix.EQ.2 ) THEN
         RETURN
      ELSEIF ( ichoix.EQ.3 ) THEN
      ELSEIF ( ichoix.EQ.4 ) THEN
         alb = alfb(i)
         alt = alft(i)
         CALL f88345(g,alb,alt,vg,vf,tjon,x1,x2,x3,alfad(i),x4,pe,cst,
     &               ic,gl1,gl2,iczw(i))
      ELSE
         alf = alfb(i)
         ic = 1
         IF ( g.LE.0. ) THEN
            alf = alft(i)
            ic = 3
         ENDIF
         xaa = alf*vf/(alf*vf+(1.-alf)*vg)
         xbb = 0.
         alfad(i) = alf
         glinf(i) = 0.
         glsup(i) = 0.
         GOTO 100
      ENDIF
      glinf(i) = gl2
      glsup(i) = gl1
      vgjo(i) = x4
      xaa = pe
      xbb = cst*sec
 100  icas(i) = ic
      xa(i) = xaa
      xb(i) = xbb
      dell = (1.-xaa)*deb(i) - xbb
      devv = xaa*deb(i) + xbb
      hel = hjont(i,1)
      hev = hjonb(i,2)
      IF ( dell.GT.0. ) hel = hjonb(i,1)
      IF ( devv.LT.0. ) hev = hjont(i,2)
      he(i,1) = hel
      he(i,2) = hev
      ha(i) = xaa*hev + (1.-xaa)*hel
      hb(i) = xbb*(hev-hel)
      RETURN
      END
      SUBROUTINE s33022(i,sec,ik,dalb,dalt,x1,x2,x3,x4)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa26 / deb(21) , debv(21) , debl(21) , alfad(21) , 
     &                alfb(21) , alft(21) , ha(21) , hb(21) , he(21,2) , 
     &                hem(21) , ve(21,2) , xa(21) , xb(21) , xd(21) , 
     &                xem(21) , sdsc , tjonc(21) , hjonb(21,2) , 
     &                hjont(21,2) , debav(21) , glinf(21) , glsup(21) , 
     &                pp1 , pp2 , alniv , vgjo(21) , glinfp(21) , 
     &                v55198(21) , icas(21) , iczw(21)
      COMMON /aaa18 / ddeb(21) , dddeb(21) , dxat(21) , dxag(21) , 
     &                dxbt(21) , dxbg(21) , dnug(21) , dnuf(21) , 
     &                dhe(22,2) , ddebo(21)
      IF ( ik.GE.1 ) THEN
         al = alfad(i)
         eps = 1.D-7
         alsu = 1. - eps
         IF ( al.GE.eps .AND. al.LE.alsu ) THEN
            vf = ve(i,1)
            vg = ve(i,2)
            temp = tjonc(i)
            sig = sigma(temp)
            rg = 1./vg
            rf = 1./vf
            tcc = sig*(rf-rg)
            tcc = vf*32.174*dsqrt(tcc)
            vbcr = 1.53*dsqrt(tcc)
            r = rg/rf
            dvf = dnuf(i)
            dvg = dnug(i)
            drf = -dvf*rf*rf
            drg = -dvg*rg*rg
            rp = r*(dvf/vf-dvg/vg)
            alo = .925*(vf/vg)**.239
            a = .67
            IF ( al.GE.alo ) a = .47
            vgj = vgjo(i)
            alop = alo*rp*.239/r
            vbcrp = .25*vbcr*(dvf/vf-rp/(1.-r))
            alb = alfb(i)
            alt = alft(i)
            tao = alop/(a*alo)
            tcr = vbcrp/vbcr
            tl1 = 0.
            tl2 = 0.
            IF ( alb.GT.eps ) tl1 = dalb/(a*alb) - tao + drg/rg + tcr
            IF ( alt.GT.eps .AND. alt.LT.alsu )
     &            tl2 = ((1./a-1.)/alt-1./(1.-alt))*dalt + drf/rf - 
     &           tao + tcr
            glinfp(i) = tl2*glinf(i)
            v55198(i) = glsup(i)*tl1
            tc = .25*dvf/vf - rp*(.25/(1.-r)+.239/(a*r))
            td = -1./(1.-al) + (1.-a)/(a*al)
            vgjt = vgj*tc
            vgja = vgj*td
            vgjaa = vgj*(1.-a)*(-2./(1.-al)+1./a)/(a*al*al)
            vgjat = vgj*tc*td
            IF ( ik.EQ.3 ) THEN
               alst = (rg*alt+rf*alb)/(rg+rf)
               z1 = (1.-al)*(alt-al) + al*(al-alb)
               z2 = (rg+rf)*al*(alst-al)
               z1t = dalt*(1.-al) - al*dalb
               z1a = 4.*al - 1. - alb - alt
               z2t = al*(drg*(alt-al)+drf*(alb-al)+rg*dalt+rf*dalb)
               z2a = rg*alt + rf*alb - 2.*al*(rg+rf)
               g = debav(i)/sec
               daldt = (z2*vgjt+vgj*z2t-g*z1t)/(g*z1a-z2*vgja-vgj*z2a)
               sd = z2a*vgj + z2*vgja - g*z1a
               s = z1/sd
               rm = al*rg + (1.-al)*rf
               t = al/rm
               u = rf*(al*vgja*rm+g+rf*vgj)/(rm*rm)
               z1aa = 4.
               z2aa = -2.*(rg+rf)
               ta = rf/(rm*rm)
               sda = z2aa*vgj + 2.*z2a*vgja + z2*vgjaa - g*z1aa
               sa = (z1a-s*sda)/sd
               ua = rf*(2.*vgja+al*vgjaa+2.*u*(1.-r))/rm
               dpal = rg*(ta+u*sa+ua*s)
               dpg = rg*s*(u*(z1a/sd+sa)+s*ua+ta+rf/(rm*rm))
               rmp = al*drg + (1.-al)*drf
               ut = (drf/rf-2.*rmp/rm)
     &              *u + rf*(al*(rmp*vgja+rm*vgjat)+drf*vgj+rf*vgjt)
     &              /(rm*rm)
               tt = -t*rmp/rm
               z1at = -dalb - dalt
               z2at = drg*(alt-2.*al) + drf*(alb-2.*al) + rg*dalt + 
     &                rf*dalb
               sdt = z2at*vgj + z2a*vgjt + z2t*vgja + z2*vgjat - g*z1at
               st = (z1t-s*sdt)/sd
               dpt = dpal*daldt + drg*(t+u*s) + rg*(tt+u*st+ut*s)
               djgt = u*daldt + 
     &                al*(vgj*(rm*drf-rf*rmp)+rm*rf*vgjt-g*rmp)/(rm*rm)
               dqg = -dpg*g
               dqt = drg*al*(g+rf*vgj)/rm + rg*djgt - g*dpt
            ELSE
               zz = 1. - al*(1.-r)
               dal = dalb
               IF ( ik.EQ.2 ) dal = dalt
               IF ( ik.EQ.4 ) dal = (dalb+dalt)/2.
               dpt = (rp*al*(1.-al)+r*dal)/(zz*zz)
               dpg = 0.
               vgjp = vgjt + vgja*dal
               dqt = (vgj*(dal/zz-al*(dvg/vg+rp*al/zz))+al*vgjp)/(vg*zz)
               dqg = 0.
            ENDIF
            x1 = dpt
            x2 = dpg/sec
            x3 = sec*dqt
            x4 = dqg
            RETURN
         ENDIF
      ENDIF
      x1 = 0.
      x2 = 0.
      x3 = 0.
      x4 = 0.
      RETURN
      END
      SUBROUTINE s44553(i,j,k,alff,hcoef,hray)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      COMMON /aaa77 / qinit , tpui(20) , qpui(20) , rpui , plmoy , 
     &                xhtc(22,12) , pl(22,12) , qrepa(22,12) , 
     &                xmcga(22,12) , xmcuo(22,12) , qced(22,12) , 
     &                qcon(22,12) , quga(22,12) , qfou(22,12) , qcei(2)
     &                 , qconi(2) , qugii(2) , tmi(2) , dtmi(2) , 
     &                qtotal , qtug , qtgf , terc(2) , tgai(22,12) , 
     &                tgaii(22,12) , t876(22,12) , tumax(22,12) , 
     &                tumin(22,12) , dtgai(22,12) , dt876(22,12) , 
     &                terco(22,12) , tmu(2) , dtmu(2) , npui , nasl(22)
     &                 , nsl(22)
      COMMON /aaa26 / deb(21) , debv(21) , debl(21) , alfad(21) , 
     &                alfb(21) , alft(21) , ha(21) , hb(21) , he(21,2) , 
     &                hem(21) , ve(21,2) , xa(21) , xb(21) , xd(21) , 
     &                xem(21) , sdsc , tjonc(21) , hjonb(21,2) , 
     &                hjont(21,2) , debav(21) , glinf(21) , glsup(21) , 
     &                pp1 , pp2 , alniv , vgjo(21) , glinfp(21) , 
     &                v55198(21) , icas(21) , iczw(21)
      COMMON /aaa99 / hlcf , hvcfo , hvap , hcon , hvin , hlin , r876 , 
     &                rgai , xm876 , xmgai , xl876 , xlgai , cp876 , 
     &                cpgai , xmc876 , xmcgai , diahy , hgapp(22) , 
     &                hcg(22) , htc(22,12) , hvcff(22)
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa11 / v0011n(20) , v0012x(20) , v0011 , v0012 , tlim , 
     &                zlimin , zlimax , dtvoi , timimp(20) , difref(20)
     &                 , difmic(20) , v00001 , v22202 , temimp , 
     &                temmic , delm , delv , delvi , delvs , v22201 , 
     &                v22203 , dtpre , dtphy , dttemp , dtchan , dtdis , 
     &                dtbef , dtorg , nimic , nmultr , izone , 
     &                n00011(20) , isort , necrit , nstar , iplot , 
     &                nzone , ifre(20) , ico , iimp , npas1(20) , 
     &                npas2(20)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      DOUBLE PRECISION m
      DATA y1/0.D+00/,y2/0.d0/
      hvcf = hvcff(i)
      IF ( ityp(i).EQ.2 ) hvcf = hvcfo
      IF ( i.LT.niv ) iopt = 2
      IF ( i.GT.niv ) iopt = 0
      IF ( i.EQ.niv .AND. j.EQ.1 ) iopt = 2
      IF ( i.EQ.niv .AND. j.EQ.2 ) iopt = 0
      IF ( icat(2).LE.2 ) iopt = 3
      tmur = tgai(i,k)
      IF ( i.EQ.niv .AND. k.EQ.islni ) tmur = tmi(j)
      tflui = ts
      IF ( ityp(i).NE.2 ) tflui = t(i,j)
      hray = f00113(icat(2),p,diahy,tmur,tflui,alff)
      xx = ts - tflui
      xts = .025 + 2.34/(2.4+xx*xx)
      IF ( xx.LT.0. ) xts = 1.
      xsi = 1.
      IF ( tflui.GT.tmur ) xsi = .1 + 1.8/(tflui-tmur+2.)
      kk = iopt + 1
      IF ( kk.EQ.2 ) THEN
         PRINT 99001
c         v66077 = hlcf*dabs(tmur-tflui)/ecart
         GOTO 100
      ELSEIF ( kk.EQ.3 ) THEN
         v66077 = hlcf
         GOTO 100
      ELSEIF ( kk.EQ.4 ) THEN
         hmil = 100./3600.
         zz1 = zcot(ibch-1)
         zz2 = zcot(ihch)
         zz = zcot(i-1) + (xl(i)*(j-.5))/nasl(i)
         xx = ((zz-zz1)/(zz2-zz1)) - .5
         tbord = 700.
         tmil = 900.
         aco = (tmil-tbord)*4.
         tmoy = tmil - aco*xx*xx
         tmin = tmoy - 100.
         tmax = tmoy + 100.
         ect = tmax - tmin
         z1 = (tmax-tmur)/ect
         z2 = (tmur-tmin)/ect
         IF ( tmur.LE.tmax ) THEN
            IF ( alff.GT.1.D-4 ) THEN
               pt1 = -.1
               pt2 = 2.*(hvcf-hmil)/hvcf
               qt1 = 1.
               qt2 = 1. - pt2
               al1 = .625
               al2 = .95
               IF ( alff.LE.al1 ) THEN
                  y1 = (pt1*alff+qt1)*hlcf
               ELSEIF ( alff.GT.al2 ) THEN
                  y1 = (pt2*alff+qt2)*hvcf
               ELSE
                  xla = al2 - al1
                  x1 = pt1*al1 + qt1
                  x2 = pt2*al2 + qt2
                  h1 = x1*hlcf
                  h2 = x2*hvcf
                  u1 = -pt1/x1
                  u2 = -pt2/x2
                  p1 = (alff-al2)*(alff-al2)
     &                 *((2.-u1*xla)*(alff-al1)+xla)/(xla*xla*xla)
                  p2 = (alff-al1)*(alff-al1)
     &                 *((2.+u2*xla)*(al2-alff)+xla)/(xla*xla*xla)
                  y1 = (h1*p1+h2*p2)
               ENDIF
            ELSE
               y1 = hlcf
            ENDIF
            IF ( tmur.LE.tmin ) THEN
               z2 = 0.
               z1 = 1.
               v66077 = z1*y1 + z2*y2
               GOTO 100
            ENDIF
         ELSE
            z1 = 0.
            z2 = 1.
         ENDIF
      ELSE
         IF ( alff.LE.0. ) THEN
            v66077 = hlcf
         ELSEIF ( alff.LE..5 ) THEN
            x = 4.*dlog(60.*hlcf)
            za = 240.*hvcf + x - 4.
            zb = -120.*hvcf - x + 2.
            v66077 = hlcf*dexp((za*alff+zb)*alff)
         ELSEIF ( alff.GT.1. ) THEN
            v66077 = hvcf
         ELSE
            v66077 = (2.*hvcf-1./30.)*alff + 1./30. - hvcf
         ENDIF
         GOTO 100
      ENDIF
      IF ( alff.GT..5 ) THEN
         y2 = 2.*(hvcf-hmil)*(alff-1.) + hvcf
         y2 = 2.*(hvcf-hmil)*(alff-1.) + hvcf
      ELSE
         beta = (hmil-hvcf)/(hlcf-hvcf)
         zb = (.5-beta)/(.5*(1.-beta))
         za = zb*zb/(1.-zb)
         zc = -1./(za+zb)
         y2 = 1./(za*alff+zb) + zc
         y2 = y2*(hlcf-hvcf) + hvcf
      ENDIF
      v66077 = z1*y1 + z2*y2
 100  hcoef = v66077
      IF ( ityp(i).EQ.2 ) RETURN
      hcoef = hcoef*xsi*xts
      RETURN
99001 FORMAT (' S44553/ECART/ERREUR ')
      END
      DOUBLE PRECISION FUNCTION f00111(i)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      DOUBLE PRECISION m
      f00111 = h(i,1)
      IF ( ityp(i).GE.2 ) f00111 = (h(i,1)*m(i,1)+h(i,2)*m(i,2))
     &                             /(m(i,1)+m(i,2))
      RETURN
      END
      SUBROUTINE s00022
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa26 / deb(21) , debv(21) , debl(21) , alfad(21) , 
     &                alfb(21) , alft(21) , ha(21) , hb(21) , he(21,2) , 
     &                hem(21) , ve(21,2) , xa(21) , xb(21) , xd(21) , 
     &                xem(21) , sdsc , tjonc(21) , hjonb(21,2) , 
     &                hjont(21,2) , debav(21) , glinf(21) , glsup(21) , 
     &                pp1 , pp2 , alniv , vgjo(21) , glinfp(21) , 
     &                v55198(21) , icas(21) , iczw(21)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa77 / qinit , tpui(20) , qpui(20) , rpui , plmoy , 
     &                xhtc(22,12) , pl(22,12) , qrepa(22,12) , 
     &                xmcga(22,12) , xmcuo(22,12) , qced(22,12) , 
     &                qcon(22,12) , quga(22,12) , qfou(22,12) , qcei(2)
     &                 , qconi(2) , qugii(2) , tmi(2) , dtmi(2) , 
     &                qtotal , qtug , qtgf , terc(2) , tgai(22,12) , 
     &                tgaii(22,12) , t876(22,12) , tumax(22,12) , 
     &                tumin(22,12) , dtgai(22,12) , dt876(22,12) , 
     &                terco(22,12) , tmu(2) , dtmu(2) , npui , nasl(22)
     &                 , nsl(22)
      COMMON /aaa11 / v0011n(20) , v0012x(20) , v0011 , v0012 , tlim , 
     &                zlimin , zlimax , dtvoi , timimp(20) , difref(20)
     &                 , difmic(20) , v00001 , v22202 , temimp , 
     &                temmic , delm , delv , delvi , delvs , v22201 , 
     &                v22203 , dtpre , dtphy , dttemp , dtchan , dtdis , 
     &                dtbef , dtorg , nimic , nmultr , izone , 
     &                n00011(20) , isort , necrit , nstar , iplot , 
     &                nzone , ifre(20) , ico , iimp , npas1(20) , 
     &                npas2(20)
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      COMMON /aaa99 / hlcf , hvcfo , hvap , hcon , hvin , hlin , r876 , 
     &                rgai , xm876 , xmgai , xl876 , xlgai , cp876 , 
     &                cpgai , xmc876 , xmcgai , diahy , hgapp(22) , 
     &                hcg(22) , htc(22,12) , hvcff(22)
      DOUBLE PRECISION m
      IF ( icat(2).GT.2 ) THEN
         z1 = xl(niv)/2.
         z2 = hniv(niv)/2.
         IF ( niv.GT.2 ) z1 = xl(niv-1)/2.
         hj = f00111(niv-1)
         x = (hj-hfs)/(hgs-hfs)
         al3 = x/(x+(1.-x)*vvfs/vvgs)
         IF ( al3.LT..05 ) z1 = z1*al3/.05
         pp1 = (alfa(niv,1)-al3)/(z1+z2)
         IF ( pp1.LT.0. ) pp1 = 0.
         pp2 = pp1
      ENDIF
      CALL s00012
      DO 100 i = 1 , nc1
         debav(i) = 0.
         xa(i) = 0.
         xb(i) = 0.
 100  CONTINUE
      CALL s00013
      DO 200 i = 1 , nc1
         idoduc = ityp(i)
         IF ( idoduc.EQ.2 ) THEN
            ha(i) = f00111(i)
            xa(i) = (ha(i)-h(i,1))/(h(i,2)-h(i,1))
            he(i,1) = h(i,1)
            he(i,2) = h(i,2)
            alfad(i) = (alfa(i,1)*v(i,1)+alfa(i,2)*v(i,2))/vc(i)
         ELSEIF ( idoduc.EQ.3 ) THEN
            ha(i) = h(i,2)
            xa(i) = (ha(i)-hf(i,2))/(hg(i,2)-hf(i,2))
            alfad(i) = alfa(i,2)
            he(i,1) = hf(i,2)
            he(i,2) = hg(i,2)
         ELSE
            ha(i) = h(i,1)
            xa(i) = (ha(i)-hf(i,1))/(hg(i,1)-hf(i,1))
            alfad(i) = alfa(i,1)
            he(i,1) = hf(i,1)
            he(i,2) = hg(i,1)
         ENDIF
         hb(i) = 0.
         xb(i) = 0.
 200  CONTINUE
      CALL s00014
      RETURN
      END
      SUBROUTINE s33055(ii)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa11 / v0011n(20) , v0012x(20) , v0011 , v0012 , tlim , 
     &                zlimin , zlimax , dtvoi , timimp(20) , difref(20)
     &                 , difmic(20) , v00001 , v22202 , temimp , 
     &                temmic , delm , delv , delvi , delvs , v22201 , 
     &                v22203 , dtpre , dtphy , dttemp , dtchan , dtdis , 
     &                dtbef , dtorg , nimic , nmultr , izone , 
     &                n00011(20) , isort , necrit , nstar , iplot , 
     &                nzone , ifre(20) , ico , iimp , npas1(20) , 
     &                npas2(20)
      COMMON /aaa77 / qinit , tpui(20) , qpui(20) , rpui , plmoy , 
     &                xhtc(22,12) , pl(22,12) , qrepa(22,12) , 
     &                xmcga(22,12) , xmcuo(22,12) , qced(22,12) , 
     &                qcon(22,12) , quga(22,12) , qfou(22,12) , qcei(2)
     &                 , qconi(2) , qugii(2) , tmi(2) , dtmi(2) , 
     &                qtotal , qtug , qtgf , terc(2) , tgai(22,12) , 
     &                tgaii(22,12) , t876(22,12) , tumax(22,12) , 
     &                tumin(22,12) , dtgai(22,12) , dt876(22,12) , 
     &                terco(22,12) , tmu(2) , dtmu(2) , npui , nasl(22)
     &                 , nsl(22)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      DOUBLE PRECISION sto(12,12) , ag(12) , bg(12) , au(12) , bu(12) , 
     &                 x(12)
      DOUBLE PRECISION xn(12)
      IF ( nmultr.LE.1 ) RETURN
      n1 = nsl(ii)
      DO 100 i = 1 , n1
         sto(i,1) = tgai(ii,i)
         sto(i,2) = tgaii(ii,i)
         sto(i,3) = t876(ii,i)
         sto(i,4) = tumax(ii,i)
         sto(i,5) = tumin(ii,i)
         sto(i,6) = xmcga(ii,i)
         sto(i,7) = xmcuo(ii,i)
         sto(i,8) = pl(ii,i)
         sto(i,9) = qrepa(ii,i)
         sto(i,10) = xhtc(ii,i)
 100  CONTINUE
      nasl(ii) = nsl(ii)*nmultr
      IF ( ii.GT.2 .AND. ii.LT.nc1 ) THEN
         x1 = -xl(ii-1)/nasl(ii-1)/2.
         x2 = xl(ii)/2.
         x3 = xl(ii) + xl(ii+1)/nasl(ii+1)/2.
         yg1 = tgai(ii-1,nasl(ii-1))
         yg3 = tgai(ii+1,1)
         yu1 = t876(ii-1,nasl(ii-1))
         yu3 = t876(ii+1,1)
         n1 = nasl(ii)
         tg2 = 0.
         tu2 = 0.
         n2 = nsl(ii)
         DO 150 j = 1 , n2
            tg2 = tg2 + tgai(ii,j)
            tu2 = tu2 + t876(ii,j)
 150     CONTINUE
         yg2 = tg2/n2
         yu2 = tu2/n2
         yx21 = (yg2-yg1)/(x2-x1)
         yx32 = (yg3-yg2)/(x3-x2)
         ga = (yx21-yx32)/(x1-x3)
         gb = (yg2-yg1-ga*(x2*x2-x1*x1))/(x2-x1)
         gc = yg1 - ga*x1*x1 - gb*x1
         yx21 = (yu2-yu1)/(x2-x1)
         yx32 = (yu3-yu2)/(x3-x2)
         ua = (yx21-yx32)/(x1-x3)
         ub = (yu2-yu1-ua*(x2*x2-x1*x1))/(x2-x1)
         uc = yu1 - ua*x1*x1 - ub*x1
         n2 = nsl(ii)
         i2 = 0
         DO 200 i = 1 , n2
            i1 = i2 + 1
            i2 = i*nmultr
            DO 160 j = i1 , i2
               y = xl(ii)/n1*(j-0.5)
               tgai(ii,j) = ga*y*y + gb*y + gc
               t876(ii,j) = ua*y*y + ub*y + uc
               tgaii(ii,j) = sto(i,2)
               tumax(ii,j) = sto(i,4)
               tumin(ii,j) = sto(i,5)
               xmcga(ii,j) = sto(i,6)/nmultr
               xmcuo(ii,j) = sto(i,7)/nmultr
               pl(ii,j) = sto(i,8)
               qrepa(ii,j) = sto(i,9)/nmultr
               xhtc(ii,j) = sto(i,10)/nmultr
 160        CONTINUE
 200     CONTINUE
         RETURN
      ELSE
         IF ( n1.EQ.1 ) THEN
            n2 = n1*nmultr
            DO 220 i = 2 , n2
               tgai(ii,i) = tgai(ii,1)
               t876(ii,i) = t876(ii,1)
 220        CONTINUE
         ELSE
            x(1) = xl(ii)/n1/2.
            DO 240 i = 2 , n1
               x(i) = x(i-1) + xl(ii)/n1
               bg(i) = (tgai(ii,i)-tgai(ii,i-1))/(x(i)-x(i-1))
               ag(i) = tgai(ii,i) - x(i)*bg(i)
               bu(i) = (t876(ii,i)-t876(ii,i-1))/(x(i)-x(i-1))
               au(i) = t876(ii,i) - x(i)*bu(i)
 240        CONTINUE
            x(1) = 0.
            x(n1) = xl(ii)
            xn(1) = xl(ii)/n1/2./nmultr
            n2 = n1*nmultr
            DO 260 i = 2 , n2
               xn(i) = xn(i-1) + xl(ii)/n1/nmultr
 260        CONTINUE
            i2 = 0
            DO 280 i = 1 , n1
               i1 = i2 + 1
               i2 = i*nmultr
               DO 270 k = i1 , i2
                  ij = i
                  IF ( xn(k).GE.x(i) ) ij = i + 1
                  tgai(ii,k) = ag(ij) + bg(ij)*xn(k)
                  t876(ii,k) = au(ij) + bu(ij)*xn(k)
 270           CONTINUE
 280        CONTINUE
         ENDIF
         i2 = 0
         DO 350 i = 1 , n1
            i1 = i2 + 1
            i2 = i*nmultr
            DO 300 k = i1 , i2
               tgaii(ii,k) = sto(i,2)
               tumax(ii,k) = sto(i,4)
               tumin(ii,k) = sto(i,5)
               xmcga(ii,k) = sto(i,6)/nmultr
               xmcuo(ii,k) = sto(i,7)/nmultr
               pl(ii,k) = sto(i,8)
               qrepa(ii,k) = sto(i,9)/nmultr
               xhtc(ii,k) = sto(i,10)/nmultr
 300        CONTINUE
 350     CONTINUE
         RETURN
      ENDIF
      END
      SUBROUTINE s00011
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa33 / vco , xl0055 , d876 , dint , dext , vol002 , 
     &                vol005 , lco , ncray
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      COMMON /aaa77 / qinit , tpui(20) , qpui(20) , rpui , plmoy , 
     &                xhtc(22,12) , pl(22,12) , qrepa(22,12) , 
     &                xmcga(22,12) , xmcuo(22,12) , qced(22,12) , 
     &                qcon(22,12) , quga(22,12) , qfou(22,12) , qcei(2)
     &                 , qconi(2) , qugii(2) , tmi(2) , dtmi(2) , 
     &                qtotal , qtug , qtgf , terc(2) , tgai(22,12) , 
     &                tgaii(22,12) , t876(22,12) , tumax(22,12) , 
     &                tumin(22,12) , dtgai(22,12) , dt876(22,12) , 
     &                terco(22,12) , tmu(2) , dtmu(2) , npui , nasl(22)
     &                 , nsl(22)
      COMMON /aaa99 / hlcf , hvcfo , hvap , hcon , hvin , hlin , r876 , 
     &                rgai , xm876 , xmgai , xl876 , xlgai , cp876 , 
     &                cpgai , xmc876 , xmcgai , diahy , hgapp(22) , 
     &                hcg(22) , htc(22,12) , hvcff(22)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      DOUBLE PRECISION m , x(3) , y(3) , xy(3)
      DOUBLE PRECISION bidon(2000)
      pi = 3.14159
      i6ft = nc1/2
      i8ft = 2*nc1/3
      j6ft = 1
      j8ft = 1
      z6 = xl0055/2.
      z8 = 2.*xl0055/3.
      DO 100 i = 2 , nc1
         ni = nasl(i)
         zminc = zcot(i-1)
         zint = xl(i)/ni
         DO 50 j = 1 , ni
            zmin = zminc + (j-1.)*zint
            zmax = zmin + zint
            IF ( z6.LE.zmax ) THEN
               IF ( z6.GE.zmin ) THEN
                  i6ft = i
                  j6ft = j
               ENDIF
               IF ( z8.LE.zmax ) THEN
                  i8ft = i
                  j8ft = j
                  GOTO 200
               ENDIF
            ENDIF
 50      CONTINUE
 100  CONTINUE
 200  sec = pi*(dext*dext-dint*dint)*ncray/4.
      vol002 = sec*xl0055
      vol005 = pi*d876*d876/4.*xl0055*ncray
      xmgai = rgai*vol002
      xm876 = r876*vol005
      xmcgai = cpgai*xmgai
      xmc876 = cp876*xm876
      perim = ncray*pi*dext
      diahy = 4.*scapa(2)/perim
      DO 300 i = 2 , nc1
         n1 = nsl(i)
         xmg = xmcgai*xl(i)/xl0055/n1
         xmu = xmc876*xl(i)/xl0055/n1
         shtc(i) = xl(i)*dext*pi
         shtc(i) = shtc(i)*ncray
         xht = shtc(i)/n1
         DO 250 j = 1 , n1
            xmcga(i,j) = xmg
            xmcuo(i,j) = xmu
            xhtc(i,j) = xht
 250     CONTINUE
 300  CONTINUE
      DO 400 i = 2 , nc1
         n1 = nsl(i)
         DO 350 j = 1 , n1
            qrepa(i,j) = pl(i,j)*xl(i)/n1/xl0055
 350     CONTINUE
 400  CONTINUE
      plmoy = qinit/ncray/xl0055
      CALL s00934(tpui,qpui,qpui,tem,rpui,xx,6)
      plmoy = plmoy*rpui
      DO 500 i = 2 , nc1
         hgap = hgapp(i)
         hcg(i) = 2.*pi/(dlog(dext/dint)/xlgai+2./(d876*hgap)
     &            +1./(4.*xl876))
 500  CONTINUE
      IF ( ktgai.NE.0 ) THEN
         DO 550 i = 2 , nc1
            n1 = nsl(i)
            DO 520 j = 1 , n1
               tgai(i,j) = t(i,1)
               IF ( ityp(i).EQ.2 ) tgai(i,j) = t(i,2)
 520        CONTINUE
 550     CONTINUE
      ENDIF
      tpe = tgai(ibch,1)
      x(3) = xl(2)/(2.*nsl(2))
      x(2) = -x(3)
      x(1) = -3.*x(3)
      y(3) = tgai(2,1)
      y(2) = t(1,1)
      y(1) = 2.*y(2) - ts + 20.
      nsl(1) = 1
      nasl(1) = 1
      CALL s00099(3,x,y,xy)
      qcon(1,1) = 2.*xy(1)*xlgai*sec*xl(2)/nsl(2)
      CALL s66832
      islni = 0
      CALL s33055(ibtr)
      CALL s33055(ihtr)
      IF ( icat(2).GT.2 ) THEN
         i = niv
         n1 = nasl(i)
         islni = hniv(i)/xl(i)*n1 + 1
         DO 600 j = 1 , islni
            tgai(i,j) = t(i,1)
 600     CONTINUE
         IF ( islni.NE.n1 ) THEN
            isl2 = islni + 1
            DO 620 j = isl2 , n1
               tgai(i,j) = t(i,2)
 620        CONTINUE
         ENDIF
         tmi(1) = t(i,1)
         tmi(2) = t(i,2)
      ENDIF
      IF ( kt876.NE.0 ) THEN
         DO 650 i = 2 , nc1
            hcgg = hcg(i)
            n1 = nasl(i)
            DO 640 j = 1 , n1
               t876(i,j) = tgai(i,j) + pl(i,j)*plmoy/hcgg
 640        CONTINUE
 650     CONTINUE
         i = niv
         j = islni
         hcgg = hcg(i)
         tmu(1) = tmi(1) + pl(i,j)*plmoy/hcgg
         tmu(2) = tmi(2) + pl(i,j)*plmoy/hcgg
      ENDIF
      DO 800 i = 2 , nc1
         n1 = nasl(i)
         DO 700 j = 1 , n1
            pi = 3.14159
            tumax(i,j) = t876(i,j) + pl(i,j)*plmoy/(8.*pi*xl876)
            tumin(i,j) = t876(i,j) - pl(i,j)*plmoy/(8.*pi*xl876)
            tgaii(i,j) = tgai(i,j) + pl(i,j)*dlog(dext/dint)
     &                   *plmoy/(2.*pi*xlgai)
 700     CONTINUE
 800  CONTINUE
      stot = 0.
      DO 900 i = ibch , ihch
         stot = stot + shtc(i)
 900  CONTINUE
      ecart = qinit/(stot*hlcf)
      DO 1000 i = 2 , nc1
         xg = hgapp(i)*3600.
 1000 CONTINUE
      DO 1100 ii = 2 , nc1
         i = nc1 + 2 - ii
         n1 = nsl(i)
         DO 1050 jj = 1 , n1
            j = n1 + 1 - jj
 1050    CONTINUE
 1100 CONTINUE
      RETURN
      END
      SUBROUTINE s00934(x,y,z,xa,ya,za,npoint)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      DOUBLE PRECISION x(20) , y(20) , z(20)
      IF ( xa.GT.x(1) ) THEN
         IF ( xa.GE.x(npoint) ) THEN
            ya = y(npoint)
            za = z(npoint)
         ENDIF
         DO 50 i = 2 , npoint
            IF ( xa.LE.x(i) ) THEN
               rap = (xa-x(i-1))/(x(i)-x(i-1))
               ya = y(i-1) + (y(i)-y(i-1))*rap
               za = z(i-1) + (z(i)-z(i-1))*rap
               GOTO 100
            ENDIF
 50      CONTINUE
 100     RETURN
      ELSE
         ya = y(1)
         za = z(1)
         RETURN
      ENDIF
      END
      SUBROUTINE s00099(np,x,t,c)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      DOUBLE PRECISION x(np) , t(np) , y(5) , z(5) , c(np)
      DO 100 i = 1 , np
         c(i) = 0.
 100  CONTINUE
      IF ( np.LE.3 ) THEN
         DO 150 i = 2 , 3
            y(i) = (t(i)-t(1))/(x(i)-x(1))
 150     CONTINUE
         c(1) = (y(3)-y(2))/(x(3)-x(2))
         c(2) = y(2) - (x(1)+x(2))*c(1)
         c(3) = t(1) - x(1)*c(2) - x(1)*x(1)*c(1)
         RETURN
      ELSEIF ( np.GT.4 ) THEN
         IF ( np.GT.5 ) RETURN
         RETURN
      ELSE
         DO 200 i = 2 , 4
            y(i) = (t(i)-t(1))/(x(i)-x(1))
 200     CONTINUE
         DO 250 i = 3 , 4
            z(i) = (y(i)-y(2))/(x(i)-x(2))
 250     CONTINUE
         c(1) = (z(4)-z(3))/(x(4)-x(3))
         c(2) = z(3) - (x(1)+x(2)+x(3))*c(1)
         c(3) = y(2) - c(1)*(x(2)*x(2)+x(1)*x(2)+x(1)*x(1)) - c(2)
     &          *(x(1)+x(2))
         c(4) = t(1) - c(1)*x(1)*x(1)*x(1) - c(2)*x(1)*x(1) - c(3)*x(1)
         RETURN
      ENDIF
      END
      SUBROUTINE s00004(ica,nivo,iorg)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa77 / qinit , tpui(20) , qpui(20) , rpui , plmoy , 
     &                xhtc(22,12) , pl(22,12) , qrepa(22,12) , 
     &                xmcga(22,12) , xmcuo(22,12) , qced(22,12) , 
     &                qcon(22,12) , quga(22,12) , qfou(22,12) , qcei(2)
     &                 , qconi(2) , qugii(2) , tmi(2) , dtmi(2) , 
     &                qtotal , qtug , qtgf , terc(2) , tgai(22,12) , 
     &                tgaii(22,12) , t876(22,12) , tumax(22,12) , 
     &                tumin(22,12) , dtgai(22,12) , dt876(22,12) , 
     &                terco(22,12) , tmu(2) , dtmu(2) , npui , nasl(22)
     &                 , nsl(22)
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      COMMON /aaa33 / vco , xl0055 , d876 , dint , dext , vol002 , 
     &                vol005 , lco , ncray
      COMMON /aaa99 / hlcf , hvcfo , hvap , hcon , hvin , hlin , r876 , 
     &                rgai , xm876 , xmgai , xl876 , xlgai , cp876 , 
     &                cpgai , xmc876 , xmcgai , diahy , hgapp(22) , 
     &                hcg(22) , htc(22,12) , hvcff(22)
      DOUBLE PRECISION m , hnivo(22)
      islnio = islni
      ibtro = ibtr
      ihtro = ihtr
      DO 100 i = 2 , nc1
         hnivo(i) = hniv(i)
 100  CONTINUE
      IF ( icat(2).GT.2 ) hniv(niv) = v(niv,1)/scapa(niv)
      CALL s66832
      IF ( ibtr.LT.ibtro ) THEN
         CALL s33055(ibtr)
         CALL s00055(ihtro)
      ENDIF
      IF ( ihtr.GT.ihtro ) THEN
         CALL s33055(ihtr)
         CALL s00055(ibtro)
      ENDIF
      IF ( icat(2).LE.2 ) RETURN
      zniv = 0.
      i = 1
 200  i = i + 1
      IF ( ityp(i).GE.3 ) THEN
         hniv(i) = v(i,1)/scapa(i)
         zniv = zniv + hniv(i)
         islni = hniv(i)/xl(i)*nasl(i) + 1
         IF ( i.LT.nc1 ) THEN
            indice = i + 1
            DO 220 i = indice , nc1
               hniv(i) = 0.
 220        CONTINUE
         ENDIF
         ll = 12
         indio = ll*nivo + islnio
         indi = ll*niv + islni
         IF ( indi.EQ.indio ) RETURN
         i1 = nivo
         j1 = islnio
         i2 = niv
         j2 = islni
         h1 = xl(i1)/nasl(i1)
         z3 = xl(i2)/nasl(i2)
         dt3 = dtgai(i2,j2)
         t3 = tgai(i2,j2)
         dtu3 = dt876(i2,j2)
         tu3 = t876(i2,j2)
         IF ( iss.EQ.2 ) THEN
            z2 = hnivo(i1) - (j1-1.)*xl(i1)/nasl(i1)
            ind1 = 2
            ind2 = 1
            vite = vitess/scapa(i1)
            h2 = -hniv(i2) + j2*xl(i2)/nasl(i2)
            h3 = hniv(i2) - (j2-1.)*xl(i2)/nasl(i2)
            i4 = i2
            j4 = j2 - 1
            IF ( j4.LT.1 ) THEN
               i4 = i2 - 1
               j4 = nasl(i4)
            ENDIF
         ELSE
            z2 = -hnivo(i1) + j1*xl(i1)/nasl(i1)
            ind1 = 1
            ind2 = 2
            vite = -vitess/scapa(i1)
            h2 = hniv(i2) - (j2-1.)*xl(i2)/nasl(i2)
            h3 = -hniv(i2) + j2*xl(i2)/nasl(i2)
            i4 = i2
            j4 = j2 + 1
            IF ( j4.GT.nasl(i2) ) THEN
               i4 = i2 + 1
               j4 = 1
            ENDIF
         ENDIF
         IF ( i4.GE.ibch .AND. i4.LE.ihch ) THEN
            h4 = xl(i4)/nasl(i4)
            t4 = tgai(i4,j4)
            tu4 = t876(i4,j4)
         ENDIF
         t1 = tmi(ind1)
         tu1 = tmu(ind1)
         IF ( iorg.NE.1 ) THEN
            dt2 = dtmi(ind2)
            t2 = tmi(ind2) - dt2*dt
            t3 = t3 - dt3*dt
            dtu2 = dtmu(ind2)
            tu2 = tmu(ind2) - dtu2*dt
            tu3 = tu3 - dtu3*dt
            u2 = (z2*tu2+z3*tu3)/(z2+z3)
            dtu2 = (vite*(tu2-u2)+z2*dtu2+z3*dtu3)/(z2+z3)
            tu3 = u2 + dtu2*dt
            u2 = (z2*t2+z3*t3)/(z2+z3)
            dtu2 = (vite*(t2-u2)+z2*dt2+z3*dt3)/(z2+z3)
            t3 = u2 + dtu2*dt
         ENDIF
         IF ( i4.GE.ibch .AND. i4.LE.ihch ) THEN
            t2 = (t1*h3+(h1+h2)/(h3+h4)*((h2+h3+h4)*t3-h2*t4))
     &           /(h1+h2+h3)
            t2min = dmin1(t1,t3)
            t2max = dmax1(t1,t3)
            IF ( t2.LT.t2min ) t2 = t2min
            IF ( t2.GT.t2max ) t2 = t2max
            tu2 = (tu1*h3+(h1+h2)/(h3+h4)*((h2+h3+h4)*tu3-h2*tu4))
     &            /(h1+h2+h3)
            t2min = dmin1(tu1,tu3)
            t2max = dmax1(tu1,tu3)
            tu2 = dmin1(tu2,t2max)
            tu2 = dmax1(tu2,t2min)
         ELSE
            t2 = (t1+t3)/2.
            tu2 = (tu1+tu3)/2.
         ENDIF
         tgai(i1,j1) = t1
         tmi(ind1) = t2
         tmi(ind2) = t3
         t876(i1,j1) = tu1
         tmu(ind1) = tu2
         tmu(ind2) = tu3
         RETURN
      ELSE
         zniv = zniv + xl(i)
         hniv(i) = 0.
         GOTO 200
      ENDIF
      END
      SUBROUTINE s66832
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa77 / qinit , tpui(20) , qpui(20) , rpui , plmoy , 
     &                xhtc(22,12) , pl(22,12) , qrepa(22,12) , 
     &                xmcga(22,12) , xmcuo(22,12) , qced(22,12) , 
     &                qcon(22,12) , quga(22,12) , qfou(22,12) , qcei(2)
     &                 , qconi(2) , qugii(2) , tmi(2) , dtmi(2) , 
     &                qtotal , qtug , qtgf , terc(2) , tgai(22,12) , 
     &                tgaii(22,12) , t876(22,12) , tumax(22,12) , 
     &                tumin(22,12) , dtgai(22,12) , dt876(22,12) , 
     &                terco(22,12) , tmu(2) , dtmu(2) , npui , nasl(22)
     &                 , nsl(22)
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      DOUBLE PRECISION m
      nivo = niv
      znivo = zniv
      ibtro = ibtr
      ihtro = ihtr
      IF ( icat(2).LE.2 ) THEN
         tgai(1,1) = tgai(2,1)
         qt = qcon(1,1)
         im = 1
         jm = 1
         DO 50 i = 2 , nc1
            n2 = nasl(i)
            DO 20 j = 1 , n2
               IF ( qcon(i,j).GT.qt ) THEN
                  nn = i
                  jj = j - 1
                  IF ( jj.LT.1 ) THEN
                     nn = i - 1
                     jj = nasl(nn)
                  ENDIF
                  IF ( (tgai(i,j)-tgai(nn,jj)).LT.50. ) THEN
                     im = i
                     jm = j
                     qt = qcon(i,j)
                  ENDIF
               ENDIF
 20         CONTINUE
 50      CONTINUE
         n1 = nasl(im)
         niv = im
         IF ( jm.LE.(n1/2) ) THEN
            ibtr = im - 1
            ihtr = im
         ELSE
            ibtr = im
            ihtr = im + 1
         ENDIF
         IF ( ibtr.LT.2 ) THEN
            ibtr = 2
            ihtr = min0(3,nc1)
         ELSEIF ( ihtr.GT.nc1 ) THEN
            ibtr = max0(nc,2)
            ihtr = nc1
         ENDIF
         zniv = 0.
         IF ( niv.GE.2 ) THEN
            IF ( niv.NE.2 ) THEN
               n1 = niv - 1
               DO 60 i = 2 , n1
                  zniv = zniv + xl(i)
 60            CONTINUE
            ENDIF
            zniv = zniv + (jm-.5)*xl(niv)/nasl(niv)
         ENDIF
         IF ( ihtr.GT.(ihtro+1) ) THEN
            zniv = znivo
            ihtr = ihtro + 1
            ibtr = ihtr - 1
            niv = 0
            RETURN
         ELSEIF ( ibtr.LT.(ibtro-1) ) THEN
            zniv = znivo
            ibtr = ibtro - 1
            ihtr = ibtr + 1
            niv = 0
            RETURN
         ELSE
            RETURN
         ENDIF
      ELSEIF ( niv.EQ.2 ) THEN
         ibtr = 2
         ihtr = 3
         RETURN
      ELSEIF ( hniv(niv).GT.xl(niv)/2. ) THEN
         IF ( niv.NE.nc1 ) THEN
            ibtr = niv
            ihtr = niv + 1
            RETURN
         ENDIF
      ENDIF
      ibtr = niv - 1
      ihtr = niv
      RETURN
      END
      SUBROUTINE s00020
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      COMMON /aaa77 / qinit , tpui(20) , qpui(20) , rpui , plmoy , 
     &                xhtc(22,12) , pl(22,12) , qrepa(22,12) , 
     &                xmcga(22,12) , xmcuo(22,12) , qced(22,12) , 
     &                qcon(22,12) , quga(22,12) , qfou(22,12) , qcei(2)
     &                 , qconi(2) , qugii(2) , tmi(2) , dtmi(2) , 
     &                qtotal , qtug , qtgf , terc(2) , tgai(22,12) , 
     &                tgaii(22,12) , t876(22,12) , tumax(22,12) , 
     &                tumin(22,12) , dtgai(22,12) , dt876(22,12) , 
     &                terco(22,12) , tmu(2) , dtmu(2) , npui , nasl(22)
     &                 , nsl(22)
      COMMON /aaa88 / flup(22,2) , fluv(22,2) , flul(22,2) , fluiv(22,2)
     &                 , debil(22,2) , fluil(22,2) , debi(22) , 
     &                debhi(22) , debiv(22,2)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa33 / vco , xl0055 , d876 , dint , dext , vol002 , 
     &                vol005 , lco , ncray
      COMMON /aaa99 / hlcf , hvcfo , hvap , hcon , hvin , hlin , r876 , 
     &                rgai , xm876 , xmgai , xl876 , xlgai , cp876 , 
     &                cpgai , xmc876 , xmcgai , diahy , hgapp(22) , 
     &                hcg(22) , htc(22,12) , hvcff(22)
      COMMON /aaa22 / dh(22,2) , dm(22,2) , dpdt , duu(22,2) , dv(22,2)
     &                 , dnu(22,2)
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      DOUBLE PRECISION m , x(5) , y(5) , xy(5) , der(2)
      DOUBLE PRECISION xg(132) , tg(132) , xf(132) , dtg(132)
      DOUBLE PRECISION xg1(132) , xg2(132) , tg1(132) , tg2(132)
      pi = 3.14159
      eps = 1.D-3
      terc(1) = 0.
      terc(2) = 0.
      dtmi(1) = 0.
      dtmi(2) = 0.
      sec = pi/4.*(dext*dext-dint*dint)
      sec = sec*ncray
      CALL s00934(tpui,qpui,qpui,tem,rpui,x(1),6)
      qtotal = qinit*rpui
      plmoy = qtotal/xl0055/ncray
      IF ( icat(2).GT.2 ) THEN
         tgai(niv,islni) = tmi(1)*ri(1) + tmi(2)*ri(2)
         t876(niv,islni) = tmu(1)*ri(1) + tmu(2)*ri(2)
      ENDIF
      IF ( kcon.NE.0 ) THEN
         xf(1) = 0.
         k = 1
         DO 50 i = 2 , nc1
            n1 = nasl(i)
            DO 20 j = 1 , n1
               terco(i,j) = 0.
               k = k + 1
               xf(k) = xf(k-1) + xl(i)/n1
               xg(k-1) = xf(k-1) + (xf(k)-xf(k-1))/2.
               tg(k-1) = tgai(i,j)
               xg1(k-1) = xg(k-1)
               xg2(k-1) = xg(k-1)
               tg1(k-1) = tg(k-1)
               tg2(k-1) = tg(k-1)
               IF ( i.EQ.niv .AND. j.EQ.islni ) THEN
                  xg1(k-1) = xf(k-1) + (xf(k)-xf(k-1))/2.*ri(1)
                  xg2(k-1) = xf(k) - (xf(k)-xf(k-1))/2.*ri(2)
                  tg1(k-1) = tmi(1)
                  tg2(k-1) = tmi(2)
                  kniv = k - 1
               ENDIF
 20         CONTINUE
 50      CONTINUE
         kmax = k
         kmax1 = kmax - 1
         DO 100 k = 2 , kmax1
            dtg(k) = (tg1(k)-tg2(k-1))/(xg1(k)-xg2(k-1))
 100     CONTINUE
         dtg(1) = 0.
         dtg(kmax) = 0.
         k = 0
         DO 150 i = 2 , nc1
            n1 = nasl(i)
            DO 120 j = 1 , n1
               k = k + 1
               IF ( k.EQ.1 ) THEN
                  x(1) = xg(1)
                  x(2) = xg1(2)
                  y(1) = tg(1)
                  y(2) = tg1(2)
                  xo = 0.
                  xy(1) = (y(2)-y(1))/(x(2)-x(1))*(x(1)+x(2)-2*xo)
                  qcon(i,j) = 2.*xy(1)*xlgai*sec*xl(i)/n1
               ELSEIF ( k.NE.kmax1 ) THEN
                  x(1) = xg2(k-1)
                  x(2) = xg(k)
                  x(3) = xg1(k+1)
                  y(1) = tg2(k-1)
                  y(2) = tg(k)
                  y(3) = tg1(k+1)
                  CALL s00099(3,x,y,xy)
                  qcon(i,j) = 2.*xy(1)*xlgai*sec*xl(i)/n1
               ELSE
                  x(1) = xg(kmax1)
                  x(2) = xg2(kmax1-1)
                  y(1) = tg(kmax1)
                  y(2) = tg2(kmax1-1)
                  xo = xf(kmax)
                  xy(1) = (y(2)-y(1))/(x(2)-x(1))*(x(1)+x(2)-2*xo)
                  qcon(i,j) = 2.*xy(1)*xlgai*sec*xl(i)/n1
               ENDIF
 120        CONTINUE
 150     CONTINUE
         x(3) = xl(2)/(2.*nasl(2))
         x(2) = -x(3)
         x(1) = -3.*x(3)
         y(3) = tgai(2,1)
         y(2) = t(1,1)
         y(1) = 2.*y(2) - ts + 20.
         CALL s00099(3,x,y,xy)
         qcon(1,1) = 2.*xy(1)*xlgai*sec*xl(2)/nasl(2)
      ENDIF
      DO 300 i = 2 , nc1
         n1 = nasl(i)
         hcgg = hcg(i)
         DO 200 j = 1 , n1
            qfou(i,j) = qrepa(i,j)*qtotal
            quga(i,j) = (t876(i,j)-tgai(i,j))*hcgg*xl(i)*ncray/n1
            dt876(i,j) = (qfou(i,j)-quga(i,j))/xmcuo(i,j)
            dtgai(i,j) = (quga(i,j)-qced(i,j)+qcon(i,j))/xmcga(i,j)
 200     CONTINUE
 300  CONTINUE
      IF ( icat(2).LE.2 ) GOTO 600
      IF ( niv.LE.ihch .AND. niv.GE.ibch ) THEN
         i = niv
         j = islni
         n1 = nasl(i)
         ccc = xl(i)*ncray*hcg(i)/n1
         qugii(1) = (tmu(1)-tmi(1))*ccc*ri(1)
         qugii(2) = (tmu(2)-tmi(2))*ccc*ri(2)
         IF ( kniv.EQ.1 ) THEN
            x(1) = xg1(1)
            x(2) = xg2(1)
            x(3) = xg(2)
            y(1) = tg1(1)
            y(2) = tg2(1)
            y(3) = tg(2)
            xo = 0.
            ind1 = 1
            ind2 = 2
         ELSEIF ( kniv.NE.kmax1 ) THEN
            x(1) = xg(kniv-1)
            x(2) = xg1(kniv)
            x(3) = xg2(kniv)
            x(4) = xg(kniv+1)
            y(1) = tg(kniv-1)
            y(2) = tg1(kniv)
            y(3) = tg2(kniv)
            y(4) = tg(kniv+1)
            CALL s00099(4,x,y,xy)
            der(1) = 6.*xy(1)*x(2) + 2.*xy(2)
            der(2) = 6.*xy(1)*x(3) + 2.*xy(2)
            GOTO 400
         ELSE
            x(1) = xg2(kmax1)
            x(2) = xg1(kmax1)
            x(3) = xg(kmax1-1)
            y(1) = tg2(kmax1)
            y(2) = tg1(kmax1)
            y(3) = tg(kmax1-1)
            xo = xf(kmax)
            ind1 = 2
            ind2 = 1
         ENDIF
      ELSE
         DO 350 ij = 1 , 3
            qugii(ij) = 0.
            qconi(ij) = 0.
 350     CONTINUE
         GOTO 600
      ENDIF
      der(ind1) = 2.*(y(2)-y(1))/((x(2)-x(1))*(x(2)+x(1)-2.*xo))
      CALL s00099(3,x,y,xy)
      der(ind2) = 2.*xy(1)
 400  coef = xlgai*sec*xl(i)/n1
      qconi(1) = coef*ri(1)*der(1)
      qconi(2) = coef*ri(2)*der(2)
      DO 500 ij = 1 , 2
         IF ( ri(ij).GE.eps ) THEN
            dtmi(ij) = (qugii(ij)-qcei(ij)+qconi(ij))
     &                 /(xmcga(i,j)*ri(ij))
            dtmu(ij) = (qfou(i,j)-qugii(ij)/ri(ij))/xmcuo(i,j)
         ENDIF
 500  CONTINUE
      zlim = .05
      zs = xl(i)/n1
      z1 = ri(1)*zs
      z2 = ri(2)*zs
      zz = vitess*(tmi(1)-tmi(2))/scapa(i)
      zzu = vitess*(tmu(1)-tmu(2))/scapa(i)
      IF ( iss.EQ.2 ) THEN
         IF ( z2.LT.zlim ) THEN
            terc(1) = zz/zlim
            tercu = zzu/zlim
            IF ( ri(2).GE.eps ) THEN
               dtmi(2) = dtmi(2) - terc(1)
               dtmu(2) = dtmu(2) - tercu
            ENDIF
            IF ( islni.EQ.n1 ) THEN
               i1 = i + 1
               j1 = 1
            ELSE
               i1 = i
               j1 = islni + 1
            ENDIF
            IF ( i1.GE.ibch .AND. i1.LE.ihch ) THEN
               terco(i1,j1) = zz*xmcga(i,j)*(1.-z2/zlim)
     &                        /(zs*xmcga(i1,j1))
               dtgai(i1,j1) = dtgai(i1,j1) - terco(i1,j1)
               tercu = zzu*xmcuo(i,j)*(1.-z2/zlim)/(zs*xmcuo(i1,j1))
               dt876(i1,j1) = dt876(i1,j1) - tercu
            ENDIF
         ELSE
            terc(1) = zz/z2
            dtmi(2) = dtmi(2) - terc(1)
            tercu = zzu/z2
            dtmu(2) = dtmu(2) - tercu
         ENDIF
      ELSEIF ( z1.LT.zlim ) THEN
         terc(1) = zz/zlim
         tercu = zzu/zlim
         IF ( ri(1).GE.eps ) THEN
            dtmi(1) = dtmi(1) - terc(1)
            dtmu(1) = dtmu(1) - tercu
         ENDIF
         IF ( islni.EQ.1 ) THEN
            i1 = i - 1
            j1 = nasl(i-1)
         ELSE
            i1 = i
            j1 = islni - 1
         ENDIF
         IF ( i1.GE.ibch .AND. i1.LE.ihch ) THEN
            terco(i1,j1) = zz*xmcga(i,j)*(1.-z1/zlim)/(zs*xmcga(i1,j1))
            dtgai(i1,j1) = dtgai(i1,j1) - terco(i1,j1)
            tercu = zzu*xmcuo(i,j)*(1.-z1/zlim)/(zs*xmcuo(i1,j1))
            dt876(i1,j1) = dt876(i1,j1) - tercu
         ENDIF
      ELSE
         terc(1) = zz/z1
         dtmi(1) = dtmi(1) - terc(1)
         tercu = zzu/z1
         dtmu(1) = dtmu(1) - tercu
      ENDIF
 600  RETURN
      END
      SUBROUTINE s00018(i12,i21,iorg)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa11 / v0011n(20) , v0012x(20) , v0011 , v0012 , tlim , 
     &                zlimin , zlimax , dtvoi , timimp(20) , difref(20)
     &                 , difmic(20) , v00001 , v22202 , temimp , 
     &                temmic , delm , delv , delvi , delvs , v22201 , 
     &                v22203 , dtpre , dtphy , dttemp , dtchan , dtdis , 
     &                dtbef , dtorg , nimic , nmultr , izone , 
     &                n00011(20) , isort , necrit , nstar , iplot , 
     &                nzone , ifre(20) , ico , iimp , npas1(20) , 
     &                npas2(20)
      COMMON /aaa22 / dh(22,2) , dm(22,2) , dpdt , duu(22,2) , dv(22,2)
     &                 , dnu(22,2)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa77 / qinit , tpui(20) , qpui(20) , rpui , plmoy , 
     &                xhtc(22,12) , pl(22,12) , qrepa(22,12) , 
     &                xmcga(22,12) , xmcuo(22,12) , qced(22,12) , 
     &                qcon(22,12) , quga(22,12) , qfou(22,12) , qcei(2)
     &                 , qconi(2) , qugii(2) , tmi(2) , dtmi(2) , 
     &                qtotal , qtug , qtgf , terc(2) , tgai(22,12) , 
     &                tgaii(22,12) , t876(22,12) , tumax(22,12) , 
     &                tumin(22,12) , dtgai(22,12) , dt876(22,12) , 
     &                terco(22,12) , tmu(2) , dtmu(2) , npui , nasl(22)
     &                 , nsl(22)
      COMMON /aaa26 / deb(21) , debv(21) , debl(21) , alfad(21) , 
     &                alfb(21) , alft(21) , ha(21) , hb(21) , he(21,2) , 
     &                hem(21) , ve(21,2) , xa(21) , xb(21) , xd(21) , 
     &                xem(21) , sdsc , tjonc(21) , hjonb(21,2) , 
     &                hjont(21,2) , debav(21) , glinf(21) , glsup(21) , 
     &                pp1 , pp2 , alniv , vgjo(21) , glinfp(21) , 
     &                v55198(21) , icas(21) , iczw(21)
      COMMON /aaa99 / hlcf , hvcfo , hvap , hcon , hvin , hlin , r876 , 
     &                rgai , xm876 , xmgai , xl876 , xlgai , cp876 , 
     &                cpgai , xmc876 , xmcgai , diahy , hgapp(22) , 
     &                hcg(22) , htc(22,12) , hvcff(22)
      COMMON /aaa17 / ddpdt , ddh(22,2) , ddv(22,2) , ddm(22,2) , 
     &                ddu(22,2)
      COMMON /aaa16 / dbent(20) , tent(20) , hent(20) , debe , ente , 
     &                dbsor(20) , tsor(20) , debs , dpdtt(20) , 
     &                tdpdt(20) , hsor(20) , thsor(20) , ents , ndbent , 
     &                ndpdt , ndbsor , nhsor
      COMMON /aaa18 / ddeb(21) , dddeb(21) , dxat(21) , dxag(21) , 
     &                dxbt(21) , dxbg(21) , dnug(21) , dnuf(21) , 
     &                dhe(22,2) , ddebo(21)
      DOUBLE PRECISION m
      dtbef = 1.25*dt
      is = iss
      i12 = 0
      i21 = 0
      eps = 1.D-8
      iorg = 0
      doduc = .8
      ddc = 10.*v0012/nc1
      coedh = dmin1(doduc,ddc)
      dt = v0012
      dttemp = v0012
      dtdis = v0012
      dtchan = v0012
      dttemp = v0012
      dtphy = v0012
      dtorg = v0012
      dtvoi = v0012
      sens = v00001
      dtp = v0012
      IF ( dabs(dpdt).GT.eps ) dtp = sens*p/dabs(dpdt)
      DO 200 i = 2 , nc1
         j1 = 2 - (1/ityp(i))
         dth = v0012
         dtvol = v0012
         sens = v00001
         DO 50 j = 1 , j1
            x = v0012
            y = dabs(dh(i,j))
            IF ( y.LE.1.D-3 ) y = 1.D-3
            yy = dabs(ddh(i,j))
            IF ( yy.LE.1.D-2 ) yy = 1.D-2
            dt2 = dsqrt(sens*h(i,j)/yy)
            dt3 = sens*h(i,j)/y
            dth = dmin1(x,dt2,dt3)
 50      CONTINUE
         IF ( ityp(i).EQ.2 ) THEN
            y = dabs(dv(i,1))
            yo = vc(i)*1.D-3
            IF ( y.LE.yo ) y = yo
            yy = dabs(ddv(i,1))
            yo = yo*10.
            IF ( yy.LE.yo ) yy = yo
            xla = .5
            ymax = vc(i)
            IF ( y.LT.ymax ) xla = .5*ymax/y
            dt1 = xla*y/yy
            dt2 = dsqrt(sens*vc(i)/(10.*yy))
            dt3 = sens*vc(i)/y
            dtvol = dmin1(x,dt1,dt2,dt3)
         ENDIF
         dtphy = dmin1(dth,dtvol,dtphy)
         sens = v22202
         n1 = nasl(i)
         DO 100 j = 1 , n1
            dtpar = v0012
            IF ( i.EQ.niv .AND. j.EQ.islni ) THEN
               k1 = 2
               DO 60 k = 1 , k1
                  dtpa = v0012
                  IF ( dabs(dtmi(k)).GT.eps )
     &                  dtpa = 2.*sens*dabs(tmi(k)/dtmi(k))
                  dtpar = dmin1(dtpar,dtpa)
 60            CONTINUE
            ELSEIF ( dabs(dtgai(i,j)).GT.eps ) THEN
               dtpar = sens*dabs(tgai(i,j)/dtgai(i,j))
            ENDIF
            dttemp = dmin1(dttemp,dtpar)
 100     CONTINUE
         IF ( ityp(i).NE.2 ) THEN
            j1 = 2 - (1/ityp(i))
            DO 120 j = 1 , j1
               IF ( dabs(dh(i,j)).GE.1.D-6 ) THEN
                  dtch1 = .6*(hfs-h(i,j))/dh(i,j)
                  dtch2 = .6*(hgs-h(i,j))/dh(i,j)
                  IF ( dtch1.LT.eps ) dtch1 = v0012
                  IF ( dtch2.LT.eps ) dtch2 = v0012
                  dtchan = dmin1(dtch1,dtch2,dtchan)
               ENDIF
 120        CONTINUE
         ENDIF
         IF ( icat(2).GT.2 ) THEN
            dtch1 = v0012
            dtch2 = v0012
            IF ( ityp(i).EQ.3 ) THEN
               xh1 = h(i,1)
               xh2 = h(i,2)
               dxh1 = dh(i,1)
               dxh2 = dh(i,2)
            ELSE
               xh1 = f00111(i)
               xh2 = f00111(i)
               dxh1 = dh(i,1)
               dxh2 = dh(i,2)
               IF ( ityp(i).NE.1 ) THEN
                  xmt = m(i,1) + m(i,2)
                  dxh1 = (dm(i,1)*(h(i,1)-xh1)+dm(i,2)*(h(i,2)-xh1)
     &                   +m(i,1)*dh(i,1)+m(i,2)*dh(i,2))/(xmt*xmt)
                  dxh2 = dxh1
               ENDIF
            ENDIF
            j = i - 1
                  idoduc = 0
            IF ( idoduc.EQ.2 ) THEN
               hinf = f00111(j)
               xmt = m(j,1) + m(j,2)
               dhinf = (dm(j,1)*(h(j,1)-hinf)+dm(j,2)*(h(j,2)-hinf)
     &                 +m(j,1)*dh(j,1)+m(j,2)*dh(j,2))/(xmt*xmt)
            ELSEIF ( idoduc.EQ.3 ) THEN
               hinf = h(j,2)
               dhinf = dh(j,2)
            ELSE
               hinf = h(j,1)
               dhinf = dh(j,1)
            ENDIF
            j = i + 1
            IF ( ityp(j).EQ.2 ) THEN
               hsup = f00111(j)
               xmt = m(j,1) + m(j,2)
               dhsup = (dm(j,1)*(h(j,1)-hsup)+dm(j,2)*(h(j,2)-hsup)
     &                 +m(j,1)*dh(j,1)+m(j,2)*dh(j,2))/(xmt*xmt)
            ELSE
               hsup = h(j,1)
               dhsup = dh(j,1)
            ENDIF
            IF ( i.NE.2 ) THEN
               ect = xh1 - hinf
               dect = dxh1 - dhinf
               IF ( dabs(dect).GE.1.D-4 ) THEN
                  dtch1 = coedh*ect/dect
                  IF ( dtch1.LT.eps ) dtch1 = v0012
               ENDIF
            ENDIF
            IF ( i.NE.nc1 ) THEN
               ect = xh2 - hsup
               dect = dxh2 - dhsup
               IF ( dabs(dect).GE.1.D-4 ) THEN
                  dtch2 = coedh*ect/dect
                  IF ( dtch2.LT.eps ) dtch2 = v0012
               ENDIF
            ENDIF
            dtvoi = dmin1(dtvoi,dtch1,dtch2)
         ENDIF
 200  CONTINUE
      IF ( icat(2).GT.2 ) THEN
         sens = v22201
         roo = 1.
         vite = dabs(vitess)
         dtdis = v0012
         vniv = vite/scapa(niv)
         vinj = deb(1)
         vinj = vinj*vvfs/scapa(niv)
         IF ( vniv.GE..01 ) THEN
            IF ( vinj.GE..01 ) roo = vinj/vniv
            dtdis = sens*xl(niv)/vniv*dmin1(1.D0,roo)
         ENDIF
      ENDIF
      dtpre = dtp
      dt = dmin1(dtp,dtphy,dttemp,dtchan,dtdis,dtbef,dtvoi)
      dto = v0012
      DO 300 i = 2 , nc1
         IF ( ityp(i).NE.1 ) THEN
            DO 220 j = 1 , 2
               yc = v(i,j)
               IF ( yc.GT.1.D-7 ) THEN
                  ya = ddv(i,j)
                  yb = dv(i,j)
                  vf = yc + (yb+ya*dt)*dt
                  IF ( vf.LT.0. ) THEN
                     IF ( dabs(ya).GE.1.D-6 ) THEN
                        delt = yb*yb - 4.*ya*yc
                        IF ( delt.GT.1.D-8 ) THEN
                           tc = dsqrt(delt)
                           dt1 = (-yb-tc)/(2.*ya)
                           dt2 = (-yb+tc)/(2.*ya)
                           dt3 = dmin1(dt1,dt2)
                           dt4 = dmax1(dt1,dt2)
                           dt1 = dt3
                           IF ( dt3.LE.0. ) dt1 = dt4
                           dt1 = .9*dt1
                           dto = dmin1(dt1,dto)
                        ENDIF
                     ELSEIF ( dabs(yb).GE.1.D-6 ) THEN
                        dt1 = -yc/yb
                        dt1 = .9*dt1
                        dto = dmin1(dt1,dto)
                     ENDIF
                  ENDIF
               ENDIF
 220        CONTINUE
         ENDIF
 300  CONTINUE
      dtorg = dto
      dt = dmin1(dt,dtorg)
      dt = dmax1(v0011,dt)
      IF ( icat(2).GT.2 ) THEN
         i = niv
         ecv = dt*(ddv(i,1)*dt+dv(i,1))
         vl1 = v(i,1) + ecv
         vl2 = v(i,2) - ecv
         IF ( vl1.LT.0. ) iorg = 1
         IF ( vl2.LT.0. ) iorg = 1
      ENDIF
      dt3 = v0012
      DO 400 i = 1 , ndbent
         tbut = tent(i) + 1.D-4
         dt2 = tbut - tem
         IF ( dt2.GT.0. ) THEN
            IF ( dt2.LT.dt ) dt3 = dmin1(dt3,dt2)
         ENDIF
 400  CONTINUE
      dtorg = dmin1(dtorg,dt3)
      dt = dmin1(dt,dtorg)
      dt = dmax1(v0011,dt)
      DO 500 i = 2 , nc1
         IF ( dabs(debl(i-1)).LT.1.D-6 ) THEN
            vmin = 1.D-7*vc(i)
            IF ( v(i,1).LT.vmin ) THEN
               h(i,1) = hf(i-1,1)
               GOTO 600
            ENDIF
         ENDIF
 500  CONTINUE
 600  DO 700 i = 1 , nc1
         albt = dabs(alfb(i)-alft(i))
         IF ( albt.GE.1.D-2 ) THEN
            sec = sc(i)
            g = deb(i)/sec
            dg = ddeb(i)/sec
            dtgsu = v0012
            denom = v55198(i) - dg
            IF ( dabs(denom).GT.1.D-3 ) THEN
               dtgsu = (g-glsup(i))/denom
               IF ( dtgsu.LE.1.D-4 ) dtgsu = v0012
            ENDIF
            dtgin = v0012
            denom = glinfp(i) - dg
            IF ( dabs(denom).GT.1.D-3 ) THEN
               dtgin = (g-glinf(i))/denom
               IF ( dtgin.LE.1.D-4 ) dtgin = v0012
            ENDIF
            dtvoi = dmin1(dtvoi,dtgsu,dtgin)
         ENDIF
 700  CONTINUE
      dt = dmin1(dtvoi,dt)
      dt = dmax1(dt,v0011)
      RETURN
      END
**==b8c.for
      SUBROUTINE s00001
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa16 / dbent(20) , tent(20) , hent(20) , debe , ente , 
     &                dbsor(20) , tsor(20) , debs , dpdtt(20) , 
     &                tdpdt(20) , hsor(20) , thsor(20) , ents , ndbent , 
     &                ndpdt , ndbsor , nhsor
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      COMMON /aaa22 / dh(22,2) , dm(22,2) , dpdt , duu(22,2) , dv(22,2)
     &                 , dnu(22,2)
      DOUBLE PRECISION m
      coef = 144.D+00/778.D+00
      CALL s00096(p,hfs,hgs,ts,vvfs,vvgs,dvvfps,dvvgps,dhfps,dhgps,
     &            dtsat)
      h1 = hfs - 5.
      CALL s55199(h1,p,t1,r,x1,x2,dtdh1,dtdp1)
      vv1 = 1./r
      h2 = hgs + 10.
      CALL s55198(h2,p,t2,r,x1,x2,dtdh2,dtdp2)
      vv2 = 1./r
      h3 = 1850.
      h4 = 1860.
      CALL s55198(h3,p,t3,r,x1,x2,x3,x4)
      vv3 = 1./r
      dvp3 = x2
      dtp3 = x4
      CALL s55198(h4,p,t4,r,x1,x2,x3,x4)
      vv4 = 1./r
      dvp4 = x2
      dtp4 = x4
      hfgs = hgs - hfs
      dhfgs = dhgps - dhfps
      vfgs = vvgs - vvfs
      dvfgs = dvvgps - dvvfps
      CALL s00934(tent,dbent,hent,tem,debe,h(1,1),20)
      CALL s00934(thsor,hsor,hsor,tem,ents,x,2)
      h(nc2,1) = ents
      IF ( kpress.EQ.1 ) THEN
         CALL s00934(tdpdt,dpdtt,dpdtt,tem,p,x,13)
      ELSE
         CALL s00934(tsor,dbsor,dbsor,tem,debs,x,ndbsor)
      ENDIF
      DO 100 i = 1 , nc2
         j1 = 2
         IF ( ityp(i).EQ.1 ) j1 = 1
         IF ( ityp(i).EQ.2 ) THEN
            IF ( h(i,1).GE.hfs ) h(i,1) = hfs - 1.D-6
            IF ( h(i,2).LE.hgs ) h(i,2) = hgs + 1.D-6
            vmin = 1.D-7*vc(i)
            IF ( v(i,1).LT.vmin ) THEN
               v(i,1) = 0.
               v(i,2) = vc(i)
            ELSEIF ( v(i,2).LT.vmin ) THEN
               v(i,1) = vc(i)
               v(i,2) = 0.
            ENDIF
         ENDIF
         DO 50 j = 1 , j1
            IF ( h(i,j).LT.10. ) h(i,j) = 10.
            xt(i,j) = (h(i,j)-hfs)/hfgs
            xti = xt(i,j)
            IF ( xti.LT.0. ) THEN
               ist(i,j) = 1
               alfa(i,j) = 0.
               xm(i,j) = 0.
               hf(i,j) = h(i,j)
               hg(i,j) = hgs
               CALL s55199(h(i,j),p,t(i,j),r,dvvh(i,j),dvvp(i,j),
     &                     dtdh(i,j),dtdp(i,j))
               dnuhp(i,j) = 0.
               dnupp(i,j) = 0.
               vv(i,j) = 1./r
               IF ( h(i,j).GT.h1 ) THEN
                  x = 1. - (hfs-h(i,j))/5.
                  t(i,j) = (1.-x)*t1 + x*ts
                  vv(i,j) = (1.-x)*vv1 + x*vvfs
                  dvvh(i,j) = (vvfs-vv1)/5.
                  dxdh = 1./5.
                  dtdh(i,j) = (ts-t1)*dxdh
               ENDIF
            ELSEIF ( xti.GT.1. ) THEN
               ist(i,j) = 3
               alfa(i,j) = 1.
               xm(i,j) = 1.
               hf(i,j) = hfs
               hg(i,j) = h(i,j)
               CALL s55198(h(i,j),p,t(i,j),r,dvvh(i,j),dvvp(i,j),
     &                     dtdh(i,j),dtdp(i,j))
               dnuhp(i,j) = 0.
               dnupp(i,j) = 0.
               vv(i,j) = 1./r
               IF ( h(i,j).LT.h2 ) THEN
                  x = (h(i,j)-hgs)/10.
                  t(i,j) = (1.-x)*ts + x*t2
                  vv(i,j) = (1.-x)*vvgs + x*vv2
                  dvvh(i,j) = (vv2-vvgs)/10.
                  dxdh = 1./10.
                  dtdh(i,j) = (t2-ts)*dxdh
               ELSEIF ( h(i,j).GT.h4 ) THEN
                  x = (h(i,j)-1860.)/10.
                  t(i,j) = t4 + (t4-t3)*x
                  vv(i,j) = vv4 + (vv4-vv3)*x
                  dtdh(i,j) = (t4-t3)/10.
                  dvvh(i,j) = (vv4-vv3)/10.
                  dtdp(i,j) = dtp4 + (dtp4-dtp3)*x
                  dvvp(i,j) = dvp4 + (dvp4-dvp3)*x
               ENDIF
            ELSE
               ist(i,j) = 2
               dvfgs = dvvgps - dvvfps
               vfgs = vvgs - vvfs
               t(i,j) = ts
               dtdp(i,j) = dtsat
               dtdh(i,j) = 0.
               xm(i,j) = xti
               alfa(i,j) = xti/((1.-xti)*vvfs/vvgs+xti)
               vv(i,j) = (1.-xti)*vvfs + xti*vvgs
               dxdp = -(dhfps+dhfgs*xti)/hfgs
               dvvdpx = dvvfps + xti*dvfgs
               dvvp(i,j) = vfgs*dxdp + dvvdpx
               dvvh(i,j) = vfgs/hfgs
               xx = vfgs*dhfgs/hfgs
               dnuhp(i,j) = (dvfgs-xx)/hfgs
               dnupp(i,j) = dxdp*(-2.*xx+dvfgs)
               hf(i,j) = hfs
               hg(i,j) = hgs
            ENDIF
            m(i,j) = v(i,j)/vv(i,j)
            u(i,j) = m(i,j)*h(i,j) - coef*p*v(i,j)
            delh(i,j) = vv(i,j) - h(i,j)*dvvh(i,j)
            delp(i,j) = dvvp(i,j) + vv(i,j)*dvvh(i,j)*coef
            bb(i,j) = m(i,j)*delp(i,j)
 50      CONTINUE
 100  CONTINUE
      RETURN
      END
      SUBROUTINE s00012
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      COMMON /aaa77 / qinit , tpui(20) , qpui(20) , rpui , plmoy , 
     &                xhtc(22,12) , pl(22,12) , qrepa(22,12) , 
     &                xmcga(22,12) , xmcuo(22,12) , qced(22,12) , 
     &                qcon(22,12) , quga(22,12) , qfou(22,12) , qcei(2)
     &                 , qconi(2) , qugii(2) , tmi(2) , dtmi(2) , 
     &                qtotal , qtug , qtgf , terc(2) , tgai(22,12) , 
     &                tgaii(22,12) , t876(22,12) , tumax(22,12) , 
     &                tumin(22,12) , dtgai(22,12) , dt876(22,12) , 
     &                terco(22,12) , tmu(2) , dtmu(2) , npui , nasl(22)
     &                 , nsl(22)
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      COMMON /aaa26 / deb(21) , debv(21) , debl(21) , alfad(21) , 
     &                alfb(21) , alft(21) , ha(21) , hb(21) , he(21,2) , 
     &                hem(21) , ve(21,2) , xa(21) , xb(21) , xd(21) , 
     &                xem(21) , sdsc , tjonc(21) , hjonb(21,2) , 
     &                hjont(21,2) , debav(21) , glinf(21) , glsup(21) , 
     &                pp1 , pp2 , alniv , vgjo(21) , glinfp(21) , 
     &                v55198(21) , icas(21) , iczw(21)
      DOUBLE PRECISION m , ax(5) , ay(5)
      tvid(1,1) = alfa(1,1)
      tvid(nc2,1) = alfa(nc2,1)
      alfb(1) = tvid(1,1)
      alft(nc1) = tvid(nc2,1)
      alec = .01
      alin = alec
      alsu = 1. - alec
      DO 100 i = 2 , nc1
         ni = nasl(i)
         xl2 = xl(i)/2.
         IF ( ityp(i).EQ.3 ) xl2 = hniv(i)/2.
         ax(2) = zcot(i-1) + xl2
         ay(2) = alfa(i,1)
         IF ( ityp(i).EQ.2 ) ay(2) = v(i,2)/vc(i)
         xlm = xl2
         alm = ay(2)
         fm = 0.
         hm = 1.
         gm = 0.
         IF ( alm.LT.alin ) THEN
            hm = alm/alec
            fm = 1. - hm
         ELSEIF ( alm.GT.alsu ) THEN
            gm = (alm-alsu)/alec
            hm = 1. - gm
         ENDIF
         j = i - 1
         ax(1) = zcot(i-1)
         xlb = -xl(j)/2.
         IF ( j.EQ.1 ) xlb = -xl(i)/2.
         alb = alfa(j,1)
         IF ( ityp(j).EQ.2 ) alb = v(j,2)/vc(j)
         IF ( ityp(j).EQ.3 ) THEN
            alb = alfa(j,2)
            xlb = (hniv(j)-xl(j))/2.
         ENDIF
         aljo = (alb*xlm-alm*xlb)/(xlm-xlb)
         fb = 0.
         gb = 0.
         hbb = 1.
         IF ( alb.LT.alin ) THEN
            hbb = alb/alec
            fb = 1. - hbb
         ELSEIF ( alb.GT.alsu ) THEN
            gb = (alb-alsu)/alec
            hbb = 1. - gb
         ENDIF
         tcc = hm*(hbb+fm*fb+gm*gb)
         ay(1) = alm + (aljo-alm)*tcc
         aljb = ay(1)
         p1 = (ay(2)-ay(1))/(ax(2)-ax(1))
         q1 = ay(1) - ax(1)*p1
         j = i + 1
         IF ( ityp(i).GT.2 ) THEN
            ax(2) = zcot(i-1) + (xl(i)+hniv(i))/2.
            ay(2) = alfa(i,2)
            alm = ay(2)
            xlm = (hniv(i)-xl(i))/2.
            fm = 0.
            hm = 0.
            gm = 0.
            IF ( alm.LT.alin ) THEN
               hm = alm/alec
               fm = 1. - hm
            ELSEIF ( alm.GT.alsu ) THEN
               gm = (alm-alsu)/alec
               hm = 1. - gm
            ENDIF
         ENDIF
         ax(3) = zcot(i-1) + xl(i)
         xlm = ax(2) - ax(3)
         xlh = xl(j)/2.
         IF ( ityp(j).EQ.3 ) xlh = hniv(j)/2.
         IF ( j.EQ.nc2 ) xlh = xl(i)/2.
         alh = alfa(j,1)
         IF ( ityp(j).EQ.2 ) alh = v(j,2)/vc(j)
         aljo = (alh*xlm-alm*xlh)/(xlm-xlh)
         fh = 0.
         gh = 0.
         hh = 1.
         IF ( alh.LT.alin ) THEN
            hh = alh/alec
            fh = 1. - hh
         ELSEIF ( alh.GT.alsu ) THEN
            gh = (alh-alsu)/alec
            hh = 1. - gh
         ENDIF
         tcc = hm*(hh+fm*fh+gm*gh)
         ay(3) = alm + (aljo-alm)*tcc
         aljt = ay(3)
         p2 = (ay(3)-ay(2))/(ax(3)-ax(2))
         q2 = ay(2) - ax(2)*p2
         IF ( icat(2).GE.3 ) THEN
            alfb(i) = aljt
            alft(i-1) = aljb
            IF ( ityp(i).GE.3 ) THEN
               tvid(i,1) = alfa(i,1)
               tvid(i,2) = alfa(i,2)
            ELSE
               DO 10 j = 1 , ni
                  tvid(i,j) = alm
 10            CONTINUE
            ENDIF
         ELSE
            alfb(i) = alm
            alft(i-1) = alm
            DO 20 j = 1 , ni
               xp = zcot(i-1) + (j-.5)*xl(i)/ni
               IF ( xp.GE.ax(2) ) THEN
                  tvid(i,j) = p2*xp + q2
               ELSE
                  tvid(i,j) = p1*xp + q1
               ENDIF
 20         CONTINUE
         ENDIF
 100  CONTINUE
      RETURN
      END
      SUBROUTINE s00005(iorg)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa11 / v0011n(20) , v0012x(20) , v0011 , v0012 , tlim , 
     &                zlimin , zlimax , dtvoi , timimp(20) , difref(20)
     &                 , difmic(20) , v00001 , v22202 , temimp , 
     &                temmic , delm , delv , delvi , delvs , v22201 , 
     &                v22203 , dtpre , dtphy , dttemp , dtchan , dtdis , 
     &                dtbef , dtorg , nimic , nmultr , izone , 
     &                n00011(20) , isort , necrit , nstar , iplot , 
     &                nzone , ifre(20) , ico , iimp , npas1(20) , 
     &                npas2(20)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      kimp = 0
      i = izone
      IF ( i.LT.nzone ) THEN
         IF ( tem.GE.timimp(i+1) ) i = i + 1
      ENDIF
      dfre = difref(i)
      ifr = ifre(i)
      dmic = difmic(i)
      np1 = npas1(i)
      np2 = npas2(i)
      v0011 = v0011n(i)
      v0012 = v0012x(i)
      IF ( i.EQ.izone ) THEN
         ect = tem - temimp
         IF ( ect.LT.dfre ) THEN
            IF ( ifr.LT.10 ) GOTO 100
            IF ( iimp.GE.np1 ) THEN
               kimp = 1
            ELSEIF ( ico.GE.np2 ) THEN
               kimp = 1
               ico = 0
            ELSEIF ( ifr.GE.20 ) THEN
               IF ( iorg.EQ.1 ) kimp = 1
            ENDIF
         ELSE
            kimp = 1
            IF ( ifr.LT.10 ) GOTO 100
         ENDIF
      ELSE
         kimp = 1
         ico = 0
         izone = i
         IF ( ifr.LT.10 ) GOTO 100
      ENDIF
      dtmi = v0011 + 1.D-6
      IF ( dt.GE.dtmi ) THEN
         ico = 0
      ELSEIF ( ico.GT.1 ) THEN
         ico = ico + 1
      ELSEIF ( iorg.NE.1 ) THEN
         kimp = 1
         ico = ico + 1
      ENDIF
 100  iimp = iimp + 1
      IF ( kimp.EQ.0 ) THEN
         ect = tem - temmic
         IF ( ect.LT.dmic ) RETURN
         x = tem/dmic
         ix = INT(x)
         num = nitera - nimic
         IF ( num.LT.1 ) num = 1
         dtmoy = (tem-temmic)/num
         temmic = ix*dmic
         nimic = nitera
         RETURN
      ELSE
         iok = 0
         IF ( isort.NE.0 ) THEN
            nstar = nstar + 1
            IF ( nstar.GE.n00011(i) ) THEN
               nstar = 0
               necrit = necrit + 1
               iok = 1
            ENDIF
         ENDIF
         iimp = 0
         x = tem/dfre
         ix = INT(x)
         temimp = ix*dfre
         num = nitera - nimic
         IF ( num.LT.1 ) num = 1
         dtmoy = (tem-temmic)/num
         temmic = temimp
         nimic = nitera
         k = ifr - 10*(ifr/10)
         PRINT 99001 , tem , nitera
         RETURN
      ENDIF
99001 FORMAT (' TEMPS = ',F15.8,' , NITERA : ',I10)
      END
      SUBROUTINE s55199(h,p,t,rho,dvdhp,dvdph,dtdh,dtdp)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      DATA a00 , a01 , a02 , a03 , a04 , a05 , a06 , a07 , a08 , a09 , 
     &     a010 , a011 , a012/1.0421485616135D-02 , 
     &     3.7989819258871D-04 , -1.0809520514321D-05 , 
     &     1.7199071099232D-07 , -1.7003453661702D-09 , 
     &     1.1093079504746D-11 , -4.9305639341012D-14 , 
     &     1.5141687819488D-16 , -3.2078176823915D-19 , 
     &     4.5968793700556D-22 , -4.2500133969565D-25 , 
     &     2.2858451991157D-28 , -5.4289561756668D-32/
      DATA a10 , a11 , a12 , a13 , a14 , a15 , a16 , a17 , a18 , a19 , 
     &     a110 , a111 , a112/7.1558907160166D-06 , 
     &     -4.8989819387822D-07 , 1.3966895742219D-08 , 
     &     -2.2153628233107D-10 , 2.1877549314087D-12 , 
     &     -1.4259859281335D-14 , 6.3323408405408D-17 , 
     &     -1.9428241441369D-19 , 4.1119914445076D-22 , 
     &     -5.8869455392068D-25 , 5.4376738094709D-28 , 
     &     -2.9220477630923D-31 , 6.9343597264571D-35/
      DATA a20 , a21 , a22 , a23 , a24 , a25 , a26 , a27 , a28 , a29 , 
     &     a210 , a211 , a212/ - 3.0284448323971D-09 , 
     &     2.0572908444785D-10 , -5.8631773583883D-12 , 
     &     9.2947600855704D-14 , -9.1733812676273D-16 , 
     &     5.9751462062171D-18 , -2.6513621151927D-20 , 
     &     8.1280449373158D-23 , -1.7188520355861D-25 , 
     &     2.4587005585713D-28 , -2.2691496114378D-31 , 
     &     1.2183868386189D-34 , -2.8891726411793D-38/
      DATA a30 , a31 , a32 , a33 , a34 , a35 , a36 , a37 , a38 , a39 , 
     &     a310 , a311 , a312/4.1603162475165D-13 , 
     &     -2.8253313464467D-14 , 8.0498643149541D-16 , 
     &     -1.2756275155692D-17 , 1.2583652213261D-19 , 
     &     -8.1918809930522D-22 , 3.6327419331754D-24 , 
     &     -1.1129150871768D-26 , 2.3518675463763D-29 , 
     &     -3.3618179351310D-32 , 3.1004787014482D-35 , 
     &     -1.6636314001942D-38 , 3.9424525577961D-38/
      DATA b00 , b01 , b02 , b03 , b04 , b05 , b06 , b07 , b08 , b09 , 
     &     b010 , b011 , b012/3.4799516636947D+01 , 
     &     8.0207756895533D-01 , 5.7134938990324D-03 , 
     &     -9.0888455214870D-05 , 9.0343489356475D-07 , 
     &     -5.9586500435765D-09 , 2.6874936213899D-11 , 
     &     -8.4045091912731D-14 , 1.8181932356958D-16 , 
     &     -2.6657692257362D-19 , 2.5243994056927D-22 , 
     &     -1.3912049726064D-25 , 3.3848430431244D-29/
      DATA b10 , b11 , b12 , b13 , b14 , b15 , b16 , b17 , b18 , b19 , 
     &     b110 , b111 , b112/ - 3.3870909274776D-03 , 
     &     3.3749976806899D-05 , -8.3841532461841D-07 , 
     &     1.3908406425265D-08 , -1.5041874666294D-10 , 
     &     1.1068510439562D-12 , -5.6404562404400D-15 , 
     &     1.9963935983267D-17 , -4.8613722666270D-20 , 
     &     7.9478277453504D-23 , -8.3010018206858D-26 , 
     &     4.9898102992625D-29 , -1.3103660877630D-32/
      DATA b20 , b21 , b22 , b23 , b24 , b25 , b26 , b27 , b28 , b29 , 
     &     b210 , b211 , b212/ - 2.2063755868780D-07 , 
     &     1.4268968388826D-08 , -3.9416351705981D-10 , 
     &     5.9606582726984D-12 , -5.4871340648895D-14 , 
     &     3.2304069082462D-16 , -1.2421935589492D-18 , 
     &     3.1127728952968D-21 , -4.9182825188505D-24 , 
     &     4.4404482566015D-27 , -1.5665047149903D-30 , 
     &     -5.6075256366923D-34 , 4.6890466767990D-37/
      c0 = a00 + 
     &     h*(a01+h*(a02+h*(a03+h*(a04+h*(a05+h*(a06+h*(a07+h*(a08+
     &     h*(a09+h*(a010+h*(a011+h*a012)))))))))))
      c1 = a10 + 
     &     h*(a11+h*(a12+h*(a13+h*(a14+h*(a15+h*(a16+h*(a17+h*(a18+
     &     h*(a19+h*(a110+h*(a111+h*a112)))))))))))
      c2 = a20 + 
     &     h*(a21+h*(a22+h*(a23+h*(a24+h*(a25+h*(a26+h*(a27+h*(a28+
     &     h*(a29+h*(a210+h*(a211+h*a212)))))))))))
      c3 = a30 + 
     &     h*(a31+h*(a32+h*(a33+h*(a34+h*(a35+h*(a36+h*(a37+h*(a38+
     &     h*(a39+h*(a310+h*(a311+h*a312)))))))))))
      d0 = b00 + 
     &     h*(b01+h*(b02+h*(b03+h*(b04+h*(b05+h*(b06+h*(b07+h*(b08+
     &     h*(b09+h*(b010+h*(b011+h*b012)))))))))))
      d1 = b10 + 
     &     h*(b11+h*(b12+h*(b13+h*(b14+h*(b15+h*(b16+h*(b17+h*(b18+
     &     h*(b19+h*(b110+h*(b111+h*b112)))))))))))
      d2 = b20 + 
     &     h*(b21+h*(b22+h*(b23+h*(b24+h*(b25+h*(b26+h*(b27+h*(b28+
     &     h*(b29+h*(b210+h*(b211+h*b212)))))))))))
      dd0 = b01 + 
     &      h*(2.*b02+h*(3.*b03+h*(4.*b04+h*(5.*b05+h*(6.*b06+h*(7.*b07+
     &      h*(8.*b08+h*(9.*b09+h*(10.*b010+h*(11.*b011+12.*b012*h))))))
     &      ))))
      dd1 = b11 + 
     &      h*(2.*b12+h*(3.*b13+h*(4.*b14+h*(5.*b15+h*(6.*b16+h*(7.*b17+
     &      h*(8.*b18+h*(9.*b19+h*(10.*b110+h*(11.*b111+12.*b112*h))))))
     &      ))))
      dd2 = b21 + 
     &      h*(2.*b22+h*(3.*b23+h*(4.*b24+h*(5.*b25+h*(6.*b26+h*(7.*b27+
     &      h*(8.*b28+h*(9.*b29+h*(10.*b210+h*(11.*b211+12.*b212*h))))))
     &      ))))
      dvdh1 = a01 + 
     &        h*(2.*a02+h*(3.*a03+h*(4.*a04+h*(5.*a05+h*(6.*a06+h*(7.*
     &        a07+
     &        h*(8.*a08+h*(9.*a09+h*(10.*a010+h*(11.*a011+h*12.*a012))))
     &        ))))))
      dvdh2 = a11 + 
     &        h*(2.*a12+h*(3.*a13+h*(4.*a14+h*(5.*a15+h*(6.*a16+h*(7.*
     &        a17+
     &        h*(8.*a18+h*(9.*a19+h*(10.*a110+h*(11.*a111+h*12.*a112))))
     &        ))))))
      dvdh3 = a21 + 
     &        h*(2.*a22+h*(3.*a23+h*(4.*a24+h*(5.*a25+h*(6.*a26+h*(7.*
     &        a27+
     &        h*(8.*a28+h*(9.*a29+h*(10.*a210+h*(11.*a211+h*12.*a212))))
     &        ))))))
      dvdh4 = a31 + 
     &        h*(2.*a32+h*(3.*a33+h*(4.*a34+h*(5.*a35+h*(6.*a36+h*(7.*
     &        a37+
     &        h*(8.*a38+h*(9.*a39+h*(10.*a310+h*(11.*a311+h*12.*a312))))
     &        ))))))
      dvdhp = dvdh1 + p*(dvdh2+p*(dvdh3+p*dvdh4))
      dvdph = c1 + 2.*p*c2 + 3.*p**2*c3
      v = c0 + p*(c1+p*(c2+p*c3))
      t = d0 + p*(d1+p*d2)
      dtdh = dd0 + p*(dd1+p*dd2)
      dtdp = d1 + 2.*d2*p
      rho = 1./v
      RETURN
      END
      SUBROUTINE s55198(h,pp,t,rho,dvdhp,dvdph,dtdh,dtdp)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      DATA a00 , a01 , a02 , a03 , a04 , a05 , a06 , a07 , a08 , 
     &     a09/6170.78663883D+00 , 489.886451913D+00 , 
     &     -1.71011901617D+00 , .00310665805845D+00 , 
     &     -34.6610591433D-07 , 24.1062845537D-10 , -10.411445494D-13 , 
     &     27.0989223969D-17 , -38.9010136647D-21 , 23.654728597D-25/
      DATA a10 , a11 , a12 , a13 , a14 , a15 , a16 , a17 , a18 , 
     &     a19/ - 27.2234538756D+00 , -1.55945023546D+00 , 
     &     .0055688166592D+00 , -10.1907487805D-06 , 11.3988461203D-09 , 
     &     -79.2905387618D-13 , 34.2019458067D-16 , -88.8161818151D-20 , 
     &     12.7093552905D-23 , -76.9751114847D-28/
      DATA a20 , a21 , a22 , a23 , a24 , a25 , a26 , a27 , a28 , 
     &     a29/.0400334696045D+00 , .0019832294859D+00 , 
     &     -72.2377802606D-07 , 13.3067830456D-09 , -14.917384566D-12 , 
     &     10.3760380082D-15 , -44.6915456261D-19 , 11.5763883026D-22 , 
     &     -16.5086089907D-26 , 99.5533322201D-31/
      DATA a30 , a31 , a32 , a33 , a34 , a35 , a36 , a37 , a38 , 
     &     a39/ - 26.7334101475D-06 , -12.5868723956D-07 , 
     &     46.6552793801D-10 , -86.4549289781D-13 , 97.1047694917D-16 , 
     &     -67.5258399441D-19 , 29.036844039D-22 , -75.0092619426D-26 , 
     &     10.6572651116D-29 , -63.9675459557D-34/
      DATA a40 , a41 , a42 , a43 , a44 , a45 , a46 , a47 , a48 , 
     &     a49/87.7523620691D-10 , 39.8481772183D-11 , 
     &     -15.0016095749D-13 , 27.947539761D-16 , -31.4412831D-19 , 
     &     21.8544044613D-22 , -93.8062091533D-26 , 24.1619703535D-29 , 
     &     -34.1939584316D-33 , 20.421351707D-37/
      DATA a50 , a51 , a52 , a53 , a54 , a55 , a56 , a57 , a58 , 
     &     a59/ - 11.4250142505D-13 , -50.3259455874D-15 , 
     &     19.2105899709D-17 , -35.9600016574D-20 , 40.5103597804D-23 , 
     &     -28.1410621514D-26 , 12.0553990633D-29 , -30.9558667049D-33 , 
     &     43.6260674D-37 , -25.9155193335D-38/
      DATA b00 , b01 , b02 , b03 , b04 , b05 , b06 , 
     &     b07/445.665390762D+00 , -2.22263915916D+00 , 
     &     .00472884372253D+00 , -55.6382273478D-07 , 
     &     39.0978422275D-10 , -16.4098861643D-13 , 38.0911781785D-17 , 
     &     -37.7244080484D-21/
      DATA b10 , b11 , b12 , b13 , b14 , b15 , b16 , 
     &     b17/ - 1093412.10859D+00 , 5392.48720906D+00 , 
     &     -11.3504501908D+00 , .0132165571029D+00 , 
     &     -91.9374308338D-07 , 38.2114755965D-10 , -87.8718361625D-14 , 
     &     86.2568295293D-18/
      DATA b20 , b21 , b22 , b23 , b24 , b25 , b26 , 
     &     b27/473986630.09D+00 , -2303848.6116D+00 , 
     &     4783.56767793D+00 , -5.50018860399D+00 , 
     &     .00378235279254D+00 , -15.556306052D-07 , 35.4309477645D-11 , 
     &     -34.4728839248D-15/
      DATA b30 , b31 , b32 , b33 , b34 , b35 , b36 , 
     &     b37/ - 59101208761.4D+00 , 285687397.896D+00 , 
     &     -590083.283098D+00 , 675.104420712D+00 , -.46204835791D+00 , 
     &     .000189172522631D+00 , -42.8993080892D-09 , 
     &     41.5668966327D-13/
      DATA b40 , b41 , b42 , b43 , b44 , b45 , b46 , 
     &     b47/3147752810980.D+00 , -15146899832.4D+00 , 
     &     31147138.3352D+00 , -35480.7250254D+00 , 24.1808570239D+00 , 
     &     -.00985946157921D+00 , 22.2693241999D-07 , 
     &     -21.4941089448D-11/
      DATA b50 , b51 , b52 , b53 , b54 , b55 , b56 , 
     &     b57/ - 75347916606600.D+00 , 361189325093.D+00 , 
     &     -739923492.971D+00 , 839728.397005D+00 , -570.189938069D+00 , 
     &     .231648962465D+00 , -52.1369298193D-06 , 50.1481876596D-10/
      DATA b60 , b61 , b62 , b63 , b64 , b65 , b66 , 
     &     b67/663617137215000.D+00 , -3171123872380.D+00 , 
     &     6475932094.22D+00 , -7326561.7806D+00 , 4959.5175126D+00 , 
     &     -2.00874787721D+00 , .000450750907579D+00 , 
     &     -43.2282398141D-09/
      p = pp
      IF ( p.LT.25. ) p = 25.D+00
      a0 = a00 + 
     &     p*(a01+p*(a02+p*(a03+p*(a04+p*(a05+p*(a06+p*(a07+p*(a08+
     &     p*(a09)))))))))
      a1 = a10 + 
     &     p*(a11+p*(a12+p*(a13+p*(a14+p*(a15+p*(a16+p*(a17+p*(a18+
     &     p*(a19)))))))))
      a2 = a20 + 
     &     p*(a21+p*(a22+p*(a23+p*(a24+p*(a25+p*(a26+p*(a27+p*(a28+
     &     p*(a29)))))))))
      a3 = a30 + 
     &     p*(a31+p*(a32+p*(a33+p*(a34+p*(a35+p*(a36+p*(a37+p*(a38+
     &     p*(a39)))))))))
      a4 = a40 + 
     &     p*(a41+p*(a42+p*(a43+p*(a44+p*(a45+p*(a46+p*(a47+p*(a48+
     &     p*(a49)))))))))
      a5 = a50 + 
     &     p*(a51+p*(a52+p*(a53+p*(a54+p*(a55+p*(a56+p*(a57+p*(a58+
     &     p*(a59)))))))))
      da0 = a01 + 
     &      p*(2.*a02+p*(3.*a03+p*(4.*a04+p*(5.*a05+p*(6.*a06+p*(7.*a07+
     &      p*(8.*a08+9.*a09*p)))))))
      da1 = a11 + 
     &      p*(2.*a12+p*(3.*a13+p*(4.*a14+p*(5.*a15+p*(6.*a16+p*(7.*a17+
     &      p*(8.*a18+9.*a19*p)))))))
      da2 = a21 + 
     &      p*(2.*a22+p*(3.*a23+p*(4.*a24+p*(5.*a25+p*(6.*a26+p*(7.*a27+
     &      p*(8.*a28+9.*a29*p)))))))
      da3 = a31 + 
     &      p*(2.*a32+p*(3.*a33+p*(4.*a34+p*(5.*a35+p*(6.*a36+p*(7.*a37+
     &      p*(8.*a38+9.*a39*p)))))))
      da4 = a41 + 
     &      p*(2.*a42+p*(3.*a43+p*(4.*a44+p*(5.*a45+p*(6.*a46+p*(7.*a47+
     &      p*(8.*a48+9.*a49*p)))))))
      da5 = a51 + 
     &      p*(2.*a52+p*(3.*a53+p*(4.*a54+p*(5.*a55+p*(6.*a56+p*(7.*a57+
     &      p*(8.*a58+9.*a59*p)))))))
      t = a0 + h*(a1+h*(a2+h*(a3+h*(a4+h*(a5)))))
      dtdh = a1 + h*(2.*a2+h*(3.*a3+h*(4.*a4+5.*a5*h)))
      dtdp = da0 + h*(da1+h*(da2+h*(da3+h*(da4+h*da5))))
      b0 = b00 + h*(b01+h*(b02+h*(b03+h*(b04+h*(b05+h*(b06+h*(b07)))))))
      b1 = b10 + h*(b11+h*(b12+h*(b13+h*(b14+h*(b15+h*(b16+h*(b17)))))))
      b2 = b20 + h*(b21+h*(b22+h*(b23+h*(b24+h*(b25+h*(b26+h*(b27)))))))
      b3 = b30 + h*(b31+h*(b32+h*(b33+h*(b34+h*(b35+h*(b36+h*(b37)))))))
      b4 = b40 + h*(b41+h*(b42+h*(b43+h*(b44+h*(b45+h*(b46+h*(b47)))))))
      b5 = b50 + h*(b51+h*(b52+h*(b53+h*(b54+h*(b55+h*(b56+h*(b57)))))))
      b6 = b60 + h*(b61+h*(b62+h*(b63+h*(b64+h*(b65+h*(b66+h*(b67)))))))
      db0 = b01 + 
     &      h*(2.*b02+h*(3.*b03+h*(4.*b04+h*(5.*b05+h*(6.*b06+h*(7.*b07)
     &      )))))
      db1 = b11 + 
     &      h*(2.*b12+h*(3.*b13+h*(4.*b14+h*(5.*b15+h*(6.*b16+h*(7.*b17)
     &      )))))
      db2 = b21 + 
     &      h*(2.*b22+h*(3.*b23+h*(4.*b24+h*(5.*b25+h*(6.*b26+h*(7.*b27)
     &      )))))
      db3 = b31 + 
     &      h*(2.*b32+h*(3.*b33+h*(4.*b34+h*(5.*b35+h*(6.*b36+h*(7.*b37)
     &      )))))
      db4 = b41 + 
     &      h*(2.*b42+h*(3.*b43+h*(4.*b44+h*(5.*b45+h*(6.*b46+h*(7.*b47)
     &      )))))
      db5 = b51 + 
     &      h*(2.*b52+h*(3.*b53+h*(4.*b54+h*(5.*b55+h*(6.*b56+h*(7.*b57)
     &      )))))
      db6 = b61 + 
     &      h*(2.*b62+h*(3.*b63+h*(4.*b64+h*(5.*b65+h*(6.*b66+h*(7.*b67)
     &      )))))
      r = 1./p
      v = b0 + r*(b1+r*(b2+r*(b3+r*(b4+r*(b5+r*(b6))))))
      dvdph = -
     &        r**2*(b1+r*(2.*b2+r*(3.*b3+r*(4.*b4+r*(5.*b5+r*(6.*b6)))))
     &        )
      dvdhp = db0 + r*(db1+r*(db2+r*(db3+r*(db4+r*(db5+r*(db6))))))
      IF ( pp.LT.25. ) THEN
         p = pp
         IF ( p.LT.0.1 ) p = 0.1
         v = v*25./p
         dvdhp = dvdhp*25./p
         dvdph = dvdph*(25./p)**2
         rho = 1./v
         RETURN
      ELSE
         rho = 1./v
         RETURN
      ENDIF
      END
      SUBROUTINE f88345(g,alfb,alft,vg,vf,t,sig,fluxg,fluxf,alj,vgj,p,q,
     &                  icas,gl1,gl2,izw)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      z1(x) = (1.-x)*(alft-x) + x*(x-alfb)
      z2(x) = x*(alft-x)/vg - x*(x-alfb)/vf
      rf = 1./vf
      rg = 1./vg
      grav = 32.174
      gc = 32.174
      a1 = .67
      a2 = .47
      b1 = 1./a1
      b2 = 1./a2
      n = 0
      nitm = 15
      izw = 0
      vfdvg = vf/vg
      sig = sigma(t)
      tcc = sig*gc*grav*(rf-rg)
      tcc = vf*dsqrt(tcc)
      vbcr = 1.53*dsqrt(tcc)
      alo = .925*(vf/vg)**.239D+00
      alsu = 1. - 1.D-7
      gl1 = 1.D+6
      gl2 = -1.D+6
      IF ( g.GE.0. ) THEN
         icas = 1
         izw = 1
         alj = alfb
      ELSE
         icas = 3
         izw = 2
         alj = alft
      ENDIF
      vgj = s00098(vbcr,alo,alj)
      b = b1
      IF ( alfb.GE.alo ) b = b2
      gl1 = ((alfb/alo)**b)*rg*vbcr
      gl2 = -rf*s00098(vbcr,alo,alft)
      IF ( alfb.GE.1.D-7 .AND. alft.LE.alsu ) THEN
         IF ( g.LT.gl1 .AND. g.GT.gl2 ) THEN
            icas = 2
            izw = 3
            n = 1
            alfst = (rg*alft+rf*alfb)/(rg+rf)
            albt = dabs(alft-alfb)
            IF ( albt.GE.1.D-3 ) THEN
               al1 = dmin1(alfb,alft)
               al2 = dmax1(alfb,alft)
               vg1 = s00098(vbcr,alo,al1)
               vg2 = s00098(vbcr,alo,al2)
               vgst = s00098(vbcr,alo,alfst)
               x = al1
               f1 = (vg1*z2(x)-g*z1(x))/albt
               x = al2
               f2 = (vg2*z2(x)-g*z1(x))/albt
               x = alfst
               fst = (vgst*z2(x)-g*z1(x))/albt
               IF ( dabs(fst).GT.1.D-04 ) THEN
                  IF ( fst.GT.0. ) THEN
                     al1 = alfst
                     f1 = fst
                  ELSE
                     al2 = alfst
                     f2 = fst
                  ENDIF
 5                n = n + 1
                  x = (al1*f2-al2*f1)/(f2-f1)
                  vgj = s00098(vbcr,alo,x)
                  IF ( (al2-al1).GE.1.D-7 ) THEN
                     f = (vgj*z2(x)-g*z1(x))/albt
                     IF ( dabs(f).GT.1.D-04 ) THEN
                        IF ( f.GT.0. ) THEN
                           al1 = x
                           f1 = f
                        ELSE
                           al2 = x
                           f2 = f
                        ENDIF
                        IF ( n.LT.nitm ) GOTO 5
                        alj = (al1*f2-al2*f1)/(f2-f1)
                        vgj = s00098(vbcr,alo,x)
                        GOTO 100
                     ELSE
                        alj = x
                        IF ( dabs(f).GE.1.D-8 ) THEN
                           IF ( f.GT.0. ) THEN
                              al1 = x
                              f1 = f
                           ELSE
                              al2 = x
                              f2 = f
                           ENDIF
                           alj = (al1*f2-al2*f1)/(f2-f1)
                           vgj = s00098(vbcr,alo,x)
                        ENDIF
                        GOTO 100
                     ENDIF
                  ELSE
                     alj = x
                     GOTO 100
                  ENDIF
               ELSE
                  alj = alfst
                  vgj = vgst
                  GOTO 100
               ENDIF
            ELSE
               alj = (alfb+alft)/2.D+00
               vgj = s00098(vbcr,alo,alj)
               izw = 4
               GOTO 100
            ENDIF
         ENDIF
      ENDIF
      rhob = alj*rg + (1.-alj)*rf
      vgj = s00098(vbcr,alo,alj)
      fluxg = (g+rf*vgj)*alj/rhob
      fluxf = (g*(1.-alj)-rg*vgj*alj)/rhob
      p = rg*alj/rhob
      q = rf*rg*vgj*alj/rhob
      IF ( g.GE.0. .AND. fluxf.LT.0. ) THEN
         izw = 0
         icas = 1
         IF ( g.LT.0. ) THEN
            gl2 = -1.D+6
            icas = 3
         ENDIF
         alj = 1.D+00
         fluxg = g*vg
         fluxf = 0.D+00
         p = 1.D+00
         q = 0.D+00
         vgj = 0.D+00
         RETURN
      ELSEIF ( g.LT.0. .AND. fluxg.GT.0. ) THEN
         izw = 0
         gl1 = 1.D+6
         icas = 1
         IF ( g.LT.0. ) icas = 3
         alj = 0.D+00
         fluxg = 0.D+00
         fluxf = g*vf
         p = 0.D+00
         q = 0.D+00
         vgj = 0.D+00
         RETURN
      ELSE
         RETURN
      ENDIF
 100  rhob = alj*rg + (1.-alj)*rf
      fluxg = (g+rf*vgj)*alj/rhob
      fluxf = (g*(1.-alj)-rg*vgj*alj)/rhob
      x = alj
      dz2 = -2.*x*(rg+rf) + alft*rg + alfb*rf
      dz1 = 4.*x - 1. - alfb - alft
      djgg = x/rhob
      a = a1
      IF ( x.GE.alo ) a = a2
      eb = 1./a - 1.D+00
      xvgja = vbcr*(x/alo)**eb*(-x+(1.-x)*(1.-a)/a)/alo
      djgal = rf*(xvgja+(g+rf*vgj)/rhob)/rhob
      z2vgja = ((alft-x)/vg+(alfb-x)/vf)*xvgja
      dalg = z1(x)/(dz2*vgj+z2vgja-g*dz1)
      p = rg*(djgg+djgal*dalg)
      q = rg*fluxg - p*g
      RETURN
      END
      DOUBLE PRECISION FUNCTION si(xtbl,ytbl,xx,nn,ind)
      DOUBLE PRECISION xx
      DOUBLE PRECISION xtbl(32) , ytbl(32)
      ind = 0
      x = xx
      n = nn
      IF ( x.LT.xtbl(1) ) THEN
         ind = 1
         ii = 2
      ELSEIF ( x.EQ.xtbl(1) ) THEN
         ii = 2
      ELSEIF ( xtbl(n).LT.x ) THEN
         ind = 2
         ii = n
      ELSEIF ( xtbl(n).EQ.x ) THEN
         ii = n
      ELSE
         DO 50 ik = 2 , n
            ii = ik
            IF ( xtbl(ik).GE.x ) GOTO 100
 50      CONTINUE
      ENDIF
 100  x1 = xtbl(ii-1)
      x2 = xtbl(ii)
      y1 = ytbl(ii-1)
      y2 = ytbl(ii)
      si = y1 + (y2-y1)*(x-x1)/(x2-x1)
      RETURN
      END
      DOUBLE PRECISION FUNCTION s00093(pwl,twall)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      DOUBLE PRECISION tabpwl(32) , taba(32) , tabb(32)
      DOUBLE PRECISION a , b
      DATA tabpwl/0.000 , 0.007 , 0.010 , 0.012 , 0.015 , 0.020 , 
     &     0.025 , 0.030 , 0.035 , 0.040 , 0.050 , 0.060 , 0.070 , 
     &     0.080 , 0.100 , 0.120 , 0.150 , 0.200 , 0.250 , 0.300 , 
     &     0.400 , 0.500 , 0.600 , 0.800 , 1.000 , 1.200 , 1.500 , 
     &     2.000 , 3.000 , 5.000 , 10.000 , 20.000/
      DATA taba/0.000950 , 0.000936 , 0.000890 , 0.000898 , 0.000890 , 
     &     0.000856 , 0.000808 , 0.000778 , 0.000769 , 0.000758 , 
     &     0.000720 , 0.000689 , 0.000678 , 0.000671 , 0.000620 , 
     &     0.000600 , 0.000565 , 0.000523 , 0.000501 , 0.000486 , 
     &     0.000452 , 0.000447 , 0.000416 , 0.000392 , 0.000384 , 
     &     0.000371 , 0.000354 , 0.000335 , 0.000322 , 0.000307 , 
     &     0.000287 , 0.000275/
      DATA tabb/0.029 , 0.037 , 0.047 , 0.056 , 0.067 , 0.080 , 0.090 , 
     &     0.096 , 0.108 , 0.120 , 0.132 , 0.144 , 0.156 , 0.168 , 
     &     0.184 , 0.200 , 0.220 , 0.245 , 0.270 , 0.295 , 0.325 , 
     &     0.355 , 0.375 , 0.410 , 0.450 , 0.480 , 0.510 , 0.550 , 
     &     0.620 , 0.700 , 0.800 , 0.910/
      a = si(tabpwl(1),taba(1),pwl,32,ind)
      b = si(tabpwl(1),tabb(1),pwl,32,ind)
      s00093 = b*dexp(-1.0*a*twall)
      RETURN
      END
      DOUBLE PRECISION FUNCTION sigma(t)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      DATA b0 , b1 , b2 , b3 , b4 , b5/0.83D+00 , 1.160936807D-1 , 
     &     1.121404688D-3 , -5.752805180D-6 , 1.286274650D-8 , 
     &     -1.149719290D-11/
      tc = (t-32.)*5./9.D+00
      tk = tc + 273.15
      dtk = 647.3D+00 - tk
      dtk = dmax1(1.D-6,dtk)
      sigma = b1*dtk*dtk/(1.+b0*dtk)
      sigma = sigma + dtk*dtk*(b2+dtk*(b3+dtk*(b4+dtk*b5)))
      sigma = sigma*12.*14.5037738D-6/2.540005
      RETURN
      END
      DOUBLE PRECISION FUNCTION s00098(vbcr,alo,al)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      a = .67
      IF ( al.GE.alo ) a = .47
      b = 1./a
      c = b - 1.D+00
      rap = (al/alo)**c
      s00098 = vbcr*(1.-al)*rap/alo
      RETURN
      END
      SUBROUTINE s00002
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa11 / v0011n(20) , v0012x(20) , v0011 , v0012 , tlim , 
     &                zlimin , zlimax , dtvoi , timimp(20) , difref(20)
     &                 , difmic(20) , v00001 , v22202 , temimp , 
     &                temmic , delm , delv , delvi , delvs , v22201 , 
     &                v22203 , dtpre , dtphy , dttemp , dtchan , dtdis , 
     &                dtbef , dtorg , nimic , nmultr , izone , 
     &                n00011(20) , isort , necrit , nstar , iplot , 
     &                nzone , ifre(20) , ico , iimp , npas1(20) , 
     &                npas2(20)
      COMMON /aaa26 / deb(21) , debv(21) , debl(21) , alfad(21) , 
     &                alfb(21) , alft(21) , ha(21) , hb(21) , he(21,2) , 
     &                hem(21) , ve(21,2) , xa(21) , xb(21) , xd(21) , 
     &                xem(21) , sdsc , tjonc(21) , hjonb(21,2) , 
     &                hjont(21,2) , debav(21) , glinf(21) , glsup(21) , 
     &                pp1 , pp2 , alniv , vgjo(21) , glinfp(21) , 
     &                v55198(21) , icas(21) , iczw(21)
      COMMON /aaa22 / dh(22,2) , dm(22,2) , dpdt , duu(22,2) , dv(22,2)
     &                 , dnu(22,2)
      COMMON /aaa33 / vco , xl0055 , d876 , dint , dext , vol002 , 
     &                vol005 , lco , ncray
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      COMMON /aaa77 / qinit , tpui(20) , qpui(20) , rpui , plmoy , 
     &                xhtc(22,12) , pl(22,12) , qrepa(22,12) , 
     &                xmcga(22,12) , xmcuo(22,12) , qced(22,12) , 
     &                qcon(22,12) , quga(22,12) , qfou(22,12) , qcei(2)
     &                 , qconi(2) , qugii(2) , tmi(2) , dtmi(2) , 
     &                qtotal , qtug , qtgf , terc(2) , tgai(22,12) , 
     &                tgaii(22,12) , t876(22,12) , tumax(22,12) , 
     &                tumin(22,12) , dtgai(22,12) , dt876(22,12) , 
     &                terco(22,12) , tmu(2) , dtmu(2) , npui , nasl(22)
     &                 , nsl(22)
      COMMON /aaa88 / flup(22,2) , fluv(22,2) , flul(22,2) , fluiv(22,2)
     &                 , debil(22,2) , fluil(22,2) , debi(22) , 
     &                debhi(22) , debiv(22,2)
      COMMON /aaa99 / hlcf , hvcfo , hvap , hcon , hvin , hlin , r876 , 
     &                rgai , xm876 , xmgai , xl876 , xlgai , cp876 , 
     &                cpgai , xmc876 , xmcgai , diahy , hgapp(22) , 
     &                hcg(22) , htc(22,12) , hvcff(22)
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa16 / dbent(20) , tent(20) , hent(20) , debe , ente , 
     &                dbsor(20) , tsor(20) , debs , dpdtt(20) , 
     &                tdpdt(20) , hsor(20) , thsor(20) , ents , ndbent , 
     &                ndpdt , ndbsor , nhsor
      COMMON /aaa17 / ddpdt , ddh(22,2) , ddv(22,2) , ddm(22,2) , 
     &                ddu(22,2)
      COMMON /aaa18 / ddeb(21) , dddeb(21) , dxat(21) , dxag(21) , 
     &                dxbt(21) , dxbg(21) , dnug(21) , dnuf(21) , 
     &                dhe(22,2) , ddebo(21)
      COMMON /aaa20 / dqp(22,2) , dflul(22) , dfluv(22) , dfluil(22) , 
     &                dfluiv(22) , ddebil(22) , ddebiv(22) , dqcei(2) , 
     &                dqced(22,12) , ddtuo(22,12) , ddtga(22,12) , 
     &                ddtmi(2) , ddtmu(2)
      CHARACTER*2 ititre(8)
      DOUBLE PRECISION m
      READ (5,99001) (ititre(i),i=1,8)
      READ (5,99006) kpress , kdeb , kcon , ktgai , kt876 , kgliss , 
     &               (icat(i),i=1,3)
      READ (5,99014) nzone
      DO 100 i = 1 , nzone
         READ (5,99007) ifre(i) , timimp(i) , difref(i) , difmic(i) , 
     &                  npas1(i) , npas2(i) , v0011n(i) , v0012x(i)
 100  CONTINUE
      READ (5,99008) (n00011(i),i=1,nzone)
      v0011 = v0011n(1)
      v0012 = v0012x(1)
      READ (5,99010) delm , delv , delvi , delvs
      READ (5,99010) v00001 , v22201 , v22202 , v22203
      READ (5,99010) tlim , zlimin , zlimax
      READ (5,99006) nmultr
      delm = delm/100.D+00
      delv = delv/100.D+00
      delvi = delvi/100.D+00
      delvs = delvs/100.D+00
      vfix = 1./12.D+00
      READ (5,99012) ncray
      READ (5,99010) r876 , xl876 , cp876
      READ (5,99010) rgai , xlgai , cpgai
      READ (5,99010) d876 , dint , dext
      d876 = d876/12.D+00
      dint = dint/12.D+00
      dext = dext/12.D+00
      READ (5,99013) tem , p , qinit , nc , ibch , ihch
      nc1 = nc + 1
      nc2 = nc + 2
      xl0055 = 0.D+00
      ityp(1) = 1
      DO 200 i = 2 , nc1
         READ (5,99015) ityp(i) , h(i,1) , h(i,2) , xl1 , xl2 , scapa(i)
         IF ( ityp(i).EQ.2 ) THEN
            xl(i) = xl1
            vc(i) = xl1*scapa(i)
            v(i,1) = vc(i)*(1.-xl2)
            v(i,2) = vc(i)*xl2
         ELSEIF ( ityp(i).EQ.3 ) THEN
            xl(i) = xl1 + xl2
            v(i,1) = xl1*scapa(i)
            v(i,2) = xl2*scapa(i)
            vc(i) = v(i,1) + v(i,2)
            hniv(i) = xl1
         ELSE
            xl(i) = xl1
            v(i,1) = xl1*scapa(i)
            vc(i) = v(i,1)
         ENDIF
 200  CONTINUE
      ityp(nc2) = 1
      h(nc2,2) = 0.D+00
      vc(nc2) = 1.D+00
      v(nc2,2) = 1.D+00
      vc(1) = 1.D+00
      v(1,1) = 1.D+00
      DO 300 i = ibch , ihch
         xl0055 = xl0055 + xl(i)
 300  CONTINUE
      lco = xl0055
      DO 400 ii = 1 , nc2
         i = nc2 + 1 - ii
         h1 = h(i,1)
         h2 = h(i,2)
         h3 = 0.D+00
         v1 = v(i,1)
         v2 = v(i,2)
         v3 = 0.D+00
 400  CONTINUE
      IF ( kdeb.EQ.1 ) READ (5,99016) sdsc
      READ (5,99014) ndbent
      READ (5,99011) (tent(i),dbent(i),hent(i),i=1,ndbent)
      READ (5,99014) nhsor
      READ (5,99016) (thsor(i),hsor(i),i=1,nhsor)
      IF ( kpress.EQ.1 ) THEN
         READ (5,99014) ndpdt
         READ (5,99016) (tdpdt(i),dpdtt(i),i=1,ndpdt)
      ELSE
         READ (5,99014) ndbsor
         READ (5,99016) (tsor(i),dbsor(i),i=1,ndbsor)
      ENDIF
      READ (5,99014) npui
      READ (5,99016) (tpui(i),qpui(i),i=1,npui)
      READ (5,99005) (hgapp(i),i=2,nc1)
      DO 500 i = 2 , nc1
         hgapp(i) = hgapp(i)/3600.D+00
 500  CONTINUE
      READ (5,99017) (nsl(i),i=2,nc1)
      DO 600 i = 2 , nc1
         n1 = nsl(i)
         nasl(i) = nsl(i)
         DO 550 j = 1 , n1
            READ (5,99003) pl(i,j) , t876(i,j) , tgai(i,j)
 550     CONTINUE
 600  CONTINUE
      READ (5,99004) hlcf , hvcf , hvap , hcon , hvin , hlin
      hlcf = hlcf/3600.D+00
      hvcf = hvcf/3600.D+00
      hvap = hvap/3600.D+00
      hcon = hcon/3600.D+00
      hvin = hvin/3600.D+00
      hlin = hlin/3600.
      hvcfo = hvcf
      temimp = tem - 10000.
      temmic = temimp
      izone = 0
      IF ( tem.GE.timimp(1) ) THEN
 650     izone = izone + 1
         IF ( izone.LT.nzone ) THEN
            IF ( tem.GT.timimp(izone+1) ) GOTO 650
         ENDIF
      ENDIF
      iimp = 0
      ico = 0
      dt = v0011
      niv = 0
      islni = 0
      hen = h(ibch,1)
      READ (5,99005) (sc(i),i=1,nc1)
      vco = 0.
      DO 700 i = ibch , ihch
         vco = vco + vc(i)
 700  CONTINUE
      zniv = 0.
      ica = icat(2)
      IF ( ica.GT.2 ) THEN
         DO 750 i = 2 , nc1
            IF ( ityp(i).GE.3 ) THEN
               zniv = zniv + hniv(i)
               niv = i
               GOTO 800
            ELSE
               zniv = zniv + xl(i)
            ENDIF
 750     CONTINUE
      ENDIF
 800  zcot(ibch-1) = 0
      IF ( ibch.GT.2 ) THEN
         ibc = ibch - 1
         DO 850 i = 2 , ibc
            j = ibch - i
            zcot(j) = zcot(j+1) - xl(j+1)
 850     CONTINUE
      ENDIF
      DO 900 i = ibch , nc1
         zcot(i) = zcot(i-1) + xl(i)
 900  CONTINUE
      zniv = zniv + zcot(1)
      RETURN
99001 FORMAT (8A2)
99002 FORMAT (/,10X,8A2)
99003 FORMAT (3F10.4)
99004 FORMAT (6F10.4)
99005 FORMAT (8F10.4)
99006 FORMAT (6(I1,9X),3I1)
99007 FORMAT (I2,8X,3F10.4,2(5X,I5),2F10.6)
99008 FORMAT (40I2)
99009 FORMAT (I1,4X,2I5,5X,3F10.4)
99010 FORMAT (5F10.4)
99011 FORMAT (3F10.4)
99012 FORMAT (I5)
99013 FORMAT (3F10.4,3(I2,8X))
99014 FORMAT (I2)
99015 FORMAT (I1,9X,6F10.4)
99016 FORMAT (2F10.4)
99017 FORMAT (8(I2,8X))
99018 FORMAT (2I3,3X,F7.4,5(2X,F8.4),3(2X,F10.4))
99019 FORMAT (18X,F10.4,4X,F10.4)
99020 FORMAT ((14X,3(4X,F10.4)))
99021 FORMAT ((4X,I2,4X,3F10.4,2(3X,I5,2X),2F10.6))
      END
      SUBROUTINE x21y21(x,y)
      DOUBLE PRECISION x(21) , y(21)
      DOUBLE PRECISION xx(21) , yy(21)
      DATA xx/0.2 , 200. , 400. , 600. , 800. , 1000. , 1500. , 2000. , 
     &     2500. , 3000. , 3500. , 4000. , 6000. , 8000. , 10000. , 
     &     15000. , 20000. , 25000. , 30000. , 40000. , 50000./
      DATA yy/0. , 69.31 , 120.68 , 166.92 , 210.12 , 251.19 , 347.43 , 
     &     437.34 , 522.82 , 604.92 , 684.31 , 761.46 , 1053.22 , 
     &     1325.78 , 1584.89 , 2192.16 , 2759.46 , 3298.77 , 3816.78 , 
     &     4804.5 , 5743.49/
      DO 100 i = 1 , 21
         x(i) = xx(i)
         y(i) = yy(i)
 100  CONTINUE
      RETURN
      END
      SUBROUTINE s00096(pp,hf,hg,t,vf,vg,dvfdp,dvgdp,dhfdp,dhgdp,dtsat)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      DATA a0 , a1 , a2 , a3 , a4 , a5/0.0168896951589D+00 , 
     &     89.7563708097D-7 , -95.3392512069D-10 , 76.4433456620D-13 , 
     &     -28.1881717776D-16 , 40.5307653492D-20/
      DATA b0 , b1 , b2 , b3 , b4 , b5 , b6 , b7/300.12985208D+00 , 
     &     -252.638119855D+00 , 97.9981947188D+00 , -22.4207151267D+00 , 
     &     3.22500188803D+00 , -0.288260253918D+00 , 
     &     .0146831531571D+00 , -32.6352964583D-5/
      DATA c0 , c1 , c2 , c3 , c4/71.5171806566D+00 , 
     &     56.4133540077D+00 , -3.73181288419D+00 , .737563606575D+00 , 
     &     .00809293492177D+00/
      DATA d0 , d1 , d2 , d3 , d4 , d5/ - 501.911804844D+00 , 
     &     643.013652461D+00 , -254.053681062D+00 , 53.4172368776D+00 , 
     &     -5.47296691662D+00 , .227574393371D+00/
      DATA e0 , e1 , e2 , e3 , e4 , e5 , e6/ - 983.676282822D+00 , 
     &     2649.64781997D+00 , -1365.75884763D+00 , 373.419845898D+00 , 
     &     -56.7876969779D+00 , 4.56687019374D+00 , -.152528030277D+00/
      DATA dd0 , dd1 , dd2 , dd3/ - 310295.234948D+00 , 
     &     121447.323002D+00 , -15841.5422032D+00 , 690.18449767D+00/
      DATA ee0 , ee1 , ee2 , ee3/464392.898586D+00 , 
     &     -181216.034989D+00 , 23651.1207875D+00 , -1029.9067531D+00/
      DATA cc0 , cc1 , cc2 , cc3 , cc4 , cc5/ - 0.603754D+00 , 
     &     -0.195861D+00 , 1.90488D-2 , -8.98731D-4 , 1.93828D-5 , 
     &     -1.59293D-7/
      DATA aa0 , aa1 , aa2 , aa3 , aa4 , aa5/ - 9.62997D-6 , 
     &     -6.26013D-7 , 5.86957D-8 , -2.84574D-9 , 6.23361D-11 , 
     &     -5.23200D-13/
      DATA bb0 , bb1 , bb2 , bb3/0.834155D+00 , 392.019D+00 , 
     &     -173.129D+00 , 161.554D+00/
      DATA df0 , df1 , df2 , df3 , df4 , df5/ - 0.640476D+00 , 
     &     -0.194453D+00 , 1.89171D-2 , -8.92998D-4 , 1.92670D-5 , 
     &     -1.58399D-7/
      DATA eg0 , eg1 , eg2 , eg3 , eg4 , eg5/ - 9.33315D-2 , 
     &     -8.71131D-2 , 8.43181D-3 , -3.95457D-4 , 8.50339D-6 , 
     &     -6.97062D-8/
      DATA ta , vfa , hfa , hga/281.03D+00 , 0.017269D+00 , 250.24D+00 , 
     &     1174.4D+0/
      p = pp
      IF ( p.GE.41. ) THEN
         w = dlog(dabs(p))
         rp = 1./p
         IF ( p.GE.2005. ) THEN
            hf = dd0 + w*(dd1+w*(dd2+w*dd3))
            hg = ee0 + w*(ee1+w*(ee2+w*ee3))
         ELSE
            hf = d0 + w*(d1+w*(d2+w*(d3+w*(d4+w*d5))))
            hg = e0 + w*(e1+w*(e2+w*(e3+w*(e4+w*(e5+w*e6)))))
            IF ( p.GT.1995. ) THEN
               fctr = (p-1995.)/10.
               hf1 = dd0 + w*(dd1+w*(dd2+w*dd3))
               hg1 = ee0 + w*(ee1+w*(ee2+w*ee3))
               hf = hf*(1.-fctr) + hf1*fctr
               hg = hg*(1.-fctr) + hg1*fctr
            ENDIF
         ENDIF
         vf = a0 + p*(a1+p*(a2+p*(a3+p*(a4+p*a5))))
         vg = b0 + w*(b1+w*(b2+w*(b3+w*(b4+w*(b5+w*(b6+w*b7))))))
         t = c0 + w*(c1+w*(c2+w*(c3+w*c4)))
         dtsat = (c1+w*(2.*c2+w*(3.*c3+4.*c4*w)))/p
         dvfdp = a1 + p*(2.*a2+p*(3.*a3+p*(4.*a4+p*5.*a5)))
         dvgdp = rp*
     &           (b1+w*(2.*b2+w*(3.*b3+w*(4.*b4+w*(5.*b5+w*(6.*b6+w*7.*
     &           b7))))))
         IF ( p.GE.2005. ) THEN
            dhfdp = rp*(dd1+w*(2.*dd2+w*3.*dd3))
            dhgdp = rp*(ee1+w*(2.*ee2+w*3.*ee3))
         ELSE
            dhfdp = rp*(d1+w*(2.*d2+w*(3.*d3+w*(4.*d4+w*5.*d5))))
            dhgdp = rp*
     &              (e1+w*(2.*e2+w*(3.*e3+w*(4.*e4+w*(5.*e5+w*6.*e6)))))
            IF ( p.GT.1995. ) THEN
               fctr = (p-1995.)/10.
               dhfdp1 = rp*(dd1+w*(2.*dd2+w*3.*dd3))
               dhgdp1 = rp*(ee1+w*(2.*ee2+w*3.*ee3))
               dhfdp = dhfdp*(1.-fctr) + dhfdp1*fctr
               dhgdp = dhgdp*(1.-fctr) + dhgdp1*fctr
            ENDIF
         ENDIF
         RETURN
      ELSEIF ( p.LT.40 ) THEN
         x = 50. - pp
         rp = 1./pp
         t = ta + x*(cc0+x*(cc1+x*(cc2+x*(cc3+x*(cc4+x*cc5)))))
         dtsat = -
     &           (cc0+x*(2.*cc1+x*(3.*cc2+x*(4.*cc3+x*(5.*cc4+6.*cc5*x))
     &           )))
         vf = vfa + x*(aa0+x*(aa1+x*(aa2+x*(aa3+x*(aa4+x*aa5)))))
         vg = bb0 + rp*(bb1+rp*(bb2+rp*bb3))
         hf = hfa + x*(df0+x*(df1+x*(df2+x*(df3+x*(df4+x*df5)))))
         hg = hga + x*(eg0+x*(eg1+x*(eg2+x*(eg3+x*(eg4+x*eg5)))))
         dvfdp = -aa0 - 
     &           x*(2.*aa1+x*(3.*aa2+x*(4.*aa3+x*(5.*aa4+x*6.*aa5))))
         dvgdp = -rp**2*(bb1+rp*(2.*bb2+rp*3.*bb3))
         dhfdp = -df0 - 
     &           x*(2.*df1+x*(3.*df2+x*(4.*df3+x*(5.*df4+x*6.*df5))))
         dhgdp = -eg0 - 
     &           x*(2.*eg1+x*(3.*eg2+x*(4.*eg3+x*(5.*eg4+x*6.*eg5))))
         RETURN
      ELSE
         fctr = p - 40.
         w = dlog(dabs(p))
         rp = 1.0/p
         x = 50. - pp
         hf1 = d0 + w*(d1+w*(d2+w*(d3+w*(d4+w*d5))))
         hg1 = e0 + w*(e1+w*(e2+w*(e3+w*(e4+w*(e5+w*e6)))))
         vf1 = a0 + p*(a1+p*(a2+p*(a3+p*(a4+p*a5))))
         vg1 = b0 + w*(b1+w*(b2+w*(b3+w*(b4+w*(b5+w*(b6+w*b7))))))
         t1 = c0 + w*(c1+w*(c2+w*(c3+w*c4)))
         t = ta + x*(cc0+x*(cc1+x*(cc2+x*(cc3+x*(cc4+x*cc5)))))
         t2 = t
         vf = vfa + x*(aa0+x*(aa1+x*(aa2+x*(aa3+x*(aa4+x*aa5)))))
         vg = bb0 + rp*(bb1+rp*(bb2+rp*bb3))
         hf = hfa + x*(df0+x*(df1+x*(df2+x*(df3+x*(df4+x*df5)))))
         hg = hga + x*(eg0+x*(eg1+x*(eg2+x*(eg3+x*(eg4+x*eg5)))))
         t = t*(1.0-fctr) + t1*fctr
         dt1dp = (c1+w*(2.*c2+w*(3.*c3+4.*c4*w)))/p
         dt2dp = -
     &           (cc0+x*(2.*cc1+x*(3.*cc2+x*(4.*cc3+x*(5.*cc4+6.*cc5*x))
     &           )))
         dtsat = dt1dp*fctr + (1.-fctr)*dt2dp + t1 - t2
         vf = vf*(1.0-fctr) + vf1*fctr
         vg = vg*(1.0-fctr) + vg1*fctr
         hf = hf*(1.0-fctr) + hf1*fctr
         hg = hg*(1.0-fctr) + hg1*fctr
         dvfdp1 = a1 + p*(2.*a2+p*(3.*a3+p*(4.*a4+p*5.*a5)))
         dvgdp1 = rp*
     &            (b1+w*(2.*b2+w*(3.*b3+w*(4.*b4+w*(5.*b5+w*(6.*b6+w*7.*
     &            b7))))))
         dhfdp1 = rp*(d1+w*(2.*d2+w*(3.*d3+w*(4.*d4+w*5.*d5))))
         dhgdp1 = rp*(e1+w*(2.*e2+w*(3.*e3+w*(4.*e4+w*(5.*e5+w*6.*e6))))
     &            )
         dvfdp = -aa0 - 
     &           x*(2.*aa1+x*(3.*aa2+x*(4.*aa3+x*(5.*aa4+x*6.*aa5))))
         dvgdp = -rp**2*(bb1+rp*(2.*bb2+rp*3.*bb3))
         dhfdp = -df0 - 
     &           x*(2.*df1+x*(3.*df2+x*(4.*df3+x*(5.*df4+x*6.*df5))))
         dhgdp = -eg0 - 
     &           x*(2.*eg1+x*(3.*eg2+x*(4.*eg3+x*(5.*eg4+x*6.*eg5))))
         dvfdp = dvfdp*(1.0-fctr) + dvfdp1*fctr
         dvgdp = dvgdp*(1.0-fctr) + dvgdp1*fctr
         dhfdp = dhfdp*(1.0-fctr) + dhfdp1*fctr
         dhgdp = dhgdp*(1.0-fctr) + dhgdp1*fctr
         RETURN
      ENDIF
c      PRINT11111,PP,TA,CC0,CC1,VFA,AA0,AA1,BB0,HFA,HGA,DF0,EG0
99001 FORMAT (10F13.3)
      END
      SUBROUTINE s00019
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa22 / dh(22,2) , dm(22,2) , dpdt , duu(22,2) , dv(22,2)
     &                 , dnu(22,2)
      COMMON /aaa10 / v(22,2) , vv(22,2) , h(22,2) , hf(22,2) , hg(22,2)
     &                 , dnuhp(22,2) , u(22,2) , xm(22,2) , xt(22,2) , 
     &                alfa(22,2) , t(22,2) , dvvh(22,2) , delh(22,2) , 
     &                dvvp(22,2) , delp(22,2) , aa(22,2) , bb(22,2) , 
     &                dtdh(22,2) , dtdp(22,2) , dtsat , dnupp(22,2) , 
     &                a(22) , b(22) , c(22) , tvid(22,12) , m(22,2) , 
     &                ist(22,2)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa77 / qinit , tpui(20) , qpui(20) , rpui , plmoy , 
     &                xhtc(22,12) , pl(22,12) , qrepa(22,12) , 
     &                xmcga(22,12) , xmcuo(22,12) , qced(22,12) , 
     &                qcon(22,12) , quga(22,12) , qfou(22,12) , qcei(2)
     &                 , qconi(2) , qugii(2) , tmi(2) , dtmi(2) , 
     &                qtotal , qtug , qtgf , terc(2) , tgai(22,12) , 
     &                tgaii(22,12) , t876(22,12) , tumax(22,12) , 
     &                tumin(22,12) , dtgai(22,12) , dt876(22,12) , 
     &                terco(22,12) , tmu(2) , dtmu(2) , npui , nasl(22)
     &                 , nsl(22)
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      COMMON /aaa26 / deb(21) , debv(21) , debl(21) , alfad(21) , 
     &                alfb(21) , alft(21) , ha(21) , hb(21) , he(21,2) , 
     &                hem(21) , ve(21,2) , xa(21) , xb(21) , xd(21) , 
     &                xem(21) , sdsc , tjonc(21) , hjonb(21,2) , 
     &                hjont(21,2) , debav(21) , glinf(21) , glsup(21) , 
     &                pp1 , pp2 , alniv , vgjo(21) , glinfp(21) , 
     &                v55198(21) , icas(21) , iczw(21)
      COMMON /aaa17 / ddpdt , ddh(22,2) , ddv(22,2) , ddm(22,2) , 
     &                ddu(22,2)
      COMMON /aaa18 / ddeb(21) , dddeb(21) , dxat(21) , dxag(21) , 
     &                dxbt(21) , dxbg(21) , dnug(21) , dnuf(21) , 
     &                dhe(22,2) , ddebo(21)
      COMMON /aaa20 / dqp(22,2) , dflul(22) , dfluv(22) , dfluil(22) , 
     &                dfluiv(22) , ddebil(22) , ddebiv(22) , dqcei(2) , 
     &                dqced(22,12) , ddtuo(22,12) , ddtga(22,12) , 
     &                ddtmi(2) , ddtmu(2)
      DOUBLE PRECISION m
      tem = tem + dt
      p = p + dt*(dpdt+ddpdt*dt)
      DO 100 i = 2 , nc1
         j1 = 2
         IF ( ityp(i).EQ.1 ) j1 = 1
         DO 50 j = 1 , j1
            xdh = dh(i,j)
            ydh = dabs(xdh)
            xddh = ddh(i,j)
            yddh = dabs(xddh)
            ydh = dmax1(1.D0,ydh)
            yddht = yddh*dt
            IF ( yddht.GT.(ydh/2.) ) THEN
               xddh = (ydh/2.)*xddh/yddh
               yddh = dabs(xddh)
            ENDIF
            IF ( ydh.GT.1.D+5 .OR. yddh.GT.1.D+8 ) THEN
               IF ( ydh.GE.1.D+5 ) xdh = xdh*1.D+5/ydh
               IF ( yddh.GE.1.D+8 ) xddh = xddh*1.D+8/yddh
            ENDIF
            h(i,j) = h(i,j) + dt*(xdh+dt*xddh)
            v(i,j) = v(i,j) + dt*(dv(i,j)+dt*ddv(i,j))
 50      CONTINUE
 100  CONTINUE
      DO 200 i = 2 , nc1
         n1 = nasl(i)
         DO 150 j = 1 , n1
            t876(i,j) = t876(i,j) + dt*(dt876(i,j)+dt*ddtuo(i,j))
            tgai(i,j) = tgai(i,j) + dt*(dtgai(i,j)+dt*ddtga(i,j))
 150     CONTINUE
 200  CONTINUE
      DO 300 k = 1 , 2
         tmi(k) = tmi(k) + dt*(dtmi(k)+dt*ddtmi(k))
         tmu(k) = tmu(k) + dt*(dtmu(k)+dt*ddtmu(k))
 300  CONTINUE
      DO 400 i = 1 , nc1
         deb(i) = deb(i) + dt*(ddeb(i)+dt*dddeb(i))
 400  CONTINUE
      RETURN
      END
      SUBROUTINE s00000(ini)
      IMPLICIT DOUBLE PRECISION(a-h,o-z)
      COMMON /aaa11 / v0011n(20) , v0012x(20) , v0011 , v0012 , tlim , 
     &                zlimin , zlimax , dtvoi , timimp(20) , difref(20)
     &                 , difmic(20) , v00001 , v22202 , temimp , 
     &                temmic , delm , delv , delvi , delvs , v22201 , 
     &                v22203 , dtpre , dtphy , dttemp , dtchan , dtdis , 
     &                dtbef , dtorg , nimic , nmultr , izone , 
     &                n00011(20) , isort , necrit , nstar , iplot , 
     &                nzone , ifre(20) , ico , iimp , npas1(20) , 
     &                npas2(20)
      COMMON /aaa26 / deb(21) , debv(21) , debl(21) , alfad(21) , 
     &                alfb(21) , alft(21) , ha(21) , hb(21) , he(42) , 
     &                hem(21) , ve(42) , xa(21) , xb(21) , xd(21) , 
     &                xem(21) , sdsc , tjonc(21) , hjonb(42) , hjont(42)
     &                 , debav(21) , glinf(21) , glsup(21) , pp1 , pp2 , 
     &                alniv , vgjo(21) , glinfp(21) , v55198(21) , 
     &                icas(21) , iczw(21)
      COMMON /aaa22 / dh(44) , dm(44) , dpdt , duu(44) , dv(44) , 
     &                dnu(44)
      COMMON /aaa33 / vco , xl0055 , d876 , dint , dext , vol002 , 
     &                vol005 , lco , ncray
      COMMON /aaa44 / sc(21) , scapa(22) , shtc(22) , vc(22) , xl(22) , 
     &                vfix , zcot(21) , i6ft , j6ft , i8ft , j8ft , nc , 
     &                nc1 , nc2 , ibch , ihch
      COMMON /aaa55 / kpress , kdeb , kcon , ktgai , kt876 , icat(3) , 
     &                kimp , kgliss
      COMMON /aaa66 / ts , hfs , hgs , hfgs , dhfps , dhgps , vvfs , 
     &                vvgs , dvvfps , dvvgps , dhfgs , vv1 , vv2 , 
     &                dvv1p , dvv2p , t1 , t2
      COMMON /aaa77 / qinit , tpui(20) , qpui(20) , rpui , plmoy , 
     &                xhtc(264) , pl(264) , qrepa(264) , xmcga(264) , 
     &                xmcuo(264) , qced(264) , qcon(264) , quga(264) , 
     &                qfou(264) , qcei(2) , qconi(2) , qugii(2) , tmi(2)
     &                 , dtmi(2) , qtotal , qtug , qtgf , terc(2) , 
     &                tgai(264) , tgaii(264) , t876(264) , tumax(264) , 
     &                tumin(264) , dtgai(264) , dt876(264) , terco(264)
     &                 , tmu(2) , dtmu(2) , npui , nasl(22) , nsl(22)
      COMMON /aaa88 / flup(44) , fluv(44) , flul(44) , fluiv(44) , 
     &                debil(44) , fluil(44) , debi(22) , debhi(22) , 
     &                debiv(44)
      COMMON /aaa99 / hlcf , hvcfo , hvap , hcon , hvin , hlin , r876 , 
     &                rgai , xm876 , xmgai , xl876 , xlgai , cp876 , 
     &                cpgai , xmc876 , xmcgai , diahy , hgapp(22) , 
     &                hcg(22) , htc(264) , hvcff(22)
      COMMON /aaa10 / v(44) , vv(44) , h(44) , hf(44) , hg(44) , 
     &                dnuhp(44) , u(44) , xm(44) , xt(44) , alfa(44) , 
     &                t(44) , dvvh(44) , delh(44) , dvvp(44) , delp(44)
     &                 , aa(44) , bb(44) , dtdh(44) , dtdp(44) , dtsat , 
     &                dnupp(44) , a(22) , b(22) , c(22) , tvid(264) , 
     &                m(44) , ist(44)
      COMMON /aaa13 / tem , p , dt , hniv(22) , vitess , zniv , ri(2) , 
     &                iss , nitera , niv , islni , ibtr , ihtr , 
     &                ityp(22)
      COMMON /aaa16 / dbent(20) , tent(20) , hent(20) , debe , ente , 
     &                dbsor(20) , tsor(20) , debs , dpdtt(20) , 
     &                tdpdt(20) , hsor(20) , thsor(20) , ents , ndbent , 
     &                ndpdt , ndbsor , nhsor
      COMMON /aaa17 / ddpdt , ddh(44) , ddv(44) , ddm(44) , ddu(44)
      COMMON /aaa18 / ddeb(21) , dddeb(21) , dxat(21) , dxag(21) , 
     &                dxbt(21) , dxbg(21) , dnug(21) , dnuf(21) , 
     &                dhe(44) , ddebo(21)
      COMMON /aaa20 / dqp(44) , dflul(22) , dfluv(22) , dfluil(22) , 
     &                dfluiv(22) , ddebil(22) , ddebiv(22) , dqcei(2) , 
     &                dqced(264) , ddtuo(264) , ddtga(264) , ddtmi(2) , 
     &                ddtmu(2)
      DOUBLE PRECISION m
      DO 100 i = 1 , 20
         dbent(i) = ini
 100  CONTINUE
      DO 200 i = 1 , 20
         tent(i) = ini
 200  CONTINUE
      DO 300 i = 1 , 20
         hent(i) = ini
 300  CONTINUE
      debe = ini
      ente = ini
      DO 400 i = 1 , 20
         dpdtt(i) = ini
 400  CONTINUE
      DO 500 i = 1 , 20
         tdpdt(i) = ini
 500  CONTINUE
      DO 600 i = 1 , 20
         dbsor(i) = ini
 600  CONTINUE
      DO 700 i = 1 , 20
         tsor(i) = ini
 700  CONTINUE
      debs = ini
      DO 800 i = 1 , 20
         hsor(i) = ini
 800  CONTINUE
      DO 900 i = 1 , 20
         thsor(i) = ini
 900  CONTINUE
      ents = ini
      ndbent = ini
      ndpdt = ini
      ndbsor = ini
      nhsor = ini
      DO 1000 i = 1 , 20
         v0011n(i) = ini
 1000 CONTINUE
      DO 1100 i = 1 , 20
         v0012x(i) = ini
 1100 CONTINUE
      v0011 = ini
      v0012 = ini
      dtvoi = ini
      DO 1200 i = 1 , 20
         timimp(i) = ini
 1200 CONTINUE
      DO 1300 i = 1 , 20
         difref(i) = ini
 1300 CONTINUE
      DO 1400 i = 1 , 20
         difmic(i) = ini
 1400 CONTINUE
      temimp = ini
      temmic = ini
      delm = ini
      delv = ini
      delvi = ini
      delvs = ini
      tlim = ini
      zlimin = ini
      zlimax = ini
      v00001 = ini
      v22202 = ini
      v22201 = ini
      v22203 = ini
      dtpre = ini
      dtphy = ini
      dttemp = ini
      dtchan = ini
      dtdis = ini
      dtbef = ini
      dtorg = ini
      nimic = ini
      nmultr = ini
      izone = ini
      DO 1500 i = 1 , 20
         n00011(i) = ini
 1500 CONTINUE
      isort = ini
      necrit = ini
      nstar = ini
      iplot = ini
      nzone = ini
      DO 1600 i = 1 , 20
         ifre(i) = ini
 1600 CONTINUE
      ico = ini
      iimp = ini
      DO 1700 i = 1 , 20
         npas1(i) = ini
 1700 CONTINUE
      DO 1800 i = 1 , 20
         npas2(i) = ini
 1800 CONTINUE
      DO 1900 i = 1 , 21
         deb(i) = ini
 1900 CONTINUE
      DO 2000 i = 1 , 21
         debv(i) = ini
 2000 CONTINUE
      DO 2100 i = 1 , 21
         debl(i) = ini
 2100 CONTINUE
      DO 2200 i = 1 , 21
         alfad(i) = ini
 2200 CONTINUE
      DO 2300 i = 1 , 21
         alfb(i) = ini
 2300 CONTINUE
      DO 2400 i = 1 , 21
         alft(i) = ini
 2400 CONTINUE
      DO 2500 i = 1 , 21
         ha(i) = ini
 2500 CONTINUE
      DO 2600 i = 1 , 21
         hb(i) = ini
 2600 CONTINUE
      DO 2700 i = 1 , 42
         he(i) = ini
 2700 CONTINUE
      DO 2800 i = 1 , 21
         hem(i) = ini
 2800 CONTINUE
      DO 2900 i = 1 , 42
         ve(i) = ini
 2900 CONTINUE
      DO 3000 i = 1 , 21
         xa(i) = ini
 3000 CONTINUE
      DO 3100 i = 1 , 21
         xb(i) = ini
 3100 CONTINUE
      DO 3200 i = 1 , 21
         xd(i) = ini
 3200 CONTINUE
      DO 3300 i = 1 , 21
         xem(i) = ini
 3300 CONTINUE
      sdsc = ini
      DO 3400 i = 1 , 21
         tjonc(i) = ini
 3400 CONTINUE
      DO 3500 i = 1 , 42
         hjonb(i) = ini
 3500 CONTINUE
      DO 3600 i = 1 , 42
         hjont(i) = ini
 3600 CONTINUE
      DO 3700 i = 1 , 21
         debav(i) = ini
 3700 CONTINUE
      DO 3800 i = 1 , 21
         glinf(i) = ini
 3800 CONTINUE
      DO 3900 i = 1 , 21
         glsup(i) = ini
 3900 CONTINUE
      pp1 = ini
      pp2 = ini
      alniv = ini
      DO 4000 i = 1 , 21
         vgjo(i) = ini
 4000 CONTINUE
      DO 4100 i = 1 , 21
         glinfp(i) = ini
 4100 CONTINUE
      DO 4200 i = 1 , 21
         v55198(i) = ini
 4200 CONTINUE
      DO 4300 i = 1 , 21
         icas(i) = ini
 4300 CONTINUE
      DO 4400 i = 1 , 21
         iczw(i) = ini
 4400 CONTINUE
      DO 4500 i = 1 , 44
         dh(i) = ini
 4500 CONTINUE
      DO 4600 i = 1 , 44
         dm(i) = ini
 4600 CONTINUE
      dpdt = ini
      DO 4700 i = 1 , 44
         duu(i) = ini
 4700 CONTINUE
      DO 4800 i = 1 , 44
         dv(i) = ini
 4800 CONTINUE
      DO 4900 i = 1 , 44
         dnu(i) = ini
 4900 CONTINUE
      ddpdt = ini
      DO 5000 i = 1 , 44
         ddh(i) = ini
 5000 CONTINUE
      DO 5100 i = 1 , 44
         ddv(i) = ini
 5100 CONTINUE
      DO 5200 i = 1 , 44
         ddm(i) = ini
 5200 CONTINUE
      DO 5300 i = 1 , 44
         ddu(i) = ini
 5300 CONTINUE
      DO 5400 i = 1 , 21
         ddeb(i) = ini
 5400 CONTINUE
      DO 5500 i = 1 , 21
         dddeb(i) = ini
 5500 CONTINUE
      DO 5600 i = 1 , 21
         dxat(i) = ini
 5600 CONTINUE
      DO 5700 i = 1 , 21
         dxag(i) = ini
 5700 CONTINUE
      DO 5800 i = 1 , 21
         dxbt(i) = ini
 5800 CONTINUE
      DO 5900 i = 1 , 21
         dxbg(i) = ini
 5900 CONTINUE
      DO 6000 i = 1 , 21
         dnug(i) = ini
 6000 CONTINUE
      DO 6100 i = 1 , 21
         dnuf(i) = ini
 6100 CONTINUE
      DO 6200 i = 1 , 44
         dhe(i) = ini
 6200 CONTINUE
      DO 6300 i = 1 , 21
         ddebo(i) = ini
 6300 CONTINUE
      DO 6400 i = 1 , 44
         dqp(i) = ini
 6400 CONTINUE
      DO 6500 i = 1 , 22
         dflul(i) = ini
 6500 CONTINUE
      DO 6600 i = 1 , 22
         dfluv(i) = ini
 6600 CONTINUE
      DO 6700 i = 1 , 22
         dfluil(i) = ini
 6700 CONTINUE
      DO 6800 i = 1 , 22
         dfluiv(i) = ini
 6800 CONTINUE
      DO 6900 i = 1 , 22
         ddebil(i) = ini
 6900 CONTINUE
      DO 7000 i = 1 , 22
         ddebiv(i) = ini
 7000 CONTINUE
      DO 7100 i = 1 , 2
         dqcei(i) = ini
 7100 CONTINUE
      DO 7200 i = 1 , 264
         dqced(i) = ini
 7200 CONTINUE
      DO 7300 i = 1 , 264
         ddtuo(i) = ini
 7300 CONTINUE
      DO 7400 i = 1 , 264
         ddtga(i) = ini
 7400 CONTINUE
      DO 7500 i = 1 , 2
         ddtmi(i) = ini
 7500 CONTINUE
      DO 7600 i = 1 , 2
         ddtmu(i) = ini
 7600 CONTINUE
      vco = ini
      xl0055 = ini
      d876 = ini
      dint = ini
      dext = ini
      vol002 = ini
      vol005 = ini
      lco = ini
      ncray = ini
      DO 7700 i = 1 , 21
         sc(i) = ini
 7700 CONTINUE
      DO 7800 i = 1 , 22
         scapa(i) = ini
 7800 CONTINUE
      DO 7900 i = 1 , 22
         shtc(i) = ini
 7900 CONTINUE
      DO 8000 i = 1 , 22
         vc(i) = ini
 8000 CONTINUE
      DO 8100 i = 1 , 22
         xl(i) = ini
 8100 CONTINUE
      vfix = ini
      DO 8200 i = 1 , 21
         zcot(i) = ini
 8200 CONTINUE
      i6ft = ini
      j6ft = ini
      i8ft = ini
      j8ft = ini
      nc = ini
      nc1 = ini
      nc2 = ini
      ibch = ini
      ihch = ini
      kpress = ini
      kdeb = ini
      kcon = ini
      ktgai = ini
      kt876 = ini
      DO 8300 i = 1 , 3
         icat(i) = ini
 8300 CONTINUE
      kimp = ini
      kgliss = ini
      ts = ini
      hfs = ini
      hgs = ini
      hfgs = ini
      dhfps = ini
      dhgps = ini
      vvfs = ini
      vvgs = ini
      dvvfps = ini
      dvvgps = ini
      dhfgs = ini
      vv1 = ini
      vv2 = ini
      dvv1p = ini
      dvv2p = ini
      t1 = ini
      t2 = ini
      qinit = ini
      DO 8400 i = 1 , 20
         tpui(i) = ini
 8400 CONTINUE
      DO 8500 i = 1 , 20
         qpui(i) = ini
 8500 CONTINUE
      rpui = ini
      plmoy = ini
      DO 8600 i = 1 , 264
         xhtc(i) = ini
 8600 CONTINUE
      DO 8700 i = 1 , 264
         pl(i) = ini
 8700 CONTINUE
      DO 8800 i = 1 , 264
         qrepa(i) = ini
 8800 CONTINUE
      DO 8900 i = 1 , 264
         xmcga(i) = ini
 8900 CONTINUE
      DO 9000 i = 1 , 264
         xmcuo(i) = ini
 9000 CONTINUE
      DO 9100 i = 1 , 264
         qced(i) = ini
 9100 CONTINUE
      DO 9200 i = 1 , 264
         qcon(i) = ini
 9200 CONTINUE
      DO 9300 i = 1 , 264
         quga(i) = ini
 9300 CONTINUE
      DO 9400 i = 1 , 264
         qfou(i) = ini
 9400 CONTINUE
      DO 9500 i = 1 , 2
         qcei(i) = ini
 9500 CONTINUE
      DO 9600 i = 1 , 2
         qconi(i) = ini
 9600 CONTINUE
      DO 9700 i = 1 , 2
         qugii(i) = ini
 9700 CONTINUE
      DO 9800 i = 1 , 2
         tmi(i) = ini
 9800 CONTINUE
      DO 9900 i = 1 , 2
         dtmi(i) = ini
 9900 CONTINUE
      qtotal = ini
      qtug = ini
      qtgf = ini
      DO 10000 i = 1 , 2
         terc(i) = ini
10000 CONTINUE
      DO 10100 i = 1 , 264
         tgai(i) = ini
10100 CONTINUE
      DO 10200 i = 1 , 264
         tgaii(i) = ini
10200 CONTINUE
      DO 10300 i = 1 , 264
         t876(i) = ini
10300 CONTINUE
      DO 10400 i = 1 , 264
         tumax(i) = ini
10400 CONTINUE
      DO 10500 i = 1 , 264
         tumin(i) = ini
10500 CONTINUE
      DO 10600 i = 1 , 264
         dtgai(i) = ini
10600 CONTINUE
      DO 10700 i = 1 , 264
         dt876(i) = ini
10700 CONTINUE
      DO 10800 i = 1 , 264
         terco(i) = ini
10800 CONTINUE
      DO 10900 i = 1 , 2
         tmu(i) = ini
10900 CONTINUE
      DO 11000 i = 1 , 2
         dtmu(i) = ini
11000 CONTINUE
      npui = ini
      DO 11100 i = 1 , 22
         nasl(i) = ini
11100 CONTINUE
      DO 11200 i = 1 , 22
         nsl(i) = ini
11200 CONTINUE
      DO 11300 i = 1 , 44
         flup(i) = ini
11300 CONTINUE
      DO 11400 i = 1 , 44
         fluv(i) = ini
11400 CONTINUE
      DO 11500 i = 1 , 44
         flul(i) = ini
11500 CONTINUE
      DO 11600 i = 1 , 44
         fluiv(i) = ini
11600 CONTINUE
      DO 11700 i = 1 , 44
         fluil(i) = ini
11700 CONTINUE
      DO 11800 i = 1 , 22
         debi(i) = ini
11800 CONTINUE
      DO 11900 i = 1 , 22
         debhi(i) = ini
11900 CONTINUE
      DO 12000 i = 1 , 44
         debiv(i) = ini
12000 CONTINUE
      DO 12100 i = 1 , 44
         debil(i) = ini
12100 CONTINUE
      hlcf = ini
      hvcfo = ini
      hvap = ini
      hcon = ini
      hvin = ini
      hlin = ini
      r876 = ini
      rgai = ini
      xm876 = ini
      xmgai = ini
      xl876 = ini
      xlgai = ini
      cp876 = ini
      cpgai = ini
      xmc876 = ini
      xmcgai = ini
      diahy = ini
      DO 12200 i = 1 , 22
         hgapp(i) = ini
12200 CONTINUE
      DO 12300 i = 1 , 22
         hcg(i) = ini
12300 CONTINUE
      DO 12400 i = 1 , 264
         htc(i) = ini
12400 CONTINUE
      DO 12500 i = 1 , 22
         hvcff(i) = ini
12500 CONTINUE
      DO 12600 i = 1 , 44
         v(i) = ini
12600 CONTINUE
      DO 12700 i = 1 , 44
         vv(i) = ini
12700 CONTINUE
      DO 12800 i = 1 , 44
         h(i) = ini
12800 CONTINUE
      DO 12900 i = 1 , 44
         hf(i) = ini
12900 CONTINUE
      DO 13000 i = 1 , 44
         hg(i) = ini
13000 CONTINUE
      DO 13100 i = 1 , 44
         dnuhp(i) = ini
13100 CONTINUE
      DO 13200 i = 1 , 44
         u(i) = ini
13200 CONTINUE
      DO 13300 i = 1 , 44
         xm(i) = ini
13300 CONTINUE
      DO 13400 i = 1 , 44
         xt(i) = ini
13400 CONTINUE
      DO 13500 i = 1 , 44
         alfa(i) = ini
13500 CONTINUE
      DO 13600 i = 1 , 44
         t(i) = ini
13600 CONTINUE
      DO 13700 i = 1 , 44
         dvvh(i) = ini
13700 CONTINUE
      DO 13800 i = 1 , 44
         delh(i) = ini
13800 CONTINUE
      DO 13900 i = 1 , 44
         dvvp(i) = ini
13900 CONTINUE
      DO 14000 i = 1 , 44
         delp(i) = ini
14000 CONTINUE
      DO 14100 i = 1 , 44
         aa(i) = ini
14100 CONTINUE
      DO 14200 i = 1 , 44
         bb(i) = ini
14200 CONTINUE
      DO 14300 i = 1 , 44
         dtdh(i) = ini
14300 CONTINUE
      DO 14400 i = 1 , 44
         dtdp(i) = ini
14400 CONTINUE
      dtsat = ini
      DO 14500 i = 1 , 44
         dnupp(i) = ini
14500 CONTINUE
      DO 14600 i = 1 , 22
         a(i) = ini
14600 CONTINUE
      DO 14700 i = 1 , 22
         b(i) = ini
14700 CONTINUE
      DO 14800 i = 1 , 22
         c(i) = ini
14800 CONTINUE
      DO 14900 i = 1 , 264
         tvid(i) = ini
14900 CONTINUE
      DO 15000 i = 1 , 44
         m(i) = ini
15000 CONTINUE
      DO 15100 i = 1 , 44
         ist(i) = ini
15100 CONTINUE
      tem = ini
      p = ini
      dt = ini
      DO 15200 i = 1 , 22
         hniv(i) = ini
15200 CONTINUE
      vitess = ini
      zniv = ini
      DO 15300 i = 1 , 2
         ri(i) = ini
15300 CONTINUE
      iss = ini
      nitera = ini
      niv = ini
      islni = ini
      ibtr = ini
      ihtr = ini
      DO 15400 i = 1 , 22
         ityp(i) = ini
15400 CONTINUE
      RETURN
      END
